/* Matcher.c generated by valac 0.56.18, the Vala compiler
 * generated from Matcher.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank-internal.h"
#include <gee.h>
#include <glib-object.h>
#include <libbamf/libbamf.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_MATCHER_0_PROPERTY,
	PLANK_MATCHER_NUM_PROPERTIES
};
static GParamSpec* plank_matcher_properties[PLANK_MATCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	PLANK_MATCHER_ACTIVE_WINDOW_CHANGED_SIGNAL,
	PLANK_MATCHER_WINDOW_OPENED_SIGNAL,
	PLANK_MATCHER_WINDOW_CLOSED_SIGNAL,
	PLANK_MATCHER_ACTIVE_APPLICATION_CHANGED_SIGNAL,
	PLANK_MATCHER_APPLICATION_OPENED_SIGNAL,
	PLANK_MATCHER_APPLICATION_CLOSED_SIGNAL,
	PLANK_MATCHER_NUM_SIGNALS
};
static guint plank_matcher_signals[PLANK_MATCHER_NUM_SIGNALS] = {0};

struct _PlankMatcherPrivate {
	GeeHashSet* pending_views;
	BamfMatcher* bamf_matcher;
};

static gint PlankMatcher_private_offset;
static gpointer plank_matcher_parent_class = NULL;
static PlankMatcher* plank_matcher_matcher;
static PlankMatcher* plank_matcher_matcher = NULL;

static void plank_matcher_handle_view_user_visible_changed (PlankMatcher* self,
                                                     BamfView* view,
                                                     gboolean user_visible);
static void _plank_matcher_handle_view_user_visible_changed_bamf_view_user_visible_changed (BamfView* _sender,
                                                                                     gboolean user_visible,
                                                                                     gpointer self);
static void plank_matcher_handle_active_application_changed (PlankMatcher* self,
                                                      BamfApplication* arg1,
                                                      BamfApplication* arg2);
static void _plank_matcher_handle_active_application_changed_bamf_matcher_active_application_changed (BamfMatcher* _sender,
                                                                                               BamfApplication* object,
                                                                                               BamfApplication* p0,
                                                                                               gpointer self);
static void plank_matcher_handle_active_window_changed (PlankMatcher* self,
                                                 BamfWindow* arg1,
                                                 BamfWindow* arg2);
static void _plank_matcher_handle_active_window_changed_bamf_matcher_active_window_changed (BamfMatcher* _sender,
                                                                                     BamfWindow* object,
                                                                                     BamfWindow* p0,
                                                                                     gpointer self);
static void plank_matcher_handle_view_opened (PlankMatcher* self,
                                       BamfView* arg1);
static void _plank_matcher_handle_view_opened_bamf_matcher_view_opened (BamfMatcher* _sender,
                                                                 BamfView* object,
                                                                 gpointer self);
static void plank_matcher_handle_view_closed (PlankMatcher* self,
                                       BamfView* arg1);
static void _plank_matcher_handle_view_closed_bamf_matcher_view_closed (BamfMatcher* _sender,
                                                                 BamfView* object,
                                                                 gpointer self);
static PlankMatcher* plank_matcher_new (void);
static PlankMatcher* plank_matcher_construct (GType object_type);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GObject * plank_matcher_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void plank_matcher_finalize (GObject * obj);
static GType plank_matcher_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
plank_matcher_get_instance_private (PlankMatcher* self)
{
	return G_STRUCT_MEMBER_P (self, PlankMatcher_private_offset);
}

static void
_plank_matcher_handle_view_user_visible_changed_bamf_view_user_visible_changed (BamfView* _sender,
                                                                                gboolean user_visible,
                                                                                gpointer self)
{
#line 65 "../lib/Services/Matcher.vala"
	plank_matcher_handle_view_user_visible_changed ((PlankMatcher*) self, _sender, user_visible);
#line 133 "Matcher.c"
}

static void
_plank_matcher_handle_active_application_changed_bamf_matcher_active_application_changed (BamfMatcher* _sender,
                                                                                          BamfApplication* object,
                                                                                          BamfApplication* p0,
                                                                                          gpointer self)
{
#line 67 "../lib/Services/Matcher.vala"
	plank_matcher_handle_active_application_changed ((PlankMatcher*) self, object, p0);
#line 144 "Matcher.c"
}

static void
_plank_matcher_handle_active_window_changed_bamf_matcher_active_window_changed (BamfMatcher* _sender,
                                                                                BamfWindow* object,
                                                                                BamfWindow* p0,
                                                                                gpointer self)
{
#line 68 "../lib/Services/Matcher.vala"
	plank_matcher_handle_active_window_changed ((PlankMatcher*) self, object, p0);
#line 155 "Matcher.c"
}

static void
_plank_matcher_handle_view_opened_bamf_matcher_view_opened (BamfMatcher* _sender,
                                                            BamfView* object,
                                                            gpointer self)
{
#line 69 "../lib/Services/Matcher.vala"
	plank_matcher_handle_view_opened ((PlankMatcher*) self, object);
#line 165 "Matcher.c"
}

static void
_plank_matcher_handle_view_closed_bamf_matcher_view_closed (BamfMatcher* _sender,
                                                            BamfView* object,
                                                            gpointer self)
{
#line 70 "../lib/Services/Matcher.vala"
	plank_matcher_handle_view_closed ((PlankMatcher*) self, object);
#line 175 "Matcher.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../lib/Services/Matcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 183 "Matcher.c"
}

PlankMatcher*
plank_matcher_get_default (void)
{
	PlankMatcher* _tmp0_;
	PlankMatcher* _tmp2_;
	PlankMatcher* _tmp3_;
	PlankMatcher* result;
#line 39 "../lib/Services/Matcher.vala"
	_tmp0_ = plank_matcher_matcher;
#line 39 "../lib/Services/Matcher.vala"
	if (_tmp0_ == NULL) {
#line 197 "Matcher.c"
		PlankMatcher* _tmp1_;
#line 40 "../lib/Services/Matcher.vala"
		_tmp1_ = plank_matcher_new ();
#line 40 "../lib/Services/Matcher.vala"
		_g_object_unref0 (plank_matcher_matcher);
#line 40 "../lib/Services/Matcher.vala"
		plank_matcher_matcher = _tmp1_;
#line 205 "Matcher.c"
	}
#line 41 "../lib/Services/Matcher.vala"
	_tmp2_ = plank_matcher_matcher;
#line 41 "../lib/Services/Matcher.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 41 "../lib/Services/Matcher.vala"
	result = _tmp3_;
#line 41 "../lib/Services/Matcher.vala"
	return result;
#line 215 "Matcher.c"
}

static PlankMatcher*
plank_matcher_construct (GType object_type)
{
	PlankMatcher * self = NULL;
#line 47 "../lib/Services/Matcher.vala"
	self = (PlankMatcher*) g_object_new (object_type, NULL);
#line 47 "../lib/Services/Matcher.vala"
	return self;
#line 226 "Matcher.c"
}

static PlankMatcher*
plank_matcher_new (void)
{
#line 47 "../lib/Services/Matcher.vala"
	return plank_matcher_construct (PLANK_TYPE_MATCHER);
#line 234 "Matcher.c"
}

static void
plank_matcher_handle_active_application_changed (PlankMatcher* self,
                                                 BamfApplication* arg1,
                                                 BamfApplication* arg2)
{
#line 74 "../lib/Services/Matcher.vala"
	g_return_if_fail (self != NULL);
#line 76 "../lib/Services/Matcher.vala"
	g_signal_emit (self, plank_matcher_signals[PLANK_MATCHER_ACTIVE_APPLICATION_CHANGED_SIGNAL], 0, arg1, arg2);
#line 246 "Matcher.c"
}

static void
plank_matcher_handle_active_window_changed (PlankMatcher* self,
                                            BamfWindow* arg1,
                                            BamfWindow* arg2)
{
#line 79 "../lib/Services/Matcher.vala"
	g_return_if_fail (self != NULL);
#line 81 "../lib/Services/Matcher.vala"
	g_signal_emit (self, plank_matcher_signals[PLANK_MATCHER_ACTIVE_WINDOW_CHANGED_SIGNAL], 0, arg1, arg2);
#line 258 "Matcher.c"
}

static void
plank_matcher_handle_view_user_visible_changed (PlankMatcher* self,
                                                BamfView* view,
                                                gboolean user_visible)
{
#line 84 "../lib/Services/Matcher.vala"
	g_return_if_fail (self != NULL);
#line 84 "../lib/Services/Matcher.vala"
	g_return_if_fail (view != NULL);
#line 86 "../lib/Services/Matcher.vala"
	if (!user_visible) {
#line 87 "../lib/Services/Matcher.vala"
		return;
#line 274 "Matcher.c"
	}
#line 89 "../lib/Services/Matcher.vala"
	plank_matcher_handle_view_opened (self, view);
#line 278 "Matcher.c"
}

static void
plank_matcher_handle_view_opened (PlankMatcher* self,
                                  BamfView* arg1)
{
	gboolean _tmp0_ = FALSE;
#line 92 "../lib/Services/Matcher.vala"
	g_return_if_fail (self != NULL);
#line 92 "../lib/Services/Matcher.vala"
	g_return_if_fail (arg1 != NULL);
#line 94 "../lib/Services/Matcher.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (arg1, bamf_application_get_type ())) {
#line 94 "../lib/Services/Matcher.vala"
		_tmp0_ = !bamf_view_is_user_visible (arg1);
#line 294 "Matcher.c"
	} else {
#line 94 "../lib/Services/Matcher.vala"
		_tmp0_ = FALSE;
#line 298 "Matcher.c"
	}
#line 94 "../lib/Services/Matcher.vala"
	if (_tmp0_) {
#line 302 "Matcher.c"
		GeeHashSet* _tmp1_;
#line 95 "../lib/Services/Matcher.vala"
		_tmp1_ = self->priv->pending_views;
#line 95 "../lib/Services/Matcher.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, arg1);
#line 96 "../lib/Services/Matcher.vala"
		g_signal_connect_object (arg1, "user-visible-changed", (GCallback) _plank_matcher_handle_view_user_visible_changed_bamf_view_user_visible_changed, self, G_CONNECT_AFTER);
#line 97 "../lib/Services/Matcher.vala"
		return;
#line 312 "Matcher.c"
	}
#line 100 "../lib/Services/Matcher.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (arg1, bamf_window_get_type ())) {
#line 101 "../lib/Services/Matcher.vala"
		g_signal_emit (self, plank_matcher_signals[PLANK_MATCHER_WINDOW_OPENED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (arg1, bamf_window_get_type (), BamfWindow));
#line 318 "Matcher.c"
	} else {
#line 102 "../lib/Services/Matcher.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (arg1, bamf_application_get_type ())) {
#line 103 "../lib/Services/Matcher.vala"
			g_signal_emit (self, plank_matcher_signals[PLANK_MATCHER_APPLICATION_OPENED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (arg1, bamf_application_get_type (), BamfApplication));
#line 324 "Matcher.c"
		}
	}
}

static void
plank_matcher_handle_view_closed (PlankMatcher* self,
                                  BamfView* arg1)
{
	GeeHashSet* _tmp0_;
#line 106 "../lib/Services/Matcher.vala"
	g_return_if_fail (self != NULL);
#line 106 "../lib/Services/Matcher.vala"
	g_return_if_fail (arg1 != NULL);
#line 108 "../lib/Services/Matcher.vala"
	_tmp0_ = self->priv->pending_views;
#line 108 "../lib/Services/Matcher.vala"
	if (gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, arg1)) {
#line 342 "Matcher.c"
		guint _tmp1_;
#line 109 "../lib/Services/Matcher.vala"
		g_signal_parse_name ("user-visible-changed", bamf_view_get_type (), &_tmp1_, NULL, FALSE);
#line 109 "../lib/Services/Matcher.vala"
		g_signal_handlers_disconnect_matched (arg1, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _plank_matcher_handle_view_user_visible_changed_bamf_view_user_visible_changed, self);
#line 110 "../lib/Services/Matcher.vala"
		return;
#line 350 "Matcher.c"
	}
#line 113 "../lib/Services/Matcher.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (arg1, bamf_window_get_type ())) {
#line 114 "../lib/Services/Matcher.vala"
		g_signal_emit (self, plank_matcher_signals[PLANK_MATCHER_WINDOW_CLOSED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (arg1, bamf_window_get_type (), BamfWindow));
#line 356 "Matcher.c"
	} else {
#line 115 "../lib/Services/Matcher.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (arg1, bamf_application_get_type ())) {
#line 116 "../lib/Services/Matcher.vala"
			g_signal_emit (self, plank_matcher_signals[PLANK_MATCHER_APPLICATION_CLOSED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (arg1, bamf_application_get_type (), BamfApplication));
#line 362 "Matcher.c"
		}
	}
}

GeeArrayList*
plank_matcher_active_launchers (PlankMatcher* self)
{
	GList* apps = NULL;
	BamfMatcher* _tmp0_;
	GList* _tmp1_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	GeeArrayList* result;
#line 119 "../lib/Services/Matcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 121 "../lib/Services/Matcher.vala"
	_tmp0_ = self->priv->bamf_matcher;
#line 121 "../lib/Services/Matcher.vala"
	_tmp1_ = bamf_matcher_get_running_applications (_tmp0_);
#line 121 "../lib/Services/Matcher.vala"
	apps = _tmp1_;
#line 122 "../lib/Services/Matcher.vala"
	_tmp2_ = gee_array_list_new (bamf_application_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 122 "../lib/Services/Matcher.vala"
	list = _tmp2_;
#line 124 "../lib/Services/Matcher.vala"
	_tmp3_ = apps;
#line 124 "../lib/Services/Matcher.vala"
	g_warn_if_fail (_tmp3_ != NULL);
#line 125 "../lib/Services/Matcher.vala"
	_tmp4_ = apps;
#line 125 "../lib/Services/Matcher.vala"
	if (_tmp4_ == NULL) {
#line 126 "../lib/Services/Matcher.vala"
		result = list;
#line 126 "../lib/Services/Matcher.vala"
		(apps == NULL) ? NULL : (apps = (g_list_free (apps), NULL));
#line 126 "../lib/Services/Matcher.vala"
		return result;
#line 405 "Matcher.c"
	}
#line 128 "../lib/Services/Matcher.vala"
	_tmp5_ = apps;
#line 409 "Matcher.c"
	{
		GList* app_collection = NULL;
		GList* app_it = NULL;
#line 128 "../lib/Services/Matcher.vala"
		app_collection = _tmp5_;
#line 128 "../lib/Services/Matcher.vala"
		for (app_it = app_collection; app_it != NULL; app_it = app_it->next) {
#line 417 "Matcher.c"
			BamfApplication* app = NULL;
#line 128 "../lib/Services/Matcher.vala"
			app = (BamfApplication*) app_it->data;
#line 421 "Matcher.c"
			{
				GeeArrayList* _tmp6_;
				BamfApplication* _tmp7_;
#line 129 "../lib/Services/Matcher.vala"
				_tmp6_ = list;
#line 129 "../lib/Services/Matcher.vala"
				_tmp7_ = app;
#line 129 "../lib/Services/Matcher.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 431 "Matcher.c"
			}
		}
	}
#line 131 "../lib/Services/Matcher.vala"
	result = list;
#line 131 "../lib/Services/Matcher.vala"
	(apps == NULL) ? NULL : (apps = (g_list_free (apps), NULL));
#line 131 "../lib/Services/Matcher.vala"
	return result;
#line 441 "Matcher.c"
}

BamfApplication*
plank_matcher_app_for_uri (PlankMatcher* self,
                           const gchar* uri)
{
	gchar* launcher = NULL;
	BamfApplication* app = NULL;
	BamfMatcher* _tmp5_;
	const gchar* _tmp6_;
	BamfApplication* _tmp7_;
	BamfApplication* _tmp8_;
	BamfApplication* _tmp9_;
	BamfApplication* _tmp10_;
	GError* _inner_error0_ = NULL;
	BamfApplication* result;
#line 134 "../lib/Services/Matcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 134 "../lib/Services/Matcher.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 462 "Matcher.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 138 "../lib/Services/Matcher.vala"
		_tmp1_ = g_filename_from_uri (uri, NULL, &_inner_error0_);
#line 138 "../lib/Services/Matcher.vala"
		_tmp0_ = _tmp1_;
#line 138 "../lib/Services/Matcher.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../lib/Services/Matcher.vala"
			if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 475 "Matcher.c"
				goto __catch0_g_convert_error;
			}
#line 138 "../lib/Services/Matcher.vala"
			_g_free0 (launcher);
#line 138 "../lib/Services/Matcher.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 138 "../lib/Services/Matcher.vala"
			g_clear_error (&_inner_error0_);
#line 138 "../lib/Services/Matcher.vala"
			return NULL;
#line 486 "Matcher.c"
		}
#line 138 "../lib/Services/Matcher.vala"
		_tmp2_ = _tmp0_;
#line 138 "../lib/Services/Matcher.vala"
		_tmp0_ = NULL;
#line 138 "../lib/Services/Matcher.vala"
		_g_free0 (launcher);
#line 138 "../lib/Services/Matcher.vala"
		launcher = _tmp2_;
#line 137 "../lib/Services/Matcher.vala"
		_g_free0 (_tmp0_);
#line 498 "Matcher.c"
	}
	goto __finally0;
	__catch0_g_convert_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 137 "../lib/Services/Matcher.vala"
		e = _inner_error0_;
#line 137 "../lib/Services/Matcher.vala"
		_inner_error0_ = NULL;
#line 140 "../lib/Services/Matcher.vala"
		_tmp3_ = e;
#line 140 "../lib/Services/Matcher.vala"
		_tmp4_ = _tmp3_->message;
#line 140 "../lib/Services/Matcher.vala"
		g_warning ("Matcher.vala:140: %s", _tmp4_);
#line 141 "../lib/Services/Matcher.vala"
		result = NULL;
#line 141 "../lib/Services/Matcher.vala"
		_g_error_free0 (e);
#line 141 "../lib/Services/Matcher.vala"
		_g_free0 (launcher);
#line 141 "../lib/Services/Matcher.vala"
		return result;
#line 524 "Matcher.c"
	}
	__finally0:
#line 137 "../lib/Services/Matcher.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 137 "../lib/Services/Matcher.vala"
		_g_free0 (launcher);
#line 137 "../lib/Services/Matcher.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 137 "../lib/Services/Matcher.vala"
		g_clear_error (&_inner_error0_);
#line 137 "../lib/Services/Matcher.vala"
		return NULL;
#line 537 "Matcher.c"
	}
#line 144 "../lib/Services/Matcher.vala"
	_tmp5_ = self->priv->bamf_matcher;
#line 144 "../lib/Services/Matcher.vala"
	_tmp6_ = launcher;
#line 144 "../lib/Services/Matcher.vala"
	_tmp7_ = bamf_matcher_get_application_for_desktop_file (_tmp5_, _tmp6_, FALSE);
#line 144 "../lib/Services/Matcher.vala"
	app = _tmp7_;
#line 146 "../lib/Services/Matcher.vala"
	_tmp8_ = app;
#line 146 "../lib/Services/Matcher.vala"
	g_warn_if_fail (_tmp8_ != NULL);
#line 148 "../lib/Services/Matcher.vala"
	_tmp9_ = app;
#line 148 "../lib/Services/Matcher.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 148 "../lib/Services/Matcher.vala"
	result = _tmp10_;
#line 148 "../lib/Services/Matcher.vala"
	_g_free0 (launcher);
#line 148 "../lib/Services/Matcher.vala"
	return result;
#line 561 "Matcher.c"
}

void
plank_matcher_set_favorites (PlankMatcher* self,
                             GeeArrayList* favs)
{
	gchar** paths = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar** _tmp2_;
	gint paths_length1;
	gint _paths_size_;
	BamfMatcher* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
#line 151 "../lib/Services/Matcher.vala"
	g_return_if_fail (self != NULL);
#line 151 "../lib/Services/Matcher.vala"
	g_return_if_fail (favs != NULL);
#line 153 "../lib/Services/Matcher.vala"
	_tmp0_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) favs);
#line 153 "../lib/Services/Matcher.vala"
	_tmp1_ = _tmp0_;
#line 153 "../lib/Services/Matcher.vala"
	_tmp2_ = g_new0 (gchar*, _tmp1_ + 1);
#line 153 "../lib/Services/Matcher.vala"
	paths = _tmp2_;
#line 153 "../lib/Services/Matcher.vala"
	paths_length1 = _tmp1_;
#line 153 "../lib/Services/Matcher.vala"
	_paths_size_ = paths_length1;
#line 593 "Matcher.c"
	{
		gint i = 0;
#line 155 "../lib/Services/Matcher.vala"
		i = 0;
#line 598 "Matcher.c"
		{
			gboolean _tmp3_ = FALSE;
#line 155 "../lib/Services/Matcher.vala"
			_tmp3_ = TRUE;
#line 155 "../lib/Services/Matcher.vala"
			while (TRUE) {
#line 605 "Matcher.c"
				gint _tmp5_;
				gint _tmp6_;
				gchar** _tmp7_;
				gint _tmp7__length1;
				gpointer _tmp8_;
#line 155 "../lib/Services/Matcher.vala"
				if (!_tmp3_) {
#line 613 "Matcher.c"
					gint _tmp4_;
#line 155 "../lib/Services/Matcher.vala"
					_tmp4_ = i;
#line 155 "../lib/Services/Matcher.vala"
					i = _tmp4_ + 1;
#line 619 "Matcher.c"
				}
#line 155 "../lib/Services/Matcher.vala"
				_tmp3_ = FALSE;
#line 155 "../lib/Services/Matcher.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) favs);
#line 155 "../lib/Services/Matcher.vala"
				_tmp6_ = _tmp5_;
#line 155 "../lib/Services/Matcher.vala"
				if (!(i < _tmp6_)) {
#line 155 "../lib/Services/Matcher.vala"
					break;
#line 631 "Matcher.c"
				}
#line 156 "../lib/Services/Matcher.vala"
				_tmp7_ = paths;
#line 156 "../lib/Services/Matcher.vala"
				_tmp7__length1 = paths_length1;
#line 156 "../lib/Services/Matcher.vala"
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) favs, i);
#line 156 "../lib/Services/Matcher.vala"
				_g_free0 (_tmp7_[i]);
#line 156 "../lib/Services/Matcher.vala"
				_tmp7_[i] = (gchar*) _tmp8_;
#line 643 "Matcher.c"
			}
		}
	}
#line 158 "../lib/Services/Matcher.vala"
	_tmp9_ = self->priv->bamf_matcher;
#line 158 "../lib/Services/Matcher.vala"
	_tmp10_ = paths;
#line 158 "../lib/Services/Matcher.vala"
	_tmp10__length1 = paths_length1;
#line 158 "../lib/Services/Matcher.vala"
	bamf_matcher_register_favorites (_tmp9_, _tmp10_);
#line 151 "../lib/Services/Matcher.vala"
	paths = (_vala_array_free (paths, paths_length1, (GDestroyNotify) g_free), NULL);
#line 657 "Matcher.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 25 "../lib/Services/Matcher.vala"
	g_return_if_fail (n_param_values == 3);
#line 25 "../lib/Services/Matcher.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 25 "../lib/Services/Matcher.vala"
		data1 = closure->data;
#line 25 "../lib/Services/Matcher.vala"
		data2 = param_values->data[0].v_pointer;
#line 682 "Matcher.c"
	} else {
#line 25 "../lib/Services/Matcher.vala"
		data1 = param_values->data[0].v_pointer;
#line 25 "../lib/Services/Matcher.vala"
		data2 = closure->data;
#line 688 "Matcher.c"
	}
#line 25 "../lib/Services/Matcher.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 25 "../lib/Services/Matcher.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 694 "Matcher.c"
}

static GObject *
plank_matcher_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankMatcher * self;
	BamfMatcher* _tmp0_;
	BamfMatcher* _tmp1_;
	BamfMatcher* _tmp2_;
	BamfMatcher* _tmp3_;
	BamfMatcher* _tmp4_;
	GeeHashSet* _tmp5_;
#line 51 "../lib/Services/Matcher.vala"
	parent_class = G_OBJECT_CLASS (plank_matcher_parent_class);
#line 51 "../lib/Services/Matcher.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../lib/Services/Matcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_MATCHER, PlankMatcher);
#line 53 "../lib/Services/Matcher.vala"
	_tmp0_ = bamf_matcher_get_default ();
#line 53 "../lib/Services/Matcher.vala"
	_g_object_unref0 (self->priv->bamf_matcher);
#line 53 "../lib/Services/Matcher.vala"
	self->priv->bamf_matcher = _tmp0_;
#line 54 "../lib/Services/Matcher.vala"
	_tmp1_ = self->priv->bamf_matcher;
#line 54 "../lib/Services/Matcher.vala"
	g_signal_connect_object (_tmp1_, "active-application-changed", (GCallback) _plank_matcher_handle_active_application_changed_bamf_matcher_active_application_changed, self, G_CONNECT_AFTER);
#line 55 "../lib/Services/Matcher.vala"
	_tmp2_ = self->priv->bamf_matcher;
#line 55 "../lib/Services/Matcher.vala"
	g_signal_connect_object (_tmp2_, "active-window-changed", (GCallback) _plank_matcher_handle_active_window_changed_bamf_matcher_active_window_changed, self, G_CONNECT_AFTER);
#line 56 "../lib/Services/Matcher.vala"
	_tmp3_ = self->priv->bamf_matcher;
#line 56 "../lib/Services/Matcher.vala"
	g_signal_connect_object (_tmp3_, "view-opened", (GCallback) _plank_matcher_handle_view_opened_bamf_matcher_view_opened, self, G_CONNECT_AFTER);
#line 57 "../lib/Services/Matcher.vala"
	_tmp4_ = self->priv->bamf_matcher;
#line 57 "../lib/Services/Matcher.vala"
	g_signal_connect_object (_tmp4_, "view-closed", (GCallback) _plank_matcher_handle_view_closed_bamf_matcher_view_closed, self, G_CONNECT_AFTER);
#line 59 "../lib/Services/Matcher.vala"
	_tmp5_ = gee_hash_set_new (bamf_view_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 59 "../lib/Services/Matcher.vala"
	_g_object_unref0 (self->priv->pending_views);
#line 59 "../lib/Services/Matcher.vala"
	self->priv->pending_views = _tmp5_;
#line 51 "../lib/Services/Matcher.vala"
	return obj;
#line 747 "Matcher.c"
}

static void
plank_matcher_class_init (PlankMatcherClass * klass,
                          gpointer klass_data)
{
#line 25 "../lib/Services/Matcher.vala"
	plank_matcher_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Services/Matcher.vala"
	g_type_class_adjust_private_offset (klass, &PlankMatcher_private_offset);
#line 25 "../lib/Services/Matcher.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_matcher_constructor;
#line 25 "../lib/Services/Matcher.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_matcher_finalize;
#line 25 "../lib/Services/Matcher.vala"
	plank_matcher_signals[PLANK_MATCHER_ACTIVE_WINDOW_CHANGED_SIGNAL] = g_signal_new ("active-window-changed", PLANK_TYPE_MATCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, bamf_window_get_type (), bamf_window_get_type ());
#line 25 "../lib/Services/Matcher.vala"
	plank_matcher_signals[PLANK_MATCHER_WINDOW_OPENED_SIGNAL] = g_signal_new ("window-opened", PLANK_TYPE_MATCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, bamf_window_get_type ());
#line 25 "../lib/Services/Matcher.vala"
	plank_matcher_signals[PLANK_MATCHER_WINDOW_CLOSED_SIGNAL] = g_signal_new ("window-closed", PLANK_TYPE_MATCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, bamf_window_get_type ());
#line 25 "../lib/Services/Matcher.vala"
	plank_matcher_signals[PLANK_MATCHER_ACTIVE_APPLICATION_CHANGED_SIGNAL] = g_signal_new ("active-application-changed", PLANK_TYPE_MATCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, bamf_application_get_type (), bamf_application_get_type ());
#line 25 "../lib/Services/Matcher.vala"
	plank_matcher_signals[PLANK_MATCHER_APPLICATION_OPENED_SIGNAL] = g_signal_new ("application-opened", PLANK_TYPE_MATCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, bamf_application_get_type ());
#line 25 "../lib/Services/Matcher.vala"
	plank_matcher_signals[PLANK_MATCHER_APPLICATION_CLOSED_SIGNAL] = g_signal_new ("application-closed", PLANK_TYPE_MATCHER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, bamf_application_get_type ());
#line 774 "Matcher.c"
}

static void
plank_matcher_instance_init (PlankMatcher * self,
                             gpointer klass)
{
#line 25 "../lib/Services/Matcher.vala"
	self->priv = plank_matcher_get_instance_private (self);
#line 783 "Matcher.c"
}

static void
plank_matcher_finalize (GObject * obj)
{
	PlankMatcher * self;
	BamfMatcher* _tmp7_;
	guint _tmp8_;
	BamfMatcher* _tmp9_;
	guint _tmp10_;
	BamfMatcher* _tmp11_;
	guint _tmp12_;
	BamfMatcher* _tmp13_;
	guint _tmp14_;
#line 25 "../lib/Services/Matcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_MATCHER, PlankMatcher);
#line 800 "Matcher.c"
	{
		GeeIterator* _view_it = NULL;
		GeeHashSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 64 "../lib/Services/Matcher.vala"
		_tmp0_ = self->priv->pending_views;
#line 64 "../lib/Services/Matcher.vala"
		_tmp1_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp0_);
#line 64 "../lib/Services/Matcher.vala"
		_view_it = _tmp1_;
#line 64 "../lib/Services/Matcher.vala"
		while (TRUE) {
#line 813 "Matcher.c"
			GeeIterator* _tmp2_;
			BamfView* view = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			BamfView* _tmp5_;
			guint _tmp6_;
#line 64 "../lib/Services/Matcher.vala"
			_tmp2_ = _view_it;
#line 64 "../lib/Services/Matcher.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 64 "../lib/Services/Matcher.vala"
				break;
#line 826 "Matcher.c"
			}
#line 64 "../lib/Services/Matcher.vala"
			_tmp3_ = _view_it;
#line 64 "../lib/Services/Matcher.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 64 "../lib/Services/Matcher.vala"
			view = (BamfView*) _tmp4_;
#line 65 "../lib/Services/Matcher.vala"
			_tmp5_ = view;
#line 65 "../lib/Services/Matcher.vala"
			g_signal_parse_name ("user-visible-changed", bamf_view_get_type (), &_tmp6_, NULL, FALSE);
#line 65 "../lib/Services/Matcher.vala"
			g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _plank_matcher_handle_view_user_visible_changed_bamf_view_user_visible_changed, self);
#line 64 "../lib/Services/Matcher.vala"
			_g_object_unref0 (view);
#line 842 "Matcher.c"
		}
#line 64 "../lib/Services/Matcher.vala"
		_g_object_unref0 (_view_it);
#line 846 "Matcher.c"
	}
#line 67 "../lib/Services/Matcher.vala"
	_tmp7_ = self->priv->bamf_matcher;
#line 67 "../lib/Services/Matcher.vala"
	g_signal_parse_name ("active-application-changed", bamf_matcher_get_type (), &_tmp8_, NULL, FALSE);
#line 67 "../lib/Services/Matcher.vala"
	g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _plank_matcher_handle_active_application_changed_bamf_matcher_active_application_changed, self);
#line 68 "../lib/Services/Matcher.vala"
	_tmp9_ = self->priv->bamf_matcher;
#line 68 "../lib/Services/Matcher.vala"
	g_signal_parse_name ("active-window-changed", bamf_matcher_get_type (), &_tmp10_, NULL, FALSE);
#line 68 "../lib/Services/Matcher.vala"
	g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _plank_matcher_handle_active_window_changed_bamf_matcher_active_window_changed, self);
#line 69 "../lib/Services/Matcher.vala"
	_tmp11_ = self->priv->bamf_matcher;
#line 69 "../lib/Services/Matcher.vala"
	g_signal_parse_name ("view-opened", bamf_matcher_get_type (), &_tmp12_, NULL, FALSE);
#line 69 "../lib/Services/Matcher.vala"
	g_signal_handlers_disconnect_matched (_tmp11_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _plank_matcher_handle_view_opened_bamf_matcher_view_opened, self);
#line 70 "../lib/Services/Matcher.vala"
	_tmp13_ = self->priv->bamf_matcher;
#line 70 "../lib/Services/Matcher.vala"
	g_signal_parse_name ("view-closed", bamf_matcher_get_type (), &_tmp14_, NULL, FALSE);
#line 70 "../lib/Services/Matcher.vala"
	g_signal_handlers_disconnect_matched (_tmp13_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _plank_matcher_handle_view_closed_bamf_matcher_view_closed, self);
#line 71 "../lib/Services/Matcher.vala"
	_g_object_unref0 (self->priv->bamf_matcher);
#line 71 "../lib/Services/Matcher.vala"
	self->priv->bamf_matcher = NULL;
#line 44 "../lib/Services/Matcher.vala"
	_g_object_unref0 (self->priv->pending_views);
#line 45 "../lib/Services/Matcher.vala"
	_g_object_unref0 (self->priv->bamf_matcher);
#line 25 "../lib/Services/Matcher.vala"
	G_OBJECT_CLASS (plank_matcher_parent_class)->finalize (obj);
#line 882 "Matcher.c"
}

/**
 * Wrapper for Bamf.Matcher
 */
static GType
plank_matcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankMatcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_matcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankMatcher), 0, (GInstanceInitFunc) plank_matcher_instance_init, NULL };
	GType plank_matcher_type_id;
	plank_matcher_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankMatcher", &g_define_type_info, 0);
	PlankMatcher_private_offset = g_type_add_instance_private (plank_matcher_type_id, sizeof (PlankMatcherPrivate));
	return plank_matcher_type_id;
}

GType
plank_matcher_get_type (void)
{
	static volatile gsize plank_matcher_type_id__once = 0;
	if (g_once_init_enter (&plank_matcher_type_id__once)) {
		GType plank_matcher_type_id;
		plank_matcher_type_id = plank_matcher_get_type_once ();
		g_once_init_leave (&plank_matcher_type_id__once, plank_matcher_type_id);
	}
	return plank_matcher_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

