/* WindowControl.c generated by valac 0.56.18, the Vala compiler
 * generated from WindowControl.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank-internal.h"
#include <glib.h>
#include <libwnck/libwnck.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <libbamf/libbamf.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_WINDOW_CONTROL_0_PROPERTY,
	PLANK_WINDOW_CONTROL_NUM_PROPERTIES
};
static GParamSpec* plank_window_control_properties[PLANK_WINDOW_CONTROL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef struct _Block1Data Block1Data;

struct _Block1Data {
	int _ref_count_;
	guint32 event_time;
};

static gpointer plank_window_control_parent_class = NULL;
static guint plank_window_control_delayed_focus_timer_id;
static guint plank_window_control_delayed_focus_timer_id = 0U;
static WnckWindow* plank_window_control_delayed_focus_window;
static WnckWindow* plank_window_control_delayed_focus_window = NULL;

static PlankWindowControl* plank_window_control_new (void);
static PlankWindowControl* plank_window_control_construct (GType object_type);
static void plank_window_control_window_manager_changed (WnckScreen* screen);
static void _plank_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender,
                                                                                      gpointer self);
static void plank_window_control_handle_window_closed (WnckWindow* window);
static void _plank_window_control_handle_window_closed_wnck_screen_window_closed (WnckScreen* _sender,
                                                                           WnckWindow* window,
                                                                           gpointer self);
static void plank_window_control_center_and_focus_window (WnckWindow* w,
                                                   guint32 event_time);
static void plank_window_control_focus_window_by_xid (guint32 xid,
                                               guint32 event_time);
static gint plank_window_control_find_active_xid_index (GArray* xids);
static void plank_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow,
                                                                 GList* additional_windows,
                                                                 guint32 event_time);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean plank_window_control_windows_share_viewport (WnckWindow* first,
                                                      WnckWindow* second);
static gboolean __lambda4_ (Block1Data* _data1_);
static gboolean ___lambda4__gsource_func (gpointer self);
static void plank_window_control_finalize (GObject * obj);
static GType plank_window_control_get_type_once (void);

static GType
plank_struts_get_type_once (void)
{
	static const GEnumValue values[] = {{PLANK_STRUTS_LEFT, "PLANK_STRUTS_LEFT", "left"}, {PLANK_STRUTS_RIGHT, "PLANK_STRUTS_RIGHT", "right"}, {PLANK_STRUTS_TOP, "PLANK_STRUTS_TOP", "top"}, {PLANK_STRUTS_BOTTOM, "PLANK_STRUTS_BOTTOM", "bottom"}, {PLANK_STRUTS_LEFT_START, "PLANK_STRUTS_LEFT_START", "left-start"}, {PLANK_STRUTS_LEFT_END, "PLANK_STRUTS_LEFT_END", "left-end"}, {PLANK_STRUTS_RIGHT_START, "PLANK_STRUTS_RIGHT_START", "right-start"}, {PLANK_STRUTS_RIGHT_END, "PLANK_STRUTS_RIGHT_END", "right-end"}, {PLANK_STRUTS_TOP_START, "PLANK_STRUTS_TOP_START", "top-start"}, {PLANK_STRUTS_TOP_END, "PLANK_STRUTS_TOP_END", "top-end"}, {PLANK_STRUTS_BOTTOM_START, "PLANK_STRUTS_BOTTOM_START", "bottom-start"}, {PLANK_STRUTS_BOTTOM_END, "PLANK_STRUTS_BOTTOM_END", "bottom-end"}, {PLANK_STRUTS_N_VALUES, "PLANK_STRUTS_N_VALUES", "n-values"}, {0, NULL, NULL}};
	GType plank_struts_type_id;
	plank_struts_type_id = g_enum_register_static ("PlankStruts", values);
	return plank_struts_type_id;
}

GType
plank_struts_get_type (void)
{
	static volatile gsize plank_struts_type_id__once = 0;
	if (g_once_init_enter (&plank_struts_type_id__once)) {
		GType plank_struts_type_id;
		plank_struts_type_id = plank_struts_get_type_once ();
		g_once_init_leave (&plank_struts_type_id__once, plank_struts_type_id);
	}
	return plank_struts_type_id__once;
}

static PlankWindowControl*
plank_window_control_construct (GType object_type)
{
	PlankWindowControl * self = NULL;
#line 49 "../lib/Services/WindowControl.vala"
	self = (PlankWindowControl*) g_object_new (object_type, NULL);
#line 49 "../lib/Services/WindowControl.vala"
	return self;
#line 120 "WindowControl.c"
}

static PlankWindowControl*
plank_window_control_new (void)
{
#line 49 "../lib/Services/WindowControl.vala"
	return plank_window_control_construct (PLANK_TYPE_WINDOW_CONTROL);
#line 128 "WindowControl.c"
}

static void
_plank_window_control_window_manager_changed_wnck_screen_window_manager_changed (WnckScreen* _sender,
                                                                                 gpointer self)
{
#line 65 "../lib/Services/WindowControl.vala"
	plank_window_control_window_manager_changed (_sender);
#line 137 "WindowControl.c"
}

static void
_plank_window_control_handle_window_closed_wnck_screen_window_closed (WnckScreen* _sender,
                                                                      WnckWindow* window,
                                                                      gpointer self)
{
#line 66 "../lib/Services/WindowControl.vala"
	plank_window_control_handle_window_closed (window);
#line 147 "WindowControl.c"
}

void
plank_window_control_initialize (void)
{
	WnckScreen* screen = NULL;
	WnckScreen* _tmp0_;
	WnckScreen* _tmp1_;
	WnckScreen* _tmp2_;
	WnckScreen* _tmp3_;
	WnckScreen* _tmp4_;
	const gchar* _tmp5_;
#line 55 "../lib/Services/WindowControl.vala"
	_tmp0_ = wnck_screen_get_default ();
#line 55 "../lib/Services/WindowControl.vala"
	screen = _tmp0_;
#line 57 "../lib/Services/WindowControl.vala"
	wnck_set_client_type (WNCK_CLIENT_TYPE_PAGER);
#line 60 "../lib/Services/WindowControl.vala"
	gdk_error_trap_push ();
#line 61 "../lib/Services/WindowControl.vala"
	_tmp1_ = screen;
#line 61 "../lib/Services/WindowControl.vala"
	wnck_screen_force_update (_tmp1_);
#line 62 "../lib/Services/WindowControl.vala"
	if (gdk_error_trap_pop () != 0) {
#line 63 "../lib/Services/WindowControl.vala"
		g_critical ("WindowControl.vala:63: Wnck.Screen.force_update() caused a XError");
#line 176 "WindowControl.c"
	}
#line 65 "../lib/Services/WindowControl.vala"
	_tmp2_ = screen;
#line 65 "../lib/Services/WindowControl.vala"
	g_signal_connect_after (_tmp2_, "window-manager-changed", (GCallback) _plank_window_control_window_manager_changed_wnck_screen_window_manager_changed, NULL);
#line 66 "../lib/Services/WindowControl.vala"
	_tmp3_ = screen;
#line 66 "../lib/Services/WindowControl.vala"
	g_signal_connect_after (_tmp3_, "window-closed", (GCallback) _plank_window_control_handle_window_closed_wnck_screen_window_closed, NULL);
#line 68 "../lib/Services/WindowControl.vala"
	_tmp4_ = screen;
#line 68 "../lib/Services/WindowControl.vala"
	_tmp5_ = wnck_screen_get_window_manager_name (_tmp4_);
#line 68 "../lib/Services/WindowControl.vala"
	g_message ("WindowControl.vala:68: Window-manager: %s", _tmp5_);
#line 192 "WindowControl.c"
}

static void
plank_window_control_window_manager_changed (WnckScreen* screen)
{
	const gchar* _tmp0_;
#line 71 "../lib/Services/WindowControl.vala"
	g_return_if_fail (screen != NULL);
#line 74 "../lib/Services/WindowControl.vala"
	gdk_error_trap_push ();
#line 75 "../lib/Services/WindowControl.vala"
	wnck_screen_force_update (screen);
#line 76 "../lib/Services/WindowControl.vala"
	if (gdk_error_trap_pop () != 0) {
#line 77 "../lib/Services/WindowControl.vala"
		g_critical ("WindowControl.vala:77: Wnck.Screen.force_update() caused a XError");
#line 209 "WindowControl.c"
	}
#line 79 "../lib/Services/WindowControl.vala"
	_tmp0_ = wnck_screen_get_window_manager_name (screen);
#line 79 "../lib/Services/WindowControl.vala"
	g_warning ("WindowControl.vala:79: Window-manager changed: %s", _tmp0_);
#line 215 "WindowControl.c"
}

static void
plank_window_control_handle_window_closed (WnckWindow* window)
{
	gboolean _tmp0_ = FALSE;
#line 82 "../lib/Services/WindowControl.vala"
	g_return_if_fail (window != NULL);
#line 84 "../lib/Services/WindowControl.vala"
	if (plank_window_control_delayed_focus_timer_id > 0U) {
#line 226 "WindowControl.c"
		WnckWindow* _tmp1_;
#line 84 "../lib/Services/WindowControl.vala"
		_tmp1_ = plank_window_control_delayed_focus_window;
#line 84 "../lib/Services/WindowControl.vala"
		_tmp0_ = _tmp1_ == window;
#line 232 "WindowControl.c"
	} else {
#line 84 "../lib/Services/WindowControl.vala"
		_tmp0_ = FALSE;
#line 236 "WindowControl.c"
	}
#line 84 "../lib/Services/WindowControl.vala"
	if (_tmp0_) {
#line 85 "../lib/Services/WindowControl.vala"
		g_source_remove (plank_window_control_delayed_focus_timer_id);
#line 86 "../lib/Services/WindowControl.vala"
		plank_window_control_delayed_focus_timer_id = 0U;
#line 87 "../lib/Services/WindowControl.vala"
		_g_object_unref0 (plank_window_control_delayed_focus_window);
#line 87 "../lib/Services/WindowControl.vala"
		plank_window_control_delayed_focus_window = NULL;
#line 248 "WindowControl.c"
	}
}

GdkPixbuf*
plank_window_control_get_app_icon (BamfApplication* app)
{
	GdkPixbuf* pbuf = NULL;
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	GdkPixbuf* _tmp17_;
	GdkPixbuf* result;
#line 91 "../lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 93 "../lib/Services/WindowControl.vala"
	pbuf = NULL;
#line 95 "../lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 96 "../lib/Services/WindowControl.vala"
	_tmp0_ = bamf_application_get_xids (app);
#line 96 "../lib/Services/WindowControl.vala"
	xids = _tmp0_;
#line 98 "../lib/Services/WindowControl.vala"
	_tmp1_ = xids;
#line 98 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 100 "../lib/Services/WindowControl.vala"
	gdk_error_trap_push ();
#line 277 "WindowControl.c"
	{
		gint i = 0;
#line 102 "../lib/Services/WindowControl.vala"
		i = 0;
#line 282 "WindowControl.c"
		{
			gboolean _tmp2_ = FALSE;
#line 102 "../lib/Services/WindowControl.vala"
			_tmp2_ = TRUE;
#line 102 "../lib/Services/WindowControl.vala"
			while (TRUE) {
#line 289 "WindowControl.c"
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				GArray* _tmp6_;
				WnckWindow* window = NULL;
				GArray* _tmp9_;
				WnckWindow* _tmp10_;
				WnckWindow* _tmp11_;
				WnckWindow* _tmp12_;
				GdkPixbuf* _tmp13_;
				WnckWindow* _tmp14_;
#line 102 "../lib/Services/WindowControl.vala"
				if (!_tmp2_) {
#line 302 "WindowControl.c"
					gint _tmp3_;
#line 102 "../lib/Services/WindowControl.vala"
					_tmp3_ = i;
#line 102 "../lib/Services/WindowControl.vala"
					i = _tmp3_ + 1;
#line 308 "WindowControl.c"
				}
#line 102 "../lib/Services/WindowControl.vala"
				_tmp2_ = FALSE;
#line 102 "../lib/Services/WindowControl.vala"
				_tmp6_ = xids;
#line 102 "../lib/Services/WindowControl.vala"
				if (_tmp6_ != NULL) {
#line 316 "WindowControl.c"
					GArray* _tmp7_;
#line 102 "../lib/Services/WindowControl.vala"
					_tmp7_ = xids;
#line 102 "../lib/Services/WindowControl.vala"
					_tmp5_ = ((guint) i) < _tmp7_->len;
#line 322 "WindowControl.c"
				} else {
#line 102 "../lib/Services/WindowControl.vala"
					_tmp5_ = FALSE;
#line 326 "WindowControl.c"
				}
#line 102 "../lib/Services/WindowControl.vala"
				if (_tmp5_) {
#line 330 "WindowControl.c"
					GdkPixbuf* _tmp8_;
#line 102 "../lib/Services/WindowControl.vala"
					_tmp8_ = pbuf;
#line 102 "../lib/Services/WindowControl.vala"
					_tmp4_ = _tmp8_ == NULL;
#line 336 "WindowControl.c"
				} else {
#line 102 "../lib/Services/WindowControl.vala"
					_tmp4_ = FALSE;
#line 340 "WindowControl.c"
				}
#line 102 "../lib/Services/WindowControl.vala"
				if (!_tmp4_) {
#line 102 "../lib/Services/WindowControl.vala"
					break;
#line 346 "WindowControl.c"
				}
#line 103 "../lib/Services/WindowControl.vala"
				_tmp9_ = xids;
#line 103 "../lib/Services/WindowControl.vala"
				_tmp10_ = wnck_window_get ((gulong) g_array_index (_tmp9_, guint32, (guint) i));
#line 103 "../lib/Services/WindowControl.vala"
				window = _tmp10_;
#line 104 "../lib/Services/WindowControl.vala"
				_tmp11_ = window;
#line 104 "../lib/Services/WindowControl.vala"
				if (_tmp11_ == NULL) {
#line 105 "../lib/Services/WindowControl.vala"
					continue;
#line 360 "WindowControl.c"
				}
#line 107 "../lib/Services/WindowControl.vala"
				_tmp12_ = window;
#line 107 "../lib/Services/WindowControl.vala"
				_tmp13_ = wnck_window_get_icon (_tmp12_);
#line 107 "../lib/Services/WindowControl.vala"
				pbuf = _tmp13_;
#line 108 "../lib/Services/WindowControl.vala"
				_tmp14_ = window;
#line 108 "../lib/Services/WindowControl.vala"
				if (wnck_window_get_icon_is_fallback (_tmp14_)) {
#line 109 "../lib/Services/WindowControl.vala"
					pbuf = NULL;
#line 374 "WindowControl.c"
				}
#line 111 "../lib/Services/WindowControl.vala"
				break;
#line 378 "WindowControl.c"
			}
		}
	}
#line 114 "../lib/Services/WindowControl.vala"
	if (gdk_error_trap_pop () != 0) {
#line 384 "WindowControl.c"
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 115 "../lib/Services/WindowControl.vala"
		_tmp15_ = bamf_view_get_name ((BamfView*) app);
#line 115 "../lib/Services/WindowControl.vala"
		_tmp16_ = _tmp15_;
#line 115 "../lib/Services/WindowControl.vala"
		g_critical ("WindowControl.vala:115: get_app_icon() for '%s' caused a XError", _tmp16_);
#line 115 "../lib/Services/WindowControl.vala"
		_g_free0 (_tmp16_);
#line 395 "WindowControl.c"
	}
#line 117 "../lib/Services/WindowControl.vala"
	_tmp17_ = pbuf;
#line 117 "../lib/Services/WindowControl.vala"
	result = _tmp17_;
#line 117 "../lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 117 "../lib/Services/WindowControl.vala"
	return result;
#line 405 "WindowControl.c"
}

GdkPixbuf*
plank_window_control_get_window_icon (BamfWindow* window)
{
	WnckWindow* w = NULL;
	WnckWindow* _tmp0_;
	GdkPixbuf* pbuf = NULL;
	WnckWindow* _tmp1_;
	WnckWindow* _tmp2_;
	WnckWindow* _tmp3_;
	GdkPixbuf* _tmp4_;
	WnckWindow* _tmp5_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* result;
#line 120 "../lib/Services/WindowControl.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 122 "../lib/Services/WindowControl.vala"
	_tmp0_ = wnck_window_get ((gulong) bamf_window_get_xid (window));
#line 122 "../lib/Services/WindowControl.vala"
	w = _tmp0_;
#line 123 "../lib/Services/WindowControl.vala"
	pbuf = NULL;
#line 125 "../lib/Services/WindowControl.vala"
	_tmp1_ = w;
#line 125 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 127 "../lib/Services/WindowControl.vala"
	_tmp2_ = w;
#line 127 "../lib/Services/WindowControl.vala"
	if (_tmp2_ == NULL) {
#line 128 "../lib/Services/WindowControl.vala"
		result = NULL;
#line 128 "../lib/Services/WindowControl.vala"
		return result;
#line 441 "WindowControl.c"
	}
#line 130 "../lib/Services/WindowControl.vala"
	gdk_error_trap_push ();
#line 132 "../lib/Services/WindowControl.vala"
	_tmp3_ = w;
#line 132 "../lib/Services/WindowControl.vala"
	_tmp4_ = wnck_window_get_icon (_tmp3_);
#line 132 "../lib/Services/WindowControl.vala"
	pbuf = _tmp4_;
#line 133 "../lib/Services/WindowControl.vala"
	_tmp5_ = w;
#line 133 "../lib/Services/WindowControl.vala"
	if (wnck_window_get_icon_is_fallback (_tmp5_)) {
#line 134 "../lib/Services/WindowControl.vala"
		pbuf = NULL;
#line 457 "WindowControl.c"
	}
#line 136 "../lib/Services/WindowControl.vala"
	if (gdk_error_trap_pop () != 0) {
#line 461 "WindowControl.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 137 "../lib/Services/WindowControl.vala"
		_tmp6_ = bamf_view_get_name ((BamfView*) window);
#line 137 "../lib/Services/WindowControl.vala"
		_tmp7_ = _tmp6_;
#line 137 "../lib/Services/WindowControl.vala"
		g_critical ("WindowControl.vala:137: get_window_icon() for '%s' caused a XError", _tmp7_);
#line 137 "../lib/Services/WindowControl.vala"
		_g_free0 (_tmp7_);
#line 472 "WindowControl.c"
	}
#line 139 "../lib/Services/WindowControl.vala"
	_tmp8_ = pbuf;
#line 139 "../lib/Services/WindowControl.vala"
	result = _tmp8_;
#line 139 "../lib/Services/WindowControl.vala"
	return result;
#line 480 "WindowControl.c"
}

gboolean
plank_window_control_has_maximized_window (BamfApplication* app)
{
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	gboolean result;
#line 142 "../lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, FALSE);
#line 144 "../lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 145 "../lib/Services/WindowControl.vala"
	_tmp0_ = bamf_application_get_xids (app);
#line 145 "../lib/Services/WindowControl.vala"
	xids = _tmp0_;
#line 147 "../lib/Services/WindowControl.vala"
	_tmp1_ = xids;
#line 147 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 502 "WindowControl.c"
	{
		gint i = 0;
#line 149 "../lib/Services/WindowControl.vala"
		i = 0;
#line 507 "WindowControl.c"
		{
			gboolean _tmp2_ = FALSE;
#line 149 "../lib/Services/WindowControl.vala"
			_tmp2_ = TRUE;
#line 149 "../lib/Services/WindowControl.vala"
			while (TRUE) {
#line 514 "WindowControl.c"
				gboolean _tmp4_ = FALSE;
				GArray* _tmp5_;
				WnckWindow* window = NULL;
				GArray* _tmp7_;
				WnckWindow* _tmp8_;
				gboolean _tmp9_ = FALSE;
				WnckWindow* _tmp10_;
#line 149 "../lib/Services/WindowControl.vala"
				if (!_tmp2_) {
#line 524 "WindowControl.c"
					gint _tmp3_;
#line 149 "../lib/Services/WindowControl.vala"
					_tmp3_ = i;
#line 149 "../lib/Services/WindowControl.vala"
					i = _tmp3_ + 1;
#line 530 "WindowControl.c"
				}
#line 149 "../lib/Services/WindowControl.vala"
				_tmp2_ = FALSE;
#line 149 "../lib/Services/WindowControl.vala"
				_tmp5_ = xids;
#line 149 "../lib/Services/WindowControl.vala"
				if (_tmp5_ != NULL) {
#line 538 "WindowControl.c"
					GArray* _tmp6_;
#line 149 "../lib/Services/WindowControl.vala"
					_tmp6_ = xids;
#line 149 "../lib/Services/WindowControl.vala"
					_tmp4_ = ((guint) i) < _tmp6_->len;
#line 544 "WindowControl.c"
				} else {
#line 149 "../lib/Services/WindowControl.vala"
					_tmp4_ = FALSE;
#line 548 "WindowControl.c"
				}
#line 149 "../lib/Services/WindowControl.vala"
				if (!_tmp4_) {
#line 149 "../lib/Services/WindowControl.vala"
					break;
#line 554 "WindowControl.c"
				}
#line 150 "../lib/Services/WindowControl.vala"
				_tmp7_ = xids;
#line 150 "../lib/Services/WindowControl.vala"
				_tmp8_ = wnck_window_get ((gulong) g_array_index (_tmp7_, guint32, (guint) i));
#line 150 "../lib/Services/WindowControl.vala"
				window = _tmp8_;
#line 151 "../lib/Services/WindowControl.vala"
				_tmp10_ = window;
#line 151 "../lib/Services/WindowControl.vala"
				if (_tmp10_ != NULL) {
#line 566 "WindowControl.c"
					WnckWindow* _tmp11_;
#line 151 "../lib/Services/WindowControl.vala"
					_tmp11_ = window;
#line 151 "../lib/Services/WindowControl.vala"
					_tmp9_ = wnck_window_is_maximized (_tmp11_);
#line 572 "WindowControl.c"
				} else {
#line 151 "../lib/Services/WindowControl.vala"
					_tmp9_ = FALSE;
#line 576 "WindowControl.c"
				}
#line 151 "../lib/Services/WindowControl.vala"
				if (_tmp9_) {
#line 152 "../lib/Services/WindowControl.vala"
					result = TRUE;
#line 152 "../lib/Services/WindowControl.vala"
					_g_array_unref0 (xids);
#line 152 "../lib/Services/WindowControl.vala"
					return result;
#line 586 "WindowControl.c"
				}
			}
		}
	}
#line 155 "../lib/Services/WindowControl.vala"
	result = FALSE;
#line 155 "../lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 155 "../lib/Services/WindowControl.vala"
	return result;
#line 597 "WindowControl.c"
}

gboolean
plank_window_control_has_minimized_window (BamfApplication* app)
{
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	gboolean result;
#line 158 "../lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, FALSE);
#line 160 "../lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 161 "../lib/Services/WindowControl.vala"
	_tmp0_ = bamf_application_get_xids (app);
#line 161 "../lib/Services/WindowControl.vala"
	xids = _tmp0_;
#line 163 "../lib/Services/WindowControl.vala"
	_tmp1_ = xids;
#line 163 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 619 "WindowControl.c"
	{
		gint i = 0;
#line 165 "../lib/Services/WindowControl.vala"
		i = 0;
#line 624 "WindowControl.c"
		{
			gboolean _tmp2_ = FALSE;
#line 165 "../lib/Services/WindowControl.vala"
			_tmp2_ = TRUE;
#line 165 "../lib/Services/WindowControl.vala"
			while (TRUE) {
#line 631 "WindowControl.c"
				gboolean _tmp4_ = FALSE;
				GArray* _tmp5_;
				WnckWindow* window = NULL;
				GArray* _tmp7_;
				WnckWindow* _tmp8_;
				gboolean _tmp9_ = FALSE;
				WnckWindow* _tmp10_;
#line 165 "../lib/Services/WindowControl.vala"
				if (!_tmp2_) {
#line 641 "WindowControl.c"
					gint _tmp3_;
#line 165 "../lib/Services/WindowControl.vala"
					_tmp3_ = i;
#line 165 "../lib/Services/WindowControl.vala"
					i = _tmp3_ + 1;
#line 647 "WindowControl.c"
				}
#line 165 "../lib/Services/WindowControl.vala"
				_tmp2_ = FALSE;
#line 165 "../lib/Services/WindowControl.vala"
				_tmp5_ = xids;
#line 165 "../lib/Services/WindowControl.vala"
				if (_tmp5_ != NULL) {
#line 655 "WindowControl.c"
					GArray* _tmp6_;
#line 165 "../lib/Services/WindowControl.vala"
					_tmp6_ = xids;
#line 165 "../lib/Services/WindowControl.vala"
					_tmp4_ = ((guint) i) < _tmp6_->len;
#line 661 "WindowControl.c"
				} else {
#line 165 "../lib/Services/WindowControl.vala"
					_tmp4_ = FALSE;
#line 665 "WindowControl.c"
				}
#line 165 "../lib/Services/WindowControl.vala"
				if (!_tmp4_) {
#line 165 "../lib/Services/WindowControl.vala"
					break;
#line 671 "WindowControl.c"
				}
#line 166 "../lib/Services/WindowControl.vala"
				_tmp7_ = xids;
#line 166 "../lib/Services/WindowControl.vala"
				_tmp8_ = wnck_window_get ((gulong) g_array_index (_tmp7_, guint32, (guint) i));
#line 166 "../lib/Services/WindowControl.vala"
				window = _tmp8_;
#line 167 "../lib/Services/WindowControl.vala"
				_tmp10_ = window;
#line 167 "../lib/Services/WindowControl.vala"
				if (_tmp10_ != NULL) {
#line 683 "WindowControl.c"
					WnckWindow* _tmp11_;
#line 167 "../lib/Services/WindowControl.vala"
					_tmp11_ = window;
#line 167 "../lib/Services/WindowControl.vala"
					_tmp9_ = wnck_window_is_minimized (_tmp11_);
#line 689 "WindowControl.c"
				} else {
#line 167 "../lib/Services/WindowControl.vala"
					_tmp9_ = FALSE;
#line 693 "WindowControl.c"
				}
#line 167 "../lib/Services/WindowControl.vala"
				if (_tmp9_) {
#line 168 "../lib/Services/WindowControl.vala"
					result = TRUE;
#line 168 "../lib/Services/WindowControl.vala"
					_g_array_unref0 (xids);
#line 168 "../lib/Services/WindowControl.vala"
					return result;
#line 703 "WindowControl.c"
				}
			}
		}
	}
#line 171 "../lib/Services/WindowControl.vala"
	result = FALSE;
#line 171 "../lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 171 "../lib/Services/WindowControl.vala"
	return result;
#line 714 "WindowControl.c"
}

gboolean
plank_window_control_has_window_on_workspace (BamfApplication* app,
                                              WnckWorkspace* workspace)
{
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	gboolean is_virtual = FALSE;
	gboolean result;
#line 174 "../lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, FALSE);
#line 174 "../lib/Services/WindowControl.vala"
	g_return_val_if_fail (workspace != NULL, FALSE);
#line 176 "../lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 177 "../lib/Services/WindowControl.vala"
	_tmp0_ = bamf_application_get_xids (app);
#line 177 "../lib/Services/WindowControl.vala"
	xids = _tmp0_;
#line 179 "../lib/Services/WindowControl.vala"
	_tmp1_ = xids;
#line 179 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 181 "../lib/Services/WindowControl.vala"
	is_virtual = wnck_workspace_is_virtual (workspace);
#line 742 "WindowControl.c"
	{
		gint i = 0;
#line 183 "../lib/Services/WindowControl.vala"
		i = 0;
#line 747 "WindowControl.c"
		{
			gboolean _tmp2_ = FALSE;
#line 183 "../lib/Services/WindowControl.vala"
			_tmp2_ = TRUE;
#line 183 "../lib/Services/WindowControl.vala"
			while (TRUE) {
#line 754 "WindowControl.c"
				gboolean _tmp4_ = FALSE;
				GArray* _tmp5_;
				WnckWindow* window = NULL;
				GArray* _tmp7_;
				WnckWindow* _tmp8_;
				gboolean _tmp9_ = FALSE;
				WnckWindow* _tmp10_;
#line 183 "../lib/Services/WindowControl.vala"
				if (!_tmp2_) {
#line 764 "WindowControl.c"
					gint _tmp3_;
#line 183 "../lib/Services/WindowControl.vala"
					_tmp3_ = i;
#line 183 "../lib/Services/WindowControl.vala"
					i = _tmp3_ + 1;
#line 770 "WindowControl.c"
				}
#line 183 "../lib/Services/WindowControl.vala"
				_tmp2_ = FALSE;
#line 183 "../lib/Services/WindowControl.vala"
				_tmp5_ = xids;
#line 183 "../lib/Services/WindowControl.vala"
				if (_tmp5_ != NULL) {
#line 778 "WindowControl.c"
					GArray* _tmp6_;
#line 183 "../lib/Services/WindowControl.vala"
					_tmp6_ = xids;
#line 183 "../lib/Services/WindowControl.vala"
					_tmp4_ = ((guint) i) < _tmp6_->len;
#line 784 "WindowControl.c"
				} else {
#line 183 "../lib/Services/WindowControl.vala"
					_tmp4_ = FALSE;
#line 788 "WindowControl.c"
				}
#line 183 "../lib/Services/WindowControl.vala"
				if (!_tmp4_) {
#line 183 "../lib/Services/WindowControl.vala"
					break;
#line 794 "WindowControl.c"
				}
#line 184 "../lib/Services/WindowControl.vala"
				_tmp7_ = xids;
#line 184 "../lib/Services/WindowControl.vala"
				_tmp8_ = wnck_window_get ((gulong) g_array_index (_tmp7_, guint32, (guint) i));
#line 184 "../lib/Services/WindowControl.vala"
				window = _tmp8_;
#line 185 "../lib/Services/WindowControl.vala"
				_tmp10_ = window;
#line 185 "../lib/Services/WindowControl.vala"
				if (_tmp10_ == NULL) {
#line 185 "../lib/Services/WindowControl.vala"
					_tmp9_ = TRUE;
#line 808 "WindowControl.c"
				} else {
					WnckWindow* _tmp11_;
#line 185 "../lib/Services/WindowControl.vala"
					_tmp11_ = window;
#line 185 "../lib/Services/WindowControl.vala"
					_tmp9_ = wnck_window_is_skip_tasklist (_tmp11_);
#line 815 "WindowControl.c"
				}
#line 185 "../lib/Services/WindowControl.vala"
				if (_tmp9_) {
#line 186 "../lib/Services/WindowControl.vala"
					continue;
#line 821 "WindowControl.c"
				}
#line 188 "../lib/Services/WindowControl.vala"
				if (!is_virtual) {
#line 825 "WindowControl.c"
					WnckWindow* _tmp12_;
#line 189 "../lib/Services/WindowControl.vala"
					_tmp12_ = window;
#line 189 "../lib/Services/WindowControl.vala"
					if (wnck_window_is_on_workspace (_tmp12_, workspace)) {
#line 190 "../lib/Services/WindowControl.vala"
						result = TRUE;
#line 190 "../lib/Services/WindowControl.vala"
						_g_array_unref0 (xids);
#line 190 "../lib/Services/WindowControl.vala"
						return result;
#line 837 "WindowControl.c"
					}
				} else {
					WnckWindow* _tmp13_;
#line 192 "../lib/Services/WindowControl.vala"
					_tmp13_ = window;
#line 192 "../lib/Services/WindowControl.vala"
					if (wnck_window_is_in_viewport (_tmp13_, workspace)) {
#line 193 "../lib/Services/WindowControl.vala"
						result = TRUE;
#line 193 "../lib/Services/WindowControl.vala"
						_g_array_unref0 (xids);
#line 193 "../lib/Services/WindowControl.vala"
						return result;
#line 851 "WindowControl.c"
					}
				}
			}
		}
	}
#line 197 "../lib/Services/WindowControl.vala"
	result = FALSE;
#line 197 "../lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 197 "../lib/Services/WindowControl.vala"
	return result;
#line 863 "WindowControl.c"
}

void
plank_window_control_update_icon_regions (BamfApplication* app,
                                          GdkRectangle* rect)
{
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
#line 200 "../lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 200 "../lib/Services/WindowControl.vala"
	g_return_if_fail (rect != NULL);
#line 202 "../lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 203 "../lib/Services/WindowControl.vala"
	_tmp0_ = bamf_application_get_xids (app);
#line 203 "../lib/Services/WindowControl.vala"
	xids = _tmp0_;
#line 205 "../lib/Services/WindowControl.vala"
	_tmp1_ = xids;
#line 205 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 887 "WindowControl.c"
	{
		gint i = 0;
#line 207 "../lib/Services/WindowControl.vala"
		i = 0;
#line 892 "WindowControl.c"
		{
			gboolean _tmp2_ = FALSE;
#line 207 "../lib/Services/WindowControl.vala"
			_tmp2_ = TRUE;
#line 207 "../lib/Services/WindowControl.vala"
			while (TRUE) {
#line 899 "WindowControl.c"
				gboolean _tmp4_ = FALSE;
				GArray* _tmp5_;
				WnckWindow* window = NULL;
				GArray* _tmp7_;
				WnckWindow* _tmp8_;
				WnckWindow* _tmp9_;
#line 207 "../lib/Services/WindowControl.vala"
				if (!_tmp2_) {
#line 908 "WindowControl.c"
					gint _tmp3_;
#line 207 "../lib/Services/WindowControl.vala"
					_tmp3_ = i;
#line 207 "../lib/Services/WindowControl.vala"
					i = _tmp3_ + 1;
#line 914 "WindowControl.c"
				}
#line 207 "../lib/Services/WindowControl.vala"
				_tmp2_ = FALSE;
#line 207 "../lib/Services/WindowControl.vala"
				_tmp5_ = xids;
#line 207 "../lib/Services/WindowControl.vala"
				if (_tmp5_ != NULL) {
#line 922 "WindowControl.c"
					GArray* _tmp6_;
#line 207 "../lib/Services/WindowControl.vala"
					_tmp6_ = xids;
#line 207 "../lib/Services/WindowControl.vala"
					_tmp4_ = ((guint) i) < _tmp6_->len;
#line 928 "WindowControl.c"
				} else {
#line 207 "../lib/Services/WindowControl.vala"
					_tmp4_ = FALSE;
#line 932 "WindowControl.c"
				}
#line 207 "../lib/Services/WindowControl.vala"
				if (!_tmp4_) {
#line 207 "../lib/Services/WindowControl.vala"
					break;
#line 938 "WindowControl.c"
				}
#line 208 "../lib/Services/WindowControl.vala"
				_tmp7_ = xids;
#line 208 "../lib/Services/WindowControl.vala"
				_tmp8_ = wnck_window_get ((gulong) g_array_index (_tmp7_, guint32, (guint) i));
#line 208 "../lib/Services/WindowControl.vala"
				window = _tmp8_;
#line 209 "../lib/Services/WindowControl.vala"
				_tmp9_ = window;
#line 209 "../lib/Services/WindowControl.vala"
				if (_tmp9_ != NULL) {
#line 950 "WindowControl.c"
					WnckWindow* _tmp10_;
					GdkRectangle _tmp11_;
					GdkRectangle _tmp12_;
					GdkRectangle _tmp13_;
					GdkRectangle _tmp14_;
#line 210 "../lib/Services/WindowControl.vala"
					_tmp10_ = window;
#line 210 "../lib/Services/WindowControl.vala"
					_tmp11_ = *rect;
#line 210 "../lib/Services/WindowControl.vala"
					_tmp12_ = *rect;
#line 210 "../lib/Services/WindowControl.vala"
					_tmp13_ = *rect;
#line 210 "../lib/Services/WindowControl.vala"
					_tmp14_ = *rect;
#line 210 "../lib/Services/WindowControl.vala"
					wnck_window_set_icon_geometry (_tmp10_, _tmp11_.x, _tmp12_.y, _tmp13_.width, _tmp14_.height);
#line 968 "WindowControl.c"
				}
			}
		}
	}
#line 200 "../lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 975 "WindowControl.c"
}

void
plank_window_control_close_all (BamfApplication* app,
                                guint32 event_time)
{
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
#line 214 "../lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 216 "../lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 217 "../lib/Services/WindowControl.vala"
	_tmp0_ = bamf_application_get_xids (app);
#line 217 "../lib/Services/WindowControl.vala"
	xids = _tmp0_;
#line 219 "../lib/Services/WindowControl.vala"
	_tmp1_ = xids;
#line 219 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 997 "WindowControl.c"
	{
		gint i = 0;
#line 221 "../lib/Services/WindowControl.vala"
		i = 0;
#line 1002 "WindowControl.c"
		{
			gboolean _tmp2_ = FALSE;
#line 221 "../lib/Services/WindowControl.vala"
			_tmp2_ = TRUE;
#line 221 "../lib/Services/WindowControl.vala"
			while (TRUE) {
#line 1009 "WindowControl.c"
				gboolean _tmp4_ = FALSE;
				GArray* _tmp5_;
				WnckWindow* window = NULL;
				GArray* _tmp7_;
				WnckWindow* _tmp8_;
				gboolean _tmp9_ = FALSE;
				WnckWindow* _tmp10_;
#line 221 "../lib/Services/WindowControl.vala"
				if (!_tmp2_) {
#line 1019 "WindowControl.c"
					gint _tmp3_;
#line 221 "../lib/Services/WindowControl.vala"
					_tmp3_ = i;
#line 221 "../lib/Services/WindowControl.vala"
					i = _tmp3_ + 1;
#line 1025 "WindowControl.c"
				}
#line 221 "../lib/Services/WindowControl.vala"
				_tmp2_ = FALSE;
#line 221 "../lib/Services/WindowControl.vala"
				_tmp5_ = xids;
#line 221 "../lib/Services/WindowControl.vala"
				if (_tmp5_ != NULL) {
#line 1033 "WindowControl.c"
					GArray* _tmp6_;
#line 221 "../lib/Services/WindowControl.vala"
					_tmp6_ = xids;
#line 221 "../lib/Services/WindowControl.vala"
					_tmp4_ = ((guint) i) < _tmp6_->len;
#line 1039 "WindowControl.c"
				} else {
#line 221 "../lib/Services/WindowControl.vala"
					_tmp4_ = FALSE;
#line 1043 "WindowControl.c"
				}
#line 221 "../lib/Services/WindowControl.vala"
				if (!_tmp4_) {
#line 221 "../lib/Services/WindowControl.vala"
					break;
#line 1049 "WindowControl.c"
				}
#line 222 "../lib/Services/WindowControl.vala"
				_tmp7_ = xids;
#line 222 "../lib/Services/WindowControl.vala"
				_tmp8_ = wnck_window_get ((gulong) g_array_index (_tmp7_, guint32, (guint) i));
#line 222 "../lib/Services/WindowControl.vala"
				window = _tmp8_;
#line 223 "../lib/Services/WindowControl.vala"
				_tmp10_ = window;
#line 223 "../lib/Services/WindowControl.vala"
				if (_tmp10_ != NULL) {
#line 1061 "WindowControl.c"
					WnckWindow* _tmp11_;
#line 223 "../lib/Services/WindowControl.vala"
					_tmp11_ = window;
#line 223 "../lib/Services/WindowControl.vala"
					_tmp9_ = !wnck_window_is_skip_tasklist (_tmp11_);
#line 1067 "WindowControl.c"
				} else {
#line 223 "../lib/Services/WindowControl.vala"
					_tmp9_ = FALSE;
#line 1071 "WindowControl.c"
				}
#line 223 "../lib/Services/WindowControl.vala"
				if (_tmp9_) {
#line 1075 "WindowControl.c"
					WnckWindow* _tmp12_;
#line 224 "../lib/Services/WindowControl.vala"
					_tmp12_ = window;
#line 224 "../lib/Services/WindowControl.vala"
					wnck_window_close (_tmp12_, event_time);
#line 1081 "WindowControl.c"
				}
			}
		}
	}
#line 214 "../lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 1088 "WindowControl.c"
}

void
plank_window_control_focus_window (BamfWindow* window,
                                   guint32 event_time)
{
	WnckWindow* w = NULL;
	WnckWindow* _tmp0_;
	WnckWindow* _tmp1_;
	WnckWindow* _tmp2_;
	WnckWindow* _tmp3_;
#line 228 "../lib/Services/WindowControl.vala"
	g_return_if_fail (window != NULL);
#line 230 "../lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 231 "../lib/Services/WindowControl.vala"
	_tmp0_ = wnck_window_get ((gulong) bamf_window_get_xid (window));
#line 231 "../lib/Services/WindowControl.vala"
	w = _tmp0_;
#line 233 "../lib/Services/WindowControl.vala"
	_tmp1_ = w;
#line 233 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 235 "../lib/Services/WindowControl.vala"
	_tmp2_ = w;
#line 235 "../lib/Services/WindowControl.vala"
	if (_tmp2_ == NULL) {
#line 236 "../lib/Services/WindowControl.vala"
		return;
#line 1118 "WindowControl.c"
	}
#line 238 "../lib/Services/WindowControl.vala"
	_tmp3_ = w;
#line 238 "../lib/Services/WindowControl.vala"
	plank_window_control_center_and_focus_window (_tmp3_, event_time);
#line 1124 "WindowControl.c"
}

static void
plank_window_control_focus_window_by_xid (guint32 xid,
                                          guint32 event_time)
{
	WnckWindow* w = NULL;
	WnckWindow* _tmp0_;
	WnckWindow* _tmp1_;
	WnckWindow* _tmp2_;
	WnckWindow* _tmp3_;
#line 243 "../lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 244 "../lib/Services/WindowControl.vala"
	_tmp0_ = wnck_window_get ((gulong) xid);
#line 244 "../lib/Services/WindowControl.vala"
	w = _tmp0_;
#line 246 "../lib/Services/WindowControl.vala"
	_tmp1_ = w;
#line 246 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 248 "../lib/Services/WindowControl.vala"
	_tmp2_ = w;
#line 248 "../lib/Services/WindowControl.vala"
	if (_tmp2_ == NULL) {
#line 249 "../lib/Services/WindowControl.vala"
		return;
#line 1152 "WindowControl.c"
	}
#line 251 "../lib/Services/WindowControl.vala"
	_tmp3_ = w;
#line 251 "../lib/Services/WindowControl.vala"
	plank_window_control_center_and_focus_window (_tmp3_, event_time);
#line 1158 "WindowControl.c"
}

static gint
plank_window_control_find_active_xid_index (GArray* xids)
{
	gint i = 0;
	gint result;
#line 256 "../lib/Services/WindowControl.vala"
	i = 0;
#line 1168 "WindowControl.c"
	{
		gboolean _tmp0_ = FALSE;
#line 257 "../lib/Services/WindowControl.vala"
		_tmp0_ = TRUE;
#line 257 "../lib/Services/WindowControl.vala"
		while (TRUE) {
#line 1175 "WindowControl.c"
			gboolean _tmp2_ = FALSE;
			WnckWindow* window = NULL;
			WnckWindow* _tmp3_;
			gboolean _tmp4_ = FALSE;
			WnckWindow* _tmp5_;
#line 257 "../lib/Services/WindowControl.vala"
			if (!_tmp0_) {
#line 1183 "WindowControl.c"
				gint _tmp1_;
#line 257 "../lib/Services/WindowControl.vala"
				_tmp1_ = i;
#line 257 "../lib/Services/WindowControl.vala"
				i = _tmp1_ + 1;
#line 1189 "WindowControl.c"
			}
#line 257 "../lib/Services/WindowControl.vala"
			_tmp0_ = FALSE;
#line 257 "../lib/Services/WindowControl.vala"
			if (xids != NULL) {
#line 257 "../lib/Services/WindowControl.vala"
				_tmp2_ = ((guint) i) < xids->len;
#line 1197 "WindowControl.c"
			} else {
#line 257 "../lib/Services/WindowControl.vala"
				_tmp2_ = FALSE;
#line 1201 "WindowControl.c"
			}
#line 257 "../lib/Services/WindowControl.vala"
			if (!_tmp2_) {
#line 257 "../lib/Services/WindowControl.vala"
				break;
#line 1207 "WindowControl.c"
			}
#line 258 "../lib/Services/WindowControl.vala"
			_tmp3_ = wnck_window_get ((gulong) g_array_index (xids, guint32, (guint) i));
#line 258 "../lib/Services/WindowControl.vala"
			window = _tmp3_;
#line 259 "../lib/Services/WindowControl.vala"
			_tmp5_ = window;
#line 259 "../lib/Services/WindowControl.vala"
			if (_tmp5_ != NULL) {
#line 1217 "WindowControl.c"
				WnckWindow* _tmp6_;
#line 259 "../lib/Services/WindowControl.vala"
				_tmp6_ = window;
#line 259 "../lib/Services/WindowControl.vala"
				_tmp4_ = wnck_window_is_active (_tmp6_);
#line 1223 "WindowControl.c"
			} else {
#line 259 "../lib/Services/WindowControl.vala"
				_tmp4_ = FALSE;
#line 1227 "WindowControl.c"
			}
#line 259 "../lib/Services/WindowControl.vala"
			if (_tmp4_) {
#line 260 "../lib/Services/WindowControl.vala"
				break;
#line 1233 "WindowControl.c"
			}
		}
	}
#line 262 "../lib/Services/WindowControl.vala"
	result = i;
#line 262 "../lib/Services/WindowControl.vala"
	return result;
#line 1241 "WindowControl.c"
}

void
plank_window_control_focus_previous (BamfApplication* app,
                                     guint32 event_time)
{
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	GArray* _tmp2_;
	gint i = 0;
	GArray* _tmp3_;
	gint _tmp4_ = 0;
	GArray* _tmp5_;
	GArray* _tmp7_;
#line 265 "../lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 267 "../lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 268 "../lib/Services/WindowControl.vala"
	_tmp0_ = bamf_application_get_xids (app);
#line 268 "../lib/Services/WindowControl.vala"
	xids = _tmp0_;
#line 270 "../lib/Services/WindowControl.vala"
	_tmp1_ = xids;
#line 270 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 272 "../lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 272 "../lib/Services/WindowControl.vala"
	if (_tmp2_ == NULL) {
#line 273 "../lib/Services/WindowControl.vala"
		_g_array_unref0 (xids);
#line 273 "../lib/Services/WindowControl.vala"
		return;
#line 1277 "WindowControl.c"
	}
#line 275 "../lib/Services/WindowControl.vala"
	_tmp3_ = xids;
#line 275 "../lib/Services/WindowControl.vala"
	i = plank_window_control_find_active_xid_index (_tmp3_);
#line 276 "../lib/Services/WindowControl.vala"
	_tmp5_ = xids;
#line 276 "../lib/Services/WindowControl.vala"
	if (((guint) i) < _tmp5_->len) {
#line 276 "../lib/Services/WindowControl.vala"
		_tmp4_ = i - 1;
#line 1289 "WindowControl.c"
	} else {
#line 276 "../lib/Services/WindowControl.vala"
		_tmp4_ = 0;
#line 1293 "WindowControl.c"
	}
#line 276 "../lib/Services/WindowControl.vala"
	i = _tmp4_;
#line 278 "../lib/Services/WindowControl.vala"
	if (i < 0) {
#line 1299 "WindowControl.c"
		GArray* _tmp6_;
#line 279 "../lib/Services/WindowControl.vala"
		_tmp6_ = xids;
#line 279 "../lib/Services/WindowControl.vala"
		i = ((gint) _tmp6_->len) - 1;
#line 1305 "WindowControl.c"
	}
#line 281 "../lib/Services/WindowControl.vala"
	_tmp7_ = xids;
#line 281 "../lib/Services/WindowControl.vala"
	plank_window_control_focus_window_by_xid (g_array_index (_tmp7_, guint32, (guint) i), event_time);
#line 265 "../lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 1313 "WindowControl.c"
}

void
plank_window_control_focus_next (BamfApplication* app,
                                 guint32 event_time)
{
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	GArray* _tmp2_;
	gint i = 0;
	GArray* _tmp3_;
	gint _tmp4_ = 0;
	GArray* _tmp5_;
	GArray* _tmp6_;
	GArray* _tmp7_;
#line 284 "../lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 286 "../lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 287 "../lib/Services/WindowControl.vala"
	_tmp0_ = bamf_application_get_xids (app);
#line 287 "../lib/Services/WindowControl.vala"
	xids = _tmp0_;
#line 289 "../lib/Services/WindowControl.vala"
	_tmp1_ = xids;
#line 289 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 291 "../lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 291 "../lib/Services/WindowControl.vala"
	if (_tmp2_ == NULL) {
#line 292 "../lib/Services/WindowControl.vala"
		_g_array_unref0 (xids);
#line 292 "../lib/Services/WindowControl.vala"
		return;
#line 1350 "WindowControl.c"
	}
#line 294 "../lib/Services/WindowControl.vala"
	_tmp3_ = xids;
#line 294 "../lib/Services/WindowControl.vala"
	i = plank_window_control_find_active_xid_index (_tmp3_);
#line 295 "../lib/Services/WindowControl.vala"
	_tmp5_ = xids;
#line 295 "../lib/Services/WindowControl.vala"
	if (((guint) i) < _tmp5_->len) {
#line 295 "../lib/Services/WindowControl.vala"
		_tmp4_ = i + 1;
#line 1362 "WindowControl.c"
	} else {
#line 295 "../lib/Services/WindowControl.vala"
		_tmp4_ = 0;
#line 1366 "WindowControl.c"
	}
#line 295 "../lib/Services/WindowControl.vala"
	i = _tmp4_;
#line 297 "../lib/Services/WindowControl.vala"
	_tmp6_ = xids;
#line 297 "../lib/Services/WindowControl.vala"
	if (((guint) i) == _tmp6_->len) {
#line 298 "../lib/Services/WindowControl.vala"
		i = 0;
#line 1376 "WindowControl.c"
	}
#line 300 "../lib/Services/WindowControl.vala"
	_tmp7_ = xids;
#line 300 "../lib/Services/WindowControl.vala"
	plank_window_control_focus_window_by_xid (g_array_index (_tmp7_, guint32, (guint) i), event_time);
#line 284 "../lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 1384 "WindowControl.c"
}

void
plank_window_control_minimize (BamfApplication* app)
{
	GList* _tmp0_;
#line 303 "../lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 305 "../lib/Services/WindowControl.vala"
	_tmp0_ = plank_window_control_get_ordered_window_stack (app);
#line 1395 "WindowControl.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 305 "../lib/Services/WindowControl.vala"
		window_collection = _tmp0_;
#line 305 "../lib/Services/WindowControl.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1403 "WindowControl.c"
			WnckWindow* window = NULL;
#line 305 "../lib/Services/WindowControl.vala"
			window = (WnckWindow*) window_it->data;
#line 1407 "WindowControl.c"
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp1_;
				WnckScreen* _tmp2_;
				WnckWorkspace* _tmp3_;
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				WnckWindow* _tmp6_;
#line 306 "../lib/Services/WindowControl.vala"
				_tmp1_ = window;
#line 306 "../lib/Services/WindowControl.vala"
				_tmp2_ = wnck_window_get_screen (_tmp1_);
#line 306 "../lib/Services/WindowControl.vala"
				_tmp3_ = wnck_screen_get_active_workspace (_tmp2_);
#line 306 "../lib/Services/WindowControl.vala"
				active_workspace = _tmp3_;
#line 307 "../lib/Services/WindowControl.vala"
				_tmp6_ = window;
#line 307 "../lib/Services/WindowControl.vala"
				if (!wnck_window_is_minimized (_tmp6_)) {
#line 1428 "WindowControl.c"
					WnckWorkspace* _tmp7_;
#line 307 "../lib/Services/WindowControl.vala"
					_tmp7_ = active_workspace;
#line 307 "../lib/Services/WindowControl.vala"
					_tmp5_ = _tmp7_ != NULL;
#line 1434 "WindowControl.c"
				} else {
#line 307 "../lib/Services/WindowControl.vala"
					_tmp5_ = FALSE;
#line 1438 "WindowControl.c"
				}
#line 307 "../lib/Services/WindowControl.vala"
				if (_tmp5_) {
#line 1442 "WindowControl.c"
					WnckWindow* _tmp8_;
					WnckWorkspace* _tmp9_;
#line 307 "../lib/Services/WindowControl.vala"
					_tmp8_ = window;
#line 307 "../lib/Services/WindowControl.vala"
					_tmp9_ = active_workspace;
#line 307 "../lib/Services/WindowControl.vala"
					_tmp4_ = wnck_window_is_in_viewport (_tmp8_, _tmp9_);
#line 1451 "WindowControl.c"
				} else {
#line 307 "../lib/Services/WindowControl.vala"
					_tmp4_ = FALSE;
#line 1455 "WindowControl.c"
				}
#line 307 "../lib/Services/WindowControl.vala"
				if (_tmp4_) {
#line 1459 "WindowControl.c"
					WnckWindow* _tmp10_;
#line 308 "../lib/Services/WindowControl.vala"
					_tmp10_ = window;
#line 308 "../lib/Services/WindowControl.vala"
					wnck_window_minimize (_tmp10_);
#line 309 "../lib/Services/WindowControl.vala"
					g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 1467 "WindowControl.c"
				}
			}
		}
#line 305 "../lib/Services/WindowControl.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 1473 "WindowControl.c"
	}
}

void
plank_window_control_restore (BamfApplication* app,
                              guint32 event_time)
{
	GList* stack = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
#line 314 "../lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 316 "../lib/Services/WindowControl.vala"
	_tmp0_ = plank_window_control_get_ordered_window_stack (app);
#line 316 "../lib/Services/WindowControl.vala"
	stack = _tmp0_;
#line 317 "../lib/Services/WindowControl.vala"
	stack = g_list_reverse (stack);
#line 318 "../lib/Services/WindowControl.vala"
	_tmp1_ = stack;
#line 1494 "WindowControl.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 318 "../lib/Services/WindowControl.vala"
		window_collection = _tmp1_;
#line 318 "../lib/Services/WindowControl.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1502 "WindowControl.c"
			WnckWindow* window = NULL;
#line 318 "../lib/Services/WindowControl.vala"
			window = (WnckWindow*) window_it->data;
#line 1506 "WindowControl.c"
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp2_;
				WnckScreen* _tmp3_;
				WnckWorkspace* _tmp4_;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				WnckWindow* _tmp7_;
#line 319 "../lib/Services/WindowControl.vala"
				_tmp2_ = window;
#line 319 "../lib/Services/WindowControl.vala"
				_tmp3_ = wnck_window_get_screen (_tmp2_);
#line 319 "../lib/Services/WindowControl.vala"
				_tmp4_ = wnck_screen_get_active_workspace (_tmp3_);
#line 319 "../lib/Services/WindowControl.vala"
				active_workspace = _tmp4_;
#line 320 "../lib/Services/WindowControl.vala"
				_tmp7_ = window;
#line 320 "../lib/Services/WindowControl.vala"
				if (wnck_window_is_minimized (_tmp7_)) {
#line 1527 "WindowControl.c"
					WnckWorkspace* _tmp8_;
#line 320 "../lib/Services/WindowControl.vala"
					_tmp8_ = active_workspace;
#line 320 "../lib/Services/WindowControl.vala"
					_tmp6_ = _tmp8_ != NULL;
#line 1533 "WindowControl.c"
				} else {
#line 320 "../lib/Services/WindowControl.vala"
					_tmp6_ = FALSE;
#line 1537 "WindowControl.c"
				}
#line 320 "../lib/Services/WindowControl.vala"
				if (_tmp6_) {
#line 1541 "WindowControl.c"
					WnckWindow* _tmp9_;
					WnckWorkspace* _tmp10_;
#line 320 "../lib/Services/WindowControl.vala"
					_tmp9_ = window;
#line 320 "../lib/Services/WindowControl.vala"
					_tmp10_ = active_workspace;
#line 320 "../lib/Services/WindowControl.vala"
					_tmp5_ = wnck_window_is_in_viewport (_tmp9_, _tmp10_);
#line 1550 "WindowControl.c"
				} else {
#line 320 "../lib/Services/WindowControl.vala"
					_tmp5_ = FALSE;
#line 1554 "WindowControl.c"
				}
#line 320 "../lib/Services/WindowControl.vala"
				if (_tmp5_) {
#line 1558 "WindowControl.c"
					WnckWindow* _tmp11_;
#line 321 "../lib/Services/WindowControl.vala"
					_tmp11_ = window;
#line 321 "../lib/Services/WindowControl.vala"
					wnck_window_unminimize (_tmp11_, event_time);
#line 322 "../lib/Services/WindowControl.vala"
					g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 1566 "WindowControl.c"
				}
			}
		}
	}
#line 314 "../lib/Services/WindowControl.vala"
	(stack == NULL) ? NULL : (stack = (g_list_free (stack), NULL));
#line 1573 "WindowControl.c"
}

void
plank_window_control_maximize (BamfApplication* app)
{
	GList* _tmp0_;
#line 327 "../lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 329 "../lib/Services/WindowControl.vala"
	_tmp0_ = plank_window_control_get_ordered_window_stack (app);
#line 1584 "WindowControl.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 329 "../lib/Services/WindowControl.vala"
		window_collection = _tmp0_;
#line 329 "../lib/Services/WindowControl.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1592 "WindowControl.c"
			WnckWindow* window = NULL;
#line 329 "../lib/Services/WindowControl.vala"
			window = (WnckWindow*) window_it->data;
#line 1596 "WindowControl.c"
			{
				WnckWindow* _tmp1_;
#line 330 "../lib/Services/WindowControl.vala"
				_tmp1_ = window;
#line 330 "../lib/Services/WindowControl.vala"
				if (!wnck_window_is_maximized (_tmp1_)) {
#line 1603 "WindowControl.c"
					WnckWindow* _tmp2_;
#line 331 "../lib/Services/WindowControl.vala"
					_tmp2_ = window;
#line 331 "../lib/Services/WindowControl.vala"
					wnck_window_maximize (_tmp2_);
#line 1609 "WindowControl.c"
				}
			}
		}
#line 329 "../lib/Services/WindowControl.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 1615 "WindowControl.c"
	}
}

void
plank_window_control_unmaximize (BamfApplication* app)
{
	GList* _tmp0_;
#line 334 "../lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 336 "../lib/Services/WindowControl.vala"
	_tmp0_ = plank_window_control_get_ordered_window_stack (app);
#line 1627 "WindowControl.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 336 "../lib/Services/WindowControl.vala"
		window_collection = _tmp0_;
#line 336 "../lib/Services/WindowControl.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1635 "WindowControl.c"
			WnckWindow* window = NULL;
#line 336 "../lib/Services/WindowControl.vala"
			window = (WnckWindow*) window_it->data;
#line 1639 "WindowControl.c"
			{
				WnckWindow* _tmp1_;
#line 337 "../lib/Services/WindowControl.vala"
				_tmp1_ = window;
#line 337 "../lib/Services/WindowControl.vala"
				if (wnck_window_is_maximized (_tmp1_)) {
#line 1646 "WindowControl.c"
					WnckWindow* _tmp2_;
#line 338 "../lib/Services/WindowControl.vala"
					_tmp2_ = window;
#line 338 "../lib/Services/WindowControl.vala"
					wnck_window_unmaximize (_tmp2_);
#line 1652 "WindowControl.c"
				}
			}
		}
#line 336 "../lib/Services/WindowControl.vala"
		(window_collection == NULL) ? NULL : (window_collection = (g_list_free (window_collection), NULL));
#line 1658 "WindowControl.c"
	}
}

GList*
plank_window_control_get_ordered_window_stack (BamfApplication* app)
{
	GList* windows = NULL;
	GArray* xids = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	GArray* _tmp2_;
	GList* stack = NULL;
	WnckScreen* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	GList* result;
#line 341 "../lib/Services/WindowControl.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 343 "../lib/Services/WindowControl.vala"
	windows = NULL;
#line 345 "../lib/Services/WindowControl.vala"
	wnck_screen_get_default ();
#line 346 "../lib/Services/WindowControl.vala"
	_tmp0_ = bamf_application_get_xids (app);
#line 346 "../lib/Services/WindowControl.vala"
	xids = _tmp0_;
#line 348 "../lib/Services/WindowControl.vala"
	_tmp1_ = xids;
#line 348 "../lib/Services/WindowControl.vala"
	g_warn_if_fail (_tmp1_ != NULL);
#line 350 "../lib/Services/WindowControl.vala"
	_tmp2_ = xids;
#line 350 "../lib/Services/WindowControl.vala"
	if (_tmp2_ == NULL) {
#line 351 "../lib/Services/WindowControl.vala"
		result = windows;
#line 351 "../lib/Services/WindowControl.vala"
		_g_array_unref0 (xids);
#line 351 "../lib/Services/WindowControl.vala"
		return result;
#line 1699 "WindowControl.c"
	}
#line 353 "../lib/Services/WindowControl.vala"
	_tmp3_ = wnck_screen_get_default ();
#line 353 "../lib/Services/WindowControl.vala"
	_tmp4_ = wnck_screen_get_windows_stacked (_tmp3_);
#line 353 "../lib/Services/WindowControl.vala"
	stack = _tmp4_;
#line 355 "../lib/Services/WindowControl.vala"
	_tmp5_ = stack;
#line 1709 "WindowControl.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 355 "../lib/Services/WindowControl.vala"
		window_collection = _tmp5_;
#line 355 "../lib/Services/WindowControl.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1717 "WindowControl.c"
			WnckWindow* window = NULL;
#line 355 "../lib/Services/WindowControl.vala"
			window = (WnckWindow*) window_it->data;
#line 1721 "WindowControl.c"
			{
				{
					gint j = 0;
#line 356 "../lib/Services/WindowControl.vala"
					j = 0;
#line 1727 "WindowControl.c"
					{
						gboolean _tmp6_ = FALSE;
#line 356 "../lib/Services/WindowControl.vala"
						_tmp6_ = TRUE;
#line 356 "../lib/Services/WindowControl.vala"
						while (TRUE) {
#line 1734 "WindowControl.c"
							GArray* _tmp8_;
							GArray* _tmp9_;
							WnckWindow* _tmp10_;
#line 356 "../lib/Services/WindowControl.vala"
							if (!_tmp6_) {
#line 1740 "WindowControl.c"
								gint _tmp7_;
#line 356 "../lib/Services/WindowControl.vala"
								_tmp7_ = j;
#line 356 "../lib/Services/WindowControl.vala"
								j = _tmp7_ + 1;
#line 1746 "WindowControl.c"
							}
#line 356 "../lib/Services/WindowControl.vala"
							_tmp6_ = FALSE;
#line 356 "../lib/Services/WindowControl.vala"
							_tmp8_ = xids;
#line 356 "../lib/Services/WindowControl.vala"
							if (!(((guint) j) < _tmp8_->len)) {
#line 356 "../lib/Services/WindowControl.vala"
								break;
#line 1756 "WindowControl.c"
							}
#line 357 "../lib/Services/WindowControl.vala"
							_tmp9_ = xids;
#line 357 "../lib/Services/WindowControl.vala"
							_tmp10_ = window;
#line 357 "../lib/Services/WindowControl.vala"
							if (((gulong) g_array_index (_tmp9_, guint32, (guint) j)) == wnck_window_get_xid (_tmp10_)) {
#line 1764 "WindowControl.c"
								WnckWindow* _tmp11_;
#line 358 "../lib/Services/WindowControl.vala"
								_tmp11_ = window;
#line 358 "../lib/Services/WindowControl.vala"
								windows = g_list_append (windows, _tmp11_);
#line 1770 "WindowControl.c"
							}
						}
					}
				}
			}
		}
	}
#line 360 "../lib/Services/WindowControl.vala"
	result = windows;
#line 360 "../lib/Services/WindowControl.vala"
	_g_array_unref0 (xids);
#line 360 "../lib/Services/WindowControl.vala"
	return result;
#line 1784 "WindowControl.c"
}

void
plank_window_control_smart_focus (BamfApplication* app,
                                  guint32 event_time)
{
	GList* windows = NULL;
	GList* _tmp0_;
	gboolean not_in_viewport = FALSE;
	gboolean urgent = FALSE;
	GList* _tmp1_;
	gboolean _tmp12_ = FALSE;
	GList* _tmp19_;
	GList* _tmp35_;
	GList* _tmp56_;
	GList* _tmp68_;
	gconstpointer _tmp69_;
	GList* _tmp70_;
#line 363 "../lib/Services/WindowControl.vala"
	g_return_if_fail (app != NULL);
#line 365 "../lib/Services/WindowControl.vala"
	_tmp0_ = plank_window_control_get_ordered_window_stack (app);
#line 365 "../lib/Services/WindowControl.vala"
	windows = _tmp0_;
#line 367 "../lib/Services/WindowControl.vala"
	not_in_viewport = TRUE;
#line 368 "../lib/Services/WindowControl.vala"
	urgent = FALSE;
#line 370 "../lib/Services/WindowControl.vala"
	_tmp1_ = windows;
#line 1815 "WindowControl.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 370 "../lib/Services/WindowControl.vala"
		window_collection = _tmp1_;
#line 370 "../lib/Services/WindowControl.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1823 "WindowControl.c"
			WnckWindow* window = NULL;
#line 370 "../lib/Services/WindowControl.vala"
			window = (WnckWindow*) window_it->data;
#line 1827 "WindowControl.c"
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp2_;
				WnckScreen* _tmp3_;
				WnckWorkspace* _tmp4_;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				WnckWindow* _tmp7_;
				WnckWindow* _tmp11_;
#line 371 "../lib/Services/WindowControl.vala"
				_tmp2_ = window;
#line 371 "../lib/Services/WindowControl.vala"
				_tmp3_ = wnck_window_get_screen (_tmp2_);
#line 371 "../lib/Services/WindowControl.vala"
				_tmp4_ = wnck_screen_get_active_workspace (_tmp3_);
#line 371 "../lib/Services/WindowControl.vala"
				active_workspace = _tmp4_;
#line 372 "../lib/Services/WindowControl.vala"
				_tmp7_ = window;
#line 372 "../lib/Services/WindowControl.vala"
				if (!wnck_window_is_skip_tasklist (_tmp7_)) {
#line 1849 "WindowControl.c"
					WnckWorkspace* _tmp8_;
#line 372 "../lib/Services/WindowControl.vala"
					_tmp8_ = active_workspace;
#line 372 "../lib/Services/WindowControl.vala"
					_tmp6_ = _tmp8_ != NULL;
#line 1855 "WindowControl.c"
				} else {
#line 372 "../lib/Services/WindowControl.vala"
					_tmp6_ = FALSE;
#line 1859 "WindowControl.c"
				}
#line 372 "../lib/Services/WindowControl.vala"
				if (_tmp6_) {
#line 1863 "WindowControl.c"
					WnckWindow* _tmp9_;
					WnckWorkspace* _tmp10_;
#line 372 "../lib/Services/WindowControl.vala"
					_tmp9_ = window;
#line 372 "../lib/Services/WindowControl.vala"
					_tmp10_ = active_workspace;
#line 372 "../lib/Services/WindowControl.vala"
					_tmp5_ = wnck_window_is_in_viewport (_tmp9_, _tmp10_);
#line 1872 "WindowControl.c"
				} else {
#line 372 "../lib/Services/WindowControl.vala"
					_tmp5_ = FALSE;
#line 1876 "WindowControl.c"
				}
#line 372 "../lib/Services/WindowControl.vala"
				if (_tmp5_) {
#line 373 "../lib/Services/WindowControl.vala"
					not_in_viewport = FALSE;
#line 1882 "WindowControl.c"
				}
#line 374 "../lib/Services/WindowControl.vala"
				_tmp11_ = window;
#line 374 "../lib/Services/WindowControl.vala"
				if (wnck_window_needs_attention (_tmp11_)) {
#line 375 "../lib/Services/WindowControl.vala"
					urgent = TRUE;
#line 1890 "WindowControl.c"
				}
			}
		}
	}
#line 379 "../lib/Services/WindowControl.vala"
	if (not_in_viewport) {
#line 379 "../lib/Services/WindowControl.vala"
		_tmp12_ = TRUE;
#line 1899 "WindowControl.c"
	} else {
#line 379 "../lib/Services/WindowControl.vala"
		_tmp12_ = urgent;
#line 1903 "WindowControl.c"
	}
#line 379 "../lib/Services/WindowControl.vala"
	if (_tmp12_) {
#line 1907 "WindowControl.c"
		GList* _tmp13_;
#line 380 "../lib/Services/WindowControl.vala"
		_tmp13_ = windows;
#line 1911 "WindowControl.c"
		{
			GList* window_collection = NULL;
			GList* window_it = NULL;
#line 380 "../lib/Services/WindowControl.vala"
			window_collection = _tmp13_;
#line 380 "../lib/Services/WindowControl.vala"
			for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1919 "WindowControl.c"
				WnckWindow* window = NULL;
#line 380 "../lib/Services/WindowControl.vala"
				window = (WnckWindow*) window_it->data;
#line 1923 "WindowControl.c"
				{
					gboolean _tmp14_ = FALSE;
					WnckWindow* _tmp16_;
#line 381 "../lib/Services/WindowControl.vala"
					if (urgent) {
#line 1929 "WindowControl.c"
						WnckWindow* _tmp15_;
#line 381 "../lib/Services/WindowControl.vala"
						_tmp15_ = window;
#line 381 "../lib/Services/WindowControl.vala"
						_tmp14_ = !wnck_window_needs_attention (_tmp15_);
#line 1935 "WindowControl.c"
					} else {
#line 381 "../lib/Services/WindowControl.vala"
						_tmp14_ = FALSE;
#line 1939 "WindowControl.c"
					}
#line 381 "../lib/Services/WindowControl.vala"
					if (_tmp14_) {
#line 382 "../lib/Services/WindowControl.vala"
						continue;
#line 1945 "WindowControl.c"
					}
#line 384 "../lib/Services/WindowControl.vala"
					_tmp16_ = window;
#line 384 "../lib/Services/WindowControl.vala"
					if (!wnck_window_is_skip_tasklist (_tmp16_)) {
#line 1951 "WindowControl.c"
						WnckWindow* _tmp17_;
						GList* _tmp18_;
#line 385 "../lib/Services/WindowControl.vala"
						_tmp17_ = window;
#line 385 "../lib/Services/WindowControl.vala"
						_tmp18_ = windows;
#line 385 "../lib/Services/WindowControl.vala"
						plank_window_control_intelligent_focus_off_viewport_window (_tmp17_, _tmp18_, event_time);
#line 386 "../lib/Services/WindowControl.vala"
						(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 386 "../lib/Services/WindowControl.vala"
						return;
#line 1964 "WindowControl.c"
					}
				}
			}
		}
	}
#line 392 "../lib/Services/WindowControl.vala"
	_tmp19_ = windows;
#line 1972 "WindowControl.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 392 "../lib/Services/WindowControl.vala"
		window_collection = _tmp19_;
#line 392 "../lib/Services/WindowControl.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 1980 "WindowControl.c"
			WnckWindow* window = NULL;
#line 392 "../lib/Services/WindowControl.vala"
			window = (WnckWindow*) window_it->data;
#line 1984 "WindowControl.c"
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp20_;
				WnckScreen* _tmp21_;
				WnckWorkspace* _tmp22_;
				gboolean _tmp23_ = FALSE;
				gboolean _tmp24_ = FALSE;
				WnckWindow* _tmp25_;
#line 393 "../lib/Services/WindowControl.vala"
				_tmp20_ = window;
#line 393 "../lib/Services/WindowControl.vala"
				_tmp21_ = wnck_window_get_screen (_tmp20_);
#line 393 "../lib/Services/WindowControl.vala"
				_tmp22_ = wnck_screen_get_active_workspace (_tmp21_);
#line 393 "../lib/Services/WindowControl.vala"
				active_workspace = _tmp22_;
#line 394 "../lib/Services/WindowControl.vala"
				_tmp25_ = window;
#line 394 "../lib/Services/WindowControl.vala"
				if (wnck_window_is_minimized (_tmp25_)) {
#line 2005 "WindowControl.c"
					WnckWorkspace* _tmp26_;
#line 394 "../lib/Services/WindowControl.vala"
					_tmp26_ = active_workspace;
#line 394 "../lib/Services/WindowControl.vala"
					_tmp24_ = _tmp26_ != NULL;
#line 2011 "WindowControl.c"
				} else {
#line 394 "../lib/Services/WindowControl.vala"
					_tmp24_ = FALSE;
#line 2015 "WindowControl.c"
				}
#line 394 "../lib/Services/WindowControl.vala"
				if (_tmp24_) {
#line 2019 "WindowControl.c"
					WnckWindow* _tmp27_;
					WnckWorkspace* _tmp28_;
#line 394 "../lib/Services/WindowControl.vala"
					_tmp27_ = window;
#line 394 "../lib/Services/WindowControl.vala"
					_tmp28_ = active_workspace;
#line 394 "../lib/Services/WindowControl.vala"
					_tmp23_ = wnck_window_is_in_viewport (_tmp27_, _tmp28_);
#line 2028 "WindowControl.c"
				} else {
#line 394 "../lib/Services/WindowControl.vala"
					_tmp23_ = FALSE;
#line 2032 "WindowControl.c"
				}
#line 394 "../lib/Services/WindowControl.vala"
				if (_tmp23_) {
#line 2036 "WindowControl.c"
					GList* _tmp29_;
#line 395 "../lib/Services/WindowControl.vala"
					_tmp29_ = windows;
#line 2040 "WindowControl.c"
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
#line 395 "../lib/Services/WindowControl.vala"
						w_collection = _tmp29_;
#line 395 "../lib/Services/WindowControl.vala"
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
#line 2048 "WindowControl.c"
							WnckWindow* w = NULL;
#line 395 "../lib/Services/WindowControl.vala"
							w = (WnckWindow*) w_it->data;
#line 2052 "WindowControl.c"
							{
								gboolean _tmp30_ = FALSE;
								WnckWindow* _tmp31_;
#line 396 "../lib/Services/WindowControl.vala"
								_tmp31_ = w;
#line 396 "../lib/Services/WindowControl.vala"
								if (wnck_window_is_minimized (_tmp31_)) {
#line 2060 "WindowControl.c"
									WnckWindow* _tmp32_;
									WnckWorkspace* _tmp33_;
#line 396 "../lib/Services/WindowControl.vala"
									_tmp32_ = w;
#line 396 "../lib/Services/WindowControl.vala"
									_tmp33_ = active_workspace;
#line 396 "../lib/Services/WindowControl.vala"
									_tmp30_ = wnck_window_is_in_viewport (_tmp32_, _tmp33_);
#line 2069 "WindowControl.c"
								} else {
#line 396 "../lib/Services/WindowControl.vala"
									_tmp30_ = FALSE;
#line 2073 "WindowControl.c"
								}
#line 396 "../lib/Services/WindowControl.vala"
								if (_tmp30_) {
#line 2077 "WindowControl.c"
									WnckWindow* _tmp34_;
#line 397 "../lib/Services/WindowControl.vala"
									_tmp34_ = w;
#line 397 "../lib/Services/WindowControl.vala"
									wnck_window_unminimize (_tmp34_, event_time);
#line 398 "../lib/Services/WindowControl.vala"
									g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 2085 "WindowControl.c"
								}
							}
						}
					}
#line 400 "../lib/Services/WindowControl.vala"
					(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 400 "../lib/Services/WindowControl.vala"
					return;
#line 2094 "WindowControl.c"
				}
			}
		}
	}
#line 405 "../lib/Services/WindowControl.vala"
	_tmp35_ = windows;
#line 2101 "WindowControl.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 405 "../lib/Services/WindowControl.vala"
		window_collection = _tmp35_;
#line 405 "../lib/Services/WindowControl.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 2109 "WindowControl.c"
			WnckWindow* window = NULL;
#line 405 "../lib/Services/WindowControl.vala"
			window = (WnckWindow*) window_it->data;
#line 2113 "WindowControl.c"
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp36_;
				WnckScreen* _tmp37_;
				WnckWorkspace* _tmp38_;
				gboolean _tmp39_ = FALSE;
				gboolean _tmp40_ = FALSE;
				gboolean _tmp41_ = FALSE;
				WnckWindow* _tmp42_;
#line 406 "../lib/Services/WindowControl.vala"
				_tmp36_ = window;
#line 406 "../lib/Services/WindowControl.vala"
				_tmp37_ = wnck_window_get_screen (_tmp36_);
#line 406 "../lib/Services/WindowControl.vala"
				_tmp38_ = wnck_screen_get_active_workspace (_tmp37_);
#line 406 "../lib/Services/WindowControl.vala"
				active_workspace = _tmp38_;
#line 407 "../lib/Services/WindowControl.vala"
				_tmp42_ = window;
#line 407 "../lib/Services/WindowControl.vala"
				if (wnck_window_is_active (_tmp42_)) {
#line 2135 "WindowControl.c"
					WnckWorkspace* _tmp43_;
#line 407 "../lib/Services/WindowControl.vala"
					_tmp43_ = active_workspace;
#line 407 "../lib/Services/WindowControl.vala"
					_tmp41_ = _tmp43_ != NULL;
#line 2141 "WindowControl.c"
				} else {
#line 407 "../lib/Services/WindowControl.vala"
					_tmp41_ = FALSE;
#line 2145 "WindowControl.c"
				}
#line 407 "../lib/Services/WindowControl.vala"
				if (_tmp41_) {
#line 2149 "WindowControl.c"
					WnckWindow* _tmp44_;
					WnckWorkspace* _tmp45_;
#line 407 "../lib/Services/WindowControl.vala"
					_tmp44_ = window;
#line 407 "../lib/Services/WindowControl.vala"
					_tmp45_ = active_workspace;
#line 407 "../lib/Services/WindowControl.vala"
					_tmp40_ = wnck_window_is_in_viewport (_tmp44_, _tmp45_);
#line 2158 "WindowControl.c"
				} else {
#line 407 "../lib/Services/WindowControl.vala"
					_tmp40_ = FALSE;
#line 2162 "WindowControl.c"
				}
#line 407 "../lib/Services/WindowControl.vala"
				if (_tmp40_) {
#line 407 "../lib/Services/WindowControl.vala"
					_tmp39_ = TRUE;
#line 2168 "WindowControl.c"
				} else {
					WnckWindow* _tmp46_;
					WnckWindow* _tmp47_;
					WnckScreen* _tmp48_;
					WnckWindow* _tmp49_;
#line 408 "../lib/Services/WindowControl.vala"
					_tmp46_ = window;
#line 408 "../lib/Services/WindowControl.vala"
					_tmp47_ = window;
#line 408 "../lib/Services/WindowControl.vala"
					_tmp48_ = wnck_window_get_screen (_tmp47_);
#line 408 "../lib/Services/WindowControl.vala"
					_tmp49_ = wnck_screen_get_active_window (_tmp48_);
#line 408 "../lib/Services/WindowControl.vala"
					_tmp39_ = _tmp46_ == _tmp49_;
#line 2184 "WindowControl.c"
				}
#line 407 "../lib/Services/WindowControl.vala"
				if (_tmp39_) {
#line 2188 "WindowControl.c"
					GList* _tmp50_;
#line 409 "../lib/Services/WindowControl.vala"
					_tmp50_ = windows;
#line 2192 "WindowControl.c"
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
#line 409 "../lib/Services/WindowControl.vala"
						w_collection = _tmp50_;
#line 409 "../lib/Services/WindowControl.vala"
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
#line 2200 "WindowControl.c"
							WnckWindow* w = NULL;
#line 409 "../lib/Services/WindowControl.vala"
							w = (WnckWindow*) w_it->data;
#line 2204 "WindowControl.c"
							{
								gboolean _tmp51_ = FALSE;
								WnckWindow* _tmp52_;
#line 410 "../lib/Services/WindowControl.vala"
								_tmp52_ = w;
#line 410 "../lib/Services/WindowControl.vala"
								if (!wnck_window_is_minimized (_tmp52_)) {
#line 2212 "WindowControl.c"
									WnckWindow* _tmp53_;
									WnckWorkspace* _tmp54_;
#line 410 "../lib/Services/WindowControl.vala"
									_tmp53_ = w;
#line 410 "../lib/Services/WindowControl.vala"
									_tmp54_ = active_workspace;
#line 410 "../lib/Services/WindowControl.vala"
									_tmp51_ = wnck_window_is_in_viewport (_tmp53_, _tmp54_);
#line 2221 "WindowControl.c"
								} else {
#line 410 "../lib/Services/WindowControl.vala"
									_tmp51_ = FALSE;
#line 2225 "WindowControl.c"
								}
#line 410 "../lib/Services/WindowControl.vala"
								if (_tmp51_) {
#line 2229 "WindowControl.c"
									WnckWindow* _tmp55_;
#line 411 "../lib/Services/WindowControl.vala"
									_tmp55_ = w;
#line 411 "../lib/Services/WindowControl.vala"
									wnck_window_minimize (_tmp55_);
#line 412 "../lib/Services/WindowControl.vala"
									g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 2237 "WindowControl.c"
								}
							}
						}
					}
#line 414 "../lib/Services/WindowControl.vala"
					(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 414 "../lib/Services/WindowControl.vala"
					return;
#line 2246 "WindowControl.c"
				}
			}
		}
	}
#line 419 "../lib/Services/WindowControl.vala"
	_tmp56_ = windows;
#line 2253 "WindowControl.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 419 "../lib/Services/WindowControl.vala"
		window_collection = _tmp56_;
#line 419 "../lib/Services/WindowControl.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 2261 "WindowControl.c"
			WnckWindow* window = NULL;
#line 419 "../lib/Services/WindowControl.vala"
			window = (WnckWindow*) window_it->data;
#line 2265 "WindowControl.c"
			{
				WnckWorkspace* active_workspace = NULL;
				WnckWindow* _tmp57_;
				WnckScreen* _tmp58_;
				WnckWorkspace* _tmp59_;
				gboolean _tmp60_ = FALSE;
				WnckWorkspace* _tmp61_;
#line 420 "../lib/Services/WindowControl.vala"
				_tmp57_ = window;
#line 420 "../lib/Services/WindowControl.vala"
				_tmp58_ = wnck_window_get_screen (_tmp57_);
#line 420 "../lib/Services/WindowControl.vala"
				_tmp59_ = wnck_screen_get_active_workspace (_tmp58_);
#line 420 "../lib/Services/WindowControl.vala"
				active_workspace = _tmp59_;
#line 421 "../lib/Services/WindowControl.vala"
				_tmp61_ = active_workspace;
#line 421 "../lib/Services/WindowControl.vala"
				if (_tmp61_ != NULL) {
#line 2285 "WindowControl.c"
					WnckWindow* _tmp62_;
					WnckWorkspace* _tmp63_;
#line 421 "../lib/Services/WindowControl.vala"
					_tmp62_ = window;
#line 421 "../lib/Services/WindowControl.vala"
					_tmp63_ = active_workspace;
#line 421 "../lib/Services/WindowControl.vala"
					_tmp60_ = wnck_window_is_in_viewport (_tmp62_, _tmp63_);
#line 2294 "WindowControl.c"
				} else {
#line 421 "../lib/Services/WindowControl.vala"
					_tmp60_ = FALSE;
#line 2298 "WindowControl.c"
				}
#line 421 "../lib/Services/WindowControl.vala"
				if (_tmp60_) {
#line 2302 "WindowControl.c"
					GList* _tmp64_;
#line 422 "../lib/Services/WindowControl.vala"
					_tmp64_ = windows;
#line 2306 "WindowControl.c"
					{
						GList* w_collection = NULL;
						GList* w_it = NULL;
#line 422 "../lib/Services/WindowControl.vala"
						w_collection = _tmp64_;
#line 422 "../lib/Services/WindowControl.vala"
						for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
#line 2314 "WindowControl.c"
							WnckWindow* w = NULL;
#line 422 "../lib/Services/WindowControl.vala"
							w = (WnckWindow*) w_it->data;
#line 2318 "WindowControl.c"
							{
								WnckWindow* _tmp65_;
								WnckWorkspace* _tmp66_;
#line 423 "../lib/Services/WindowControl.vala"
								_tmp65_ = w;
#line 423 "../lib/Services/WindowControl.vala"
								_tmp66_ = active_workspace;
#line 423 "../lib/Services/WindowControl.vala"
								if (wnck_window_is_in_viewport (_tmp65_, _tmp66_)) {
#line 2328 "WindowControl.c"
									WnckWindow* _tmp67_;
#line 424 "../lib/Services/WindowControl.vala"
									_tmp67_ = w;
#line 424 "../lib/Services/WindowControl.vala"
									plank_window_control_center_and_focus_window (_tmp67_, event_time);
#line 425 "../lib/Services/WindowControl.vala"
									g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 2336 "WindowControl.c"
								}
							}
						}
					}
#line 427 "../lib/Services/WindowControl.vala"
					(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 427 "../lib/Services/WindowControl.vala"
					return;
#line 2345 "WindowControl.c"
				}
			}
		}
	}
#line 432 "../lib/Services/WindowControl.vala"
	_tmp68_ = windows;
#line 432 "../lib/Services/WindowControl.vala"
	_tmp69_ = g_list_nth_data (_tmp68_, (guint) 0);
#line 432 "../lib/Services/WindowControl.vala"
	_tmp70_ = windows;
#line 432 "../lib/Services/WindowControl.vala"
	plank_window_control_intelligent_focus_off_viewport_window ((WnckWindow*) _tmp69_, _tmp70_, event_time);
#line 363 "../lib/Services/WindowControl.vala"
	(windows == NULL) ? NULL : (windows = (g_list_free (windows), NULL));
#line 2360 "WindowControl.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 435 "../lib/Services/WindowControl.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 435 "../lib/Services/WindowControl.vala"
	return _data1_;
#line 2370 "WindowControl.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 435 "../lib/Services/WindowControl.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 435 "../lib/Services/WindowControl.vala"
		g_slice_free (Block1Data, _data1_);
#line 2382 "WindowControl.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 458 "../lib/Services/WindowControl.vala"
	return self ? g_object_ref (self) : NULL;
#line 2391 "WindowControl.c"
}

static gboolean
__lambda4_ (Block1Data* _data1_)
{
	WnckWindow* _tmp0_;
	gboolean result;
#line 460 "../lib/Services/WindowControl.vala"
	plank_window_control_delayed_focus_timer_id = 0U;
#line 461 "../lib/Services/WindowControl.vala"
	_tmp0_ = plank_window_control_delayed_focus_window;
#line 461 "../lib/Services/WindowControl.vala"
	wnck_window_activate (_tmp0_, _data1_->event_time);
#line 462 "../lib/Services/WindowControl.vala"
	_g_object_unref0 (plank_window_control_delayed_focus_window);
#line 462 "../lib/Services/WindowControl.vala"
	plank_window_control_delayed_focus_window = NULL;
#line 463 "../lib/Services/WindowControl.vala"
	result = FALSE;
#line 463 "../lib/Services/WindowControl.vala"
	return result;
#line 2413 "WindowControl.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ (self);
#line 459 "../lib/Services/WindowControl.vala"
	return result;
#line 2423 "WindowControl.c"
}

static void
plank_window_control_intelligent_focus_off_viewport_window (WnckWindow* targetWindow,
                                                            GList* additional_windows,
                                                            guint32 event_time)
{
	Block1Data* _data1_;
	WnckWindow* _tmp5_;
#line 435 "../lib/Services/WindowControl.vala"
	g_return_if_fail (targetWindow != NULL);
#line 435 "../lib/Services/WindowControl.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 435 "../lib/Services/WindowControl.vala"
	_data1_->_ref_count_ = 1;
#line 435 "../lib/Services/WindowControl.vala"
	_data1_->event_time = event_time;
#line 438 "../lib/Services/WindowControl.vala"
	additional_windows = g_list_reverse (additional_windows);
#line 2443 "WindowControl.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 440 "../lib/Services/WindowControl.vala"
		window_collection = additional_windows;
#line 440 "../lib/Services/WindowControl.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 2451 "WindowControl.c"
			WnckWindow* window = NULL;
#line 440 "../lib/Services/WindowControl.vala"
			window = (WnckWindow*) window_it->data;
#line 2455 "WindowControl.c"
			{
				WnckWindow* _tmp0_;
				gboolean _tmp1_ = FALSE;
				WnckWindow* _tmp2_;
#line 441 "../lib/Services/WindowControl.vala"
				_tmp0_ = window;
#line 441 "../lib/Services/WindowControl.vala"
				if (_tmp0_ == targetWindow) {
#line 442 "../lib/Services/WindowControl.vala"
					continue;
#line 2466 "WindowControl.c"
				}
#line 443 "../lib/Services/WindowControl.vala"
				_tmp2_ = window;
#line 443 "../lib/Services/WindowControl.vala"
				if (!wnck_window_is_minimized (_tmp2_)) {
#line 2472 "WindowControl.c"
					WnckWindow* _tmp3_;
#line 443 "../lib/Services/WindowControl.vala"
					_tmp3_ = window;
#line 443 "../lib/Services/WindowControl.vala"
					_tmp1_ = plank_window_control_windows_share_viewport (targetWindow, _tmp3_);
#line 2478 "WindowControl.c"
				} else {
#line 443 "../lib/Services/WindowControl.vala"
					_tmp1_ = FALSE;
#line 2482 "WindowControl.c"
				}
#line 443 "../lib/Services/WindowControl.vala"
				if (_tmp1_) {
#line 2486 "WindowControl.c"
					WnckWindow* _tmp4_;
#line 444 "../lib/Services/WindowControl.vala"
					_tmp4_ = window;
#line 444 "../lib/Services/WindowControl.vala"
					plank_window_control_center_and_focus_window (_tmp4_, _data1_->event_time);
#line 445 "../lib/Services/WindowControl.vala"
					g_usleep ((gulong) PLANK_WINDOW_CONTROL_WINDOW_GROUP_DELAY);
#line 2494 "WindowControl.c"
				}
			}
		}
	}
#line 449 "../lib/Services/WindowControl.vala"
	plank_window_control_center_and_focus_window (targetWindow, _data1_->event_time);
#line 451 "../lib/Services/WindowControl.vala"
	if (g_list_length (additional_windows) <= ((guint) 1)) {
#line 452 "../lib/Services/WindowControl.vala"
		block1_data_unref (_data1_);
#line 452 "../lib/Services/WindowControl.vala"
		_data1_ = NULL;
#line 452 "../lib/Services/WindowControl.vala"
		return;
#line 2509 "WindowControl.c"
	}
#line 456 "../lib/Services/WindowControl.vala"
	if (plank_window_control_delayed_focus_timer_id > 0U) {
#line 457 "../lib/Services/WindowControl.vala"
		g_source_remove (plank_window_control_delayed_focus_timer_id);
#line 2515 "WindowControl.c"
	}
#line 458 "../lib/Services/WindowControl.vala"
	_tmp5_ = _g_object_ref0 (targetWindow);
#line 458 "../lib/Services/WindowControl.vala"
	_g_object_unref0 (plank_window_control_delayed_focus_window);
#line 458 "../lib/Services/WindowControl.vala"
	plank_window_control_delayed_focus_window = _tmp5_;
#line 459 "../lib/Services/WindowControl.vala"
	plank_window_control_delayed_focus_timer_id = gdk_threads_add_timeout (PLANK_WINDOW_CONTROL_VIEWPORT_CHANGE_DELAY, ___lambda4__gsource_func, _data1_);
#line 435 "../lib/Services/WindowControl.vala"
	block1_data_unref (_data1_);
#line 435 "../lib/Services/WindowControl.vala"
	_data1_ = NULL;
#line 2529 "WindowControl.c"
}

static gboolean
plank_window_control_windows_share_viewport (WnckWindow* first,
                                             WnckWindow* second)
{
	gboolean _tmp0_ = FALSE;
	WnckWorkspace* wksp = NULL;
	WnckWorkspace* _tmp1_;
	WnckWorkspace* _tmp2_;
	WnckWorkspace* _tmp4_;
	GdkRectangle firstGeo = {0};
	GdkRectangle _tmp5_ = {0};
	GdkRectangle secondGeo = {0};
	GdkRectangle _tmp6_ = {0};
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	WnckWorkspace* _tmp15_;
	WnckWorkspace* _tmp16_;
	WnckWorkspace* _tmp17_;
	WnckWorkspace* _tmp18_;
	gint viewportWidth = 0;
	WnckScreen* _tmp19_;
	gint viewportHeight = 0;
	WnckScreen* _tmp20_;
	gint firstViewportX = 0;
	GdkRectangle _tmp21_;
	GdkRectangle _tmp22_;
	gint firstViewportY = 0;
	GdkRectangle _tmp23_;
	GdkRectangle _tmp24_;
	GdkRectangle viewpRect = {0};
	GdkRectangle _tmp25_ = {0};
	GdkRectangle _tmp26_;
	gboolean result;
#line 469 "../lib/Services/WindowControl.vala"
	if (first == NULL) {
#line 469 "../lib/Services/WindowControl.vala"
		_tmp0_ = TRUE;
#line 2575 "WindowControl.c"
	} else {
#line 469 "../lib/Services/WindowControl.vala"
		_tmp0_ = second == NULL;
#line 2579 "WindowControl.c"
	}
#line 469 "../lib/Services/WindowControl.vala"
	if (_tmp0_) {
#line 470 "../lib/Services/WindowControl.vala"
		result = FALSE;
#line 470 "../lib/Services/WindowControl.vala"
		return result;
#line 2587 "WindowControl.c"
	}
#line 472 "../lib/Services/WindowControl.vala"
	_tmp1_ = wnck_window_get_workspace (first);
#line 472 "../lib/Services/WindowControl.vala"
	wksp = _tmp1_;
#line 473 "../lib/Services/WindowControl.vala"
	_tmp2_ = wksp;
#line 473 "../lib/Services/WindowControl.vala"
	if (_tmp2_ == NULL) {
#line 2597 "WindowControl.c"
		WnckWorkspace* _tmp3_;
#line 474 "../lib/Services/WindowControl.vala"
		_tmp3_ = wnck_window_get_workspace (second);
#line 474 "../lib/Services/WindowControl.vala"
		wksp = _tmp3_;
#line 2603 "WindowControl.c"
	}
#line 476 "../lib/Services/WindowControl.vala"
	_tmp4_ = wksp;
#line 476 "../lib/Services/WindowControl.vala"
	if (_tmp4_ == NULL) {
#line 477 "../lib/Services/WindowControl.vala"
		result = FALSE;
#line 477 "../lib/Services/WindowControl.vala"
		return result;
#line 2613 "WindowControl.c"
	}
#line 479 "../lib/Services/WindowControl.vala"
	firstGeo = _tmp5_;
#line 480 "../lib/Services/WindowControl.vala"
	secondGeo = _tmp6_;
#line 482 "../lib/Services/WindowControl.vala"
	wnck_window_get_geometry (first, &_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
#line 482 "../lib/Services/WindowControl.vala"
	firstGeo.x = _tmp7_;
#line 482 "../lib/Services/WindowControl.vala"
	firstGeo.y = _tmp8_;
#line 482 "../lib/Services/WindowControl.vala"
	firstGeo.width = _tmp9_;
#line 482 "../lib/Services/WindowControl.vala"
	firstGeo.height = _tmp10_;
#line 483 "../lib/Services/WindowControl.vala"
	wnck_window_get_geometry (second, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
#line 483 "../lib/Services/WindowControl.vala"
	secondGeo.x = _tmp11_;
#line 483 "../lib/Services/WindowControl.vala"
	secondGeo.y = _tmp12_;
#line 483 "../lib/Services/WindowControl.vala"
	secondGeo.width = _tmp13_;
#line 483 "../lib/Services/WindowControl.vala"
	secondGeo.height = _tmp14_;
#line 485 "../lib/Services/WindowControl.vala"
	_tmp15_ = wksp;
#line 485 "../lib/Services/WindowControl.vala"
	firstGeo.x = firstGeo.x + wnck_workspace_get_viewport_x (_tmp15_);
#line 486 "../lib/Services/WindowControl.vala"
	_tmp16_ = wksp;
#line 486 "../lib/Services/WindowControl.vala"
	firstGeo.y = firstGeo.y + wnck_workspace_get_viewport_y (_tmp16_);
#line 488 "../lib/Services/WindowControl.vala"
	_tmp17_ = wksp;
#line 488 "../lib/Services/WindowControl.vala"
	secondGeo.x = secondGeo.x + wnck_workspace_get_viewport_x (_tmp17_);
#line 489 "../lib/Services/WindowControl.vala"
	_tmp18_ = wksp;
#line 489 "../lib/Services/WindowControl.vala"
	secondGeo.y = secondGeo.y + wnck_workspace_get_viewport_y (_tmp18_);
#line 491 "../lib/Services/WindowControl.vala"
	_tmp19_ = wnck_window_get_screen (first);
#line 491 "../lib/Services/WindowControl.vala"
	viewportWidth = wnck_screen_get_width (_tmp19_);
#line 492 "../lib/Services/WindowControl.vala"
	_tmp20_ = wnck_window_get_screen (first);
#line 492 "../lib/Services/WindowControl.vala"
	viewportHeight = wnck_screen_get_height (_tmp20_);
#line 494 "../lib/Services/WindowControl.vala"
	_tmp21_ = firstGeo;
#line 494 "../lib/Services/WindowControl.vala"
	_tmp22_ = firstGeo;
#line 494 "../lib/Services/WindowControl.vala"
	firstViewportX = ((_tmp21_.x + (_tmp22_.width / 2)) / viewportWidth) * viewportWidth;
#line 495 "../lib/Services/WindowControl.vala"
	_tmp23_ = firstGeo;
#line 495 "../lib/Services/WindowControl.vala"
	_tmp24_ = firstGeo;
#line 495 "../lib/Services/WindowControl.vala"
	firstViewportY = ((_tmp23_.y + (_tmp24_.height / 2)) / viewportHeight) * viewportHeight;
#line 497 "../lib/Services/WindowControl.vala"
	_tmp25_.x = firstViewportX;
#line 497 "../lib/Services/WindowControl.vala"
	_tmp25_.y = firstViewportY;
#line 497 "../lib/Services/WindowControl.vala"
	_tmp25_.width = viewportWidth;
#line 497 "../lib/Services/WindowControl.vala"
	_tmp25_.height = viewportHeight;
#line 497 "../lib/Services/WindowControl.vala"
	viewpRect = _tmp25_;
#line 498 "../lib/Services/WindowControl.vala"
	_tmp26_ = secondGeo;
#line 498 "../lib/Services/WindowControl.vala"
	result = gdk_rectangle_intersect (&viewpRect, &_tmp26_, NULL);
#line 498 "../lib/Services/WindowControl.vala"
	return result;
#line 2691 "WindowControl.c"
}

static void
plank_window_control_center_and_focus_window (WnckWindow* w,
                                              guint32 event_time)
{
	WnckWorkspace* workspace = NULL;
	WnckWorkspace* _tmp0_;
	gboolean _tmp1_ = FALSE;
	WnckWorkspace* _tmp2_;
#line 501 "../lib/Services/WindowControl.vala"
	g_return_if_fail (w != NULL);
#line 503 "../lib/Services/WindowControl.vala"
	_tmp0_ = wnck_window_get_workspace (w);
#line 503 "../lib/Services/WindowControl.vala"
	workspace = _tmp0_;
#line 505 "../lib/Services/WindowControl.vala"
	_tmp2_ = workspace;
#line 505 "../lib/Services/WindowControl.vala"
	if (_tmp2_ != NULL) {
#line 2712 "WindowControl.c"
		WnckWorkspace* _tmp3_;
		WnckScreen* _tmp4_;
		WnckWorkspace* _tmp5_;
#line 505 "../lib/Services/WindowControl.vala"
		_tmp3_ = workspace;
#line 505 "../lib/Services/WindowControl.vala"
		_tmp4_ = wnck_window_get_screen (w);
#line 505 "../lib/Services/WindowControl.vala"
		_tmp5_ = wnck_screen_get_active_workspace (_tmp4_);
#line 505 "../lib/Services/WindowControl.vala"
		_tmp1_ = _tmp3_ != _tmp5_;
#line 2724 "WindowControl.c"
	} else {
#line 505 "../lib/Services/WindowControl.vala"
		_tmp1_ = FALSE;
#line 2728 "WindowControl.c"
	}
#line 505 "../lib/Services/WindowControl.vala"
	if (_tmp1_) {
#line 2732 "WindowControl.c"
		WnckWorkspace* _tmp6_;
#line 506 "../lib/Services/WindowControl.vala"
		_tmp6_ = workspace;
#line 506 "../lib/Services/WindowControl.vala"
		wnck_workspace_activate (_tmp6_, event_time);
#line 2738 "WindowControl.c"
	}
#line 508 "../lib/Services/WindowControl.vala"
	if (wnck_window_is_minimized (w)) {
#line 509 "../lib/Services/WindowControl.vala"
		wnck_window_unminimize (w, event_time);
#line 2744 "WindowControl.c"
	}
#line 511 "../lib/Services/WindowControl.vala"
	wnck_window_activate_transient (w, event_time);
#line 2748 "WindowControl.c"
}

void
plank_window_control_get_easy_geometry (WnckWindow* w,
                                        GdkRectangle* result)
{
	GdkRectangle geo = {0};
	GdkRectangle _tmp0_ = {0};
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 514 "../lib/Services/WindowControl.vala"
	g_return_if_fail (w != NULL);
#line 516 "../lib/Services/WindowControl.vala"
	geo = _tmp0_;
#line 518 "../lib/Services/WindowControl.vala"
	wnck_window_get_geometry (w, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 518 "../lib/Services/WindowControl.vala"
	geo.x = _tmp1_;
#line 518 "../lib/Services/WindowControl.vala"
	geo.y = _tmp2_;
#line 518 "../lib/Services/WindowControl.vala"
	geo.width = _tmp3_;
#line 518 "../lib/Services/WindowControl.vala"
	geo.height = _tmp4_;
#line 520 "../lib/Services/WindowControl.vala"
	*result = geo;
#line 520 "../lib/Services/WindowControl.vala"
	return;
#line 2779 "WindowControl.c"
}

static void
plank_window_control_class_init (PlankWindowControlClass * klass,
                                 gpointer klass_data)
{
#line 39 "../lib/Services/WindowControl.vala"
	plank_window_control_parent_class = g_type_class_peek_parent (klass);
#line 39 "../lib/Services/WindowControl.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_window_control_finalize;
#line 2790 "WindowControl.c"
}

static void
plank_window_control_instance_init (PlankWindowControl * self,
                                    gpointer klass)
{
}

static void
plank_window_control_finalize (GObject * obj)
{
	PlankWindowControl * self;
#line 39 "../lib/Services/WindowControl.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_WINDOW_CONTROL, PlankWindowControl);
#line 39 "../lib/Services/WindowControl.vala"
	G_OBJECT_CLASS (plank_window_control_parent_class)->finalize (obj);
#line 2807 "WindowControl.c"
}

static GType
plank_window_control_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankWindowControlClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_window_control_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankWindowControl), 0, (GInstanceInitFunc) plank_window_control_instance_init, NULL };
	GType plank_window_control_type_id;
	plank_window_control_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankWindowControl", &g_define_type_info, 0);
	return plank_window_control_type_id;
}

GType
plank_window_control_get_type (void)
{
	static volatile gsize plank_window_control_type_id__once = 0;
	if (g_once_init_enter (&plank_window_control_type_id__once)) {
		GType plank_window_control_type_id;
		plank_window_control_type_id = plank_window_control_get_type_once ();
		g_once_init_leave (&plank_window_control_type_id__once, plank_window_control_type_id);
	}
	return plank_window_control_type_id__once;
}

