/* Color.c generated by valac 0.56.18, the Vala compiler
 * generated from Color.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

static void plank_color_hsv_to_rgb (gdouble h,
                             gdouble s,
                             gdouble v,
                             gdouble* r,
                             gdouble* g,
                             gdouble* b);
static void plank_color_rgb_to_hsv (gdouble r,
                             gdouble g,
                             gdouble b,
                             gdouble* h,
                             gdouble* s,
                             gdouble* v);
static void plank_color_rgb_to_hsl (gdouble r,
                             gdouble g,
                             gdouble b,
                             gdouble* h,
                             gdouble* s,
                             gdouble* l);
static void plank_color_hsl_to_rgb (gdouble h,
                             gdouble s,
                             gdouble l,
                             gdouble* r,
                             gdouble* g,
                             gdouble* b);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

/**
 * Create new color for the given HSV values while
 * h in [0,360), s in [0,1] and v in [0,1]
 *
 * @param h the hue for the color
 * @param s the saturation for the color
 * @param v the value for the color
 * @return new {@link Color} based on the HSV values
 */
void
plank_color_from_hsv (gdouble h,
                      gdouble s,
                      gdouble v,
                      PlankColor* result)
{
	PlankColor _result_ = {0};
	PlankColor _tmp0_ = {0};
#line 38 "../lib/Drawing/Color.vala"
	_tmp0_.red = 1.0;
#line 38 "../lib/Drawing/Color.vala"
	_tmp0_.green = 1.0;
#line 38 "../lib/Drawing/Color.vala"
	_tmp0_.blue = 1.0;
#line 38 "../lib/Drawing/Color.vala"
	_tmp0_.alpha = 1.0;
#line 38 "../lib/Drawing/Color.vala"
	_result_ = _tmp0_;
#line 39 "../lib/Drawing/Color.vala"
	plank_color_set_hsv (&_result_, h, s, v);
#line 40 "../lib/Drawing/Color.vala"
	*result = _result_;
#line 40 "../lib/Drawing/Color.vala"
	return;
#line 111 "Color.c"
}

/**
 * Create new color for the given HSL values while
 * h in [0,360), s in [0,1] and l in [0,1]
 *
 * @param h the hue for the color
 * @param s the saturation for the color
 * @param l the lightness for the color
 * @return new {@link Color} based on the HSL values
 */
void
plank_color_from_hsl (gdouble h,
                      gdouble s,
                      gdouble l,
                      PlankColor* result)
{
	PlankColor _result_ = {0};
	PlankColor _tmp0_ = {0};
#line 54 "../lib/Drawing/Color.vala"
	_tmp0_.red = 1.0;
#line 54 "../lib/Drawing/Color.vala"
	_tmp0_.green = 1.0;
#line 54 "../lib/Drawing/Color.vala"
	_tmp0_.blue = 1.0;
#line 54 "../lib/Drawing/Color.vala"
	_tmp0_.alpha = 1.0;
#line 54 "../lib/Drawing/Color.vala"
	_result_ = _tmp0_;
#line 55 "../lib/Drawing/Color.vala"
	plank_color_set_hsl (&_result_, h, s, l);
#line 56 "../lib/Drawing/Color.vala"
	*result = _result_;
#line 56 "../lib/Drawing/Color.vala"
	return;
#line 147 "Color.c"
}

/**
 * Set HSV color values of this color.
 */
void
plank_color_set_hsv (PlankColor *self,
                     gdouble h,
                     gdouble s,
                     gdouble v)
{
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 64 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp0_, &_tmp1_, &_tmp2_);
#line 64 "../lib/Drawing/Color.vala"
	(*self).red = _tmp0_;
#line 64 "../lib/Drawing/Color.vala"
	(*self).green = _tmp1_;
#line 64 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp2_;
#line 170 "Color.c"
}

/**
 * Sets the hue for the color.
 *
 * @param hue the new hue for the color
 */
void
plank_color_set_hue (PlankColor *self,
                     gdouble hue)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 72 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((hue >= ((gdouble) 0)) && (hue <= ((gdouble) 360)), "hue >= 0 && hue <= 360");
#line 76 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 76 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 76 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 76 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 77 "../lib/Drawing/Color.vala"
	h = hue;
#line 78 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 78 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 78 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 78 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 211 "Color.c"
}

/**
 * Sets the saturation for the color.
 *
 * @param sat the new saturation for the color
 */
void
plank_color_set_sat (PlankColor *self,
                     gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 86 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1");
#line 90 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 90 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 90 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 90 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 91 "../lib/Drawing/Color.vala"
	s = sat;
#line 92 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 92 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 92 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 92 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 252 "Color.c"
}

/**
 * Sets the value for the color.
 *
 * @param val the new value for the color
 */
void
plank_color_set_val (PlankColor *self,
                     gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 100 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1");
#line 104 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 104 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 104 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 104 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 105 "../lib/Drawing/Color.vala"
	v = val;
#line 106 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 106 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 106 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 106 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 293 "Color.c"
}

/**
 * Get HSV color values of this color.
 */
void
plank_color_get_hsv (PlankColor *self,
                     gdouble* h,
                     gdouble* s,
                     gdouble* v)
{
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 114 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 114 "../lib/Drawing/Color.vala"
	_vala_h = _tmp0_;
#line 114 "../lib/Drawing/Color.vala"
	_vala_s = _tmp1_;
#line 114 "../lib/Drawing/Color.vala"
	_vala_v = _tmp2_;
#line 112 "../lib/Drawing/Color.vala"
	if (h) {
#line 112 "../lib/Drawing/Color.vala"
		*h = _vala_h;
#line 323 "Color.c"
	}
#line 112 "../lib/Drawing/Color.vala"
	if (s) {
#line 112 "../lib/Drawing/Color.vala"
		*s = _vala_s;
#line 329 "Color.c"
	}
#line 112 "../lib/Drawing/Color.vala"
	if (v) {
#line 112 "../lib/Drawing/Color.vala"
		*v = _vala_v;
#line 335 "Color.c"
	}
}

/**
 * Returns the hue for the color.
 *
 * @return the hue for the color
 */
gdouble
plank_color_get_hue (PlankColor *self)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 125 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 125 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 125 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 125 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 126 "../lib/Drawing/Color.vala"
	result = h;
#line 126 "../lib/Drawing/Color.vala"
	return result;
#line 366 "Color.c"
}

/**
 * Returns the saturation for the color.
 *
 * @return the saturation for the color
 */
gdouble
plank_color_get_sat (PlankColor *self)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 137 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 137 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 137 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 137 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 138 "../lib/Drawing/Color.vala"
	result = s;
#line 138 "../lib/Drawing/Color.vala"
	return result;
#line 396 "Color.c"
}

/**
 * Returns the value for the color.
 *
 * @return the value for the color
 */
gdouble
plank_color_get_val (PlankColor *self)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble result;
#line 149 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 149 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 149 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 149 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 150 "../lib/Drawing/Color.vala"
	result = v;
#line 150 "../lib/Drawing/Color.vala"
	return result;
#line 426 "Color.c"
}

/**
 * Increases the color's hue.
 *
 * @param val the amount to add to the hue
 */
void
plank_color_add_hue (PlankColor *self,
                     gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 161 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 161 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 161 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 161 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 162 "../lib/Drawing/Color.vala"
	h = fmod (fmod (h + val, 360) + 360, 360);
#line 163 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 163 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 163 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 163 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 465 "Color.c"
}

/**
 * Assures the color's saturation is greater than or equal to the given one.
 *
 * @param sat the minimum saturation
 */
void
plank_color_set_min_sat (PlankColor *self,
                         gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 171 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1");
#line 175 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 175 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 175 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 175 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 176 "../lib/Drawing/Color.vala"
	s = MAX (s, sat);
#line 177 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 177 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 177 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 177 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 506 "Color.c"
}

/**
 * Assures the color's value is greater than or equal to the given one.
 *
 * @param val the minimum value
 */
void
plank_color_set_min_val (PlankColor *self,
                         gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 185 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1");
#line 189 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 189 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 189 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 189 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 190 "../lib/Drawing/Color.vala"
	v = MAX (v, val);
#line 191 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 191 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 191 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 191 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 547 "Color.c"
}

/**
 * Assures the color's saturation is less than or equal to the given one.
 *
 * @param sat the maximum saturation
 */
void
plank_color_set_max_sat (PlankColor *self,
                         gdouble sat)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 199 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((sat >= ((gdouble) 0)) && (sat <= ((gdouble) 1)), "sat >= 0 && sat <= 1");
#line 203 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 203 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 203 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 203 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 204 "../lib/Drawing/Color.vala"
	s = MIN (s, sat);
#line 205 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 205 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 205 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 205 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 588 "Color.c"
}

/**
 * Assures the color's value is less than or equal to the given one.
 *
 * @param val the maximum value
 */
void
plank_color_set_max_val (PlankColor *self,
                         gdouble val)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 213 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((val >= ((gdouble) 0)) && (val <= ((gdouble) 1)), "val >= 0 && val <= 1");
#line 217 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 217 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 217 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 217 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 218 "../lib/Drawing/Color.vala"
	v = MIN (v, val);
#line 219 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 219 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 219 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 219 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 629 "Color.c"
}

/**
 * Multiplies the color's saturation using the amount.
 *
 * @param amount amount to multiply the saturation by
 */
void
plank_color_multiply_sat (PlankColor *self,
                          gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 227 "../lib/Drawing/Color.vala"
	_vala_return_if_fail (amount >= ((gdouble) 0), "amount >= 0");
#line 231 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 231 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 231 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 231 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 232 "../lib/Drawing/Color.vala"
	s = MIN ((gdouble) 1, s * amount);
#line 233 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 233 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 233 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 233 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 670 "Color.c"
}

/**
 * Brighten the color's value using the value.
 *
 * @param amount percent of the value to brighten by
 */
void
plank_color_brighten_val (PlankColor *self,
                          gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 241 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1");
#line 245 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 245 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 245 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 245 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 246 "../lib/Drawing/Color.vala"
	v = MIN ((gdouble) 1, v + ((1 - v) * amount));
#line 247 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 247 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 247 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 247 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 711 "Color.c"
}

/**
 * Darkens the color's value using the value.
 *
 * @param amount percent of the value to darken by
 */
void
plank_color_darken_val (PlankColor *self,
                        gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 255 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1");
#line 259 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 259 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 259 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 259 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 260 "../lib/Drawing/Color.vala"
	v = MAX ((gdouble) 0, v - ((1 - v) * amount));
#line 261 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 261 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 261 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 261 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 752 "Color.c"
}

/**
 * Darkens the color's value using the saturtion.
 *
 * @param amount percent of the saturation to darken by
 */
void
plank_color_darken_by_sat (PlankColor *self,
                           gdouble amount)
{
	gdouble h = 0.0;
	gdouble s = 0.0;
	gdouble v = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 269 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((amount >= ((gdouble) 0)) && (amount <= ((gdouble) 1)), "amount >= 0 && amount <= 1");
#line 273 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsv ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 273 "../lib/Drawing/Color.vala"
	h = _tmp0_;
#line 273 "../lib/Drawing/Color.vala"
	s = _tmp1_;
#line 273 "../lib/Drawing/Color.vala"
	v = _tmp2_;
#line 274 "../lib/Drawing/Color.vala"
	v = MAX ((gdouble) 0, v - (amount * s));
#line 275 "../lib/Drawing/Color.vala"
	plank_color_hsv_to_rgb (h, s, v, &_tmp3_, &_tmp4_, &_tmp5_);
#line 275 "../lib/Drawing/Color.vala"
	(*self).red = _tmp3_;
#line 275 "../lib/Drawing/Color.vala"
	(*self).green = _tmp4_;
#line 275 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp5_;
#line 793 "Color.c"
}

/**
 * Get HSL color values of this color.
 */
void
plank_color_get_hsl (PlankColor *self,
                     gdouble* h,
                     gdouble* s,
                     gdouble* l)
{
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_l = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 283 "../lib/Drawing/Color.vala"
	plank_color_rgb_to_hsl ((*self).red, (*self).green, (*self).blue, &_tmp0_, &_tmp1_, &_tmp2_);
#line 283 "../lib/Drawing/Color.vala"
	_vala_h = _tmp0_;
#line 283 "../lib/Drawing/Color.vala"
	_vala_s = _tmp1_;
#line 283 "../lib/Drawing/Color.vala"
	_vala_l = _tmp2_;
#line 281 "../lib/Drawing/Color.vala"
	if (h) {
#line 281 "../lib/Drawing/Color.vala"
		*h = _vala_h;
#line 823 "Color.c"
	}
#line 281 "../lib/Drawing/Color.vala"
	if (s) {
#line 281 "../lib/Drawing/Color.vala"
		*s = _vala_s;
#line 829 "Color.c"
	}
#line 281 "../lib/Drawing/Color.vala"
	if (l) {
#line 281 "../lib/Drawing/Color.vala"
		*l = _vala_l;
#line 835 "Color.c"
	}
}

/**
 * Set HSL color values of this color.
 */
void
plank_color_set_hsl (PlankColor *self,
                     gdouble h,
                     gdouble s,
                     gdouble v)
{
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
#line 291 "../lib/Drawing/Color.vala"
	plank_color_hsl_to_rgb (h, s, v, &_tmp0_, &_tmp1_, &_tmp2_);
#line 291 "../lib/Drawing/Color.vala"
	(*self).red = _tmp0_;
#line 291 "../lib/Drawing/Color.vala"
	(*self).green = _tmp1_;
#line 291 "../lib/Drawing/Color.vala"
	(*self).blue = _tmp2_;
#line 859 "Color.c"
}

static void
plank_color_rgb_to_hsv (gdouble r,
                        gdouble g,
                        gdouble b,
                        gdouble* h,
                        gdouble* s,
                        gdouble* v)
{
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_v = 0.0;
	gdouble min = 0.0;
	gdouble max = 0.0;
	gdouble delta = 0.0;
#line 294 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((r >= ((gdouble) 0)) && (r <= ((gdouble) 1)), "r >= 0 && r <= 1");
#line 294 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((g >= ((gdouble) 0)) && (g <= ((gdouble) 1)), "g >= 0 && g <= 1");
#line 294 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((b >= ((gdouble) 0)) && (b <= ((gdouble) 1)), "b >= 0 && b <= 1");
#line 299 "../lib/Drawing/Color.vala"
	_vala_v = MAX (r, MAX (g, b));
#line 300 "../lib/Drawing/Color.vala"
	if (_vala_v == ((gdouble) 0)) {
#line 301 "../lib/Drawing/Color.vala"
		_vala_h = (gdouble) 0;
#line 302 "../lib/Drawing/Color.vala"
		_vala_s = (gdouble) 0;
#line 303 "../lib/Drawing/Color.vala"
		if (h) {
#line 303 "../lib/Drawing/Color.vala"
			*h = _vala_h;
#line 894 "Color.c"
		}
#line 303 "../lib/Drawing/Color.vala"
		if (s) {
#line 303 "../lib/Drawing/Color.vala"
			*s = _vala_s;
#line 900 "Color.c"
		}
#line 303 "../lib/Drawing/Color.vala"
		if (v) {
#line 303 "../lib/Drawing/Color.vala"
			*v = _vala_v;
#line 906 "Color.c"
		}
#line 303 "../lib/Drawing/Color.vala"
		return;
#line 910 "Color.c"
	}
#line 307 "../lib/Drawing/Color.vala"
	r = r / _vala_v;
#line 308 "../lib/Drawing/Color.vala"
	g = g / _vala_v;
#line 309 "../lib/Drawing/Color.vala"
	b = b / _vala_v;
#line 311 "../lib/Drawing/Color.vala"
	min = MIN (r, MIN (g, b));
#line 312 "../lib/Drawing/Color.vala"
	max = MAX (r, MAX (g, b));
#line 314 "../lib/Drawing/Color.vala"
	delta = max - min;
#line 315 "../lib/Drawing/Color.vala"
	_vala_s = delta;
#line 316 "../lib/Drawing/Color.vala"
	if (_vala_s == ((gdouble) 0)) {
#line 317 "../lib/Drawing/Color.vala"
		_vala_h = (gdouble) 0;
#line 318 "../lib/Drawing/Color.vala"
		if (h) {
#line 318 "../lib/Drawing/Color.vala"
			*h = _vala_h;
#line 934 "Color.c"
		}
#line 318 "../lib/Drawing/Color.vala"
		if (s) {
#line 318 "../lib/Drawing/Color.vala"
			*s = _vala_s;
#line 940 "Color.c"
		}
#line 318 "../lib/Drawing/Color.vala"
		if (v) {
#line 318 "../lib/Drawing/Color.vala"
			*v = _vala_v;
#line 946 "Color.c"
		}
#line 318 "../lib/Drawing/Color.vala"
		return;
#line 950 "Color.c"
	}
#line 322 "../lib/Drawing/Color.vala"
	r = (r - min) / delta;
#line 323 "../lib/Drawing/Color.vala"
	g = (g - min) / delta;
#line 324 "../lib/Drawing/Color.vala"
	b = (b - min) / delta;
#line 326 "../lib/Drawing/Color.vala"
	if (max == r) {
#line 327 "../lib/Drawing/Color.vala"
		_vala_h = 0 + (60 * (g - b));
#line 328 "../lib/Drawing/Color.vala"
		if (_vala_h < ((gdouble) 0)) {
#line 329 "../lib/Drawing/Color.vala"
			_vala_h = _vala_h + 360;
#line 966 "Color.c"
		}
	} else {
#line 330 "../lib/Drawing/Color.vala"
		if (max == g) {
#line 331 "../lib/Drawing/Color.vala"
			_vala_h = 120 + (60 * (b - r));
#line 973 "Color.c"
		} else {
#line 333 "../lib/Drawing/Color.vala"
			_vala_h = 240 + (60 * (r - g));
#line 977 "Color.c"
		}
	}
#line 294 "../lib/Drawing/Color.vala"
	if (h) {
#line 294 "../lib/Drawing/Color.vala"
		*h = _vala_h;
#line 984 "Color.c"
	}
#line 294 "../lib/Drawing/Color.vala"
	if (s) {
#line 294 "../lib/Drawing/Color.vala"
		*s = _vala_s;
#line 990 "Color.c"
	}
#line 294 "../lib/Drawing/Color.vala"
	if (v) {
#line 294 "../lib/Drawing/Color.vala"
		*v = _vala_v;
#line 996 "Color.c"
	}
}

static void
plank_color_hsv_to_rgb (gdouble h,
                        gdouble s,
                        gdouble v,
                        gdouble* r,
                        gdouble* g,
                        gdouble* b)
{
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
#line 337 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((h >= ((gdouble) 0)) && (h < ((gdouble) 360)), "h >= 0 && h < 360");
#line 337 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((s >= ((gdouble) 0)) && (s <= ((gdouble) 1)), "s >= 0 && s <= 1");
#line 337 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((v >= ((gdouble) 0)) && (v <= ((gdouble) 1)), "v >= 0 && v <= 1");
#line 342 "../lib/Drawing/Color.vala"
	if (s == ((gdouble) 0)) {
#line 343 "../lib/Drawing/Color.vala"
		_vala_r = v;
#line 344 "../lib/Drawing/Color.vala"
		_vala_g = v;
#line 345 "../lib/Drawing/Color.vala"
		_vala_b = v;
#line 1025 "Color.c"
	} else {
		gint secNum = 0;
		gdouble fracSec = 0.0;
		gdouble p = 0.0;
		gdouble q = 0.0;
		gdouble t = 0.0;
#line 347 "../lib/Drawing/Color.vala"
		secNum = (gint) (h / 60);
#line 348 "../lib/Drawing/Color.vala"
		fracSec = (h / 60.0) - secNum;
#line 350 "../lib/Drawing/Color.vala"
		p = v * (1 - s);
#line 351 "../lib/Drawing/Color.vala"
		q = v * (1 - (s * fracSec));
#line 352 "../lib/Drawing/Color.vala"
		t = v * (1 - (s * (1 - fracSec)));
#line 354 "../lib/Drawing/Color.vala"
		switch (secNum) {
#line 354 "../lib/Drawing/Color.vala"
			case 0:
#line 1046 "Color.c"
			{
#line 356 "../lib/Drawing/Color.vala"
				_vala_r = v;
#line 357 "../lib/Drawing/Color.vala"
				_vala_g = t;
#line 358 "../lib/Drawing/Color.vala"
				_vala_b = p;
#line 359 "../lib/Drawing/Color.vala"
				break;
#line 1056 "Color.c"
			}
#line 354 "../lib/Drawing/Color.vala"
			case 1:
#line 1060 "Color.c"
			{
#line 361 "../lib/Drawing/Color.vala"
				_vala_r = q;
#line 362 "../lib/Drawing/Color.vala"
				_vala_g = v;
#line 363 "../lib/Drawing/Color.vala"
				_vala_b = p;
#line 364 "../lib/Drawing/Color.vala"
				break;
#line 1070 "Color.c"
			}
#line 354 "../lib/Drawing/Color.vala"
			case 2:
#line 1074 "Color.c"
			{
#line 366 "../lib/Drawing/Color.vala"
				_vala_r = p;
#line 367 "../lib/Drawing/Color.vala"
				_vala_g = v;
#line 368 "../lib/Drawing/Color.vala"
				_vala_b = t;
#line 369 "../lib/Drawing/Color.vala"
				break;
#line 1084 "Color.c"
			}
#line 354 "../lib/Drawing/Color.vala"
			case 3:
#line 1088 "Color.c"
			{
#line 371 "../lib/Drawing/Color.vala"
				_vala_r = p;
#line 372 "../lib/Drawing/Color.vala"
				_vala_g = q;
#line 373 "../lib/Drawing/Color.vala"
				_vala_b = v;
#line 374 "../lib/Drawing/Color.vala"
				break;
#line 1098 "Color.c"
			}
#line 354 "../lib/Drawing/Color.vala"
			case 4:
#line 1102 "Color.c"
			{
#line 376 "../lib/Drawing/Color.vala"
				_vala_r = t;
#line 377 "../lib/Drawing/Color.vala"
				_vala_g = p;
#line 378 "../lib/Drawing/Color.vala"
				_vala_b = v;
#line 379 "../lib/Drawing/Color.vala"
				break;
#line 1112 "Color.c"
			}
#line 354 "../lib/Drawing/Color.vala"
			case 5:
#line 1116 "Color.c"
			{
#line 381 "../lib/Drawing/Color.vala"
				_vala_r = v;
#line 382 "../lib/Drawing/Color.vala"
				_vala_g = p;
#line 383 "../lib/Drawing/Color.vala"
				_vala_b = q;
#line 384 "../lib/Drawing/Color.vala"
				break;
#line 1126 "Color.c"
			}
			default:
			{
#line 386 "../lib/Drawing/Color.vala"
				g_assert_not_reached ();
#line 1132 "Color.c"
			}
		}
	}
#line 337 "../lib/Drawing/Color.vala"
	if (r) {
#line 337 "../lib/Drawing/Color.vala"
		*r = _vala_r;
#line 1140 "Color.c"
	}
#line 337 "../lib/Drawing/Color.vala"
	if (g) {
#line 337 "../lib/Drawing/Color.vala"
		*g = _vala_g;
#line 1146 "Color.c"
	}
#line 337 "../lib/Drawing/Color.vala"
	if (b) {
#line 337 "../lib/Drawing/Color.vala"
		*b = _vala_b;
#line 1152 "Color.c"
	}
}

static void
plank_color_rgb_to_hsl (gdouble r,
                        gdouble g,
                        gdouble b,
                        gdouble* h,
                        gdouble* s,
                        gdouble* l)
{
	gdouble _vala_h = 0.0;
	gdouble _vala_s = 0.0;
	gdouble _vala_l = 0.0;
	gdouble max = 0.0;
	gdouble min = 0.0;
	gdouble delta = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble r2 = 0.0;
	gdouble g2 = 0.0;
	gdouble b2 = 0.0;
#line 391 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((r >= ((gdouble) 0)) && (r <= ((gdouble) 1)), "r >= 0 && r <= 1");
#line 391 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((g >= ((gdouble) 0)) && (g <= ((gdouble) 1)), "g >= 0 && g <= 1");
#line 391 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((b >= ((gdouble) 0)) && (b <= ((gdouble) 1)), "b >= 0 && b <= 1");
#line 396 "../lib/Drawing/Color.vala"
	max = MAX (r, MAX (g, b));
#line 397 "../lib/Drawing/Color.vala"
	if (max == 0.0) {
#line 398 "../lib/Drawing/Color.vala"
		_vala_h = 0.0;
#line 399 "../lib/Drawing/Color.vala"
		_vala_s = 0.0;
#line 400 "../lib/Drawing/Color.vala"
		_vala_l = 0.0;
#line 401 "../lib/Drawing/Color.vala"
		if (h) {
#line 401 "../lib/Drawing/Color.vala"
			*h = _vala_h;
#line 1194 "Color.c"
		}
#line 401 "../lib/Drawing/Color.vala"
		if (s) {
#line 401 "../lib/Drawing/Color.vala"
			*s = _vala_s;
#line 1200 "Color.c"
		}
#line 401 "../lib/Drawing/Color.vala"
		if (l) {
#line 401 "../lib/Drawing/Color.vala"
			*l = _vala_l;
#line 1206 "Color.c"
		}
#line 401 "../lib/Drawing/Color.vala"
		return;
#line 1210 "Color.c"
	}
#line 404 "../lib/Drawing/Color.vala"
	min = MIN (r, MIN (g, b));
#line 405 "../lib/Drawing/Color.vala"
	_vala_l = (min + max) / 2.0;
#line 406 "../lib/Drawing/Color.vala"
	if (_vala_l <= 0.0) {
#line 407 "../lib/Drawing/Color.vala"
		_vala_h = 0.0;
#line 408 "../lib/Drawing/Color.vala"
		_vala_s = 0.0;
#line 409 "../lib/Drawing/Color.vala"
		if (h) {
#line 409 "../lib/Drawing/Color.vala"
			*h = _vala_h;
#line 1226 "Color.c"
		}
#line 409 "../lib/Drawing/Color.vala"
		if (s) {
#line 409 "../lib/Drawing/Color.vala"
			*s = _vala_s;
#line 1232 "Color.c"
		}
#line 409 "../lib/Drawing/Color.vala"
		if (l) {
#line 409 "../lib/Drawing/Color.vala"
			*l = _vala_l;
#line 1238 "Color.c"
		}
#line 409 "../lib/Drawing/Color.vala"
		return;
#line 1242 "Color.c"
	}
#line 412 "../lib/Drawing/Color.vala"
	delta = max - min;
#line 413 "../lib/Drawing/Color.vala"
	if (delta <= 0.0) {
#line 414 "../lib/Drawing/Color.vala"
		_vala_h = 0.0;
#line 415 "../lib/Drawing/Color.vala"
		_vala_s = 0.0;
#line 416 "../lib/Drawing/Color.vala"
		if (h) {
#line 416 "../lib/Drawing/Color.vala"
			*h = _vala_h;
#line 1256 "Color.c"
		}
#line 416 "../lib/Drawing/Color.vala"
		if (s) {
#line 416 "../lib/Drawing/Color.vala"
			*s = _vala_s;
#line 1262 "Color.c"
		}
#line 416 "../lib/Drawing/Color.vala"
		if (l) {
#line 416 "../lib/Drawing/Color.vala"
			*l = _vala_l;
#line 1268 "Color.c"
		}
#line 416 "../lib/Drawing/Color.vala"
		return;
#line 1272 "Color.c"
	}
#line 419 "../lib/Drawing/Color.vala"
	if (_vala_l <= 0.5) {
#line 419 "../lib/Drawing/Color.vala"
		_tmp0_ = min + max;
#line 1278 "Color.c"
	} else {
#line 419 "../lib/Drawing/Color.vala"
		_tmp0_ = (2.0 - min) - max;
#line 1282 "Color.c"
	}
#line 419 "../lib/Drawing/Color.vala"
	_vala_s = delta / _tmp0_;
#line 421 "../lib/Drawing/Color.vala"
	r2 = (60 * (max - r)) / delta;
#line 422 "../lib/Drawing/Color.vala"
	g2 = (60 * (max - g)) / delta;
#line 423 "../lib/Drawing/Color.vala"
	b2 = (60 * (max - b)) / delta;
#line 425 "../lib/Drawing/Color.vala"
	if (max == r) {
#line 426 "../lib/Drawing/Color.vala"
		_vala_h = b2 - g2;
#line 427 "../lib/Drawing/Color.vala"
		if (_vala_h < ((gdouble) 0)) {
#line 428 "../lib/Drawing/Color.vala"
			_vala_h = _vala_h + 360;
#line 1300 "Color.c"
		}
	} else {
#line 429 "../lib/Drawing/Color.vala"
		if (max == g) {
#line 430 "../lib/Drawing/Color.vala"
			_vala_h = 120 + (r2 - b2);
#line 1307 "Color.c"
		} else {
#line 432 "../lib/Drawing/Color.vala"
			_vala_h = 240 + (g2 - r2);
#line 1311 "Color.c"
		}
	}
#line 391 "../lib/Drawing/Color.vala"
	if (h) {
#line 391 "../lib/Drawing/Color.vala"
		*h = _vala_h;
#line 1318 "Color.c"
	}
#line 391 "../lib/Drawing/Color.vala"
	if (s) {
#line 391 "../lib/Drawing/Color.vala"
		*s = _vala_s;
#line 1324 "Color.c"
	}
#line 391 "../lib/Drawing/Color.vala"
	if (l) {
#line 391 "../lib/Drawing/Color.vala"
		*l = _vala_l;
#line 1330 "Color.c"
	}
}

static void
plank_color_hsl_to_rgb (gdouble h,
                        gdouble s,
                        gdouble l,
                        gdouble* r,
                        gdouble* g,
                        gdouble* b)
{
	gdouble _vala_r = 0.0;
	gdouble _vala_g = 0.0;
	gdouble _vala_b = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble v = 0.0;
	gint secNum = 0;
	gdouble fracSec = 0.0;
	gdouble p = 0.0;
	gdouble q = 0.0;
	gdouble t = 0.0;
#line 436 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((h >= ((gdouble) 0)) && (h < ((gdouble) 360)), "h >= 0 && h < 360");
#line 436 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((s >= ((gdouble) 0)) && (s <= ((gdouble) 1)), "s >= 0 && s <= 1");
#line 436 "../lib/Drawing/Color.vala"
	_vala_return_if_fail ((l >= ((gdouble) 0)) && (l <= ((gdouble) 1)), "l >= 0 && l <= 1");
#line 441 "../lib/Drawing/Color.vala"
	if (l <= 0.5) {
#line 441 "../lib/Drawing/Color.vala"
		_tmp0_ = l * (1.0 + s);
#line 1362 "Color.c"
	} else {
#line 441 "../lib/Drawing/Color.vala"
		_tmp0_ = (l + s) - (l * s);
#line 1366 "Color.c"
	}
#line 441 "../lib/Drawing/Color.vala"
	v = _tmp0_;
#line 442 "../lib/Drawing/Color.vala"
	if (v <= 0.0) {
#line 443 "../lib/Drawing/Color.vala"
		_vala_r = l;
#line 444 "../lib/Drawing/Color.vala"
		_vala_g = l;
#line 445 "../lib/Drawing/Color.vala"
		_vala_b = l;
#line 446 "../lib/Drawing/Color.vala"
		if (r) {
#line 446 "../lib/Drawing/Color.vala"
			*r = _vala_r;
#line 1382 "Color.c"
		}
#line 446 "../lib/Drawing/Color.vala"
		if (g) {
#line 446 "../lib/Drawing/Color.vala"
			*g = _vala_g;
#line 1388 "Color.c"
		}
#line 446 "../lib/Drawing/Color.vala"
		if (b) {
#line 446 "../lib/Drawing/Color.vala"
			*b = _vala_b;
#line 1394 "Color.c"
		}
#line 446 "../lib/Drawing/Color.vala"
		return;
#line 1398 "Color.c"
	}
#line 449 "../lib/Drawing/Color.vala"
	secNum = (gint) (h / 60);
#line 450 "../lib/Drawing/Color.vala"
	fracSec = (h / 30.0) - (2 * secNum);
#line 452 "../lib/Drawing/Color.vala"
	p = l - (v - l);
#line 453 "../lib/Drawing/Color.vala"
	q = v - ((v - l) * fracSec);
#line 454 "../lib/Drawing/Color.vala"
	t = l + ((v - l) * (fracSec - 1));
#line 456 "../lib/Drawing/Color.vala"
	switch (secNum) {
#line 456 "../lib/Drawing/Color.vala"
		case 0:
#line 1414 "Color.c"
		{
#line 458 "../lib/Drawing/Color.vala"
			_vala_r = v;
#line 459 "../lib/Drawing/Color.vala"
			_vala_g = t;
#line 460 "../lib/Drawing/Color.vala"
			_vala_b = p;
#line 461 "../lib/Drawing/Color.vala"
			break;
#line 1424 "Color.c"
		}
#line 456 "../lib/Drawing/Color.vala"
		case 1:
#line 1428 "Color.c"
		{
#line 463 "../lib/Drawing/Color.vala"
			_vala_r = q;
#line 464 "../lib/Drawing/Color.vala"
			_vala_g = v;
#line 465 "../lib/Drawing/Color.vala"
			_vala_b = p;
#line 466 "../lib/Drawing/Color.vala"
			break;
#line 1438 "Color.c"
		}
#line 456 "../lib/Drawing/Color.vala"
		case 2:
#line 1442 "Color.c"
		{
#line 468 "../lib/Drawing/Color.vala"
			_vala_r = p;
#line 469 "../lib/Drawing/Color.vala"
			_vala_g = v;
#line 470 "../lib/Drawing/Color.vala"
			_vala_b = t;
#line 471 "../lib/Drawing/Color.vala"
			break;
#line 1452 "Color.c"
		}
#line 456 "../lib/Drawing/Color.vala"
		case 3:
#line 1456 "Color.c"
		{
#line 473 "../lib/Drawing/Color.vala"
			_vala_r = p;
#line 474 "../lib/Drawing/Color.vala"
			_vala_g = q;
#line 475 "../lib/Drawing/Color.vala"
			_vala_b = v;
#line 476 "../lib/Drawing/Color.vala"
			break;
#line 1466 "Color.c"
		}
#line 456 "../lib/Drawing/Color.vala"
		case 4:
#line 1470 "Color.c"
		{
#line 478 "../lib/Drawing/Color.vala"
			_vala_r = t;
#line 479 "../lib/Drawing/Color.vala"
			_vala_g = p;
#line 480 "../lib/Drawing/Color.vala"
			_vala_b = v;
#line 481 "../lib/Drawing/Color.vala"
			break;
#line 1480 "Color.c"
		}
#line 456 "../lib/Drawing/Color.vala"
		case 5:
#line 1484 "Color.c"
		{
#line 483 "../lib/Drawing/Color.vala"
			_vala_r = v;
#line 484 "../lib/Drawing/Color.vala"
			_vala_g = p;
#line 485 "../lib/Drawing/Color.vala"
			_vala_b = q;
#line 486 "../lib/Drawing/Color.vala"
			break;
#line 1494 "Color.c"
		}
		default:
		{
#line 488 "../lib/Drawing/Color.vala"
			g_assert_not_reached ();
#line 1500 "Color.c"
		}
	}
#line 436 "../lib/Drawing/Color.vala"
	if (r) {
#line 436 "../lib/Drawing/Color.vala"
		*r = _vala_r;
#line 1507 "Color.c"
	}
#line 436 "../lib/Drawing/Color.vala"
	if (g) {
#line 436 "../lib/Drawing/Color.vala"
		*g = _vala_g;
#line 1513 "Color.c"
	}
#line 436 "../lib/Drawing/Color.vala"
	if (b) {
#line 436 "../lib/Drawing/Color.vala"
		*b = _vala_b;
#line 1519 "Color.c"
	}
}

/**
 * Convert color to string formatted like "%d;;%d;;%d;;%d"
 * with numeric entries ranged in 0..255
 *
 * @return the string representation of this color
 */
gchar*
plank_color_to_prefs_string (PlankColor *self)
{
	gchar* _tmp0_;
	gchar* result;
#line 500 "../lib/Drawing/Color.vala"
	_tmp0_ = g_strdup_printf ("%d;;%d;;%d;;%d", (gint) ((*self).red * G_MAXUINT8), (gint) ((*self).green * G_MAXUINT8), (gint) ((*self).blue * G_MAXUINT8), (gint) ((*self).alpha * G_MAXUINT8));
#line 500 "../lib/Drawing/Color.vala"
	result = _tmp0_;
#line 500 "../lib/Drawing/Color.vala"
	return result;
#line 1540 "Color.c"
}

/**
 * Create new color converted from string formatted like
 * "%d;;%d;;%d;;%d" with numeric entries ranged in 0..255
 *
 * @return new {@link Color} based on the given string
 */
void
plank_color_from_prefs_string (const gchar* s,
                               PlankColor* result)
{
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gint _tmp6__length1;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	PlankColor _tmp12_ = {0};
#line 512 "../lib/Drawing/Color.vala"
	g_return_if_fail (s != NULL);
#line 514 "../lib/Drawing/Color.vala"
	_tmp1_ = _tmp0_ = g_strsplit (s, ";;", 0);
#line 514 "../lib/Drawing/Color.vala"
	parts = _tmp1_;
#line 514 "../lib/Drawing/Color.vala"
	parts_length1 = _vala_array_length (_tmp0_);
#line 514 "../lib/Drawing/Color.vala"
	_parts_size_ = parts_length1;
#line 516 "../lib/Drawing/Color.vala"
	_tmp2_ = parts;
#line 516 "../lib/Drawing/Color.vala"
	_tmp2__length1 = parts_length1;
#line 516 "../lib/Drawing/Color.vala"
	if (_tmp2__length1 != 4) {
#line 1589 "Color.c"
		PlankColor _tmp3_ = {0};
#line 517 "../lib/Drawing/Color.vala"
		g_critical ("Color.vala:517: Malformed color string '%s'", s);
#line 518 "../lib/Drawing/Color.vala"
		*result = _tmp3_;
#line 518 "../lib/Drawing/Color.vala"
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 518 "../lib/Drawing/Color.vala"
		return;
#line 1599 "Color.c"
	}
#line 521 "../lib/Drawing/Color.vala"
	_tmp4_ = parts;
#line 521 "../lib/Drawing/Color.vala"
	_tmp4__length1 = parts_length1;
#line 521 "../lib/Drawing/Color.vala"
	_tmp5_ = _tmp4_[0];
#line 521 "../lib/Drawing/Color.vala"
	_tmp6_ = parts;
#line 521 "../lib/Drawing/Color.vala"
	_tmp6__length1 = parts_length1;
#line 521 "../lib/Drawing/Color.vala"
	_tmp7_ = _tmp6_[1];
#line 521 "../lib/Drawing/Color.vala"
	_tmp8_ = parts;
#line 521 "../lib/Drawing/Color.vala"
	_tmp8__length1 = parts_length1;
#line 521 "../lib/Drawing/Color.vala"
	_tmp9_ = _tmp8_[2];
#line 521 "../lib/Drawing/Color.vala"
	_tmp10_ = parts;
#line 521 "../lib/Drawing/Color.vala"
	_tmp10__length1 = parts_length1;
#line 521 "../lib/Drawing/Color.vala"
	_tmp11_ = _tmp10_[3];
#line 521 "../lib/Drawing/Color.vala"
	_tmp12_.red = CLAMP ((gdouble) atoi (_tmp5_), 0.0, (gdouble) G_MAXUINT8) / G_MAXUINT8;
#line 521 "../lib/Drawing/Color.vala"
	_tmp12_.green = CLAMP ((gdouble) atoi (_tmp7_), 0.0, (gdouble) G_MAXUINT8) / G_MAXUINT8;
#line 521 "../lib/Drawing/Color.vala"
	_tmp12_.blue = CLAMP ((gdouble) atoi (_tmp9_), 0.0, (gdouble) G_MAXUINT8) / G_MAXUINT8;
#line 521 "../lib/Drawing/Color.vala"
	_tmp12_.alpha = CLAMP ((gdouble) atoi (_tmp11_), 0.0, (gdouble) G_MAXUINT8) / G_MAXUINT8;
#line 521 "../lib/Drawing/Color.vala"
	*result = _tmp12_;
#line 521 "../lib/Drawing/Color.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 521 "../lib/Drawing/Color.vala"
	return;
#line 1639 "Color.c"
}

PlankColor*
plank_color_dup (const PlankColor* self)
{
	PlankColor* dup;
#line 25 "../lib/Drawing/Color.vala"
	dup = g_new0 (PlankColor, 1);
#line 25 "../lib/Drawing/Color.vala"
	memcpy (dup, self, sizeof (PlankColor));
#line 25 "../lib/Drawing/Color.vala"
	return dup;
#line 1652 "Color.c"
}

void
plank_color_free (PlankColor* self)
{
#line 25 "../lib/Drawing/Color.vala"
	g_free (self);
#line 1660 "Color.c"
}

static GType
plank_color_get_type_once (void)
{
	GType plank_color_type_id;
	plank_color_type_id = g_boxed_type_register_static ("PlankColor", (GBoxedCopyFunc) plank_color_dup, (GBoxedFreeFunc) plank_color_free);
	return plank_color_type_id;
}

GType
plank_color_get_type (void)
{
	static volatile gsize plank_color_type_id__once = 0;
	if (g_once_init_enter (&plank_color_type_id__once)) {
		GType plank_color_type_id;
		plank_color_type_id = plank_color_get_type_once ();
		g_once_init_leave (&plank_color_type_id__once, plank_color_type_id);
	}
	return plank_color_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 52 "../lib/Docklets/DockletManager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1690 "Color.c"
		gssize i;
#line 52 "../lib/Docklets/DockletManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 52 "../lib/Docklets/DockletManager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 52 "../lib/Docklets/DockletManager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1698 "Color.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 52 "../lib/Docklets/DockletManager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 52 "../lib/Docklets/DockletManager.vala"
	g_free (array);
#line 1713 "Color.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 52 "../lib/Docklets/DockletManager.vala"
	if (array) {
#line 52 "../lib/Docklets/DockletManager.vala"
		while (((gpointer*) array)[length]) {
#line 52 "../lib/Docklets/DockletManager.vala"
			length++;
#line 1727 "Color.c"
		}
	}
#line 52 "../lib/Docklets/DockletManager.vala"
	return length;
#line 1732 "Color.c"
}

