/* Theme.c generated by valac 0.56.18, the Vala compiler
 * generated from Theme.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gtk-compat.h>
#include <stdarg.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <granite.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_THEME_0_PROPERTY,
	PLANK_THEME_TOP_ROUNDNESS_PROPERTY,
	PLANK_THEME_BOTTOM_ROUNDNESS_PROPERTY,
	PLANK_THEME_LINE_WIDTH_PROPERTY,
	PLANK_THEME_OUTER_STROKE_COLOR_PROPERTY,
	PLANK_THEME_FILL_START_COLOR_PROPERTY,
	PLANK_THEME_FILL_END_COLOR_PROPERTY,
	PLANK_THEME_INNER_STROKE_COLOR_PROPERTY,
	PLANK_THEME_NUM_PROPERTIES
};
static GParamSpec* plank_theme_properties[PLANK_THEME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gtk_widget_path_unref0(var) ((var == NULL) ? NULL : (var = (gtk_widget_path_unref (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))

struct _PlankThemePrivate {
	gint _TopRoundness;
	gint _BottomRoundness;
	gint _LineWidth;
	PlankColor _OuterStrokeColor;
	PlankColor _FillStartColor;
	PlankColor _FillEndColor;
	PlankColor _InnerStrokeColor;
	GFile* theme_folder;
	GtkStyleContext* style_context;
};

static gint PlankTheme_private_offset;
static gpointer plank_theme_parent_class = NULL;

static void plank_theme_update_style_context (PlankTheme* self,
                                       const gchar* theme_name);
static void plank_theme_gtk_theme_name_changed (PlankTheme* self,
                                         GObject* o,
                                         GParamSpec* p);
static void plank_theme_real_reset_properties (PlankPreferences* base);
static void plank_theme_real_verify (PlankPreferences* base,
                              const gchar* prop);
static GFile* plank_theme_get_default_theme_folder (void);
static GFile* plank_theme_get_gtk_theme_folder (void);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
static GObject * plank_theme_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void _plank_theme_gtk_theme_name_changed_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void plank_theme_finalize (GObject * obj);
static GType plank_theme_get_type_once (void);
static void _vala_plank_theme_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_plank_theme_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
plank_theme_get_instance_private (PlankTheme* self)
{
	return G_STRUCT_MEMBER_P (self, PlankTheme_private_offset);
}

GtkStyleContext*
plank_theme_create_style_context (GType widget_type,
                                  GtkStyleContext* parent_style,
                                  GtkCssProvider* provider,
                                  const gchar* object_name,
                                  const gchar* first_class,
                                  ...)
{
	GtkWidgetPath* path = NULL;
	GtkStyleContext* style = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkWidgetPath* _tmp5_;
	GtkWidgetPath* _tmp7_;
	va_list name_list = {0};
	GtkStyleContext* _tmp14_;
	GtkWidgetPath* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkStyleContext* result;
#line 30 "../lib/Drawing/Theme.vala"
	g_return_val_if_fail (provider != NULL, NULL);
#line 30 "../lib/Drawing/Theme.vala"
	g_return_val_if_fail (first_class != NULL, NULL);
#line 35 "../lib/Drawing/Theme.vala"
	_tmp0_ = gtk_style_context_new ();
#line 35 "../lib/Drawing/Theme.vala"
	style = _tmp0_;
#line 38 "../lib/Drawing/Theme.vala"
	_tmp1_ = style;
#line 38 "../lib/Drawing/Theme.vala"
	gtk_style_context_set_parent (_tmp1_, parent_style);
#line 40 "../lib/Drawing/Theme.vala"
	if (parent_style != NULL) {
#line 150 "Theme.c"
		GtkWidgetPath* _tmp2_;
		GtkWidgetPath* _tmp3_;
#line 41 "../lib/Drawing/Theme.vala"
		_tmp2_ = gtk_style_context_get_path (parent_style);
#line 41 "../lib/Drawing/Theme.vala"
		_tmp3_ = gtk_widget_path_copy (_tmp2_);
#line 41 "../lib/Drawing/Theme.vala"
		_gtk_widget_path_unref0 (path);
#line 41 "../lib/Drawing/Theme.vala"
		path = _tmp3_;
#line 161 "Theme.c"
	} else {
		GtkWidgetPath* _tmp4_;
#line 43 "../lib/Drawing/Theme.vala"
		_tmp4_ = gtk_widget_path_new ();
#line 43 "../lib/Drawing/Theme.vala"
		_gtk_widget_path_unref0 (path);
#line 43 "../lib/Drawing/Theme.vala"
		path = _tmp4_;
#line 170 "Theme.c"
	}
#line 45 "../lib/Drawing/Theme.vala"
	_tmp5_ = path;
#line 45 "../lib/Drawing/Theme.vala"
	gtk_widget_path_append_type (_tmp5_, widget_type);
#line 47 "../lib/Drawing/Theme.vala"
	if (object_name != NULL) {
#line 178 "Theme.c"
		GtkWidgetPath* _tmp6_;
#line 48 "../lib/Drawing/Theme.vala"
		_tmp6_ = path;
#line 48 "../lib/Drawing/Theme.vala"
		plank_compat_gtk_widget_path_iter_set_object_name (_tmp6_, -1, object_name);
#line 184 "Theme.c"
	}
#line 50 "../lib/Drawing/Theme.vala"
	_tmp7_ = path;
#line 50 "../lib/Drawing/Theme.vala"
	gtk_widget_path_iter_add_class (_tmp7_, -1, first_class);
#line 51 "../lib/Drawing/Theme.vala"
	va_start (name_list, first_class);
#line 192 "Theme.c"
	{
		const gchar* name = NULL;
		const gchar* _tmp8_;
#line 52 "../lib/Drawing/Theme.vala"
		_tmp8_ = va_arg (name_list, const gchar*);
#line 52 "../lib/Drawing/Theme.vala"
		name = _tmp8_;
#line 200 "Theme.c"
		{
			gboolean _tmp9_ = FALSE;
#line 52 "../lib/Drawing/Theme.vala"
			_tmp9_ = TRUE;
#line 52 "../lib/Drawing/Theme.vala"
			while (TRUE) {
#line 207 "Theme.c"
				const gchar* _tmp11_;
				GtkWidgetPath* _tmp12_;
				const gchar* _tmp13_;
#line 52 "../lib/Drawing/Theme.vala"
				if (!_tmp9_) {
#line 213 "Theme.c"
					const gchar* _tmp10_;
#line 52 "../lib/Drawing/Theme.vala"
					_tmp10_ = va_arg (name_list, const gchar*);
#line 52 "../lib/Drawing/Theme.vala"
					name = _tmp10_;
#line 219 "Theme.c"
				}
#line 52 "../lib/Drawing/Theme.vala"
				_tmp9_ = FALSE;
#line 52 "../lib/Drawing/Theme.vala"
				_tmp11_ = name;
#line 52 "../lib/Drawing/Theme.vala"
				if (!(_tmp11_ != NULL)) {
#line 52 "../lib/Drawing/Theme.vala"
					break;
#line 229 "Theme.c"
				}
#line 53 "../lib/Drawing/Theme.vala"
				_tmp12_ = path;
#line 53 "../lib/Drawing/Theme.vala"
				_tmp13_ = name;
#line 53 "../lib/Drawing/Theme.vala"
				gtk_widget_path_iter_add_class (_tmp12_, -1, _tmp13_);
#line 237 "Theme.c"
			}
		}
	}
#line 55 "../lib/Drawing/Theme.vala"
	_tmp14_ = style;
#line 55 "../lib/Drawing/Theme.vala"
	_tmp15_ = path;
#line 55 "../lib/Drawing/Theme.vala"
	gtk_style_context_set_path (_tmp14_, _tmp15_);
#line 56 "../lib/Drawing/Theme.vala"
	_tmp16_ = style;
#line 56 "../lib/Drawing/Theme.vala"
	gtk_style_context_add_provider (_tmp16_, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_SETTINGS);
#line 58 "../lib/Drawing/Theme.vala"
	result = style;
#line 58 "../lib/Drawing/Theme.vala"
	va_end (name_list);
#line 58 "../lib/Drawing/Theme.vala"
	_gtk_widget_path_unref0 (path);
#line 58 "../lib/Drawing/Theme.vala"
	return result;
#line 259 "Theme.c"
}

PlankTheme*
plank_theme_construct (GType object_type)
{
	PlankTheme * self = NULL;
	GFile* _tmp0_;
#line 85 "../lib/Drawing/Theme.vala"
	self = (PlankTheme*) plank_preferences_construct (object_type);
#line 87 "../lib/Drawing/Theme.vala"
	_tmp0_ = plank_theme_get_theme_folder (PLANK_THEME_DEFAULT_NAME);
#line 87 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (self->priv->theme_folder);
#line 87 "../lib/Drawing/Theme.vala"
	self->priv->theme_folder = _tmp0_;
#line 85 "../lib/Drawing/Theme.vala"
	return self;
#line 277 "Theme.c"
}

PlankTheme*
plank_theme_construct_with_name (GType object_type,
                                 const gchar* name)
{
	PlankTheme * self = NULL;
	GFile* _tmp0_;
#line 90 "../lib/Drawing/Theme.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 90 "../lib/Drawing/Theme.vala"
	self = (PlankTheme*) plank_preferences_construct (object_type);
#line 92 "../lib/Drawing/Theme.vala"
	_tmp0_ = plank_theme_get_theme_folder (name);
#line 92 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (self->priv->theme_folder);
#line 92 "../lib/Drawing/Theme.vala"
	self->priv->theme_folder = _tmp0_;
#line 90 "../lib/Drawing/Theme.vala"
	return self;
#line 298 "Theme.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 109 "../lib/Drawing/Theme.vala"
	return self ? g_object_ref (self) : NULL;
#line 306 "Theme.c"
}

static void
plank_theme_update_style_context (PlankTheme* self,
                                  const gchar* theme_name)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkStyleContext* _tmp6_;
#line 105 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 108 "../lib/Drawing/Theme.vala"
	if (theme_name != NULL) {
#line 321 "Theme.c"
		GtkCssProvider* _tmp0_;
		GtkCssProvider* _tmp1_;
#line 109 "../lib/Drawing/Theme.vala"
		_tmp0_ = gtk_css_provider_get_named (theme_name, NULL);
#line 109 "../lib/Drawing/Theme.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 109 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (provider);
#line 109 "../lib/Drawing/Theme.vala"
		provider = _tmp1_;
#line 332 "Theme.c"
	} else {
		GtkCssProvider* _tmp2_;
		GtkCssProvider* _tmp3_;
#line 111 "../lib/Drawing/Theme.vala"
		_tmp2_ = gtk_css_provider_get_default ();
#line 111 "../lib/Drawing/Theme.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 111 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (provider);
#line 111 "../lib/Drawing/Theme.vala"
		provider = _tmp3_;
#line 344 "Theme.c"
	}
#line 113 "../lib/Drawing/Theme.vala"
	_tmp4_ = provider;
#line 113 "../lib/Drawing/Theme.vala"
	_tmp5_ = plank_theme_create_style_context (gtk_icon_view_get_type (), NULL, _tmp4_, "iconview", GTK_STYLE_CLASS_VIEW, NULL);
#line 113 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (self->priv->style_context);
#line 113 "../lib/Drawing/Theme.vala"
	self->priv->style_context = _tmp5_;
#line 116 "../lib/Drawing/Theme.vala"
	_tmp6_ = self->priv->style_context;
#line 116 "../lib/Drawing/Theme.vala"
	gtk_style_context_set_state (_tmp6_, GTK_STATE_FLAG_FOCUSED | GTK_STATE_FLAG_SELECTED);
#line 105 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (provider);
#line 360 "Theme.c"
}

static void
plank_theme_gtk_theme_name_changed (PlankTheme* self,
                                    GObject* o,
                                    GParamSpec* p)
{
	gchar* theme_name = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GParamSpecBoolean* _tmp2_;
	GParamSpecBoolean* _tmp3_;
#line 119 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 119 "../lib/Drawing/Theme.vala"
	g_return_if_fail (o != NULL);
#line 119 "../lib/Drawing/Theme.vala"
	g_return_if_fail (p != NULL);
#line 121 "../lib/Drawing/Theme.vala"
	g_object_get (G_TYPE_CHECK_INSTANCE_CAST (o, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp0_, NULL);
#line 121 "../lib/Drawing/Theme.vala"
	_tmp1_ = _tmp0_;
#line 121 "../lib/Drawing/Theme.vala"
	theme_name = _tmp1_;
#line 122 "../lib/Drawing/Theme.vala"
	plank_theme_update_style_context (self, theme_name);
#line 125 "../lib/Drawing/Theme.vala"
	_tmp2_ = (GParamSpecBoolean*) g_param_spec_boolean ("theme-changed", "theme-changed", "theme-changed", TRUE, G_PARAM_READABLE);
#line 125 "../lib/Drawing/Theme.vala"
	_tmp3_ = _tmp2_;
#line 125 "../lib/Drawing/Theme.vala"
	g_object_notify ((GObject*) self, (GParamSpec*) _tmp3_);
#line 125 "../lib/Drawing/Theme.vala"
	_g_param_spec_unref0 (_tmp3_);
#line 119 "../lib/Drawing/Theme.vala"
	_g_free0 (theme_name);
#line 397 "Theme.c"
}

GtkStyleContext*
plank_theme_get_style_context (PlankTheme* self)
{
	GtkStyleContext* _tmp0_;
	GtkStyleContext* result;
#line 128 "../lib/Drawing/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 130 "../lib/Drawing/Theme.vala"
	_tmp0_ = self->priv->style_context;
#line 130 "../lib/Drawing/Theme.vala"
	result = _tmp0_;
#line 130 "../lib/Drawing/Theme.vala"
	return result;
#line 413 "Theme.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_theme_real_reset_properties (PlankPreferences* base)
{
	PlankTheme * self;
	PlankColor _tmp0_ = {0};
	PlankColor _tmp1_ = {0};
	PlankColor _tmp2_ = {0};
	PlankColor _tmp3_ = {0};
#line 136 "../lib/Drawing/Theme.vala"
	self = (PlankTheme*) base;
#line 138 "../lib/Drawing/Theme.vala"
	plank_theme_set_TopRoundness (self, 6);
#line 139 "../lib/Drawing/Theme.vala"
	plank_theme_set_BottomRoundness (self, 6);
#line 141 "../lib/Drawing/Theme.vala"
	plank_theme_set_LineWidth (self, 1);
#line 143 "../lib/Drawing/Theme.vala"
	_tmp0_.red = 0.1647;
#line 143 "../lib/Drawing/Theme.vala"
	_tmp0_.green = 0.1647;
#line 143 "../lib/Drawing/Theme.vala"
	_tmp0_.blue = 0.1647;
#line 143 "../lib/Drawing/Theme.vala"
	_tmp0_.alpha = 1.0;
#line 143 "../lib/Drawing/Theme.vala"
	plank_theme_set_OuterStrokeColor (self, &_tmp0_);
#line 144 "../lib/Drawing/Theme.vala"
	_tmp1_.red = 0.1647;
#line 144 "../lib/Drawing/Theme.vala"
	_tmp1_.green = 0.1647;
#line 144 "../lib/Drawing/Theme.vala"
	_tmp1_.blue = 0.1647;
#line 144 "../lib/Drawing/Theme.vala"
	_tmp1_.alpha = 1.0;
#line 144 "../lib/Drawing/Theme.vala"
	plank_theme_set_FillStartColor (self, &_tmp1_);
#line 145 "../lib/Drawing/Theme.vala"
	_tmp2_.red = 0.3176;
#line 145 "../lib/Drawing/Theme.vala"
	_tmp2_.green = 0.3176;
#line 145 "../lib/Drawing/Theme.vala"
	_tmp2_.blue = 0.3176;
#line 145 "../lib/Drawing/Theme.vala"
	_tmp2_.alpha = 1.0;
#line 145 "../lib/Drawing/Theme.vala"
	plank_theme_set_FillEndColor (self, &_tmp2_);
#line 146 "../lib/Drawing/Theme.vala"
	_tmp3_.red = 1.0;
#line 146 "../lib/Drawing/Theme.vala"
	_tmp3_.green = 1.0;
#line 146 "../lib/Drawing/Theme.vala"
	_tmp3_.blue = 1.0;
#line 146 "../lib/Drawing/Theme.vala"
	_tmp3_.alpha = 1.0;
#line 146 "../lib/Drawing/Theme.vala"
	plank_theme_set_InnerStrokeColor (self, &_tmp3_);
#line 475 "Theme.c"
}

/**
 * Loads a theme for the renderer to use.
 *
 * @param type the type of theme to load
 */
void
plank_theme_load (PlankTheme* self,
                  const gchar* type)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
#line 154 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 154 "../lib/Drawing/Theme.vala"
	g_return_if_fail (type != NULL);
#line 157 "../lib/Drawing/Theme.vala"
	_tmp0_ = self->priv->theme_folder;
#line 157 "../lib/Drawing/Theme.vala"
	if (_tmp0_ == NULL) {
#line 158 "../lib/Drawing/Theme.vala"
		plank_preferences_reset_properties ((PlankPreferences*) self);
#line 159 "../lib/Drawing/Theme.vala"
		return;
#line 505 "Theme.c"
	}
#line 162 "../lib/Drawing/Theme.vala"
	_tmp1_ = self->priv->theme_folder;
#line 162 "../lib/Drawing/Theme.vala"
	_tmp2_ = g_strdup_printf ("%s.theme", type);
#line 162 "../lib/Drawing/Theme.vala"
	_tmp3_ = _tmp2_;
#line 162 "../lib/Drawing/Theme.vala"
	_tmp4_ = g_file_get_child (_tmp1_, _tmp3_);
#line 162 "../lib/Drawing/Theme.vala"
	_tmp5_ = _tmp4_;
#line 162 "../lib/Drawing/Theme.vala"
	plank_preferences_init_from_file ((PlankPreferences*) self, _tmp5_);
#line 162 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (_tmp5_);
#line 162 "../lib/Drawing/Theme.vala"
	_g_free0 (_tmp3_);
#line 523 "Theme.c"
}

/**
 * Returns the top offset.
 *
 * @return the top offset
 */
gint
plank_theme_get_top_offset (PlankTheme* self)
{
	gint _tmp0_;
	gint result;
#line 170 "../lib/Drawing/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 172 "../lib/Drawing/Theme.vala"
	_tmp0_ = self->priv->_LineWidth;
#line 172 "../lib/Drawing/Theme.vala"
	result = 2 * _tmp0_;
#line 172 "../lib/Drawing/Theme.vala"
	return result;
#line 544 "Theme.c"
}

/**
 * Returns the bottom offset.
 *
 * @return the bottom offset
 */
gint
plank_theme_get_bottom_offset (PlankTheme* self)
{
	gint _tmp0_ = 0;
	gint _tmp1_;
	gint result;
#line 180 "../lib/Drawing/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 182 "../lib/Drawing/Theme.vala"
	_tmp1_ = self->priv->_BottomRoundness;
#line 182 "../lib/Drawing/Theme.vala"
	if (_tmp1_ > 0) {
#line 564 "Theme.c"
		gint _tmp2_;
#line 182 "../lib/Drawing/Theme.vala"
		_tmp2_ = self->priv->_LineWidth;
#line 182 "../lib/Drawing/Theme.vala"
		_tmp0_ = 2 * _tmp2_;
#line 570 "Theme.c"
	} else {
#line 182 "../lib/Drawing/Theme.vala"
		_tmp0_ = 0;
#line 574 "Theme.c"
	}
#line 182 "../lib/Drawing/Theme.vala"
	result = _tmp0_;
#line 182 "../lib/Drawing/Theme.vala"
	return result;
#line 580 "Theme.c"
}

/**
 * Draws a background onto the surface.
 *
 * @param surface the surface to draw on
 */
void
plank_theme_draw_background (PlankTheme* self,
                             PlankSurface* surface)
{
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_pattern_t* gradient = NULL;
	gint width = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint height = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_;
	gint bottom_offset = 0;
	cairo_t* _tmp10_;
	cairo_pattern_t* _tmp11_;
	cairo_pattern_t* _tmp12_;
	PlankColor _tmp13_;
	PlankColor _tmp14_;
	PlankColor _tmp15_;
	PlankColor _tmp16_;
	cairo_pattern_t* _tmp17_;
	PlankColor _tmp18_;
	PlankColor _tmp19_;
	PlankColor _tmp20_;
	PlankColor _tmp21_;
	cairo_t* _tmp22_;
	cairo_pattern_t* _tmp23_;
	cairo_t* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	cairo_t* _tmp32_;
	cairo_t* _tmp33_;
	PlankColor _tmp34_;
	PlankColor _tmp35_;
	PlankColor _tmp36_;
	PlankColor _tmp37_;
	cairo_t* _tmp38_;
	gint _tmp39_;
	cairo_t* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	cairo_pattern_t* _tmp43_;
	cairo_pattern_t* _tmp44_;
	PlankColor _tmp45_;
	PlankColor _tmp46_;
	PlankColor _tmp47_;
	gint _tmp48_ = 0;
	gint _tmp49_;
	cairo_pattern_t* _tmp52_;
	PlankColor _tmp53_;
	PlankColor _tmp54_;
	PlankColor _tmp55_;
	gint _tmp56_ = 0;
	gint _tmp57_;
	cairo_pattern_t* _tmp60_;
	PlankColor _tmp61_;
	PlankColor _tmp62_;
	PlankColor _tmp63_;
	cairo_pattern_t* _tmp64_;
	PlankColor _tmp65_;
	PlankColor _tmp66_;
	PlankColor _tmp67_;
	cairo_t* _tmp68_;
	cairo_pattern_t* _tmp69_;
	cairo_t* _tmp70_;
	cairo_t* _tmp71_;
	cairo_t* _tmp72_;
#line 190 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 190 "../lib/Drawing/Theme.vala"
	g_return_if_fail (surface != NULL);
#line 192 "../lib/Drawing/Theme.vala"
	_tmp0_ = plank_surface_get_Context (surface);
#line 192 "../lib/Drawing/Theme.vala"
	_tmp1_ = _tmp0_;
#line 192 "../lib/Drawing/Theme.vala"
	cr = _tmp1_;
#line 194 "../lib/Drawing/Theme.vala"
	_tmp2_ = plank_surface_get_Width (surface);
#line 194 "../lib/Drawing/Theme.vala"
	_tmp3_ = _tmp2_;
#line 194 "../lib/Drawing/Theme.vala"
	width = _tmp3_;
#line 195 "../lib/Drawing/Theme.vala"
	_tmp4_ = plank_surface_get_Height (surface);
#line 195 "../lib/Drawing/Theme.vala"
	_tmp5_ = _tmp4_;
#line 195 "../lib/Drawing/Theme.vala"
	height = _tmp5_;
#line 196 "../lib/Drawing/Theme.vala"
	_tmp7_ = self->priv->_BottomRoundness;
#line 196 "../lib/Drawing/Theme.vala"
	if (_tmp7_ > 0) {
#line 690 "Theme.c"
		gint _tmp8_;
#line 196 "../lib/Drawing/Theme.vala"
		_tmp8_ = self->priv->_LineWidth;
#line 196 "../lib/Drawing/Theme.vala"
		_tmp6_ = _tmp8_;
#line 696 "Theme.c"
	} else {
		gint _tmp9_;
#line 196 "../lib/Drawing/Theme.vala"
		_tmp9_ = self->priv->_LineWidth;
#line 196 "../lib/Drawing/Theme.vala"
		_tmp6_ = -_tmp9_;
#line 703 "Theme.c"
	}
#line 196 "../lib/Drawing/Theme.vala"
	bottom_offset = _tmp6_;
#line 198 "../lib/Drawing/Theme.vala"
	_tmp10_ = cr;
#line 198 "../lib/Drawing/Theme.vala"
	cairo_save (_tmp10_);
#line 200 "../lib/Drawing/Theme.vala"
	_tmp11_ = cairo_pattern_create_linear ((gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) height);
#line 200 "../lib/Drawing/Theme.vala"
	_cairo_pattern_destroy0 (gradient);
#line 200 "../lib/Drawing/Theme.vala"
	gradient = _tmp11_;
#line 201 "../lib/Drawing/Theme.vala"
	_tmp12_ = gradient;
#line 201 "../lib/Drawing/Theme.vala"
	_tmp13_ = self->priv->_FillStartColor;
#line 201 "../lib/Drawing/Theme.vala"
	_tmp14_ = self->priv->_FillStartColor;
#line 201 "../lib/Drawing/Theme.vala"
	_tmp15_ = self->priv->_FillStartColor;
#line 201 "../lib/Drawing/Theme.vala"
	_tmp16_ = self->priv->_FillStartColor;
#line 201 "../lib/Drawing/Theme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp12_, (gdouble) 0, _tmp13_.red, _tmp14_.green, _tmp15_.blue, _tmp16_.alpha);
#line 202 "../lib/Drawing/Theme.vala"
	_tmp17_ = gradient;
#line 202 "../lib/Drawing/Theme.vala"
	_tmp18_ = self->priv->_FillEndColor;
#line 202 "../lib/Drawing/Theme.vala"
	_tmp19_ = self->priv->_FillEndColor;
#line 202 "../lib/Drawing/Theme.vala"
	_tmp20_ = self->priv->_FillEndColor;
#line 202 "../lib/Drawing/Theme.vala"
	_tmp21_ = self->priv->_FillEndColor;
#line 202 "../lib/Drawing/Theme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp17_, (gdouble) 1, _tmp18_.red, _tmp19_.green, _tmp20_.blue, _tmp21_.alpha);
#line 204 "../lib/Drawing/Theme.vala"
	_tmp22_ = cr;
#line 204 "../lib/Drawing/Theme.vala"
	_tmp23_ = gradient;
#line 204 "../lib/Drawing/Theme.vala"
	cairo_set_source (_tmp22_, _tmp23_);
#line 205 "../lib/Drawing/Theme.vala"
	_tmp24_ = cr;
#line 205 "../lib/Drawing/Theme.vala"
	_tmp25_ = self->priv->_LineWidth;
#line 205 "../lib/Drawing/Theme.vala"
	_tmp26_ = self->priv->_LineWidth;
#line 205 "../lib/Drawing/Theme.vala"
	_tmp27_ = self->priv->_LineWidth;
#line 205 "../lib/Drawing/Theme.vala"
	_tmp28_ = self->priv->_LineWidth;
#line 205 "../lib/Drawing/Theme.vala"
	_tmp29_ = self->priv->_TopRoundness;
#line 205 "../lib/Drawing/Theme.vala"
	_tmp30_ = self->priv->_BottomRoundness;
#line 205 "../lib/Drawing/Theme.vala"
	_tmp31_ = self->priv->_LineWidth;
#line 205 "../lib/Drawing/Theme.vala"
	plank_theme_draw_rounded_rect (_tmp24_, _tmp25_ / 2.0, _tmp26_ / 2.0, (gdouble) (width - _tmp27_), (height - (_tmp28_ / 2.0)) - (bottom_offset / 2.0), (gdouble) _tmp29_, (gdouble) _tmp30_, (gdouble) _tmp31_);
#line 213 "../lib/Drawing/Theme.vala"
	_tmp32_ = cr;
#line 213 "../lib/Drawing/Theme.vala"
	cairo_fill_preserve (_tmp32_);
#line 215 "../lib/Drawing/Theme.vala"
	_tmp33_ = cr;
#line 215 "../lib/Drawing/Theme.vala"
	_tmp34_ = self->priv->_OuterStrokeColor;
#line 215 "../lib/Drawing/Theme.vala"
	_tmp35_ = self->priv->_OuterStrokeColor;
#line 215 "../lib/Drawing/Theme.vala"
	_tmp36_ = self->priv->_OuterStrokeColor;
#line 215 "../lib/Drawing/Theme.vala"
	_tmp37_ = self->priv->_OuterStrokeColor;
#line 215 "../lib/Drawing/Theme.vala"
	cairo_set_source_rgba (_tmp33_, _tmp34_.red, _tmp35_.green, _tmp36_.blue, _tmp37_.alpha);
#line 216 "../lib/Drawing/Theme.vala"
	_tmp38_ = cr;
#line 216 "../lib/Drawing/Theme.vala"
	_tmp39_ = self->priv->_LineWidth;
#line 216 "../lib/Drawing/Theme.vala"
	cairo_set_line_width (_tmp38_, (gdouble) _tmp39_);
#line 217 "../lib/Drawing/Theme.vala"
	_tmp40_ = cr;
#line 217 "../lib/Drawing/Theme.vala"
	cairo_stroke (_tmp40_);
#line 219 "../lib/Drawing/Theme.vala"
	_tmp41_ = self->priv->_LineWidth;
#line 219 "../lib/Drawing/Theme.vala"
	_tmp42_ = self->priv->_LineWidth;
#line 219 "../lib/Drawing/Theme.vala"
	_tmp43_ = cairo_pattern_create_linear ((gdouble) 0, (gdouble) (2 * _tmp41_), (gdouble) 0, (gdouble) ((height - (2 * _tmp42_)) - bottom_offset));
#line 219 "../lib/Drawing/Theme.vala"
	_cairo_pattern_destroy0 (gradient);
#line 219 "../lib/Drawing/Theme.vala"
	gradient = _tmp43_;
#line 220 "../lib/Drawing/Theme.vala"
	_tmp44_ = gradient;
#line 220 "../lib/Drawing/Theme.vala"
	_tmp45_ = self->priv->_InnerStrokeColor;
#line 220 "../lib/Drawing/Theme.vala"
	_tmp46_ = self->priv->_InnerStrokeColor;
#line 220 "../lib/Drawing/Theme.vala"
	_tmp47_ = self->priv->_InnerStrokeColor;
#line 220 "../lib/Drawing/Theme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp44_, (gdouble) 0, _tmp45_.red, _tmp46_.green, _tmp47_.blue, 0.5);
#line 221 "../lib/Drawing/Theme.vala"
	_tmp49_ = self->priv->_TopRoundness;
#line 221 "../lib/Drawing/Theme.vala"
	if (_tmp49_ > 0) {
#line 815 "Theme.c"
		gint _tmp50_;
#line 221 "../lib/Drawing/Theme.vala"
		_tmp50_ = self->priv->_TopRoundness;
#line 221 "../lib/Drawing/Theme.vala"
		_tmp48_ = _tmp50_;
#line 821 "Theme.c"
	} else {
		gint _tmp51_;
#line 221 "../lib/Drawing/Theme.vala"
		_tmp51_ = self->priv->_LineWidth;
#line 221 "../lib/Drawing/Theme.vala"
		_tmp48_ = _tmp51_;
#line 828 "Theme.c"
	}
#line 221 "../lib/Drawing/Theme.vala"
	_tmp52_ = gradient;
#line 221 "../lib/Drawing/Theme.vala"
	_tmp53_ = self->priv->_InnerStrokeColor;
#line 221 "../lib/Drawing/Theme.vala"
	_tmp54_ = self->priv->_InnerStrokeColor;
#line 221 "../lib/Drawing/Theme.vala"
	_tmp55_ = self->priv->_InnerStrokeColor;
#line 221 "../lib/Drawing/Theme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp52_, _tmp48_ / ((gdouble) height), _tmp53_.red, _tmp54_.green, _tmp55_.blue, 0.12);
#line 222 "../lib/Drawing/Theme.vala"
	_tmp57_ = self->priv->_BottomRoundness;
#line 222 "../lib/Drawing/Theme.vala"
	if (_tmp57_ > 0) {
#line 844 "Theme.c"
		gint _tmp58_;
#line 222 "../lib/Drawing/Theme.vala"
		_tmp58_ = self->priv->_BottomRoundness;
#line 222 "../lib/Drawing/Theme.vala"
		_tmp56_ = _tmp58_;
#line 850 "Theme.c"
	} else {
		gint _tmp59_;
#line 222 "../lib/Drawing/Theme.vala"
		_tmp59_ = self->priv->_LineWidth;
#line 222 "../lib/Drawing/Theme.vala"
		_tmp56_ = _tmp59_;
#line 857 "Theme.c"
	}
#line 222 "../lib/Drawing/Theme.vala"
	_tmp60_ = gradient;
#line 222 "../lib/Drawing/Theme.vala"
	_tmp61_ = self->priv->_InnerStrokeColor;
#line 222 "../lib/Drawing/Theme.vala"
	_tmp62_ = self->priv->_InnerStrokeColor;
#line 222 "../lib/Drawing/Theme.vala"
	_tmp63_ = self->priv->_InnerStrokeColor;
#line 222 "../lib/Drawing/Theme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp60_, 1 - (_tmp56_ / ((gdouble) height)), _tmp61_.red, _tmp62_.green, _tmp63_.blue, 0.08);
#line 223 "../lib/Drawing/Theme.vala"
	_tmp64_ = gradient;
#line 223 "../lib/Drawing/Theme.vala"
	_tmp65_ = self->priv->_InnerStrokeColor;
#line 223 "../lib/Drawing/Theme.vala"
	_tmp66_ = self->priv->_InnerStrokeColor;
#line 223 "../lib/Drawing/Theme.vala"
	_tmp67_ = self->priv->_InnerStrokeColor;
#line 223 "../lib/Drawing/Theme.vala"
	cairo_pattern_add_color_stop_rgba (_tmp64_, (gdouble) 1, _tmp65_.red, _tmp66_.green, _tmp67_.blue, 0.19);
#line 225 "../lib/Drawing/Theme.vala"
	_tmp68_ = cr;
#line 225 "../lib/Drawing/Theme.vala"
	_tmp69_ = gradient;
#line 225 "../lib/Drawing/Theme.vala"
	cairo_set_source (_tmp68_, _tmp69_);
#line 226 "../lib/Drawing/Theme.vala"
	_tmp70_ = cr;
#line 226 "../lib/Drawing/Theme.vala"
	plank_theme_draw_inner_rect (self, _tmp70_, width, height);
#line 227 "../lib/Drawing/Theme.vala"
	_tmp71_ = cr;
#line 227 "../lib/Drawing/Theme.vala"
	cairo_stroke (_tmp71_);
#line 229 "../lib/Drawing/Theme.vala"
	_tmp72_ = cr;
#line 229 "../lib/Drawing/Theme.vala"
	cairo_restore (_tmp72_);
#line 190 "../lib/Drawing/Theme.vala"
	_cairo_pattern_destroy0 (gradient);
#line 899 "Theme.c"
}

/**
 * Similar to draw_rounded_rect, but moves in to avoid a containing rounded rect's lines.
 *
 * @param cr the context to draw with
 * @param width the width of the rect
 * @param height the height of the rect
 */
void
plank_theme_draw_inner_rect (PlankTheme* self,
                             cairo_t* cr,
                             gint width,
                             gint height)
{
	gint _tmp0_ = 0;
	gint _tmp1_;
	gint bottom_offset = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
#line 239 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 239 "../lib/Drawing/Theme.vala"
	g_return_if_fail (cr != NULL);
#line 241 "../lib/Drawing/Theme.vala"
	_tmp1_ = self->priv->_BottomRoundness;
#line 241 "../lib/Drawing/Theme.vala"
	if (_tmp1_ > 0) {
#line 935 "Theme.c"
		gint _tmp2_;
#line 241 "../lib/Drawing/Theme.vala"
		_tmp2_ = self->priv->_LineWidth;
#line 241 "../lib/Drawing/Theme.vala"
		_tmp0_ = _tmp2_;
#line 941 "Theme.c"
	} else {
		gint _tmp3_;
#line 241 "../lib/Drawing/Theme.vala"
		_tmp3_ = self->priv->_LineWidth;
#line 241 "../lib/Drawing/Theme.vala"
		_tmp0_ = -_tmp3_;
#line 948 "Theme.c"
	}
#line 241 "../lib/Drawing/Theme.vala"
	bottom_offset = _tmp0_;
#line 243 "../lib/Drawing/Theme.vala"
	_tmp4_ = self->priv->_LineWidth;
#line 243 "../lib/Drawing/Theme.vala"
	_tmp5_ = self->priv->_LineWidth;
#line 243 "../lib/Drawing/Theme.vala"
	_tmp6_ = self->priv->_LineWidth;
#line 243 "../lib/Drawing/Theme.vala"
	_tmp7_ = self->priv->_LineWidth;
#line 243 "../lib/Drawing/Theme.vala"
	_tmp8_ = self->priv->_TopRoundness;
#line 243 "../lib/Drawing/Theme.vala"
	_tmp9_ = self->priv->_LineWidth;
#line 243 "../lib/Drawing/Theme.vala"
	_tmp10_ = self->priv->_BottomRoundness;
#line 243 "../lib/Drawing/Theme.vala"
	_tmp11_ = self->priv->_LineWidth;
#line 243 "../lib/Drawing/Theme.vala"
	_tmp12_ = self->priv->_LineWidth;
#line 243 "../lib/Drawing/Theme.vala"
	plank_theme_draw_rounded_rect (cr, (3 * _tmp4_) / 2.0, (3 * _tmp5_) / 2.0, (gdouble) (width - (3 * _tmp6_)), (height - ((3 * _tmp7_) / 2.0)) - ((3 * bottom_offset) / 2.0), (gdouble) (_tmp8_ - _tmp9_), (gdouble) (_tmp10_ - _tmp11_), (gdouble) _tmp12_);
#line 972 "Theme.c"
}

/**
 * Draws a rounded rectangle.  If compositing is disabled, just draws a normal rectangle.
 *
 * @param cr the context to draw with
 * @param x the x location of the rect
 * @param y the y location of the rect
 * @param width the width of the rect
 * @param height the height of the rect
 * @param top_radius the roundedness of the top edge
 * @param bottom_radius the roundedness of the bottom edge
 * @param line_width the line-width of the rect
 */
void
plank_theme_draw_rounded_rect (cairo_t* cr,
                               gdouble x,
                               gdouble y,
                               gdouble width,
                               gdouble height,
                               gdouble top_radius,
                               gdouble bottom_radius,
                               gdouble line_width)
{
	gdouble min_size = 0.0;
	GdkScreen* _tmp0_;
#line 265 "../lib/Drawing/Theme.vala"
	g_return_if_fail (cr != NULL);
#line 267 "../lib/Drawing/Theme.vala"
	min_size = MIN (width, height);
#line 269 "../lib/Drawing/Theme.vala"
	top_radius = CLAMP (top_radius, 0.0, min_size);
#line 270 "../lib/Drawing/Theme.vala"
	bottom_radius = CLAMP (bottom_radius, 0.0, min_size - top_radius);
#line 272 "../lib/Drawing/Theme.vala"
	_tmp0_ = gdk_screen_get_default ();
#line 272 "../lib/Drawing/Theme.vala"
	if (!gdk_screen_is_composited (_tmp0_)) {
#line 273 "../lib/Drawing/Theme.vala"
		bottom_radius = 0.0;
#line 273 "../lib/Drawing/Theme.vala"
		top_radius = bottom_radius;
#line 1015 "Theme.c"
	}
#line 276 "../lib/Drawing/Theme.vala"
	if (top_radius == 0.0) {
#line 277 "../lib/Drawing/Theme.vala"
		cairo_move_to (cr, x - (line_width / 2.0), y);
#line 1021 "Theme.c"
	} else {
#line 279 "../lib/Drawing/Theme.vala"
		cairo_move_to (cr, x + top_radius, y);
#line 1025 "Theme.c"
	}
#line 281 "../lib/Drawing/Theme.vala"
	cairo_arc (cr, (x + width) - top_radius, y + top_radius, top_radius, -G_PI_2, (gdouble) 0);
#line 282 "../lib/Drawing/Theme.vala"
	cairo_arc (cr, (x + width) - bottom_radius, (y + height) - bottom_radius, bottom_radius, (gdouble) 0, G_PI_2);
#line 283 "../lib/Drawing/Theme.vala"
	cairo_arc (cr, x + bottom_radius, (y + height) - bottom_radius, bottom_radius, G_PI_2, G_PI);
#line 284 "../lib/Drawing/Theme.vala"
	cairo_arc (cr, x + top_radius, y + top_radius, top_radius, G_PI, -G_PI_2);
#line 285 "../lib/Drawing/Theme.vala"
	cairo_close_path (cr);
#line 1037 "Theme.c"
}

/**
 * Draws a rounded horizontal line.
 *
 * @param cr the context to draw with
 * @param x the x location of the line
 * @param y the y location of the line
 * @param width the width of the line
 * @param height the height of the line
 * @param is_round_left weather the left is round or not
 * @param is_round_right weather the right is round or not
 * @param stroke filling style of the outline
 * @param fill filling style of the inner area
 */
void
plank_theme_draw_rounded_line (cairo_t* cr,
                               gdouble x,
                               gdouble y,
                               gdouble width,
                               gdouble height,
                               gboolean is_round_left,
                               gboolean is_round_right,
                               cairo_pattern_t* stroke,
                               cairo_pattern_t* fill)
{
	gdouble _tmp0_ = 0.0;
	gdouble left_radius = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble right_radius = 0.0;
#line 301 "../lib/Drawing/Theme.vala"
	g_return_if_fail (cr != NULL);
#line 303 "../lib/Drawing/Theme.vala"
	if (height > width) {
#line 304 "../lib/Drawing/Theme.vala"
		y = y + floor ((height - width) / 2.0);
#line 305 "../lib/Drawing/Theme.vala"
		height = width;
#line 1076 "Theme.c"
	}
#line 308 "../lib/Drawing/Theme.vala"
	height = 2.0 * floor (height / 2.0);
#line 310 "../lib/Drawing/Theme.vala"
	if (is_round_left) {
#line 310 "../lib/Drawing/Theme.vala"
		_tmp0_ = height / 2.0;
#line 1084 "Theme.c"
	} else {
#line 310 "../lib/Drawing/Theme.vala"
		_tmp0_ = 0.0;
#line 1088 "Theme.c"
	}
#line 310 "../lib/Drawing/Theme.vala"
	left_radius = _tmp0_;
#line 311 "../lib/Drawing/Theme.vala"
	if (is_round_right) {
#line 311 "../lib/Drawing/Theme.vala"
		_tmp1_ = height / 2.0;
#line 1096 "Theme.c"
	} else {
#line 311 "../lib/Drawing/Theme.vala"
		_tmp1_ = 0.0;
#line 1100 "Theme.c"
	}
#line 311 "../lib/Drawing/Theme.vala"
	right_radius = _tmp1_;
#line 313 "../lib/Drawing/Theme.vala"
	cairo_move_to (cr, (x + width) - right_radius, y);
#line 314 "../lib/Drawing/Theme.vala"
	cairo_line_to (cr, x + left_radius, y);
#line 315 "../lib/Drawing/Theme.vala"
	if (is_round_left) {
#line 316 "../lib/Drawing/Theme.vala"
		cairo_arc_negative (cr, x + left_radius, y + left_radius, left_radius, -G_PI_2, G_PI_2);
#line 1112 "Theme.c"
	} else {
#line 318 "../lib/Drawing/Theme.vala"
		cairo_line_to (cr, x, y + height);
#line 1116 "Theme.c"
	}
#line 319 "../lib/Drawing/Theme.vala"
	cairo_line_to (cr, (x + width) - right_radius, y + height);
#line 320 "../lib/Drawing/Theme.vala"
	if (is_round_right) {
#line 321 "../lib/Drawing/Theme.vala"
		cairo_arc_negative (cr, (x + width) - right_radius, y + right_radius, right_radius, G_PI_2, -G_PI_2);
#line 1124 "Theme.c"
	} else {
#line 323 "../lib/Drawing/Theme.vala"
		cairo_line_to (cr, x + width, y);
#line 1128 "Theme.c"
	}
#line 324 "../lib/Drawing/Theme.vala"
	cairo_close_path (cr);
#line 326 "../lib/Drawing/Theme.vala"
	if (fill != NULL) {
#line 327 "../lib/Drawing/Theme.vala"
		cairo_set_source (cr, fill);
#line 328 "../lib/Drawing/Theme.vala"
		cairo_fill_preserve (cr);
#line 1138 "Theme.c"
	}
#line 330 "../lib/Drawing/Theme.vala"
	if (stroke != NULL) {
#line 331 "../lib/Drawing/Theme.vala"
		cairo_set_source (cr, stroke);
#line 1144 "Theme.c"
	}
#line 332 "../lib/Drawing/Theme.vala"
	cairo_stroke (cr);
#line 1148 "Theme.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_theme_real_verify (PlankPreferences* base,
                         const gchar* prop)
{
	PlankTheme * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 342 "../lib/Drawing/Theme.vala"
	static GQuark _tmp1_label0 = 0;
#line 342 "../lib/Drawing/Theme.vala"
	static GQuark _tmp1_label1 = 0;
#line 342 "../lib/Drawing/Theme.vala"
	static GQuark _tmp1_label2 = 0;
#line 342 "../lib/Drawing/Theme.vala"
	static GQuark _tmp1_label3 = 0;
#line 342 "../lib/Drawing/Theme.vala"
	static GQuark _tmp1_label4 = 0;
#line 342 "../lib/Drawing/Theme.vala"
	static GQuark _tmp1_label5 = 0;
#line 342 "../lib/Drawing/Theme.vala"
	static GQuark _tmp1_label6 = 0;
#line 338 "../lib/Drawing/Theme.vala"
	self = (PlankTheme*) base;
#line 338 "../lib/Drawing/Theme.vala"
	g_return_if_fail (prop != NULL);
#line 340 "../lib/Drawing/Theme.vala"
	PLANK_PREFERENCES_CLASS (plank_theme_parent_class)->verify (G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_PREFERENCES, PlankPreferences), prop);
#line 342 "../lib/Drawing/Theme.vala"
	_tmp0_ = prop;
#line 342 "../lib/Drawing/Theme.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 342 "../lib/Drawing/Theme.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("TopRoundness")))) {
#line 342 "../lib/Drawing/Theme.vala"
		switch (0) {
#line 1189 "Theme.c"
			default:
			{
				gint _tmp3_;
#line 344 "../lib/Drawing/Theme.vala"
				_tmp3_ = self->priv->_TopRoundness;
#line 344 "../lib/Drawing/Theme.vala"
				if (_tmp3_ < 0) {
#line 345 "../lib/Drawing/Theme.vala"
					plank_theme_set_TopRoundness (self, 0);
#line 1199 "Theme.c"
				}
#line 346 "../lib/Drawing/Theme.vala"
				break;
#line 1203 "Theme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("BottomRoundness")))) {
#line 342 "../lib/Drawing/Theme.vala"
		switch (0) {
#line 1209 "Theme.c"
			default:
			{
				gint _tmp4_;
#line 349 "../lib/Drawing/Theme.vala"
				_tmp4_ = self->priv->_BottomRoundness;
#line 349 "../lib/Drawing/Theme.vala"
				if (_tmp4_ < 0) {
#line 350 "../lib/Drawing/Theme.vala"
					plank_theme_set_BottomRoundness (self, 0);
#line 1219 "Theme.c"
				}
#line 351 "../lib/Drawing/Theme.vala"
				break;
#line 1223 "Theme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("LineWidth")))) {
#line 342 "../lib/Drawing/Theme.vala"
		switch (0) {
#line 1229 "Theme.c"
			default:
			{
				gint _tmp5_;
#line 354 "../lib/Drawing/Theme.vala"
				_tmp5_ = self->priv->_LineWidth;
#line 354 "../lib/Drawing/Theme.vala"
				if (_tmp5_ < 0) {
#line 355 "../lib/Drawing/Theme.vala"
					plank_theme_set_LineWidth (self, 0);
#line 1239 "Theme.c"
				}
#line 356 "../lib/Drawing/Theme.vala"
				break;
#line 1243 "Theme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("OuterStrokeColor")))) {
#line 342 "../lib/Drawing/Theme.vala"
		switch (0) {
#line 1249 "Theme.c"
			default:
			{
#line 359 "../lib/Drawing/Theme.vala"
				break;
#line 1254 "Theme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("FillStartColor")))) {
#line 342 "../lib/Drawing/Theme.vala"
		switch (0) {
#line 1260 "Theme.c"
			default:
			{
#line 362 "../lib/Drawing/Theme.vala"
				break;
#line 1265 "Theme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("FillEndColor")))) {
#line 342 "../lib/Drawing/Theme.vala"
		switch (0) {
#line 1271 "Theme.c"
			default:
			{
#line 365 "../lib/Drawing/Theme.vala"
				break;
#line 1276 "Theme.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("InnerStrokeColor")))) {
#line 342 "../lib/Drawing/Theme.vala"
		switch (0) {
#line 1282 "Theme.c"
			default:
			{
#line 368 "../lib/Drawing/Theme.vala"
				break;
#line 1287 "Theme.c"
			}
		}
	}
}

/**
 * Get a sorted array of all available theme-names
 *
 * @return array containing all available theme-names
 */
gchar**
plank_theme_get_theme_list (gint* result_length1)
{
	GeeHashSet* list = NULL;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeHashSet* _tmp2_;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp31_;
	GeeHashSet* _tmp32_;
	gint _tmp33_ = 0;
	gpointer* _tmp34_;
	gchar** _tmp35_;
	gint _tmp35__length1;
	GError* _inner_error0_ = NULL;
	gchar** result;
#line 379 "../lib/Drawing/Theme.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 379 "../lib/Drawing/Theme.vala"
	list = _tmp0_;
#line 381 "../lib/Drawing/Theme.vala"
	_tmp1_ = list;
#line 381 "../lib/Drawing/Theme.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, PLANK_THEME_DEFAULT_NAME);
#line 382 "../lib/Drawing/Theme.vala"
	_tmp2_ = list;
#line 382 "../lib/Drawing/Theme.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, PLANK_THEME_GTK_THEME_NAME);
#line 1326 "Theme.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFileEnumerator* _tmp5_;
		GFileInfo* info = NULL;
#line 386 "../lib/Drawing/Theme.vala"
		_tmp3_ = plank_paths_get_AppThemeFolder ();
#line 386 "../lib/Drawing/Theme.vala"
		_tmp4_ = _tmp3_;
#line 386 "../lib/Drawing/Theme.vala"
		_tmp5_ = g_file_enumerate_children (_tmp4_, "standard::name,standard::type", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 386 "../lib/Drawing/Theme.vala"
		enumerator = _tmp5_;
#line 386 "../lib/Drawing/Theme.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1343 "Theme.c"
			goto __catch0_g_error;
		}
#line 389 "../lib/Drawing/Theme.vala"
		while (TRUE) {
#line 1348 "Theme.c"
			GFileInfo* _tmp6_ = NULL;
			GFileEnumerator* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			gboolean _tmp11_ = FALSE;
			GFileInfo* _tmp12_;
			GeeHashSet* _tmp14_;
			GFileInfo* _tmp15_;
			const gchar* _tmp16_;
#line 389 "../lib/Drawing/Theme.vala"
			_tmp7_ = enumerator;
#line 389 "../lib/Drawing/Theme.vala"
			_tmp8_ = g_file_enumerator_next_file (_tmp7_, NULL, &_inner_error0_);
#line 389 "../lib/Drawing/Theme.vala"
			_tmp6_ = _tmp8_;
#line 389 "../lib/Drawing/Theme.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 389 "../lib/Drawing/Theme.vala"
				_g_object_unref0 (info);
#line 389 "../lib/Drawing/Theme.vala"
				_g_object_unref0 (enumerator);
#line 1371 "Theme.c"
				goto __catch0_g_error;
			}
#line 389 "../lib/Drawing/Theme.vala"
			_tmp9_ = _tmp6_;
#line 389 "../lib/Drawing/Theme.vala"
			_tmp6_ = NULL;
#line 389 "../lib/Drawing/Theme.vala"
			_g_object_unref0 (info);
#line 389 "../lib/Drawing/Theme.vala"
			info = _tmp9_;
#line 389 "../lib/Drawing/Theme.vala"
			_tmp10_ = info;
#line 389 "../lib/Drawing/Theme.vala"
			if (!(_tmp10_ != NULL)) {
#line 389 "../lib/Drawing/Theme.vala"
				_g_object_unref0 (_tmp6_);
#line 389 "../lib/Drawing/Theme.vala"
				break;
#line 1390 "Theme.c"
			}
#line 390 "../lib/Drawing/Theme.vala"
			_tmp12_ = info;
#line 390 "../lib/Drawing/Theme.vala"
			if (g_file_info_get_is_hidden (_tmp12_)) {
#line 390 "../lib/Drawing/Theme.vala"
				_tmp11_ = TRUE;
#line 1398 "Theme.c"
			} else {
				GFileInfo* _tmp13_;
#line 391 "../lib/Drawing/Theme.vala"
				_tmp13_ = info;
#line 391 "../lib/Drawing/Theme.vala"
				_tmp11_ = g_file_info_get_file_type (_tmp13_) != G_FILE_TYPE_DIRECTORY;
#line 1405 "Theme.c"
			}
#line 390 "../lib/Drawing/Theme.vala"
			if (_tmp11_) {
#line 392 "../lib/Drawing/Theme.vala"
				_g_object_unref0 (_tmp6_);
#line 392 "../lib/Drawing/Theme.vala"
				continue;
#line 1413 "Theme.c"
			}
#line 394 "../lib/Drawing/Theme.vala"
			_tmp14_ = list;
#line 394 "../lib/Drawing/Theme.vala"
			_tmp15_ = info;
#line 394 "../lib/Drawing/Theme.vala"
			_tmp16_ = g_file_info_get_name (_tmp15_);
#line 394 "../lib/Drawing/Theme.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp16_);
#line 389 "../lib/Drawing/Theme.vala"
			_g_object_unref0 (_tmp6_);
#line 1425 "Theme.c"
		}
#line 385 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (info);
#line 385 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (enumerator);
#line 1431 "Theme.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 385 "../lib/Drawing/Theme.vala"
		g_clear_error (&_inner_error0_);
#line 1438 "Theme.c"
	}
	__finally0:
#line 385 "../lib/Drawing/Theme.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 385 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (list);
#line 385 "../lib/Drawing/Theme.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 385 "../lib/Drawing/Theme.vala"
		g_clear_error (&_inner_error0_);
#line 385 "../lib/Drawing/Theme.vala"
		return NULL;
#line 1451 "Theme.c"
	}
	{
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp17_;
		GFile* _tmp18_;
		GFileEnumerator* _tmp19_;
		GFileInfo* info = NULL;
#line 400 "../lib/Drawing/Theme.vala"
		_tmp17_ = plank_paths_get_ThemeFolder ();
#line 400 "../lib/Drawing/Theme.vala"
		_tmp18_ = _tmp17_;
#line 400 "../lib/Drawing/Theme.vala"
		_tmp19_ = g_file_enumerate_children (_tmp18_, "standard::name,standard::type", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 400 "../lib/Drawing/Theme.vala"
		enumerator = _tmp19_;
#line 400 "../lib/Drawing/Theme.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1469 "Theme.c"
			goto __catch1_g_error;
		}
#line 403 "../lib/Drawing/Theme.vala"
		while (TRUE) {
#line 1474 "Theme.c"
			GFileInfo* _tmp20_ = NULL;
			GFileEnumerator* _tmp21_;
			GFileInfo* _tmp22_;
			GFileInfo* _tmp23_;
			GFileInfo* _tmp24_;
			gboolean _tmp25_ = FALSE;
			GFileInfo* _tmp26_;
			GeeHashSet* _tmp28_;
			GFileInfo* _tmp29_;
			const gchar* _tmp30_;
#line 403 "../lib/Drawing/Theme.vala"
			_tmp21_ = enumerator;
#line 403 "../lib/Drawing/Theme.vala"
			_tmp22_ = g_file_enumerator_next_file (_tmp21_, NULL, &_inner_error0_);
#line 403 "../lib/Drawing/Theme.vala"
			_tmp20_ = _tmp22_;
#line 403 "../lib/Drawing/Theme.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 403 "../lib/Drawing/Theme.vala"
				_g_object_unref0 (info);
#line 403 "../lib/Drawing/Theme.vala"
				_g_object_unref0 (enumerator);
#line 1497 "Theme.c"
				goto __catch1_g_error;
			}
#line 403 "../lib/Drawing/Theme.vala"
			_tmp23_ = _tmp20_;
#line 403 "../lib/Drawing/Theme.vala"
			_tmp20_ = NULL;
#line 403 "../lib/Drawing/Theme.vala"
			_g_object_unref0 (info);
#line 403 "../lib/Drawing/Theme.vala"
			info = _tmp23_;
#line 403 "../lib/Drawing/Theme.vala"
			_tmp24_ = info;
#line 403 "../lib/Drawing/Theme.vala"
			if (!(_tmp24_ != NULL)) {
#line 403 "../lib/Drawing/Theme.vala"
				_g_object_unref0 (_tmp20_);
#line 403 "../lib/Drawing/Theme.vala"
				break;
#line 1516 "Theme.c"
			}
#line 404 "../lib/Drawing/Theme.vala"
			_tmp26_ = info;
#line 404 "../lib/Drawing/Theme.vala"
			if (g_file_info_get_is_hidden (_tmp26_)) {
#line 404 "../lib/Drawing/Theme.vala"
				_tmp25_ = TRUE;
#line 1524 "Theme.c"
			} else {
				GFileInfo* _tmp27_;
#line 405 "../lib/Drawing/Theme.vala"
				_tmp27_ = info;
#line 405 "../lib/Drawing/Theme.vala"
				_tmp25_ = g_file_info_get_file_type (_tmp27_) != G_FILE_TYPE_DIRECTORY;
#line 1531 "Theme.c"
			}
#line 404 "../lib/Drawing/Theme.vala"
			if (_tmp25_) {
#line 406 "../lib/Drawing/Theme.vala"
				_g_object_unref0 (_tmp20_);
#line 406 "../lib/Drawing/Theme.vala"
				continue;
#line 1539 "Theme.c"
			}
#line 408 "../lib/Drawing/Theme.vala"
			_tmp28_ = list;
#line 408 "../lib/Drawing/Theme.vala"
			_tmp29_ = info;
#line 408 "../lib/Drawing/Theme.vala"
			_tmp30_ = g_file_info_get_name (_tmp29_);
#line 408 "../lib/Drawing/Theme.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp30_);
#line 403 "../lib/Drawing/Theme.vala"
			_g_object_unref0 (_tmp20_);
#line 1551 "Theme.c"
		}
#line 399 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (info);
#line 399 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (enumerator);
#line 1557 "Theme.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 399 "../lib/Drawing/Theme.vala"
		g_clear_error (&_inner_error0_);
#line 1564 "Theme.c"
	}
	__finally1:
#line 399 "../lib/Drawing/Theme.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 399 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (list);
#line 399 "../lib/Drawing/Theme.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 399 "../lib/Drawing/Theme.vala"
		g_clear_error (&_inner_error0_);
#line 399 "../lib/Drawing/Theme.vala"
		return NULL;
#line 1577 "Theme.c"
	}
#line 412 "../lib/Drawing/Theme.vala"
	_tmp31_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 412 "../lib/Drawing/Theme.vala"
	_result_ = _tmp31_;
#line 413 "../lib/Drawing/Theme.vala"
	_tmp32_ = list;
#line 413 "../lib/Drawing/Theme.vala"
	gee_array_list_add_all (_result_, (GeeCollection*) _tmp32_);
#line 414 "../lib/Drawing/Theme.vala"
	gee_list_sort ((GeeList*) _result_, NULL, NULL, NULL);
#line 416 "../lib/Drawing/Theme.vala"
	_tmp34_ = gee_collection_to_array ((GeeCollection*) _result_, &_tmp33_);
#line 416 "../lib/Drawing/Theme.vala"
	_tmp35_ = _tmp34_;
#line 416 "../lib/Drawing/Theme.vala"
	_tmp35__length1 = _tmp33_;
#line 416 "../lib/Drawing/Theme.vala"
	if (result_length1) {
#line 416 "../lib/Drawing/Theme.vala"
		*result_length1 = _tmp35__length1;
#line 1599 "Theme.c"
	}
#line 416 "../lib/Drawing/Theme.vala"
	result = _tmp35_;
#line 416 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (_result_);
#line 416 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (list);
#line 416 "../lib/Drawing/Theme.vala"
	return result;
#line 1609 "Theme.c"
}

/**
 * Try to get an already existing folder located in the
 * themes folder while prefering the user's themes folder.
 * If there is no folder found we fallback to the "Default" theme.
 * If even that folder doesn't exist return NULL (and use built-in defaults)
 *
 * @param name the basename of the folder
 * @return {@link GLib.File} the folder of the theme or NULL
 */
GFile*
plank_theme_get_theme_folder (const gchar* name)
{
	GFile* folder = NULL;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GFile* _tmp6_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GFile* _tmp12_;
	GFile* _tmp14_;
	GFile* result;
#line 428 "../lib/Drawing/Theme.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 430 "../lib/Drawing/Theme.vala"
	if (g_strcmp0 (name, PLANK_THEME_DEFAULT_NAME) == 0) {
#line 1641 "Theme.c"
		GFile* _tmp0_;
#line 431 "../lib/Drawing/Theme.vala"
		_tmp0_ = plank_theme_get_default_theme_folder ();
#line 431 "../lib/Drawing/Theme.vala"
		result = _tmp0_;
#line 431 "../lib/Drawing/Theme.vala"
		return result;
#line 1649 "Theme.c"
	}
#line 433 "../lib/Drawing/Theme.vala"
	if (g_strcmp0 (name, PLANK_THEME_GTK_THEME_NAME) == 0) {
#line 1653 "Theme.c"
		GFile* _tmp1_;
#line 434 "../lib/Drawing/Theme.vala"
		_tmp1_ = plank_theme_get_gtk_theme_folder ();
#line 434 "../lib/Drawing/Theme.vala"
		result = _tmp1_;
#line 434 "../lib/Drawing/Theme.vala"
		return result;
#line 1661 "Theme.c"
	}
#line 439 "../lib/Drawing/Theme.vala"
	_tmp2_ = plank_paths_get_AppThemeFolder ();
#line 439 "../lib/Drawing/Theme.vala"
	_tmp3_ = _tmp2_;
#line 439 "../lib/Drawing/Theme.vala"
	_tmp4_ = g_file_get_child (_tmp3_, name);
#line 439 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (folder);
#line 439 "../lib/Drawing/Theme.vala"
	folder = _tmp4_;
#line 440 "../lib/Drawing/Theme.vala"
	_tmp6_ = folder;
#line 440 "../lib/Drawing/Theme.vala"
	if (g_file_query_exists (_tmp6_, NULL)) {
#line 1677 "Theme.c"
		GFile* _tmp7_;
#line 441 "../lib/Drawing/Theme.vala"
		_tmp7_ = folder;
#line 441 "../lib/Drawing/Theme.vala"
		_tmp5_ = g_file_query_file_type (_tmp7_, G_FILE_QUERY_INFO_NONE, NULL) == G_FILE_TYPE_DIRECTORY;
#line 1683 "Theme.c"
	} else {
#line 440 "../lib/Drawing/Theme.vala"
		_tmp5_ = FALSE;
#line 1687 "Theme.c"
	}
#line 440 "../lib/Drawing/Theme.vala"
	if (_tmp5_) {
#line 442 "../lib/Drawing/Theme.vala"
		result = folder;
#line 442 "../lib/Drawing/Theme.vala"
		return result;
#line 1695 "Theme.c"
	}
#line 445 "../lib/Drawing/Theme.vala"
	_tmp8_ = plank_paths_get_ThemeFolder ();
#line 445 "../lib/Drawing/Theme.vala"
	_tmp9_ = _tmp8_;
#line 445 "../lib/Drawing/Theme.vala"
	_tmp10_ = g_file_get_child (_tmp9_, name);
#line 445 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (folder);
#line 445 "../lib/Drawing/Theme.vala"
	folder = _tmp10_;
#line 446 "../lib/Drawing/Theme.vala"
	_tmp12_ = folder;
#line 446 "../lib/Drawing/Theme.vala"
	if (g_file_query_exists (_tmp12_, NULL)) {
#line 1711 "Theme.c"
		GFile* _tmp13_;
#line 447 "../lib/Drawing/Theme.vala"
		_tmp13_ = folder;
#line 447 "../lib/Drawing/Theme.vala"
		_tmp11_ = g_file_query_file_type (_tmp13_, G_FILE_QUERY_INFO_NONE, NULL) == G_FILE_TYPE_DIRECTORY;
#line 1717 "Theme.c"
	} else {
#line 446 "../lib/Drawing/Theme.vala"
		_tmp11_ = FALSE;
#line 1721 "Theme.c"
	}
#line 446 "../lib/Drawing/Theme.vala"
	if (_tmp11_) {
#line 448 "../lib/Drawing/Theme.vala"
		result = folder;
#line 448 "../lib/Drawing/Theme.vala"
		return result;
#line 1729 "Theme.c"
	}
#line 450 "../lib/Drawing/Theme.vala"
	g_warning ("Theme.vala:450: %s not found, falling back to %s.", name, PLANK_THEME_DEFAULT_NAME);
#line 452 "../lib/Drawing/Theme.vala"
	_tmp14_ = plank_theme_get_default_theme_folder ();
#line 452 "../lib/Drawing/Theme.vala"
	result = _tmp14_;
#line 452 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (folder);
#line 452 "../lib/Drawing/Theme.vala"
	return result;
#line 1741 "Theme.c"
}

static GFile*
plank_theme_get_default_theme_folder (void)
{
	GFile* folder = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GFile* _tmp4_;
	GFile* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GFile* result;
#line 460 "../lib/Drawing/Theme.vala"
	_tmp0_ = plank_paths_get_ThemeFolder ();
#line 460 "../lib/Drawing/Theme.vala"
	_tmp1_ = _tmp0_;
#line 460 "../lib/Drawing/Theme.vala"
	_tmp2_ = g_file_get_child (_tmp1_, PLANK_THEME_DEFAULT_NAME);
#line 460 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (folder);
#line 460 "../lib/Drawing/Theme.vala"
	folder = _tmp2_;
#line 461 "../lib/Drawing/Theme.vala"
	_tmp4_ = folder;
#line 461 "../lib/Drawing/Theme.vala"
	if (g_file_query_exists (_tmp4_, NULL)) {
#line 1771 "Theme.c"
		GFile* _tmp5_;
#line 462 "../lib/Drawing/Theme.vala"
		_tmp5_ = folder;
#line 462 "../lib/Drawing/Theme.vala"
		_tmp3_ = g_file_query_file_type (_tmp5_, G_FILE_QUERY_INFO_NONE, NULL) == G_FILE_TYPE_DIRECTORY;
#line 1777 "Theme.c"
	} else {
#line 461 "../lib/Drawing/Theme.vala"
		_tmp3_ = FALSE;
#line 1781 "Theme.c"
	}
#line 461 "../lib/Drawing/Theme.vala"
	if (_tmp3_) {
#line 463 "../lib/Drawing/Theme.vala"
		result = folder;
#line 463 "../lib/Drawing/Theme.vala"
		return result;
#line 1789 "Theme.c"
	}
#line 465 "../lib/Drawing/Theme.vala"
	_tmp6_ = folder;
#line 465 "../lib/Drawing/Theme.vala"
	_tmp7_ = g_file_get_path (_tmp6_);
#line 465 "../lib/Drawing/Theme.vala"
	_tmp8_ = _tmp7_;
#line 465 "../lib/Drawing/Theme.vala"
	g_warning ("Theme.vala:465: %s is not a folder fallback to the built-in defaults!", _tmp8_);
#line 465 "../lib/Drawing/Theme.vala"
	_g_free0 (_tmp8_);
#line 467 "../lib/Drawing/Theme.vala"
	result = NULL;
#line 467 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (folder);
#line 467 "../lib/Drawing/Theme.vala"
	return result;
#line 1807 "Theme.c"
}

static GFile*
plank_theme_get_gtk_theme_folder (void)
{
	GFile* folder = NULL;
	const gchar* exec_name = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* folder_name = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GraniteSettings* _tmp4_;
	GraniteSettingsColorScheme _tmp5_;
	GraniteSettingsColorScheme _tmp6_;
	gchar* name = NULL;
	GtkSettings* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp26_;
	GFile* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GFile* _tmp31_;
	GFile* _tmp32_;
	const gchar* _tmp58_;
	GFile* result;
#line 473 "../lib/Drawing/Theme.vala"
	_tmp0_ = plank_paths_get_AppName ();
#line 473 "../lib/Drawing/Theme.vala"
	_tmp1_ = _tmp0_;
#line 473 "../lib/Drawing/Theme.vala"
	exec_name = _tmp1_;
#line 474 "../lib/Drawing/Theme.vala"
	_tmp2_ = exec_name;
#line 474 "../lib/Drawing/Theme.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 474 "../lib/Drawing/Theme.vala"
	folder_name = _tmp3_;
#line 477 "../lib/Drawing/Theme.vala"
	_tmp4_ = granite_settings_get_default ();
#line 477 "../lib/Drawing/Theme.vala"
	_tmp5_ = granite_settings_get_prefers_color_scheme (_tmp4_);
#line 477 "../lib/Drawing/Theme.vala"
	_tmp6_ = _tmp5_;
#line 477 "../lib/Drawing/Theme.vala"
	if (_tmp6_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK) {
#line 1863 "Theme.c"
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 478 "../lib/Drawing/Theme.vala"
		_tmp7_ = folder_name;
#line 478 "../lib/Drawing/Theme.vala"
		_tmp8_ = g_strconcat (_tmp7_, "-dark", NULL);
#line 478 "../lib/Drawing/Theme.vala"
		_g_free0 (folder_name);
#line 478 "../lib/Drawing/Theme.vala"
		folder_name = _tmp8_;
#line 1874 "Theme.c"
	}
#line 481 "../lib/Drawing/Theme.vala"
	_tmp9_ = gtk_settings_get_default ();
#line 481 "../lib/Drawing/Theme.vala"
	g_object_get (_tmp9_, "gtk-theme-name", &_tmp10_, NULL);
#line 481 "../lib/Drawing/Theme.vala"
	_tmp11_ = _tmp10_;
#line 481 "../lib/Drawing/Theme.vala"
	name = _tmp11_;
#line 484 "../lib/Drawing/Theme.vala"
	_tmp12_ = plank_paths_get_DataHomeFolder ();
#line 484 "../lib/Drawing/Theme.vala"
	_tmp13_ = _tmp12_;
#line 484 "../lib/Drawing/Theme.vala"
	_tmp14_ = name;
#line 484 "../lib/Drawing/Theme.vala"
	_tmp15_ = g_strdup_printf ("themes/%s", _tmp14_);
#line 484 "../lib/Drawing/Theme.vala"
	_tmp16_ = _tmp15_;
#line 484 "../lib/Drawing/Theme.vala"
	_tmp17_ = g_file_get_child (_tmp13_, _tmp16_);
#line 484 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (folder);
#line 484 "../lib/Drawing/Theme.vala"
	folder = _tmp17_;
#line 484 "../lib/Drawing/Theme.vala"
	_g_free0 (_tmp16_);
#line 485 "../lib/Drawing/Theme.vala"
	_tmp18_ = folder;
#line 485 "../lib/Drawing/Theme.vala"
	if (g_file_query_exists (_tmp18_, NULL)) {
#line 1906 "Theme.c"
		GFile* _tmp19_;
		const gchar* _tmp20_;
		GFile* _tmp21_;
		gboolean _tmp22_ = FALSE;
		GFile* _tmp23_;
		const gchar* _tmp25_;
#line 486 "../lib/Drawing/Theme.vala"
		_tmp19_ = folder;
#line 486 "../lib/Drawing/Theme.vala"
		_tmp20_ = folder_name;
#line 486 "../lib/Drawing/Theme.vala"
		_tmp21_ = g_file_get_child (_tmp19_, _tmp20_);
#line 486 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (folder);
#line 486 "../lib/Drawing/Theme.vala"
		folder = _tmp21_;
#line 487 "../lib/Drawing/Theme.vala"
		_tmp23_ = folder;
#line 487 "../lib/Drawing/Theme.vala"
		if (g_file_query_exists (_tmp23_, NULL)) {
#line 1927 "Theme.c"
			GFile* _tmp24_;
#line 488 "../lib/Drawing/Theme.vala"
			_tmp24_ = folder;
#line 488 "../lib/Drawing/Theme.vala"
			_tmp22_ = g_file_query_file_type (_tmp24_, G_FILE_QUERY_INFO_NONE, NULL) == G_FILE_TYPE_DIRECTORY;
#line 1933 "Theme.c"
		} else {
#line 487 "../lib/Drawing/Theme.vala"
			_tmp22_ = FALSE;
#line 1937 "Theme.c"
		}
#line 487 "../lib/Drawing/Theme.vala"
		if (_tmp22_) {
#line 489 "../lib/Drawing/Theme.vala"
			result = folder;
#line 489 "../lib/Drawing/Theme.vala"
			_g_free0 (name);
#line 489 "../lib/Drawing/Theme.vala"
			_g_free0 (folder_name);
#line 489 "../lib/Drawing/Theme.vala"
			return result;
#line 1949 "Theme.c"
		}
#line 491 "../lib/Drawing/Theme.vala"
		_tmp25_ = name;
#line 491 "../lib/Drawing/Theme.vala"
		g_warning ("Theme.vala:491: Currently selected gtk+ theme '%s' does not provide a " \
"dock theme, fallback to the built-in defaults!", _tmp25_);
#line 492 "../lib/Drawing/Theme.vala"
		result = NULL;
#line 492 "../lib/Drawing/Theme.vala"
		_g_free0 (name);
#line 492 "../lib/Drawing/Theme.vala"
		_g_free0 (folder_name);
#line 492 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (folder);
#line 492 "../lib/Drawing/Theme.vala"
		return result;
#line 1965 "Theme.c"
	}
#line 496 "../lib/Drawing/Theme.vala"
	_tmp26_ = plank_paths_get_HomeFolder ();
#line 496 "../lib/Drawing/Theme.vala"
	_tmp27_ = _tmp26_;
#line 496 "../lib/Drawing/Theme.vala"
	_tmp28_ = name;
#line 496 "../lib/Drawing/Theme.vala"
	_tmp29_ = g_strdup_printf (".themes/%s", _tmp28_);
#line 496 "../lib/Drawing/Theme.vala"
	_tmp30_ = _tmp29_;
#line 496 "../lib/Drawing/Theme.vala"
	_tmp31_ = g_file_get_child (_tmp27_, _tmp30_);
#line 496 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (folder);
#line 496 "../lib/Drawing/Theme.vala"
	folder = _tmp31_;
#line 496 "../lib/Drawing/Theme.vala"
	_g_free0 (_tmp30_);
#line 497 "../lib/Drawing/Theme.vala"
	_tmp32_ = folder;
#line 497 "../lib/Drawing/Theme.vala"
	if (g_file_query_exists (_tmp32_, NULL)) {
#line 1989 "Theme.c"
		GFile* _tmp33_;
		const gchar* _tmp34_;
		GFile* _tmp35_;
		gboolean _tmp36_ = FALSE;
		GFile* _tmp37_;
		const gchar* _tmp39_;
#line 498 "../lib/Drawing/Theme.vala"
		_tmp33_ = folder;
#line 498 "../lib/Drawing/Theme.vala"
		_tmp34_ = folder_name;
#line 498 "../lib/Drawing/Theme.vala"
		_tmp35_ = g_file_get_child (_tmp33_, _tmp34_);
#line 498 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (folder);
#line 498 "../lib/Drawing/Theme.vala"
		folder = _tmp35_;
#line 499 "../lib/Drawing/Theme.vala"
		_tmp37_ = folder;
#line 499 "../lib/Drawing/Theme.vala"
		if (g_file_query_exists (_tmp37_, NULL)) {
#line 2010 "Theme.c"
			GFile* _tmp38_;
#line 500 "../lib/Drawing/Theme.vala"
			_tmp38_ = folder;
#line 500 "../lib/Drawing/Theme.vala"
			_tmp36_ = g_file_query_file_type (_tmp38_, G_FILE_QUERY_INFO_NONE, NULL) == G_FILE_TYPE_DIRECTORY;
#line 2016 "Theme.c"
		} else {
#line 499 "../lib/Drawing/Theme.vala"
			_tmp36_ = FALSE;
#line 2020 "Theme.c"
		}
#line 499 "../lib/Drawing/Theme.vala"
		if (_tmp36_) {
#line 501 "../lib/Drawing/Theme.vala"
			result = folder;
#line 501 "../lib/Drawing/Theme.vala"
			_g_free0 (name);
#line 501 "../lib/Drawing/Theme.vala"
			_g_free0 (folder_name);
#line 501 "../lib/Drawing/Theme.vala"
			return result;
#line 2032 "Theme.c"
		}
#line 503 "../lib/Drawing/Theme.vala"
		_tmp39_ = name;
#line 503 "../lib/Drawing/Theme.vala"
		g_warning ("Theme.vala:503: Currently selected gtk+ theme '%s' does not provide a " \
"dock theme, fallback to the built-in defaults!", _tmp39_);
#line 504 "../lib/Drawing/Theme.vala"
		result = NULL;
#line 504 "../lib/Drawing/Theme.vala"
		_g_free0 (name);
#line 504 "../lib/Drawing/Theme.vala"
		_g_free0 (folder_name);
#line 504 "../lib/Drawing/Theme.vala"
		_g_object_unref0 (folder);
#line 504 "../lib/Drawing/Theme.vala"
		return result;
#line 2048 "Theme.c"
	}
	{
		GeeArrayList* _datafolder_list = NULL;
		GeeArrayList* _tmp40_;
		GeeArrayList* _tmp41_;
		gint _datafolder_size = 0;
		GeeArrayList* _tmp42_;
		gint _tmp43_;
		gint _tmp44_;
		gint _datafolder_index = 0;
#line 508 "../lib/Drawing/Theme.vala"
		_tmp40_ = plank_paths_get_DataDirFolders ();
#line 508 "../lib/Drawing/Theme.vala"
		_tmp41_ = _tmp40_;
#line 508 "../lib/Drawing/Theme.vala"
		_datafolder_list = _tmp41_;
#line 508 "../lib/Drawing/Theme.vala"
		_tmp42_ = _datafolder_list;
#line 508 "../lib/Drawing/Theme.vala"
		_tmp43_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp42_);
#line 508 "../lib/Drawing/Theme.vala"
		_tmp44_ = _tmp43_;
#line 508 "../lib/Drawing/Theme.vala"
		_datafolder_size = _tmp44_;
#line 508 "../lib/Drawing/Theme.vala"
		_datafolder_index = -1;
#line 508 "../lib/Drawing/Theme.vala"
		while (TRUE) {
#line 2077 "Theme.c"
			gint _tmp45_;
			gint _tmp46_;
			GFile* datafolder = NULL;
			GeeArrayList* _tmp47_;
			gpointer _tmp48_;
			GFile* _tmp49_;
			const gchar* _tmp50_;
			const gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			GFile* _tmp54_;
			gboolean _tmp55_ = FALSE;
			GFile* _tmp56_;
#line 508 "../lib/Drawing/Theme.vala"
			_datafolder_index = _datafolder_index + 1;
#line 508 "../lib/Drawing/Theme.vala"
			_tmp45_ = _datafolder_index;
#line 508 "../lib/Drawing/Theme.vala"
			_tmp46_ = _datafolder_size;
#line 508 "../lib/Drawing/Theme.vala"
			if (!(_tmp45_ < _tmp46_)) {
#line 508 "../lib/Drawing/Theme.vala"
				break;
#line 2101 "Theme.c"
			}
#line 508 "../lib/Drawing/Theme.vala"
			_tmp47_ = _datafolder_list;
#line 508 "../lib/Drawing/Theme.vala"
			_tmp48_ = gee_abstract_list_get ((GeeAbstractList*) _tmp47_, _datafolder_index);
#line 508 "../lib/Drawing/Theme.vala"
			datafolder = (GFile*) _tmp48_;
#line 509 "../lib/Drawing/Theme.vala"
			_tmp49_ = datafolder;
#line 509 "../lib/Drawing/Theme.vala"
			_tmp50_ = name;
#line 509 "../lib/Drawing/Theme.vala"
			_tmp51_ = folder_name;
#line 509 "../lib/Drawing/Theme.vala"
			_tmp52_ = g_strdup_printf ("themes/%s/%s", _tmp50_, _tmp51_);
#line 509 "../lib/Drawing/Theme.vala"
			_tmp53_ = _tmp52_;
#line 509 "../lib/Drawing/Theme.vala"
			_tmp54_ = g_file_get_child (_tmp49_, _tmp53_);
#line 509 "../lib/Drawing/Theme.vala"
			_g_object_unref0 (folder);
#line 509 "../lib/Drawing/Theme.vala"
			folder = _tmp54_;
#line 509 "../lib/Drawing/Theme.vala"
			_g_free0 (_tmp53_);
#line 510 "../lib/Drawing/Theme.vala"
			_tmp56_ = folder;
#line 510 "../lib/Drawing/Theme.vala"
			if (g_file_query_exists (_tmp56_, NULL)) {
#line 2131 "Theme.c"
				GFile* _tmp57_;
#line 511 "../lib/Drawing/Theme.vala"
				_tmp57_ = folder;
#line 511 "../lib/Drawing/Theme.vala"
				_tmp55_ = g_file_query_file_type (_tmp57_, G_FILE_QUERY_INFO_NONE, NULL) == G_FILE_TYPE_DIRECTORY;
#line 2137 "Theme.c"
			} else {
#line 510 "../lib/Drawing/Theme.vala"
				_tmp55_ = FALSE;
#line 2141 "Theme.c"
			}
#line 510 "../lib/Drawing/Theme.vala"
			if (_tmp55_) {
#line 512 "../lib/Drawing/Theme.vala"
				result = folder;
#line 512 "../lib/Drawing/Theme.vala"
				_g_object_unref0 (datafolder);
#line 512 "../lib/Drawing/Theme.vala"
				_g_free0 (name);
#line 512 "../lib/Drawing/Theme.vala"
				_g_free0 (folder_name);
#line 512 "../lib/Drawing/Theme.vala"
				return result;
#line 2155 "Theme.c"
			}
#line 508 "../lib/Drawing/Theme.vala"
			_g_object_unref0 (datafolder);
#line 2159 "Theme.c"
		}
	}
#line 515 "../lib/Drawing/Theme.vala"
	_tmp58_ = name;
#line 515 "../lib/Drawing/Theme.vala"
	g_warning ("Theme.vala:515: Currently selected gtk+ theme '%s' does not provide a " \
"dock theme, fallback to the built-in defaults!", _tmp58_);
#line 516 "../lib/Drawing/Theme.vala"
	result = NULL;
#line 516 "../lib/Drawing/Theme.vala"
	_g_free0 (name);
#line 516 "../lib/Drawing/Theme.vala"
	_g_free0 (folder_name);
#line 516 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (folder);
#line 516 "../lib/Drawing/Theme.vala"
	return result;
#line 2176 "Theme.c"
}

gint
plank_theme_get_TopRoundness (PlankTheme* self)
{
	gint result;
#line 62 "../lib/Drawing/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 62 "../lib/Drawing/Theme.vala"
	result = self->priv->_TopRoundness;
#line 62 "../lib/Drawing/Theme.vala"
	return result;
#line 2189 "Theme.c"
}

void
plank_theme_set_TopRoundness (PlankTheme* self,
                              gint value)
{
	gint old_value;
#line 62 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 62 "../lib/Drawing/Theme.vala"
	old_value = plank_theme_get_TopRoundness (self);
#line 62 "../lib/Drawing/Theme.vala"
	if (old_value != value) {
#line 62 "../lib/Drawing/Theme.vala"
		self->priv->_TopRoundness = value;
#line 62 "../lib/Drawing/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_theme_properties[PLANK_THEME_TOP_ROUNDNESS_PROPERTY]);
#line 2207 "Theme.c"
	}
}

gint
plank_theme_get_BottomRoundness (PlankTheme* self)
{
	gint result;
#line 65 "../lib/Drawing/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "../lib/Drawing/Theme.vala"
	result = self->priv->_BottomRoundness;
#line 65 "../lib/Drawing/Theme.vala"
	return result;
#line 2221 "Theme.c"
}

void
plank_theme_set_BottomRoundness (PlankTheme* self,
                                 gint value)
{
	gint old_value;
#line 65 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 65 "../lib/Drawing/Theme.vala"
	old_value = plank_theme_get_BottomRoundness (self);
#line 65 "../lib/Drawing/Theme.vala"
	if (old_value != value) {
#line 65 "../lib/Drawing/Theme.vala"
		self->priv->_BottomRoundness = value;
#line 65 "../lib/Drawing/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_theme_properties[PLANK_THEME_BOTTOM_ROUNDNESS_PROPERTY]);
#line 2239 "Theme.c"
	}
}

gint
plank_theme_get_LineWidth (PlankTheme* self)
{
	gint result;
#line 68 "../lib/Drawing/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 68 "../lib/Drawing/Theme.vala"
	result = self->priv->_LineWidth;
#line 68 "../lib/Drawing/Theme.vala"
	return result;
#line 2253 "Theme.c"
}

void
plank_theme_set_LineWidth (PlankTheme* self,
                           gint value)
{
	gint old_value;
#line 68 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 68 "../lib/Drawing/Theme.vala"
	old_value = plank_theme_get_LineWidth (self);
#line 68 "../lib/Drawing/Theme.vala"
	if (old_value != value) {
#line 68 "../lib/Drawing/Theme.vala"
		self->priv->_LineWidth = value;
#line 68 "../lib/Drawing/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_theme_properties[PLANK_THEME_LINE_WIDTH_PROPERTY]);
#line 2271 "Theme.c"
	}
}

void
plank_theme_get_OuterStrokeColor (PlankTheme* self,
                                  PlankColor * result)
{
	PlankColor _tmp0_;
#line 71 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 71 "../lib/Drawing/Theme.vala"
	_tmp0_ = self->priv->_OuterStrokeColor;
#line 71 "../lib/Drawing/Theme.vala"
	*result = _tmp0_;
#line 71 "../lib/Drawing/Theme.vala"
	return;
#line 2288 "Theme.c"
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
#line 71 "../lib/Drawing/Theme.vala"
	if (s1 == s2) {
#line 71 "../lib/Drawing/Theme.vala"
		return TRUE;
#line 2299 "Theme.c"
	}
#line 71 "../lib/Drawing/Theme.vala"
	if (s1 == NULL) {
#line 71 "../lib/Drawing/Theme.vala"
		return FALSE;
#line 2305 "Theme.c"
	}
#line 71 "../lib/Drawing/Theme.vala"
	if (s2 == NULL) {
#line 71 "../lib/Drawing/Theme.vala"
		return FALSE;
#line 2311 "Theme.c"
	}
#line 71 "../lib/Drawing/Theme.vala"
	if (s1->red != s2->red) {
#line 71 "../lib/Drawing/Theme.vala"
		return FALSE;
#line 2317 "Theme.c"
	}
#line 71 "../lib/Drawing/Theme.vala"
	if (s1->green != s2->green) {
#line 71 "../lib/Drawing/Theme.vala"
		return FALSE;
#line 2323 "Theme.c"
	}
#line 71 "../lib/Drawing/Theme.vala"
	if (s1->blue != s2->blue) {
#line 71 "../lib/Drawing/Theme.vala"
		return FALSE;
#line 2329 "Theme.c"
	}
#line 71 "../lib/Drawing/Theme.vala"
	if (s1->alpha != s2->alpha) {
#line 71 "../lib/Drawing/Theme.vala"
		return FALSE;
#line 2335 "Theme.c"
	}
#line 71 "../lib/Drawing/Theme.vala"
	return TRUE;
#line 2339 "Theme.c"
}

void
plank_theme_set_OuterStrokeColor (PlankTheme* self,
                                  PlankColor * value)
{
	PlankColor old_value;
#line 71 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 71 "../lib/Drawing/Theme.vala"
	plank_theme_get_OuterStrokeColor (self, &old_value);
#line 71 "../lib/Drawing/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 2353 "Theme.c"
		PlankColor _tmp0_;
#line 71 "../lib/Drawing/Theme.vala"
		_tmp0_ = *value;
#line 71 "../lib/Drawing/Theme.vala"
		self->priv->_OuterStrokeColor = _tmp0_;
#line 71 "../lib/Drawing/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_theme_properties[PLANK_THEME_OUTER_STROKE_COLOR_PROPERTY]);
#line 2361 "Theme.c"
	}
}

void
plank_theme_get_FillStartColor (PlankTheme* self,
                                PlankColor * result)
{
	PlankColor _tmp0_;
#line 74 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 74 "../lib/Drawing/Theme.vala"
	_tmp0_ = self->priv->_FillStartColor;
#line 74 "../lib/Drawing/Theme.vala"
	*result = _tmp0_;
#line 74 "../lib/Drawing/Theme.vala"
	return;
#line 2378 "Theme.c"
}

void
plank_theme_set_FillStartColor (PlankTheme* self,
                                PlankColor * value)
{
	PlankColor old_value;
#line 74 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 74 "../lib/Drawing/Theme.vala"
	plank_theme_get_FillStartColor (self, &old_value);
#line 74 "../lib/Drawing/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 2392 "Theme.c"
		PlankColor _tmp0_;
#line 74 "../lib/Drawing/Theme.vala"
		_tmp0_ = *value;
#line 74 "../lib/Drawing/Theme.vala"
		self->priv->_FillStartColor = _tmp0_;
#line 74 "../lib/Drawing/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_theme_properties[PLANK_THEME_FILL_START_COLOR_PROPERTY]);
#line 2400 "Theme.c"
	}
}

void
plank_theme_get_FillEndColor (PlankTheme* self,
                              PlankColor * result)
{
	PlankColor _tmp0_;
#line 77 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 77 "../lib/Drawing/Theme.vala"
	_tmp0_ = self->priv->_FillEndColor;
#line 77 "../lib/Drawing/Theme.vala"
	*result = _tmp0_;
#line 77 "../lib/Drawing/Theme.vala"
	return;
#line 2417 "Theme.c"
}

void
plank_theme_set_FillEndColor (PlankTheme* self,
                              PlankColor * value)
{
	PlankColor old_value;
#line 77 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 77 "../lib/Drawing/Theme.vala"
	plank_theme_get_FillEndColor (self, &old_value);
#line 77 "../lib/Drawing/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 2431 "Theme.c"
		PlankColor _tmp0_;
#line 77 "../lib/Drawing/Theme.vala"
		_tmp0_ = *value;
#line 77 "../lib/Drawing/Theme.vala"
		self->priv->_FillEndColor = _tmp0_;
#line 77 "../lib/Drawing/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_theme_properties[PLANK_THEME_FILL_END_COLOR_PROPERTY]);
#line 2439 "Theme.c"
	}
}

void
plank_theme_get_InnerStrokeColor (PlankTheme* self,
                                  PlankColor * result)
{
	PlankColor _tmp0_;
#line 80 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 80 "../lib/Drawing/Theme.vala"
	_tmp0_ = self->priv->_InnerStrokeColor;
#line 80 "../lib/Drawing/Theme.vala"
	*result = _tmp0_;
#line 80 "../lib/Drawing/Theme.vala"
	return;
#line 2456 "Theme.c"
}

void
plank_theme_set_InnerStrokeColor (PlankTheme* self,
                                  PlankColor * value)
{
	PlankColor old_value;
#line 80 "../lib/Drawing/Theme.vala"
	g_return_if_fail (self != NULL);
#line 80 "../lib/Drawing/Theme.vala"
	plank_theme_get_InnerStrokeColor (self, &old_value);
#line 80 "../lib/Drawing/Theme.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 2470 "Theme.c"
		PlankColor _tmp0_;
#line 80 "../lib/Drawing/Theme.vala"
		_tmp0_ = *value;
#line 80 "../lib/Drawing/Theme.vala"
		self->priv->_InnerStrokeColor = _tmp0_;
#line 80 "../lib/Drawing/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_theme_properties[PLANK_THEME_INNER_STROKE_COLOR_PROPERTY]);
#line 2478 "Theme.c"
	}
}

static void
_plank_theme_gtk_theme_name_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 102 "../lib/Drawing/Theme.vala"
	plank_theme_gtk_theme_name_changed ((PlankTheme*) self, _sender, pspec);
#line 2489 "Theme.c"
}

static GObject *
plank_theme_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankTheme * self;
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp0_;
	gchar* theme_name = NULL;
	GtkSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkSettings* _tmp5_;
#line 95 "../lib/Drawing/Theme.vala"
	parent_class = G_OBJECT_CLASS (plank_theme_parent_class);
#line 95 "../lib/Drawing/Theme.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 95 "../lib/Drawing/Theme.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_THEME, PlankTheme);
#line 97 "../lib/Drawing/Theme.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 97 "../lib/Drawing/Theme.vala"
	gtk_settings = _tmp0_;
#line 99 "../lib/Drawing/Theme.vala"
	_tmp1_ = gtk_settings;
#line 99 "../lib/Drawing/Theme.vala"
	g_object_get (_tmp1_, "gtk-theme-name", &_tmp2_, NULL);
#line 99 "../lib/Drawing/Theme.vala"
	_tmp3_ = _tmp2_;
#line 99 "../lib/Drawing/Theme.vala"
	theme_name = _tmp3_;
#line 100 "../lib/Drawing/Theme.vala"
	_tmp4_ = theme_name;
#line 100 "../lib/Drawing/Theme.vala"
	plank_theme_update_style_context (self, _tmp4_);
#line 102 "../lib/Drawing/Theme.vala"
	_tmp5_ = gtk_settings;
#line 102 "../lib/Drawing/Theme.vala"
	g_signal_connect_object ((GObject*) _tmp5_, "notify::gtk-theme-name", (GCallback) _plank_theme_gtk_theme_name_changed_g_object_notify, self, 0);
#line 95 "../lib/Drawing/Theme.vala"
	_g_free0 (theme_name);
#line 95 "../lib/Drawing/Theme.vala"
	return obj;
#line 2538 "Theme.c"
}

static void
plank_theme_class_init (PlankThemeClass * klass,
                        gpointer klass_data)
{
#line 25 "../lib/Drawing/Theme.vala"
	plank_theme_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Drawing/Theme.vala"
	g_type_class_adjust_private_offset (klass, &PlankTheme_private_offset);
#line 25 "../lib/Drawing/Theme.vala"
	((PlankPreferencesClass *) klass)->reset_properties = (void (*) (PlankPreferences*)) plank_theme_real_reset_properties;
#line 25 "../lib/Drawing/Theme.vala"
	((PlankPreferencesClass *) klass)->verify = (void (*) (PlankPreferences*, const gchar*)) plank_theme_real_verify;
#line 25 "../lib/Drawing/Theme.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_theme_get_property;
#line 25 "../lib/Drawing/Theme.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_theme_set_property;
#line 25 "../lib/Drawing/Theme.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_theme_constructor;
#line 25 "../lib/Drawing/Theme.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_theme_finalize;
#line 25 "../lib/Drawing/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_TOP_ROUNDNESS_PROPERTY, plank_theme_properties[PLANK_THEME_TOP_ROUNDNESS_PROPERTY] = g_param_spec_int ("TopRoundness", "top-roundness", "The roundness of the top corners.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_BOTTOM_ROUNDNESS_PROPERTY, plank_theme_properties[PLANK_THEME_BOTTOM_ROUNDNESS_PROPERTY] = g_param_spec_int ("BottomRoundness", "bottom-roundness", "The roundness of the bottom corners.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_LINE_WIDTH_PROPERTY, plank_theme_properties[PLANK_THEME_LINE_WIDTH_PROPERTY] = g_param_spec_int ("LineWidth", "line-width", "The thickness (in pixels) of lines drawn.", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_OUTER_STROKE_COLOR_PROPERTY, plank_theme_properties[PLANK_THEME_OUTER_STROKE_COLOR_PROPERTY] = g_param_spec_boxed ("OuterStrokeColor", "outer-stroke-color", "The color (RGBA) of the outer stroke.", PLANK_TYPE_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_FILL_START_COLOR_PROPERTY, plank_theme_properties[PLANK_THEME_FILL_START_COLOR_PROPERTY] = g_param_spec_boxed ("FillStartColor", "fill-start-color", "The starting color (RGBA) of the fill gradient.", PLANK_TYPE_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_FILL_END_COLOR_PROPERTY, plank_theme_properties[PLANK_THEME_FILL_END_COLOR_PROPERTY] = g_param_spec_boxed ("FillEndColor", "fill-end-color", "The ending color (RGBA) of the fill gradient.", PLANK_TYPE_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../lib/Drawing/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_THEME_INNER_STROKE_COLOR_PROPERTY, plank_theme_properties[PLANK_THEME_INNER_STROKE_COLOR_PROPERTY] = g_param_spec_boxed ("InnerStrokeColor", "inner-stroke-color", "The color (RGBA) of the inner stroke.", PLANK_TYPE_COLOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2575 "Theme.c"
}

static void
plank_theme_instance_init (PlankTheme * self,
                           gpointer klass)
{
#line 25 "../lib/Drawing/Theme.vala"
	self->priv = plank_theme_get_instance_private (self);
#line 2584 "Theme.c"
}

static void
plank_theme_finalize (GObject * obj)
{
	PlankTheme * self;
#line 25 "../lib/Drawing/Theme.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_THEME, PlankTheme);
#line 82 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (self->priv->theme_folder);
#line 83 "../lib/Drawing/Theme.vala"
	_g_object_unref0 (self->priv->style_context);
#line 25 "../lib/Drawing/Theme.vala"
	G_OBJECT_CLASS (plank_theme_parent_class)->finalize (obj);
#line 2599 "Theme.c"
}

/**
 * A themed renderer for windows.
 */
static GType
plank_theme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankTheme), 0, (GInstanceInitFunc) plank_theme_instance_init, NULL };
	GType plank_theme_type_id;
	plank_theme_type_id = g_type_register_static (PLANK_TYPE_PREFERENCES, "PlankTheme", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	PlankTheme_private_offset = g_type_add_instance_private (plank_theme_type_id, sizeof (PlankThemePrivate));
	return plank_theme_type_id;
}

GType
plank_theme_get_type (void)
{
	static volatile gsize plank_theme_type_id__once = 0;
	if (g_once_init_enter (&plank_theme_type_id__once)) {
		GType plank_theme_type_id;
		plank_theme_type_id = plank_theme_get_type_once ();
		g_once_init_leave (&plank_theme_type_id__once, plank_theme_type_id);
	}
	return plank_theme_type_id__once;
}

static void
_vala_plank_theme_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	PlankTheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_THEME, PlankTheme);
#line 25 "../lib/Drawing/Theme.vala"
	switch (property_id) {
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_TOP_ROUNDNESS_PROPERTY:
#line 25 "../lib/Drawing/Theme.vala"
		g_value_set_int (value, plank_theme_get_TopRoundness (self));
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_BOTTOM_ROUNDNESS_PROPERTY:
#line 25 "../lib/Drawing/Theme.vala"
		g_value_set_int (value, plank_theme_get_BottomRoundness (self));
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_LINE_WIDTH_PROPERTY:
#line 25 "../lib/Drawing/Theme.vala"
		g_value_set_int (value, plank_theme_get_LineWidth (self));
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_OUTER_STROKE_COLOR_PROPERTY:
#line 2657 "Theme.c"
		{
			PlankColor boxed;
#line 25 "../lib/Drawing/Theme.vala"
			plank_theme_get_OuterStrokeColor (self, &boxed);
#line 25 "../lib/Drawing/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 2664 "Theme.c"
		}
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_FILL_START_COLOR_PROPERTY:
#line 2670 "Theme.c"
		{
			PlankColor boxed;
#line 25 "../lib/Drawing/Theme.vala"
			plank_theme_get_FillStartColor (self, &boxed);
#line 25 "../lib/Drawing/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 2677 "Theme.c"
		}
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_FILL_END_COLOR_PROPERTY:
#line 2683 "Theme.c"
		{
			PlankColor boxed;
#line 25 "../lib/Drawing/Theme.vala"
			plank_theme_get_FillEndColor (self, &boxed);
#line 25 "../lib/Drawing/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 2690 "Theme.c"
		}
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_INNER_STROKE_COLOR_PROPERTY:
#line 2696 "Theme.c"
		{
			PlankColor boxed;
#line 25 "../lib/Drawing/Theme.vala"
			plank_theme_get_InnerStrokeColor (self, &boxed);
#line 25 "../lib/Drawing/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 2703 "Theme.c"
		}
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 2707 "Theme.c"
		default:
#line 25 "../lib/Drawing/Theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 2713 "Theme.c"
	}
}

static void
_vala_plank_theme_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	PlankTheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_THEME, PlankTheme);
#line 25 "../lib/Drawing/Theme.vala"
	switch (property_id) {
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_TOP_ROUNDNESS_PROPERTY:
#line 25 "../lib/Drawing/Theme.vala"
		plank_theme_set_TopRoundness (self, g_value_get_int (value));
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_BOTTOM_ROUNDNESS_PROPERTY:
#line 25 "../lib/Drawing/Theme.vala"
		plank_theme_set_BottomRoundness (self, g_value_get_int (value));
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_LINE_WIDTH_PROPERTY:
#line 25 "../lib/Drawing/Theme.vala"
		plank_theme_set_LineWidth (self, g_value_get_int (value));
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_OUTER_STROKE_COLOR_PROPERTY:
#line 25 "../lib/Drawing/Theme.vala"
		plank_theme_set_OuterStrokeColor (self, g_value_get_boxed (value));
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_FILL_START_COLOR_PROPERTY:
#line 25 "../lib/Drawing/Theme.vala"
		plank_theme_set_FillStartColor (self, g_value_get_boxed (value));
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_FILL_END_COLOR_PROPERTY:
#line 25 "../lib/Drawing/Theme.vala"
		plank_theme_set_FillEndColor (self, g_value_get_boxed (value));
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 25 "../lib/Drawing/Theme.vala"
		case PLANK_THEME_INNER_STROKE_COLOR_PROPERTY:
#line 25 "../lib/Drawing/Theme.vala"
		plank_theme_set_InnerStrokeColor (self, g_value_get_boxed (value));
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 2769 "Theme.c"
		default:
#line 25 "../lib/Drawing/Theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Drawing/Theme.vala"
		break;
#line 2775 "Theme.c"
	}
}

