/* ApplicationDockItemProvider.c generated by valac 0.56.18, the Vala compiler
 * generated from ApplicationDockItemProvider.vala, do not modify */

/**/
/*  Copyright (C) 2011-2013 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <gio/gio.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libbamf/libbamf.h>
#include "plank-internal.h"
#include <libwnck/libwnck.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_APPLICATION_DOCK_ITEM_PROVIDER_0_PROPERTY,
	PLANK_APPLICATION_DOCK_ITEM_PROVIDER_LAUNCHERS_DIR_PROPERTY,
	PLANK_APPLICATION_DOCK_ITEM_PROVIDER_NUM_PROPERTIES
};
static GParamSpec* plank_application_dock_item_provider_properties[PLANK_APPLICATION_DOCK_ITEM_PROVIDER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
enum  {
	PLANK_APPLICATION_DOCK_ITEM_PROVIDER_ITEM_WINDOW_ADDED_SIGNAL,
	PLANK_APPLICATION_DOCK_ITEM_PROVIDER_NUM_SIGNALS
};
static guint plank_application_dock_item_provider_signals[PLANK_APPLICATION_DOCK_ITEM_PROVIDER_NUM_SIGNALS] = {0};

struct _PlankApplicationDockItemProviderPrivate {
	GFile* _LaunchersDir;
	GFileMonitor* items_monitor;
	gboolean delay_items_monitor_handle;
	GeeArrayList* queued_files;
};

struct _Block10Data {
	int _ref_count_;
	PlankApplicationDockItemProvider* self;
	gchar* sender_name;
	GVariant* parameters;
};

static gint PlankApplicationDockItemProvider_private_offset;
static gpointer plank_application_dock_item_provider_parent_class = NULL;
static PlankUnityClientIface * plank_application_dock_item_provider_plank_unity_client_parent_iface = NULL;

static void _plank_application_dock_item_provider_app_opened_plank_matcher_application_opened (PlankMatcher* _sender,
                                                                                        BamfApplication* app,
                                                                                        gpointer self);
static void plank_application_dock_item_provider_handle_items_dir_changed (GFile* f,
                                                                    GFile* other,
                                                                    GFileMonitorEvent event,
                                                                    PlankApplicationDockItemProvider* self);
static void _plank_application_dock_item_provider_handle_items_dir_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                                            GFile* file,
                                                                                            GFile* other_file,
                                                                                            GFileMonitorEvent event_type,
                                                                                            gpointer self);
 G_GNUC_INTERNAL BamfApplication* plank_application_dock_item_get_App (PlankApplicationDockItem* self);
static GFile* plank_application_dock_item_provider_desktop_file_for_application_uri (const gchar* app_uri);
static gboolean plank_application_dock_item_provider_real_add_item_with_uri (PlankDockItemProvider* base,
                                                                      const gchar* uri,
                                                                      PlankDockItem* target);
static void plank_application_dock_item_provider_real_prepare (PlankDockContainer* base);
 G_GNUC_INTERNAL void plank_application_dock_item_set_App (PlankApplicationDockItem* self,
                                          BamfApplication* value);
static gchar** plank_application_dock_item_provider_real_get_dockitem_filenames (PlankDockItemProvider* base,
                                                                          gint* result_length1);
static void plank_application_dock_item_provider_real_app_opened (PlankApplicationDockItemProvider* self,
                                                           BamfApplication* app);
static void plank_application_dock_item_provider_process_queued_files (PlankApplicationDockItemProvider* self);
static void plank_application_dock_item_provider_real_connect_element (PlankDockContainer* base,
                                                                PlankDockElement* element);
static void plank_application_dock_item_provider_handle_item_app_window_added (PlankApplicationDockItemProvider* self,
                                                                        PlankApplicationDockItem* item);
static void _plank_application_dock_item_provider_handle_item_app_window_added_plank_application_dock_item_app_window_added (PlankApplicationDockItem* _sender,
                                                                                                                      gpointer self);
static void plank_application_dock_item_provider_real_disconnect_element (PlankDockContainer* base,
                                                                   PlankDockElement* element);
static void plank_application_dock_item_provider_real_remove_launcher_entry (PlankUnityClient* base,
                                                                      const gchar* sender_name);
static void plank_application_dock_item_provider_real_update_launcher_entry (PlankUnityClient* base,
                                                                      const gchar* sender_name,
                                                                      GVariant* parameters,
                                                                      gboolean is_retry);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gboolean ___lambda39_ (Block10Data* _data10_);
static gboolean ____lambda39__gsource_func (gpointer self);
static GObject * plank_application_dock_item_provider_constructor (GType type,
                                                            guint n_construct_properties,
                                                            GObjectConstructParam * construct_properties);
static void plank_application_dock_item_provider_finalize (GObject * obj);
static GType plank_application_dock_item_provider_get_type_once (void);
static void _vala_plank_application_dock_item_provider_get_property (GObject * object,
                                                              guint property_id,
                                                              GValue * value,
                                                              GParamSpec * pspec);
static void _vala_plank_application_dock_item_provider_set_property (GObject * object,
                                                              guint property_id,
                                                              const GValue * value,
                                                              GParamSpec * pspec);

static inline gpointer
plank_application_dock_item_provider_get_instance_private (PlankApplicationDockItemProvider* self)
{
	return G_STRUCT_MEMBER_P (self, PlankApplicationDockItemProvider_private_offset);
}

static void
_plank_application_dock_item_provider_app_opened_plank_matcher_application_opened (PlankMatcher* _sender,
                                                                                   BamfApplication* app,
                                                                                   gpointer self)
{
#line 66 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_application_dock_item_provider_app_opened ((PlankApplicationDockItemProvider*) self, app);
#line 151 "ApplicationDockItemProvider.c"
}

static void
_plank_application_dock_item_provider_handle_items_dir_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                                       GFile* file,
                                                                                       GFile* other_file,
                                                                                       GFileMonitorEvent event_type,
                                                                                       gpointer self)
{
#line 69 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_application_dock_item_provider_handle_items_dir_changed (file, other_file, event_type, (PlankApplicationDockItemProvider*) self);
#line 163 "ApplicationDockItemProvider.c"
}

/**
 * Creates a new container for dock items.
 *
 * @param launchers_dir the directory where to load/save .dockitems files from/to
 */
PlankApplicationDockItemProvider*
plank_application_dock_item_provider_construct (GType object_type,
                                                GFile* launchers_dir)
{
	PlankApplicationDockItemProvider * self = NULL;
#line 40 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_val_if_fail (launchers_dir != NULL, NULL);
#line 42 "../lib/Items/ApplicationDockItemProvider.vala"
	self = (PlankApplicationDockItemProvider*) g_object_new (object_type, "LaunchersDir", launchers_dir, NULL);
#line 40 "../lib/Items/ApplicationDockItemProvider.vala"
	return self;
#line 182 "ApplicationDockItemProvider.c"
}

PlankApplicationDockItemProvider*
plank_application_dock_item_provider_new (GFile* launchers_dir)
{
#line 40 "../lib/Items/ApplicationDockItemProvider.vala"
	return plank_application_dock_item_provider_construct (PLANK_TYPE_APPLICATION_DOCK_ITEM_PROVIDER, launchers_dir);
#line 190 "ApplicationDockItemProvider.c"
}

PlankApplicationDockItem*
plank_application_dock_item_provider_item_for_application (PlankApplicationDockItemProvider* self,
                                                           BamfApplication* app)
{
	gchar* app_desktop_file = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	PlankApplicationDockItem* result;
#line 75 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 77 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp0_ = bamf_application_get_desktop_file (app);
#line 77 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 77 "../lib/Items/ApplicationDockItemProvider.vala"
	app_desktop_file = _tmp1_;
#line 78 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp3_ = app_desktop_file;
#line 78 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp3_ != NULL) {
#line 218 "ApplicationDockItemProvider.c"
		const gchar* _tmp4_;
#line 78 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp4_ = app_desktop_file;
#line 78 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp2_ = g_str_has_prefix (_tmp4_, "/");
#line 224 "ApplicationDockItemProvider.c"
	} else {
#line 78 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp2_ = FALSE;
#line 228 "ApplicationDockItemProvider.c"
	}
#line 78 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp2_) {
#line 232 "ApplicationDockItemProvider.c"
		{
			gchar* _tmp5_ = NULL;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp6_ = app_desktop_file;
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp7_ = g_filename_to_uri (_tmp6_, NULL, &_inner_error0_);
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp5_ = _tmp7_;
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
				if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 248 "ApplicationDockItemProvider.c"
					goto __catch0_g_convert_error;
				}
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_free0 (app_desktop_file);
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
				g_clear_error (&_inner_error0_);
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
				return NULL;
#line 259 "ApplicationDockItemProvider.c"
			}
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp8_ = _tmp5_;
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp5_ = NULL;
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_free0 (app_desktop_file);
#line 80 "../lib/Items/ApplicationDockItemProvider.vala"
			app_desktop_file = _tmp8_;
#line 79 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_free0 (_tmp5_);
#line 271 "ApplicationDockItemProvider.c"
		}
		goto __finally0;
		__catch0_g_convert_error:
		{
			GError* e = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 79 "../lib/Items/ApplicationDockItemProvider.vala"
			e = _inner_error0_;
#line 79 "../lib/Items/ApplicationDockItemProvider.vala"
			_inner_error0_ = NULL;
#line 82 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp9_ = e;
#line 82 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp10_ = _tmp9_->message;
#line 82 "../lib/Items/ApplicationDockItemProvider.vala"
			g_warning ("ApplicationDockItemProvider.vala:82: %s", _tmp10_);
#line 79 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_error_free0 (e);
#line 291 "ApplicationDockItemProvider.c"
		}
		__finally0:
#line 79 "../lib/Items/ApplicationDockItemProvider.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_free0 (app_desktop_file);
#line 79 "../lib/Items/ApplicationDockItemProvider.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 79 "../lib/Items/ApplicationDockItemProvider.vala"
			g_clear_error (&_inner_error0_);
#line 79 "../lib/Items/ApplicationDockItemProvider.vala"
			return NULL;
#line 304 "ApplicationDockItemProvider.c"
		}
	}
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp11_;
		gint _item_size = 0;
		GeeArrayList* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _item_index = 0;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp11_ = ((PlankDockContainer*) self)->internal_elements;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
		_item_list = _tmp11_;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp12_ = _item_list;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp14_ = _tmp13_;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
		_item_size = _tmp14_;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
		_item_index = -1;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
		while (TRUE) {
#line 331 "ApplicationDockItemProvider.c"
			gint _tmp15_;
			gint _tmp16_;
			PlankDockElement* item = NULL;
			GeeArrayList* _tmp17_;
			gpointer _tmp18_;
			PlankApplicationDockItem* appitem = NULL;
			PlankDockElement* _tmp19_;
			PlankApplicationDockItem* _tmp20_;
			BamfApplication* item_app = NULL;
			PlankApplicationDockItem* _tmp21_;
			BamfApplication* _tmp22_;
			BamfApplication* _tmp23_;
			gboolean _tmp24_ = FALSE;
			BamfApplication* _tmp25_;
			const gchar* launcher = NULL;
			PlankApplicationDockItem* _tmp28_;
			const gchar* _tmp29_;
			const gchar* _tmp30_;
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_ = FALSE;
			const gchar* _tmp33_;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
			_item_index = _item_index + 1;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp15_ = _item_index;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp16_ = _item_size;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
			if (!(_tmp15_ < _tmp16_)) {
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
				break;
#line 363 "ApplicationDockItemProvider.c"
			}
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp17_ = _item_list;
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _item_index);
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
			item = (PlankDockElement*) _tmp18_;
#line 86 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp19_ = item;
#line 86 "../lib/Items/ApplicationDockItemProvider.vala"
			appitem = PLANK_IS_APPLICATION_DOCK_ITEM (_tmp19_) ? ((PlankApplicationDockItem*) _tmp19_) : NULL;
#line 87 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp20_ = appitem;
#line 87 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp20_ == NULL) {
#line 88 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (item);
#line 88 "../lib/Items/ApplicationDockItemProvider.vala"
				continue;
#line 383 "ApplicationDockItemProvider.c"
			}
#line 90 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp21_ = appitem;
#line 90 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp22_ = plank_application_dock_item_get_App (_tmp21_);
#line 90 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp23_ = _tmp22_;
#line 90 "../lib/Items/ApplicationDockItemProvider.vala"
			item_app = _tmp23_;
#line 91 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp25_ = item_app;
#line 91 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp25_ != NULL) {
#line 397 "ApplicationDockItemProvider.c"
				BamfApplication* _tmp26_;
#line 91 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp26_ = item_app;
#line 91 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp24_ = _tmp26_ == app;
#line 403 "ApplicationDockItemProvider.c"
			} else {
#line 91 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp24_ = FALSE;
#line 407 "ApplicationDockItemProvider.c"
			}
#line 91 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp24_) {
#line 411 "ApplicationDockItemProvider.c"
				PlankApplicationDockItem* _tmp27_;
#line 92 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp27_ = appitem;
#line 92 "../lib/Items/ApplicationDockItemProvider.vala"
				result = _tmp27_;
#line 92 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (item);
#line 92 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_free0 (app_desktop_file);
#line 92 "../lib/Items/ApplicationDockItemProvider.vala"
				return result;
#line 423 "ApplicationDockItemProvider.c"
			}
#line 94 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp28_ = appitem;
#line 94 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp29_ = plank_dock_item_get_Launcher ((PlankDockItem*) _tmp28_);
#line 94 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp30_ = _tmp29_;
#line 94 "../lib/Items/ApplicationDockItemProvider.vala"
			launcher = _tmp30_;
#line 95 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp33_ = launcher;
#line 95 "../lib/Items/ApplicationDockItemProvider.vala"
			if (g_strcmp0 (_tmp33_, "") != 0) {
#line 437 "ApplicationDockItemProvider.c"
				const gchar* _tmp34_;
#line 95 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp34_ = app_desktop_file;
#line 95 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp32_ = _tmp34_ != NULL;
#line 443 "ApplicationDockItemProvider.c"
			} else {
#line 95 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp32_ = FALSE;
#line 447 "ApplicationDockItemProvider.c"
			}
#line 95 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp32_) {
#line 451 "ApplicationDockItemProvider.c"
				const gchar* _tmp35_;
				const gchar* _tmp36_;
#line 95 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp35_ = launcher;
#line 95 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp36_ = app_desktop_file;
#line 95 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp31_ = g_strcmp0 (_tmp35_, _tmp36_) == 0;
#line 460 "ApplicationDockItemProvider.c"
			} else {
#line 95 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp31_ = FALSE;
#line 464 "ApplicationDockItemProvider.c"
			}
#line 95 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp31_) {
#line 468 "ApplicationDockItemProvider.c"
				PlankApplicationDockItem* _tmp37_;
#line 96 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp37_ = appitem;
#line 96 "../lib/Items/ApplicationDockItemProvider.vala"
				result = _tmp37_;
#line 96 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (item);
#line 96 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_free0 (app_desktop_file);
#line 96 "../lib/Items/ApplicationDockItemProvider.vala"
				return result;
#line 480 "ApplicationDockItemProvider.c"
			}
#line 85 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_object_unref0 (item);
#line 484 "ApplicationDockItemProvider.c"
		}
	}
#line 99 "../lib/Items/ApplicationDockItemProvider.vala"
	result = NULL;
#line 99 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_free0 (app_desktop_file);
#line 99 "../lib/Items/ApplicationDockItemProvider.vala"
	return result;
#line 493 "ApplicationDockItemProvider.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 515 "ApplicationDockItemProvider.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 519 "ApplicationDockItemProvider.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 525 "ApplicationDockItemProvider.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 529 "ApplicationDockItemProvider.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 533 "ApplicationDockItemProvider.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 541 "ApplicationDockItemProvider.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 569 "ApplicationDockItemProvider.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 578 "ApplicationDockItemProvider.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 592 "ApplicationDockItemProvider.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 601 "ApplicationDockItemProvider.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 615 "ApplicationDockItemProvider.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 624 "ApplicationDockItemProvider.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 633 "ApplicationDockItemProvider.c"
}

static GFile*
plank_application_dock_item_provider_desktop_file_for_application_uri (const gchar* app_uri)
{
	GFile* result;
#line 102 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_val_if_fail (app_uri != NULL, NULL);
#line 642 "ApplicationDockItemProvider.c"
	{
		GeeArrayList* _folder_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _folder_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _folder_index = 0;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp0_ = plank_paths_get_DataDirFolders ();
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp1_ = _tmp0_;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
		_folder_list = _tmp1_;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp2_ = _folder_list;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp4_ = _tmp3_;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
		_folder_size = _tmp4_;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
		_folder_index = -1;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
		while (TRUE) {
#line 670 "ApplicationDockItemProvider.c"
			gint _tmp5_;
			gint _tmp6_;
			GFile* folder = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			GFile* applications_folder = NULL;
			GFile* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			GFile* desktop_file = NULL;
			GFile* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			GFile* _tmp15_;
			GFile* _tmp16_;
			GFile* _tmp17_;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
			_folder_index = _folder_index + 1;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp5_ = _folder_index;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp6_ = _folder_size;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
				break;
#line 697 "ApplicationDockItemProvider.c"
			}
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp7_ = _folder_list;
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _folder_index);
#line 104 "../lib/Items/ApplicationDockItemProvider.vala"
			folder = (GFile*) _tmp8_;
#line 105 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp9_ = folder;
#line 105 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp10_ = g_file_get_child (_tmp9_, "applications");
#line 105 "../lib/Items/ApplicationDockItemProvider.vala"
			applications_folder = _tmp10_;
#line 106 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp11_ = applications_folder;
#line 106 "../lib/Items/ApplicationDockItemProvider.vala"
			if (!g_file_query_exists (_tmp11_, NULL)) {
#line 107 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (applications_folder);
#line 107 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (folder);
#line 107 "../lib/Items/ApplicationDockItemProvider.vala"
				continue;
#line 721 "ApplicationDockItemProvider.c"
			}
#line 109 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp12_ = applications_folder;
#line 109 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp13_ = string_replace (app_uri, "application://", "");
#line 109 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp14_ = _tmp13_;
#line 109 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp15_ = g_file_get_child (_tmp12_, _tmp14_);
#line 109 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp16_ = _tmp15_;
#line 109 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_free0 (_tmp14_);
#line 109 "../lib/Items/ApplicationDockItemProvider.vala"
			desktop_file = _tmp16_;
#line 110 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp17_ = desktop_file;
#line 110 "../lib/Items/ApplicationDockItemProvider.vala"
			if (!g_file_query_exists (_tmp17_, NULL)) {
#line 111 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (desktop_file);
#line 111 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (applications_folder);
#line 111 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (folder);
#line 111 "../lib/Items/ApplicationDockItemProvider.vala"
				continue;
#line 749 "ApplicationDockItemProvider.c"
			}
#line 113 "../lib/Items/ApplicationDockItemProvider.vala"
			result = desktop_file;
#line 113 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_object_unref0 (applications_folder);
#line 113 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_object_unref0 (folder);
#line 113 "../lib/Items/ApplicationDockItemProvider.vala"
			return result;
#line 759 "ApplicationDockItemProvider.c"
		}
	}
#line 116 "../lib/Items/ApplicationDockItemProvider.vala"
	g_debug ("ApplicationDockItemProvider.vala:116: Matching application for '%s' no" \
"t found or not installed!", app_uri);
#line 118 "../lib/Items/ApplicationDockItemProvider.vala"
	result = NULL;
#line 118 "../lib/Items/ApplicationDockItemProvider.vala"
	return result;
#line 768 "ApplicationDockItemProvider.c"
}

/**
 * {@inheritDoc}
 */
static gboolean
plank_application_dock_item_provider_real_add_item_with_uri (PlankDockItemProvider* base,
                                                             const gchar* uri,
                                                             PlankDockItem* target)
{
	PlankApplicationDockItemProvider * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GFile* dockitem_file = NULL;
	PlankItemFactory* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	PlankDockElement* element = NULL;
	PlankItemFactory* _tmp11_;
	GFile* _tmp12_;
	PlankDockElement* _tmp13_;
	PlankDockItem* item = NULL;
	PlankDockElement* _tmp14_;
	PlankDockItem* _tmp15_;
	PlankDockItem* _tmp16_;
	gboolean result;
#line 124 "../lib/Items/ApplicationDockItemProvider.vala"
	self = (PlankApplicationDockItemProvider*) base;
#line 124 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 126 "../lib/Items/ApplicationDockItemProvider.vala"
	if (uri == NULL) {
#line 126 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp0_ = TRUE;
#line 805 "ApplicationDockItemProvider.c"
	} else {
#line 126 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp0_ = g_strcmp0 (uri, "") == 0;
#line 809 "ApplicationDockItemProvider.c"
	}
#line 126 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp0_) {
#line 127 "../lib/Items/ApplicationDockItemProvider.vala"
		result = FALSE;
#line 127 "../lib/Items/ApplicationDockItemProvider.vala"
		return result;
#line 817 "ApplicationDockItemProvider.c"
	}
#line 129 "../lib/Items/ApplicationDockItemProvider.vala"
	if (target != NULL) {
#line 821 "ApplicationDockItemProvider.c"
		PlankPlaceholderDockItem* _tmp3_;
#line 129 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp3_ = plank_dock_container_placeholder_item;
#line 129 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp2_ = target != G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, PLANK_TYPE_DOCK_ITEM, PlankDockItem);
#line 827 "ApplicationDockItemProvider.c"
	} else {
#line 129 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp2_ = FALSE;
#line 831 "ApplicationDockItemProvider.c"
	}
#line 129 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp2_) {
#line 835 "ApplicationDockItemProvider.c"
		GeeArrayList* _tmp4_;
#line 129 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp4_ = ((PlankDockContainer*) self)->internal_elements;
#line 129 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp1_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp4_, (PlankDockElement*) target);
#line 841 "ApplicationDockItemProvider.c"
	} else {
#line 129 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp1_ = FALSE;
#line 845 "ApplicationDockItemProvider.c"
	}
#line 129 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp1_) {
#line 849 "ApplicationDockItemProvider.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 130 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp5_ = plank_dock_element_get_Text ((PlankDockElement*) target);
#line 130 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp6_ = _tmp5_;
#line 130 "../lib/Items/ApplicationDockItemProvider.vala"
		g_critical ("ApplicationDockItemProvider.vala:130: Item '%s' does not exist in this" \
" DockItemProvider.", _tmp6_);
#line 131 "../lib/Items/ApplicationDockItemProvider.vala"
		result = FALSE;
#line 131 "../lib/Items/ApplicationDockItemProvider.vala"
		return result;
#line 862 "ApplicationDockItemProvider.c"
	}
#line 134 "../lib/Items/ApplicationDockItemProvider.vala"
	if (plank_dock_item_provider_item_exists_for_uri ((PlankDockItemProvider*) self, uri)) {
#line 135 "../lib/Items/ApplicationDockItemProvider.vala"
		g_warning ("ApplicationDockItemProvider.vala:135: Item for '%s' already exists in " \
"this DockItemProvider.", uri);
#line 136 "../lib/Items/ApplicationDockItemProvider.vala"
		result = FALSE;
#line 136 "../lib/Items/ApplicationDockItemProvider.vala"
		return result;
#line 872 "ApplicationDockItemProvider.c"
	}
#line 140 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_application_dock_item_provider_delay_items_monitor (self);
#line 142 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp7_ = plank_factory_item_factory;
#line 142 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp8_ = self->priv->_LaunchersDir;
#line 142 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp9_ = plank_item_factory_make_dock_item (_tmp7_, uri, _tmp8_);
#line 142 "../lib/Items/ApplicationDockItemProvider.vala"
	dockitem_file = _tmp9_;
#line 143 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp10_ = dockitem_file;
#line 143 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp10_ == NULL) {
#line 144 "../lib/Items/ApplicationDockItemProvider.vala"
		plank_application_dock_item_provider_resume_items_monitor (self);
#line 145 "../lib/Items/ApplicationDockItemProvider.vala"
		result = FALSE;
#line 145 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (dockitem_file);
#line 145 "../lib/Items/ApplicationDockItemProvider.vala"
		return result;
#line 896 "ApplicationDockItemProvider.c"
	}
#line 148 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp11_ = plank_factory_item_factory;
#line 148 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp12_ = dockitem_file;
#line 148 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp13_ = plank_item_factory_make_element (_tmp11_, _tmp12_);
#line 148 "../lib/Items/ApplicationDockItemProvider.vala"
	element = _tmp13_;
#line 149 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp14_ = element;
#line 149 "../lib/Items/ApplicationDockItemProvider.vala"
	item = PLANK_IS_DOCK_ITEM (_tmp14_) ? ((PlankDockItem*) _tmp14_) : NULL;
#line 150 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp15_ = item;
#line 150 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp15_ == NULL) {
#line 151 "../lib/Items/ApplicationDockItemProvider.vala"
		plank_application_dock_item_provider_resume_items_monitor (self);
#line 152 "../lib/Items/ApplicationDockItemProvider.vala"
		result = FALSE;
#line 152 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (element);
#line 152 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (dockitem_file);
#line 152 "../lib/Items/ApplicationDockItemProvider.vala"
		return result;
#line 924 "ApplicationDockItemProvider.c"
	}
#line 155 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp16_ = item;
#line 155 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_dock_container_add ((PlankDockContainer*) self, (PlankDockElement*) _tmp16_, (PlankDockElement*) target);
#line 157 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_application_dock_item_provider_resume_items_monitor (self);
#line 159 "../lib/Items/ApplicationDockItemProvider.vala"
	result = TRUE;
#line 159 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (element);
#line 159 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (dockitem_file);
#line 159 "../lib/Items/ApplicationDockItemProvider.vala"
	return result;
#line 940 "ApplicationDockItemProvider.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_application_dock_item_provider_real_prepare (PlankDockContainer* base)
{
	PlankApplicationDockItemProvider * self;
#line 165 "../lib/Items/ApplicationDockItemProvider.vala"
	self = (PlankApplicationDockItemProvider*) base;
#line 952 "ApplicationDockItemProvider.c"
	{
		GeeArrayList* _app_list = NULL;
		PlankMatcher* _tmp0_;
		PlankMatcher* _tmp1_;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
		gint _app_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _app_index = 0;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp0_ = plank_matcher_get_default ();
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp1_ = _tmp0_;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp2_ = plank_matcher_active_launchers (_tmp1_);
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp3_ = _tmp2_;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (_tmp1_);
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_app_list = _tmp3_;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp4_ = _app_list;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp6_ = _tmp5_;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_app_size = _tmp6_;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_app_index = -1;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		while (TRUE) {
#line 988 "ApplicationDockItemProvider.c"
			gint _tmp7_;
			gint _tmp8_;
			BamfApplication* app = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			PlankApplicationDockItem* found = NULL;
			BamfApplication* _tmp11_;
			PlankApplicationDockItem* _tmp12_;
			PlankApplicationDockItem* _tmp13_;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
			_app_index = _app_index + 1;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp7_ = _app_index;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp8_ = _app_size;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
				break;
#line 1008 "ApplicationDockItemProvider.c"
			}
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp9_ = _app_list;
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _app_index);
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
			app = (BamfApplication*) _tmp10_;
#line 169 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp11_ = app;
#line 169 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp12_ = plank_application_dock_item_provider_item_for_application (self, _tmp11_);
#line 169 "../lib/Items/ApplicationDockItemProvider.vala"
			found = _tmp12_;
#line 170 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp13_ = found;
#line 170 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp13_ != NULL) {
#line 1026 "ApplicationDockItemProvider.c"
				PlankApplicationDockItem* _tmp14_;
				BamfApplication* _tmp15_;
#line 171 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp14_ = found;
#line 171 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp15_ = app;
#line 171 "../lib/Items/ApplicationDockItemProvider.vala"
				plank_application_dock_item_set_App (_tmp14_, _tmp15_);
#line 1035 "ApplicationDockItemProvider.c"
			}
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_object_unref0 (app);
#line 1039 "ApplicationDockItemProvider.c"
		}
#line 168 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (_app_list);
#line 1043 "ApplicationDockItemProvider.c"
	}
}

/**
 * {@inheritDoc}
 */
static gchar**
plank_application_dock_item_provider_real_get_dockitem_filenames (PlankDockItemProvider* base,
                                                                  gint* result_length1)
{
	PlankApplicationDockItemProvider * self;
	GeeArrayList* item_list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp22_;
	gint _tmp23_ = 0;
	gpointer* _tmp24_;
	gchar** _tmp25_;
	gint _tmp25__length1;
	gchar** result;
#line 178 "../lib/Items/ApplicationDockItemProvider.vala"
	self = (PlankApplicationDockItemProvider*) base;
#line 180 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 180 "../lib/Items/ApplicationDockItemProvider.vala"
	item_list = _tmp0_;
#line 1069 "ApplicationDockItemProvider.c"
	{
		GeeArrayList* _element_list = NULL;
		GeeArrayList* _tmp1_;
		gint _element_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _element_index = 0;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp1_ = ((PlankDockContainer*) self)->internal_elements;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
		_element_list = _tmp1_;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp2_ = _element_list;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp4_ = _tmp3_;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
		_element_size = _tmp4_;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
		_element_index = -1;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
		while (TRUE) {
#line 1094 "ApplicationDockItemProvider.c"
			gint _tmp5_;
			gint _tmp6_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			PlankDockItem* item = NULL;
			PlankDockElement* _tmp9_;
			gboolean _tmp10_ = FALSE;
			PlankDockItem* _tmp11_;
			gchar* dock_item_filename = NULL;
			PlankDockItem* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			const gchar* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
			_element_index = _element_index + 1;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp5_ = _element_index;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp6_ = _element_size;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
				break;
#line 1121 "ApplicationDockItemProvider.c"
			}
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp7_ = _element_list;
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _element_index);
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
			element = (PlankDockElement*) _tmp8_;
#line 183 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp9_ = element;
#line 183 "../lib/Items/ApplicationDockItemProvider.vala"
			item = PLANK_IS_DOCK_ITEM (_tmp9_) ? ((PlankDockItem*) _tmp9_) : NULL;
#line 184 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp11_ = item;
#line 184 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp11_ == NULL) {
#line 184 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp10_ = TRUE;
#line 1139 "ApplicationDockItemProvider.c"
			} else {
				PlankDockItem* _tmp12_;
#line 184 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp12_ = item;
#line 184 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp10_ = PLANK_IS_TRANSIENT_DOCK_ITEM (_tmp12_);
#line 1146 "ApplicationDockItemProvider.c"
			}
#line 184 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp10_) {
#line 185 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (element);
#line 185 "../lib/Items/ApplicationDockItemProvider.vala"
				continue;
#line 1154 "ApplicationDockItemProvider.c"
			}
#line 187 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp13_ = item;
#line 187 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp14_ = plank_dock_item_get_DockItemFilename (_tmp13_);
#line 187 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp15_ = _tmp14_;
#line 187 "../lib/Items/ApplicationDockItemProvider.vala"
			dock_item_filename = _tmp15_;
#line 188 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp16_ = dock_item_filename;
#line 188 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp17_ = strlen (_tmp16_);
#line 188 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp18_ = _tmp17_;
#line 188 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp18_ > 0) {
#line 1172 "ApplicationDockItemProvider.c"
				GeeArrayList* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
#line 189 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp19_ = item_list;
#line 189 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp20_ = dock_item_filename;
#line 189 "../lib/Items/ApplicationDockItemProvider.vala"
				dock_item_filename = NULL;
#line 189 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp21_ = _tmp20_;
#line 189 "../lib/Items/ApplicationDockItemProvider.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp21_);
#line 189 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_free0 (_tmp21_);
#line 1188 "ApplicationDockItemProvider.c"
			}
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_free0 (dock_item_filename);
#line 182 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_object_unref0 (element);
#line 1194 "ApplicationDockItemProvider.c"
		}
	}
#line 193 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp22_ = item_list;
#line 193 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp24_ = gee_collection_to_array ((GeeCollection*) _tmp22_, &_tmp23_);
#line 193 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp25_ = _tmp24_;
#line 193 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp25__length1 = _tmp23_;
#line 193 "../lib/Items/ApplicationDockItemProvider.vala"
	if (result_length1) {
#line 193 "../lib/Items/ApplicationDockItemProvider.vala"
		*result_length1 = _tmp25__length1;
#line 1209 "ApplicationDockItemProvider.c"
	}
#line 193 "../lib/Items/ApplicationDockItemProvider.vala"
	result = _tmp25_;
#line 193 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (item_list);
#line 193 "../lib/Items/ApplicationDockItemProvider.vala"
	return result;
#line 1217 "ApplicationDockItemProvider.c"
}

static void
plank_application_dock_item_provider_real_app_opened (PlankApplicationDockItemProvider* self,
                                                      BamfApplication* app)
{
	WnckScreen* _tmp0_;
	PlankApplicationDockItem* found = NULL;
	PlankApplicationDockItem* _tmp1_;
	PlankApplicationDockItem* _tmp2_;
#line 196 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (app != NULL);
#line 199 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp0_ = wnck_screen_get_default ();
#line 199 "../lib/Items/ApplicationDockItemProvider.vala"
	wnck_screen_force_update (_tmp0_);
#line 201 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp1_ = plank_application_dock_item_provider_item_for_application (self, app);
#line 201 "../lib/Items/ApplicationDockItemProvider.vala"
	found = _tmp1_;
#line 202 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp2_ = found;
#line 202 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp2_ != NULL) {
#line 1242 "ApplicationDockItemProvider.c"
		PlankApplicationDockItem* _tmp3_;
#line 203 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp3_ = found;
#line 203 "../lib/Items/ApplicationDockItemProvider.vala"
		plank_application_dock_item_set_App (_tmp3_, app);
#line 1248 "ApplicationDockItemProvider.c"
	}
}

void
plank_application_dock_item_provider_app_opened (PlankApplicationDockItemProvider* self,
                                                 BamfApplication* app)
{
	PlankApplicationDockItemProviderClass* _klass_;
#line 196 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (self != NULL);
#line 196 "../lib/Items/ApplicationDockItemProvider.vala"
	_klass_ = PLANK_APPLICATION_DOCK_ITEM_PROVIDER_GET_CLASS (self);
#line 196 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_klass_->app_opened) {
#line 196 "../lib/Items/ApplicationDockItemProvider.vala"
		_klass_->app_opened (self, app);
#line 1265 "ApplicationDockItemProvider.c"
	}
}

void
plank_application_dock_item_provider_delay_items_monitor (PlankApplicationDockItemProvider* self)
{
#line 206 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (self != NULL);
#line 208 "../lib/Items/ApplicationDockItemProvider.vala"
	self->priv->delay_items_monitor_handle = TRUE;
#line 1276 "ApplicationDockItemProvider.c"
}

void
plank_application_dock_item_provider_resume_items_monitor (PlankApplicationDockItemProvider* self)
{
#line 211 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (self != NULL);
#line 213 "../lib/Items/ApplicationDockItemProvider.vala"
	self->priv->delay_items_monitor_handle = FALSE;
#line 214 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_application_dock_item_provider_process_queued_files (self);
#line 1288 "ApplicationDockItemProvider.c"
}

static void
plank_application_dock_item_provider_process_queued_files (PlankApplicationDockItemProvider* self)
{
	GeeArrayList* _tmp65_;
#line 217 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (self != NULL);
#line 1297 "ApplicationDockItemProvider.c"
	{
		GeeArrayList* _file_list = NULL;
		GeeArrayList* _tmp0_;
		gint _file_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _file_index = 0;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp0_ = self->priv->queued_files;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
		_file_list = _tmp0_;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp1_ = _file_list;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp3_ = _tmp2_;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
		_file_size = _tmp3_;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
		_file_index = -1;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
		while (TRUE) {
#line 1322 "ApplicationDockItemProvider.c"
			gint _tmp4_;
			gint _tmp5_;
			GFile* file = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			gchar* basename = NULL;
			GFile* _tmp8_;
			gchar* _tmp9_;
			gboolean skip = FALSE;
			const gchar* _tmp26_;
			PlankDockElement* element = NULL;
			PlankItemFactory* _tmp27_;
			GFile* _tmp28_;
			PlankDockElement* _tmp29_;
			PlankDockItem* item = NULL;
			PlankDockElement* _tmp30_;
			PlankDockItem* _tmp31_;
			PlankDockItem* dupe = NULL;
			PlankDockItem* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			PlankDockItem* _tmp35_;
			PlankDockItem* _tmp36_;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
			_file_index = _file_index + 1;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp4_ = _file_index;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp5_ = _file_size;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
				break;
#line 1356 "ApplicationDockItemProvider.c"
			}
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp6_ = _file_list;
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _file_index);
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
			file = (GFile*) _tmp7_;
#line 220 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp8_ = file;
#line 220 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp9_ = g_file_get_basename (_tmp8_);
#line 220 "../lib/Items/ApplicationDockItemProvider.vala"
			basename = _tmp9_;
#line 221 "../lib/Items/ApplicationDockItemProvider.vala"
			skip = FALSE;
#line 1372 "ApplicationDockItemProvider.c"
			{
				GeeArrayList* _element_list = NULL;
				GeeArrayList* _tmp10_;
				gint _element_size = 0;
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _element_index = 0;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp10_ = ((PlankDockContainer*) self)->internal_elements;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
				_element_list = _tmp10_;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp11_ = _element_list;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp13_ = _tmp12_;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
				_element_size = _tmp13_;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
				_element_index = -1;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
				while (TRUE) {
#line 1397 "ApplicationDockItemProvider.c"
					gint _tmp14_;
					gint _tmp15_;
					PlankDockElement* element = NULL;
					GeeArrayList* _tmp16_;
					gpointer _tmp17_;
					PlankDockItem* item = NULL;
					PlankDockElement* _tmp18_;
					gboolean _tmp19_ = FALSE;
					PlankDockItem* _tmp20_;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
					_element_index = _element_index + 1;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp14_ = _element_index;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp15_ = _element_size;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
					if (!(_tmp14_ < _tmp15_)) {
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
						break;
#line 1417 "ApplicationDockItemProvider.c"
					}
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp16_ = _element_list;
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _element_index);
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
					element = (PlankDockElement*) _tmp17_;
#line 223 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp18_ = element;
#line 223 "../lib/Items/ApplicationDockItemProvider.vala"
					item = PLANK_IS_DOCK_ITEM (_tmp18_) ? ((PlankDockItem*) _tmp18_) : NULL;
#line 224 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp20_ = item;
#line 224 "../lib/Items/ApplicationDockItemProvider.vala"
					if (_tmp20_ != NULL) {
#line 1433 "ApplicationDockItemProvider.c"
						const gchar* _tmp21_;
						PlankDockItem* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						gchar* _tmp25_;
#line 224 "../lib/Items/ApplicationDockItemProvider.vala"
						_tmp21_ = basename;
#line 224 "../lib/Items/ApplicationDockItemProvider.vala"
						_tmp22_ = item;
#line 224 "../lib/Items/ApplicationDockItemProvider.vala"
						_tmp23_ = plank_dock_item_get_DockItemFilename (_tmp22_);
#line 224 "../lib/Items/ApplicationDockItemProvider.vala"
						_tmp24_ = _tmp23_;
#line 224 "../lib/Items/ApplicationDockItemProvider.vala"
						_tmp25_ = _tmp24_;
#line 224 "../lib/Items/ApplicationDockItemProvider.vala"
						_tmp19_ = g_strcmp0 (_tmp21_, _tmp25_) == 0;
#line 224 "../lib/Items/ApplicationDockItemProvider.vala"
						_g_free0 (_tmp25_);
#line 1453 "ApplicationDockItemProvider.c"
					} else {
#line 224 "../lib/Items/ApplicationDockItemProvider.vala"
						_tmp19_ = FALSE;
#line 1457 "ApplicationDockItemProvider.c"
					}
#line 224 "../lib/Items/ApplicationDockItemProvider.vala"
					if (_tmp19_) {
#line 225 "../lib/Items/ApplicationDockItemProvider.vala"
						skip = TRUE;
#line 226 "../lib/Items/ApplicationDockItemProvider.vala"
						_g_object_unref0 (element);
#line 226 "../lib/Items/ApplicationDockItemProvider.vala"
						break;
#line 1467 "ApplicationDockItemProvider.c"
					}
#line 222 "../lib/Items/ApplicationDockItemProvider.vala"
					_g_object_unref0 (element);
#line 1471 "ApplicationDockItemProvider.c"
				}
			}
#line 230 "../lib/Items/ApplicationDockItemProvider.vala"
			if (skip) {
#line 231 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_free0 (basename);
#line 231 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (file);
#line 231 "../lib/Items/ApplicationDockItemProvider.vala"
				continue;
#line 1482 "ApplicationDockItemProvider.c"
			}
#line 233 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp26_ = basename;
#line 233 "../lib/Items/ApplicationDockItemProvider.vala"
			plank_logger_verbose ("ApplicationDockItemProvider.process_queued_files ('%s')", _tmp26_, NULL);
#line 234 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp27_ = plank_factory_item_factory;
#line 234 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp28_ = file;
#line 234 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp29_ = plank_item_factory_make_element (_tmp27_, _tmp28_);
#line 234 "../lib/Items/ApplicationDockItemProvider.vala"
			element = _tmp29_;
#line 235 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp30_ = element;
#line 235 "../lib/Items/ApplicationDockItemProvider.vala"
			item = PLANK_IS_DOCK_ITEM (_tmp30_) ? ((PlankDockItem*) _tmp30_) : NULL;
#line 236 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp31_ = item;
#line 236 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp31_ == NULL) {
#line 237 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (element);
#line 237 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_free0 (basename);
#line 237 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (file);
#line 237 "../lib/Items/ApplicationDockItemProvider.vala"
				continue;
#line 1512 "ApplicationDockItemProvider.c"
			}
#line 240 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp32_ = item;
#line 240 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp33_ = plank_dock_item_get_Launcher (_tmp32_);
#line 240 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp34_ = _tmp33_;
#line 240 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp35_ = plank_dock_item_provider_item_for_uri ((PlankDockItemProvider*) self, _tmp34_);
#line 240 "../lib/Items/ApplicationDockItemProvider.vala"
			dupe = _tmp35_;
#line 240 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp36_ = dupe;
#line 240 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp36_ != NULL) {
#line 1528 "ApplicationDockItemProvider.c"
				PlankDockItem* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				GFile* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				PlankDockItem* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
				gchar* _tmp46_;
				PlankDockItem* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				PlankDockItem* _tmp51_;
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp37_ = item;
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp38_ = plank_dock_item_get_Launcher (_tmp37_);
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp39_ = _tmp38_;
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp40_ = file;
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp41_ = g_file_get_path (_tmp40_);
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp42_ = _tmp41_;
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp43_ = dupe;
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp44_ = plank_dock_item_get_DockItemFilename (_tmp43_);
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp45_ = _tmp44_;
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp46_ = _tmp45_;
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp47_ = item;
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp48_ = plank_dock_item_get_DockItemFilename (_tmp47_);
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp49_ = _tmp48_;
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp50_ = _tmp49_;
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				g_warning ("ApplicationDockItemProvider.vala:241: The launcher '%s' in dock item '" \
"%s' is already managed by dock item '%s'. Removing '%s'.", _tmp39_, _tmp42_, _tmp46_, _tmp50_);
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_free0 (_tmp50_);
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_free0 (_tmp46_);
#line 241 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_free0 (_tmp42_);
#line 243 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp51_ = item;
#line 243 "../lib/Items/ApplicationDockItemProvider.vala"
				plank_dock_item_delete (_tmp51_);
#line 1584 "ApplicationDockItemProvider.c"
			} else {
				PlankDockItem* _tmp52_;
#line 244 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp52_ = item;
#line 244 "../lib/Items/ApplicationDockItemProvider.vala"
				if (!plank_dock_item_is_valid (_tmp52_)) {
#line 1591 "ApplicationDockItemProvider.c"
					PlankDockItem* _tmp53_;
					const gchar* _tmp54_;
					const gchar* _tmp55_;
					GFile* _tmp56_;
					gchar* _tmp57_;
					gchar* _tmp58_;
					PlankDockItem* _tmp59_;
					gchar* _tmp60_;
					gchar* _tmp61_;
					gchar* _tmp62_;
					PlankDockItem* _tmp63_;
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp53_ = item;
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp54_ = plank_dock_item_get_Launcher (_tmp53_);
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp55_ = _tmp54_;
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp56_ = file;
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp57_ = g_file_get_path (_tmp56_);
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp58_ = _tmp57_;
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp59_ = item;
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp60_ = plank_dock_item_get_DockItemFilename (_tmp59_);
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp61_ = _tmp60_;
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp62_ = _tmp61_;
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					g_warning ("ApplicationDockItemProvider.vala:245: The launcher '%s' in dock item '" \
"%s' does not exist. Removing '%s'.", _tmp55_, _tmp58_, _tmp62_);
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_g_free0 (_tmp62_);
#line 245 "../lib/Items/ApplicationDockItemProvider.vala"
					_g_free0 (_tmp58_);
#line 246 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp63_ = item;
#line 246 "../lib/Items/ApplicationDockItemProvider.vala"
					plank_dock_item_delete (_tmp63_);
#line 1633 "ApplicationDockItemProvider.c"
				} else {
					PlankDockItem* _tmp64_;
#line 248 "../lib/Items/ApplicationDockItemProvider.vala"
					_tmp64_ = item;
#line 248 "../lib/Items/ApplicationDockItemProvider.vala"
					plank_dock_container_add ((PlankDockContainer*) self, (PlankDockElement*) _tmp64_, NULL);
#line 1640 "ApplicationDockItemProvider.c"
				}
			}
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_object_unref0 (element);
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_free0 (basename);
#line 219 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_object_unref0 (file);
#line 1649 "ApplicationDockItemProvider.c"
		}
	}
#line 252 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp65_ = self->priv->queued_files;
#line 252 "../lib/Items/ApplicationDockItemProvider.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp65_);
#line 1656 "ApplicationDockItemProvider.c"
}

static void
plank_application_dock_item_provider_handle_items_dir_changed (GFile* f,
                                                               GFile* other,
                                                               GFileMonitorEvent event,
                                                               PlankApplicationDockItemProvider* self)
{
	gchar* _tmp17_;
	gchar* _tmp18_;
	GeeArrayList* _tmp19_;
#line 256 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (self != NULL);
#line 256 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (f != NULL);
#line 259 "../lib/Items/ApplicationDockItemProvider.vala"
	if (event != G_FILE_MONITOR_EVENT_CREATED) {
#line 260 "../lib/Items/ApplicationDockItemProvider.vala"
		return;
#line 1676 "ApplicationDockItemProvider.c"
	}
#line 262 "../lib/Items/ApplicationDockItemProvider.vala"
	if (!plank_file_is_dockitem (f)) {
#line 263 "../lib/Items/ApplicationDockItemProvider.vala"
		return;
#line 1682 "ApplicationDockItemProvider.c"
	}
	{
		GeeArrayList* _element_list = NULL;
		GeeArrayList* _tmp0_;
		gint _element_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _element_index = 0;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp0_ = ((PlankDockContainer*) self)->internal_elements;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
		_element_list = _tmp0_;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp1_ = _element_list;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp3_ = _tmp2_;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
		_element_size = _tmp3_;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
		_element_index = -1;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
		while (TRUE) {
#line 1708 "ApplicationDockItemProvider.c"
			gint _tmp4_;
			gint _tmp5_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			PlankDockItem* item = NULL;
			PlankDockElement* _tmp8_;
			gboolean _tmp9_ = FALSE;
			PlankDockItem* _tmp10_;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
			_element_index = _element_index + 1;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp4_ = _element_index;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp5_ = _element_size;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
				break;
#line 1728 "ApplicationDockItemProvider.c"
			}
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp6_ = _element_list;
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _element_index);
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
			element = (PlankDockElement*) _tmp7_;
#line 267 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp8_ = element;
#line 267 "../lib/Items/ApplicationDockItemProvider.vala"
			item = PLANK_IS_DOCK_ITEM (_tmp8_) ? ((PlankDockItem*) _tmp8_) : NULL;
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp10_ = item;
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp10_ != NULL) {
#line 1744 "ApplicationDockItemProvider.c"
				gchar* _tmp11_;
				gchar* _tmp12_;
				PlankDockItem* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp11_ = g_file_get_basename (f);
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp12_ = _tmp11_;
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp13_ = item;
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp14_ = plank_dock_item_get_DockItemFilename (_tmp13_);
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp15_ = _tmp14_;
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp16_ = _tmp15_;
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp9_ = g_strcmp0 (_tmp12_, _tmp16_) == 0;
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_free0 (_tmp16_);
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_free0 (_tmp12_);
#line 1769 "ApplicationDockItemProvider.c"
			} else {
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp9_ = FALSE;
#line 1773 "ApplicationDockItemProvider.c"
			}
#line 268 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp9_) {
#line 269 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (element);
#line 269 "../lib/Items/ApplicationDockItemProvider.vala"
				return;
#line 1781 "ApplicationDockItemProvider.c"
			}
#line 266 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_object_unref0 (element);
#line 1785 "ApplicationDockItemProvider.c"
		}
	}
#line 272 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp17_ = g_file_get_path (f);
#line 272 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp18_ = _tmp17_;
#line 272 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_logger_verbose ("ApplicationDockItemProvider.handle_items_dir_changed (processing '%s')", _tmp18_, NULL);
#line 272 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_free0 (_tmp18_);
#line 274 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp19_ = self->priv->queued_files;
#line 274 "../lib/Items/ApplicationDockItemProvider.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, f);
#line 276 "../lib/Items/ApplicationDockItemProvider.vala"
	if (!self->priv->delay_items_monitor_handle) {
#line 277 "../lib/Items/ApplicationDockItemProvider.vala"
		plank_application_dock_item_provider_process_queued_files (self);
#line 1804 "ApplicationDockItemProvider.c"
	}
}

static void
_plank_application_dock_item_provider_handle_item_app_window_added_plank_application_dock_item_app_window_added (PlankApplicationDockItem* _sender,
                                                                                                                 gpointer self)
{
#line 286 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_application_dock_item_provider_handle_item_app_window_added ((PlankApplicationDockItemProvider*) self, _sender);
#line 1814 "ApplicationDockItemProvider.c"
}

static void
plank_application_dock_item_provider_real_connect_element (PlankDockContainer* base,
                                                           PlankDockElement* element)
{
	PlankApplicationDockItemProvider * self;
	PlankApplicationDockItem* appitem = NULL;
	PlankApplicationDockItem* _tmp0_;
#line 280 "../lib/Items/ApplicationDockItemProvider.vala"
	self = (PlankApplicationDockItemProvider*) base;
#line 280 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (element != NULL);
#line 282 "../lib/Items/ApplicationDockItemProvider.vala"
	PLANK_DOCK_CONTAINER_CLASS (plank_application_dock_item_provider_parent_class)->connect_element ((PlankDockContainer*) G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_DOCK_ITEM_PROVIDER, PlankDockItemProvider), element);
#line 284 "../lib/Items/ApplicationDockItemProvider.vala"
	appitem = PLANK_IS_APPLICATION_DOCK_ITEM (element) ? ((PlankApplicationDockItem*) element) : NULL;
#line 285 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp0_ = appitem;
#line 285 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp0_ != NULL) {
#line 1836 "ApplicationDockItemProvider.c"
		PlankApplicationDockItem* _tmp1_;
#line 286 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp1_ = appitem;
#line 286 "../lib/Items/ApplicationDockItemProvider.vala"
		g_signal_connect_object (_tmp1_, "app-window-added", (GCallback) _plank_application_dock_item_provider_handle_item_app_window_added_plank_application_dock_item_app_window_added, self, 0);
#line 1842 "ApplicationDockItemProvider.c"
	}
}

static void
plank_application_dock_item_provider_real_disconnect_element (PlankDockContainer* base,
                                                              PlankDockElement* element)
{
	PlankApplicationDockItemProvider * self;
	PlankApplicationDockItem* appitem = NULL;
	PlankApplicationDockItem* _tmp0_;
#line 290 "../lib/Items/ApplicationDockItemProvider.vala"
	self = (PlankApplicationDockItemProvider*) base;
#line 290 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (element != NULL);
#line 292 "../lib/Items/ApplicationDockItemProvider.vala"
	PLANK_DOCK_CONTAINER_CLASS (plank_application_dock_item_provider_parent_class)->disconnect_element ((PlankDockContainer*) G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_DOCK_ITEM_PROVIDER, PlankDockItemProvider), element);
#line 294 "../lib/Items/ApplicationDockItemProvider.vala"
	appitem = PLANK_IS_APPLICATION_DOCK_ITEM (element) ? ((PlankApplicationDockItem*) element) : NULL;
#line 295 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp0_ = appitem;
#line 295 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp0_ != NULL) {
#line 1865 "ApplicationDockItemProvider.c"
		PlankApplicationDockItem* _tmp1_;
		guint _tmp2_;
#line 296 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp1_ = appitem;
#line 296 "../lib/Items/ApplicationDockItemProvider.vala"
		g_signal_parse_name ("app-window-added", PLANK_TYPE_APPLICATION_DOCK_ITEM, &_tmp2_, NULL, FALSE);
#line 296 "../lib/Items/ApplicationDockItemProvider.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _plank_application_dock_item_provider_handle_item_app_window_added_plank_application_dock_item_app_window_added, self);
#line 1874 "ApplicationDockItemProvider.c"
	}
}

static void
plank_application_dock_item_provider_handle_item_app_window_added (PlankApplicationDockItemProvider* self,
                                                                   PlankApplicationDockItem* item)
{
#line 300 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (self != NULL);
#line 300 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (item != NULL);
#line 302 "../lib/Items/ApplicationDockItemProvider.vala"
	g_signal_emit (self, plank_application_dock_item_provider_signals[PLANK_APPLICATION_DOCK_ITEM_PROVIDER_ITEM_WINDOW_ADDED_SIGNAL], 0, item);
#line 1888 "ApplicationDockItemProvider.c"
}

static void
plank_application_dock_item_provider_real_remove_launcher_entry (PlankUnityClient* base,
                                                                 const gchar* sender_name)
{
	PlankApplicationDockItemProvider * self;
#line 305 "../lib/Items/ApplicationDockItemProvider.vala"
	self = (PlankApplicationDockItemProvider*) base;
#line 305 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (sender_name != NULL);
#line 1900 "ApplicationDockItemProvider.c"
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp0_;
		gint _item_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _item_index = 0;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp0_ = ((PlankDockContainer*) self)->internal_elements;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
		_item_list = _tmp0_;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp1_ = _item_list;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp3_ = _tmp2_;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
		_item_size = _tmp3_;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
		_item_index = -1;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
		while (TRUE) {
#line 1925 "ApplicationDockItemProvider.c"
			gint _tmp4_;
			gint _tmp5_;
			PlankDockElement* item = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			PlankApplicationDockItem* app_item = NULL;
			PlankDockElement* _tmp8_;
			PlankApplicationDockItem* _tmp9_;
			PlankApplicationDockItem* _tmp10_;
			const gchar* _tmp11_;
			PlankApplicationDockItem* _tmp12_;
			PlankTransientDockItem* transient_item = NULL;
			PlankDockElement* _tmp13_;
			gboolean _tmp14_ = FALSE;
			PlankTransientDockItem* _tmp15_;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
			_item_index = _item_index + 1;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp4_ = _item_index;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp5_ = _item_size;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
				break;
#line 1951 "ApplicationDockItemProvider.c"
			}
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp6_ = _item_list;
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _item_index);
#line 308 "../lib/Items/ApplicationDockItemProvider.vala"
			item = (PlankDockElement*) _tmp7_;
#line 309 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp8_ = item;
#line 309 "../lib/Items/ApplicationDockItemProvider.vala"
			app_item = PLANK_IS_APPLICATION_DOCK_ITEM (_tmp8_) ? ((PlankApplicationDockItem*) _tmp8_) : NULL;
#line 310 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp9_ = app_item;
#line 310 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp9_ == NULL) {
#line 311 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (item);
#line 311 "../lib/Items/ApplicationDockItemProvider.vala"
				continue;
#line 1971 "ApplicationDockItemProvider.c"
			}
#line 313 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp10_ = app_item;
#line 313 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp11_ = plank_application_dock_item_get_unity_dbusname (_tmp10_);
#line 313 "../lib/Items/ApplicationDockItemProvider.vala"
			if (g_strcmp0 (_tmp11_, sender_name) != 0) {
#line 314 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (item);
#line 314 "../lib/Items/ApplicationDockItemProvider.vala"
				continue;
#line 1983 "ApplicationDockItemProvider.c"
			}
#line 316 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp12_ = app_item;
#line 316 "../lib/Items/ApplicationDockItemProvider.vala"
			plank_application_dock_item_unity_reset (_tmp12_);
#line 320 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp13_ = item;
#line 320 "../lib/Items/ApplicationDockItemProvider.vala"
			transient_item = PLANK_IS_TRANSIENT_DOCK_ITEM (_tmp13_) ? ((PlankTransientDockItem*) _tmp13_) : NULL;
#line 321 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp15_ = transient_item;
#line 321 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp15_ != NULL) {
#line 1997 "ApplicationDockItemProvider.c"
				PlankTransientDockItem* _tmp16_;
				BamfApplication* _tmp17_;
				BamfApplication* _tmp18_;
#line 321 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp16_ = transient_item;
#line 321 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp17_ = plank_application_dock_item_get_App ((PlankApplicationDockItem*) _tmp16_);
#line 321 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp18_ = _tmp17_;
#line 321 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp14_ = _tmp18_ == NULL;
#line 2009 "ApplicationDockItemProvider.c"
			} else {
#line 321 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp14_ = FALSE;
#line 2013 "ApplicationDockItemProvider.c"
			}
#line 321 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp14_) {
#line 2017 "ApplicationDockItemProvider.c"
				PlankTransientDockItem* _tmp19_;
#line 322 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp19_ = transient_item;
#line 322 "../lib/Items/ApplicationDockItemProvider.vala"
				plank_dock_container_remove ((PlankDockContainer*) self, (PlankDockElement*) _tmp19_);
#line 2023 "ApplicationDockItemProvider.c"
			}
#line 324 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_object_unref0 (item);
#line 324 "../lib/Items/ApplicationDockItemProvider.vala"
			break;
#line 2029 "ApplicationDockItemProvider.c"
		}
	}
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	return self ? g_variant_ref (self) : NULL;
#line 2039 "ApplicationDockItemProvider.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	return _data10_;
#line 2049 "ApplicationDockItemProvider.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2059 "ApplicationDockItemProvider.c"
		PlankApplicationDockItemProvider* self;
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
		self = _data10_->self;
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_free0 (_data10_->sender_name);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_variant_unref0 (_data10_->parameters);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (self);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
		g_slice_free (Block10Data, _data10_);
#line 2071 "ApplicationDockItemProvider.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 344 "../lib/Items/ApplicationDockItemProvider.vala"
	return self ? g_object_ref (self) : NULL;
#line 2080 "ApplicationDockItemProvider.c"
}

static gboolean
___lambda39_ (Block10Data* _data10_)
{
	PlankApplicationDockItemProvider* self;
	gboolean result;
#line 373 "../lib/Items/ApplicationDockItemProvider.vala"
	self = _data10_->self;
#line 374 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_unity_client_update_launcher_entry ((PlankUnityClient*) self, _data10_->sender_name, _data10_->parameters, TRUE);
#line 375 "../lib/Items/ApplicationDockItemProvider.vala"
	result = FALSE;
#line 375 "../lib/Items/ApplicationDockItemProvider.vala"
	return result;
#line 2096 "ApplicationDockItemProvider.c"
}

static gboolean
____lambda39__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda39_ (self);
#line 373 "../lib/Items/ApplicationDockItemProvider.vala"
	return result;
#line 2106 "ApplicationDockItemProvider.c"
}

static void
plank_application_dock_item_provider_real_update_launcher_entry (PlankUnityClient* base,
                                                                 const gchar* sender_name,
                                                                 GVariant* parameters,
                                                                 gboolean is_retry)
{
	PlankApplicationDockItemProvider * self;
	Block10Data* _data10_;
	gchar* _tmp0_;
	GVariant* _tmp1_;
	gchar* app_uri = NULL;
	GVariantIter* prop_iter = NULL;
	gchar* _tmp2_ = NULL;
	GVariantIter* _tmp3_ = NULL;
	const gchar* _tmp4_;
	PlankApplicationDockItem* current_item = NULL;
	PlankApplicationDockItem* alternate_item = NULL;
	PlankApplicationDockItem* _tmp24_;
	PlankApplicationDockItem* _tmp27_;
	PlankDefaultApplicationDockItemProvider* provider = NULL;
	gboolean _tmp39_ = FALSE;
	PlankDefaultApplicationDockItemProvider* _tmp40_;
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	self = (PlankApplicationDockItemProvider*) base;
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (sender_name != NULL);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (parameters != NULL);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_data10_->_ref_count_ = 1;
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_data10_->self = g_object_ref (self);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp0_ = g_strdup (sender_name);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_free0 (_data10_->sender_name);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_data10_->sender_name = _tmp0_;
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp1_ = _g_variant_ref0 (parameters);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_variant_unref0 (_data10_->parameters);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_data10_->parameters = _tmp1_;
#line 332 "../lib/Items/ApplicationDockItemProvider.vala"
	g_variant_get (_data10_->parameters, "(sa{sv})", &_tmp2_, &_tmp3_, NULL);
#line 332 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_free0 (app_uri);
#line 332 "../lib/Items/ApplicationDockItemProvider.vala"
	app_uri = _tmp2_;
#line 332 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_variant_iter_free0 (prop_iter);
#line 332 "../lib/Items/ApplicationDockItemProvider.vala"
	prop_iter = _tmp3_;
#line 334 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp4_ = app_uri;
#line 334 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_logger_verbose ("Unity.handle_update_request (processing update for %s)", _tmp4_, NULL);
#line 336 "../lib/Items/ApplicationDockItemProvider.vala"
	current_item = NULL;
#line 336 "../lib/Items/ApplicationDockItemProvider.vala"
	alternate_item = NULL;
#line 2173 "ApplicationDockItemProvider.c"
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp5_;
		gint _item_size = 0;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _item_index = 0;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp5_ = ((PlankDockContainer*) self)->internal_elements;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
		_item_list = _tmp5_;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp6_ = _item_list;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp8_ = _tmp7_;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
		_item_size = _tmp8_;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
		_item_index = -1;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
		while (TRUE) {
#line 2198 "ApplicationDockItemProvider.c"
			gint _tmp9_;
			gint _tmp10_;
			PlankDockElement* item = NULL;
			GeeArrayList* _tmp11_;
			gpointer _tmp12_;
			PlankApplicationDockItem* app_item = NULL;
			PlankDockElement* _tmp13_;
			PlankApplicationDockItem* _tmp14_;
			PlankApplicationDockItem* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			PlankApplicationDockItem* _tmp20_;
			const gchar* _tmp21_;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
			_item_index = _item_index + 1;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp9_ = _item_index;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp10_ = _item_size;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
			if (!(_tmp9_ < _tmp10_)) {
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
				break;
#line 2222 "ApplicationDockItemProvider.c"
			}
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp11_ = _item_list;
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _item_index);
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
			item = (PlankDockElement*) _tmp12_;
#line 338 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp13_ = item;
#line 338 "../lib/Items/ApplicationDockItemProvider.vala"
			app_item = PLANK_IS_APPLICATION_DOCK_ITEM (_tmp13_) ? ((PlankApplicationDockItem*) _tmp13_) : NULL;
#line 339 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp14_ = app_item;
#line 339 "../lib/Items/ApplicationDockItemProvider.vala"
			if (_tmp14_ == NULL) {
#line 340 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (item);
#line 340 "../lib/Items/ApplicationDockItemProvider.vala"
				continue;
#line 2242 "ApplicationDockItemProvider.c"
			}
#line 343 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp15_ = app_item;
#line 343 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp16_ = plank_application_dock_item_get_unity_application_uri (_tmp15_);
#line 343 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp17_ = app_uri;
#line 343 "../lib/Items/ApplicationDockItemProvider.vala"
			if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
#line 2252 "ApplicationDockItemProvider.c"
				PlankApplicationDockItem* _tmp18_;
				PlankApplicationDockItem* _tmp19_;
#line 344 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp18_ = app_item;
#line 344 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp19_ = _g_object_ref0 (_tmp18_);
#line 344 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (current_item);
#line 344 "../lib/Items/ApplicationDockItemProvider.vala"
				current_item = _tmp19_;
#line 345 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (item);
#line 345 "../lib/Items/ApplicationDockItemProvider.vala"
				break;
#line 2267 "ApplicationDockItemProvider.c"
			}
#line 348 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp20_ = app_item;
#line 348 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp21_ = plank_application_dock_item_get_unity_dbusname (_tmp20_);
#line 348 "../lib/Items/ApplicationDockItemProvider.vala"
			if (g_strcmp0 (_tmp21_, _data10_->sender_name) == 0) {
#line 2275 "ApplicationDockItemProvider.c"
				PlankApplicationDockItem* _tmp22_;
				PlankApplicationDockItem* _tmp23_;
#line 349 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp22_ = app_item;
#line 349 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp23_ = _g_object_ref0 (_tmp22_);
#line 349 "../lib/Items/ApplicationDockItemProvider.vala"
				_g_object_unref0 (alternate_item);
#line 349 "../lib/Items/ApplicationDockItemProvider.vala"
				alternate_item = _tmp23_;
#line 2286 "ApplicationDockItemProvider.c"
			}
#line 337 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_object_unref0 (item);
#line 2290 "ApplicationDockItemProvider.c"
		}
	}
#line 353 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp24_ = current_item;
#line 353 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp24_ == NULL) {
#line 2297 "ApplicationDockItemProvider.c"
		PlankApplicationDockItem* _tmp25_;
		PlankApplicationDockItem* _tmp26_;
#line 354 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp25_ = alternate_item;
#line 354 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp26_ = _g_object_ref0 (_tmp25_);
#line 354 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (current_item);
#line 354 "../lib/Items/ApplicationDockItemProvider.vala"
		current_item = _tmp26_;
#line 2308 "ApplicationDockItemProvider.c"
	}
#line 357 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp27_ = current_item;
#line 357 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp27_ != NULL) {
#line 2314 "ApplicationDockItemProvider.c"
		PlankApplicationDockItem* _tmp28_;
		GVariantIter* _tmp29_;
		PlankTransientDockItem* transient_item = NULL;
		PlankApplicationDockItem* _tmp30_;
		gboolean _tmp31_ = FALSE;
		gboolean _tmp32_ = FALSE;
		PlankTransientDockItem* _tmp33_;
#line 358 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp28_ = current_item;
#line 358 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp29_ = prop_iter;
#line 358 "../lib/Items/ApplicationDockItemProvider.vala"
		plank_application_dock_item_unity_update (_tmp28_, _data10_->sender_name, _tmp29_);
#line 362 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp30_ = current_item;
#line 362 "../lib/Items/ApplicationDockItemProvider.vala"
		transient_item = PLANK_IS_TRANSIENT_DOCK_ITEM (_tmp30_) ? ((PlankTransientDockItem*) _tmp30_) : NULL;
#line 363 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp33_ = transient_item;
#line 363 "../lib/Items/ApplicationDockItemProvider.vala"
		if (_tmp33_ != NULL) {
#line 2336 "ApplicationDockItemProvider.c"
			PlankTransientDockItem* _tmp34_;
			BamfApplication* _tmp35_;
			BamfApplication* _tmp36_;
#line 363 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp34_ = transient_item;
#line 363 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp35_ = plank_application_dock_item_get_App ((PlankApplicationDockItem*) _tmp34_);
#line 363 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp36_ = _tmp35_;
#line 363 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp32_ = _tmp36_ == NULL;
#line 2348 "ApplicationDockItemProvider.c"
		} else {
#line 363 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp32_ = FALSE;
#line 2352 "ApplicationDockItemProvider.c"
		}
#line 363 "../lib/Items/ApplicationDockItemProvider.vala"
		if (_tmp32_) {
#line 2356 "ApplicationDockItemProvider.c"
			PlankTransientDockItem* _tmp37_;
#line 364 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp37_ = transient_item;
#line 364 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp31_ = !plank_application_dock_item_has_unity_info ((PlankApplicationDockItem*) _tmp37_);
#line 2362 "ApplicationDockItemProvider.c"
		} else {
#line 363 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp31_ = FALSE;
#line 2366 "ApplicationDockItemProvider.c"
		}
#line 363 "../lib/Items/ApplicationDockItemProvider.vala"
		if (_tmp31_) {
#line 2370 "ApplicationDockItemProvider.c"
			PlankTransientDockItem* _tmp38_;
#line 365 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp38_ = transient_item;
#line 365 "../lib/Items/ApplicationDockItemProvider.vala"
			plank_dock_container_remove ((PlankDockContainer*) self, (PlankDockElement*) _tmp38_);
#line 2376 "ApplicationDockItemProvider.c"
		}
#line 367 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (alternate_item);
#line 367 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (current_item);
#line 367 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_variant_iter_free0 (prop_iter);
#line 367 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_free0 (app_uri);
#line 367 "../lib/Items/ApplicationDockItemProvider.vala"
		block10_data_unref (_data10_);
#line 367 "../lib/Items/ApplicationDockItemProvider.vala"
		_data10_ = NULL;
#line 367 "../lib/Items/ApplicationDockItemProvider.vala"
		return;
#line 2392 "ApplicationDockItemProvider.c"
	}
#line 370 "../lib/Items/ApplicationDockItemProvider.vala"
	if (!is_retry) {
#line 373 "../lib/Items/ApplicationDockItemProvider.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda39__gsource_func, block10_data_ref (_data10_), block10_data_unref);
#line 378 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (alternate_item);
#line 378 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (current_item);
#line 378 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_variant_iter_free0 (prop_iter);
#line 378 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_free0 (app_uri);
#line 378 "../lib/Items/ApplicationDockItemProvider.vala"
		block10_data_unref (_data10_);
#line 378 "../lib/Items/ApplicationDockItemProvider.vala"
		_data10_ = NULL;
#line 378 "../lib/Items/ApplicationDockItemProvider.vala"
		return;
#line 2412 "ApplicationDockItemProvider.c"
	}
#line 381 "../lib/Items/ApplicationDockItemProvider.vala"
	provider = PLANK_IS_DEFAULT_APPLICATION_DOCK_ITEM_PROVIDER (self) ? ((PlankDefaultApplicationDockItemProvider*) self) : NULL;
#line 382 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp40_ = provider;
#line 382 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp40_ != NULL) {
#line 2420 "ApplicationDockItemProvider.c"
		PlankDefaultApplicationDockItemProvider* _tmp41_;
		PlankDockPreferences* _tmp42_;
		PlankDockPreferences* _tmp43_;
		gboolean _tmp44_;
		gboolean _tmp45_;
#line 382 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp41_ = provider;
#line 382 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp42_ = plank_default_application_dock_item_provider_get_Prefs (_tmp41_);
#line 382 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp43_ = _tmp42_;
#line 382 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp44_ = plank_dock_preferences_get_PinnedOnly (_tmp43_);
#line 382 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp45_ = _tmp44_;
#line 382 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp39_ = !_tmp45_;
#line 2438 "ApplicationDockItemProvider.c"
	} else {
#line 382 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp39_ = FALSE;
#line 2442 "ApplicationDockItemProvider.c"
	}
#line 382 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp39_) {
#line 2446 "ApplicationDockItemProvider.c"
		GFile* desktop_file = NULL;
		const gchar* _tmp46_;
		GFile* _tmp47_;
		GFile* _tmp48_;
		PlankApplicationDockItem* _tmp57_;
#line 384 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp46_ = app_uri;
#line 384 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp47_ = plank_application_dock_item_provider_desktop_file_for_application_uri (_tmp46_);
#line 384 "../lib/Items/ApplicationDockItemProvider.vala"
		desktop_file = _tmp47_;
#line 385 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp48_ = desktop_file;
#line 385 "../lib/Items/ApplicationDockItemProvider.vala"
		if (_tmp48_ != NULL) {
#line 2462 "ApplicationDockItemProvider.c"
			GFile* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			PlankTransientDockItem* _tmp52_;
			PlankApplicationDockItem* _tmp53_;
			GVariantIter* _tmp54_;
			PlankApplicationDockItem* _tmp55_;
#line 386 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp49_ = desktop_file;
#line 386 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp50_ = g_file_get_uri (_tmp49_);
#line 386 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp51_ = _tmp50_;
#line 386 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp52_ = plank_transient_dock_item_new_with_launcher (_tmp51_);
#line 386 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_object_unref0 (current_item);
#line 386 "../lib/Items/ApplicationDockItemProvider.vala"
			current_item = (PlankApplicationDockItem*) _tmp52_;
#line 386 "../lib/Items/ApplicationDockItemProvider.vala"
			_g_free0 (_tmp51_);
#line 387 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp53_ = current_item;
#line 387 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp54_ = prop_iter;
#line 387 "../lib/Items/ApplicationDockItemProvider.vala"
			plank_application_dock_item_unity_update (_tmp53_, _data10_->sender_name, _tmp54_);
#line 391 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp55_ = current_item;
#line 391 "../lib/Items/ApplicationDockItemProvider.vala"
			if (plank_application_dock_item_has_unity_info (_tmp55_)) {
#line 2494 "ApplicationDockItemProvider.c"
				PlankApplicationDockItem* _tmp56_;
#line 392 "../lib/Items/ApplicationDockItemProvider.vala"
				_tmp56_ = current_item;
#line 392 "../lib/Items/ApplicationDockItemProvider.vala"
				plank_dock_container_add ((PlankDockContainer*) self, (PlankDockElement*) _tmp56_, NULL);
#line 2500 "ApplicationDockItemProvider.c"
			}
		}
#line 395 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp57_ = current_item;
#line 395 "../lib/Items/ApplicationDockItemProvider.vala"
		if (_tmp57_ == NULL) {
#line 2507 "ApplicationDockItemProvider.c"
			const gchar* _tmp58_;
#line 396 "../lib/Items/ApplicationDockItemProvider.vala"
			_tmp58_ = app_uri;
#line 396 "../lib/Items/ApplicationDockItemProvider.vala"
			g_warning ("ApplicationDockItemProvider.vala:396: Matching application for '%s' no" \
"t found or not installed!", _tmp58_);
#line 2513 "ApplicationDockItemProvider.c"
		}
#line 382 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (desktop_file);
#line 2517 "ApplicationDockItemProvider.c"
	}
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (alternate_item);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (current_item);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_variant_iter_free0 (prop_iter);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_free0 (app_uri);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	block10_data_unref (_data10_);
#line 328 "../lib/Items/ApplicationDockItemProvider.vala"
	_data10_ = NULL;
#line 2531 "ApplicationDockItemProvider.c"
}

GFile*
plank_application_dock_item_provider_get_LaunchersDir (PlankApplicationDockItemProvider* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp0_ = self->priv->_LaunchersDir;
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
	result = _tmp0_;
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
	return result;
#line 2547 "ApplicationDockItemProvider.c"
}

static void
plank_application_dock_item_provider_set_LaunchersDir (PlankApplicationDockItemProvider* self,
                                                       GFile* value)
{
	GFile* old_value;
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
	g_return_if_fail (self != NULL);
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
	old_value = plank_application_dock_item_provider_get_LaunchersDir (self);
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
	if (old_value != value) {
#line 2561 "ApplicationDockItemProvider.c"
		GFile* _tmp0_;
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (self->priv->_LaunchersDir);
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
		self->priv->_LaunchersDir = _tmp0_;
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_application_dock_item_provider_properties[PLANK_APPLICATION_DOCK_ITEM_PROVIDER_LAUNCHERS_DIR_PROPERTY]);
#line 2571 "ApplicationDockItemProvider.c"
	}
}

static GObject *
plank_application_dock_item_provider_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankApplicationDockItemProvider * self;
	GeeArrayList* _tmp0_;
	GFile* _tmp1_;
	PlankMatcher* _tmp2_;
	PlankMatcher* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 45 "../lib/Items/ApplicationDockItemProvider.vala"
	parent_class = G_OBJECT_CLASS (plank_application_dock_item_provider_parent_class);
#line 45 "../lib/Items/ApplicationDockItemProvider.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 45 "../lib/Items/ApplicationDockItemProvider.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_APPLICATION_DOCK_ITEM_PROVIDER, PlankApplicationDockItemProvider);
#line 47 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp0_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 47 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (self->priv->queued_files);
#line 47 "../lib/Items/ApplicationDockItemProvider.vala"
	self->priv->queued_files = _tmp0_;
#line 50 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp1_ = self->priv->_LaunchersDir;
#line 50 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_paths_ensure_directory_exists (_tmp1_);
#line 52 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp2_ = plank_matcher_get_default ();
#line 52 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp3_ = _tmp2_;
#line 52 "../lib/Items/ApplicationDockItemProvider.vala"
	g_signal_connect_object (_tmp3_, "application-opened", (GCallback) _plank_application_dock_item_provider_app_opened_plank_matcher_application_opened, self, 0);
#line 52 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (_tmp3_);
#line 2612 "ApplicationDockItemProvider.c"
	{
		GFileMonitor* _tmp4_ = NULL;
		GFile* _tmp5_;
		GFileMonitor* _tmp6_;
		GFileMonitor* _tmp7_;
		GFileMonitor* _tmp8_;
#line 55 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp5_ = self->priv->_LaunchersDir;
#line 55 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp6_ = g_file_monitor_directory (_tmp5_, 0, NULL, &_inner_error0_);
#line 55 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp4_ = _tmp6_;
#line 55 "../lib/Items/ApplicationDockItemProvider.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2627 "ApplicationDockItemProvider.c"
			goto __catch0_g_error;
		}
#line 55 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp7_ = _tmp4_;
#line 55 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp4_ = NULL;
#line 55 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (self->priv->items_monitor);
#line 55 "../lib/Items/ApplicationDockItemProvider.vala"
		self->priv->items_monitor = _tmp7_;
#line 56 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp8_ = self->priv->items_monitor;
#line 56 "../lib/Items/ApplicationDockItemProvider.vala"
		g_signal_connect_object (_tmp8_, "changed", (GCallback) _plank_application_dock_item_provider_handle_items_dir_changed_g_file_monitor_changed, self, 0);
#line 54 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (_tmp4_);
#line 2644 "ApplicationDockItemProvider.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 54 "../lib/Items/ApplicationDockItemProvider.vala"
		e = _inner_error0_;
#line 54 "../lib/Items/ApplicationDockItemProvider.vala"
		_inner_error0_ = NULL;
#line 58 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp9_ = e;
#line 58 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp10_ = _tmp9_->message;
#line 58 "../lib/Items/ApplicationDockItemProvider.vala"
		g_critical ("ApplicationDockItemProvider.vala:58: Unable to watch the launchers dir" \
"ectory. (%s)", _tmp10_);
#line 54 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_error_free0 (e);
#line 2664 "ApplicationDockItemProvider.c"
	}
	__finally0:
#line 54 "../lib/Items/ApplicationDockItemProvider.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 54 "../lib/Items/ApplicationDockItemProvider.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 54 "../lib/Items/ApplicationDockItemProvider.vala"
		g_clear_error (&_inner_error0_);
#line 2673 "ApplicationDockItemProvider.c"
	}
#line 45 "../lib/Items/ApplicationDockItemProvider.vala"
	return obj;
#line 2677 "ApplicationDockItemProvider.c"
}

static void
plank_application_dock_item_provider_class_init (PlankApplicationDockItemProviderClass * klass,
                                                 gpointer klass_data)
{
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_application_dock_item_provider_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	g_type_class_adjust_private_offset (klass, &PlankApplicationDockItemProvider_private_offset);
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	((PlankDockItemProviderClass *) klass)->add_item_with_uri = (gboolean (*) (PlankDockItemProvider*, const gchar*, PlankDockItem*)) plank_application_dock_item_provider_real_add_item_with_uri;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	((PlankDockContainerClass *) klass)->prepare = (void (*) (PlankDockContainer*)) plank_application_dock_item_provider_real_prepare;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	((PlankDockItemProviderClass *) klass)->get_dockitem_filenames = (gchar** (*) (PlankDockItemProvider*, gint*)) plank_application_dock_item_provider_real_get_dockitem_filenames;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	((PlankApplicationDockItemProviderClass *) klass)->app_opened = (void (*) (PlankApplicationDockItemProvider*, BamfApplication*)) plank_application_dock_item_provider_real_app_opened;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	((PlankDockContainerClass *) klass)->connect_element = (void (*) (PlankDockContainer*, PlankDockElement*)) plank_application_dock_item_provider_real_connect_element;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	((PlankDockContainerClass *) klass)->disconnect_element = (void (*) (PlankDockContainer*, PlankDockElement*)) plank_application_dock_item_provider_real_disconnect_element;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_application_dock_item_provider_get_property;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_application_dock_item_provider_set_property;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_application_dock_item_provider_constructor;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_application_dock_item_provider_finalize;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_APPLICATION_DOCK_ITEM_PROVIDER_LAUNCHERS_DIR_PROPERTY, plank_application_dock_item_provider_properties[PLANK_APPLICATION_DOCK_ITEM_PROVIDER_LAUNCHERS_DIR_PROPERTY] = g_param_spec_object ("LaunchersDir", "LaunchersDir", "LaunchersDir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_application_dock_item_provider_signals[PLANK_APPLICATION_DOCK_ITEM_PROVIDER_ITEM_WINDOW_ADDED_SIGNAL] = g_signal_new ("item-window-added", PLANK_TYPE_APPLICATION_DOCK_ITEM_PROVIDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, PLANK_TYPE_APPLICATION_DOCK_ITEM);
#line 2712 "ApplicationDockItemProvider.c"
}

static void
plank_application_dock_item_provider_plank_unity_client_interface_init (PlankUnityClientIface * iface,
                                                                        gpointer iface_data)
{
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	plank_application_dock_item_provider_plank_unity_client_parent_iface = g_type_interface_peek_parent (iface);
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	iface->remove_launcher_entry = (void (*) (PlankUnityClient*, const gchar*)) plank_application_dock_item_provider_real_remove_launcher_entry;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	iface->update_launcher_entry = (void (*) (PlankUnityClient*, const gchar*, GVariant*, gboolean)) plank_application_dock_item_provider_real_update_launcher_entry;
#line 2725 "ApplicationDockItemProvider.c"
}

static void
plank_application_dock_item_provider_instance_init (PlankApplicationDockItemProvider * self,
                                                    gpointer klass)
{
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	self->priv = plank_application_dock_item_provider_get_instance_private (self);
#line 31 "../lib/Items/ApplicationDockItemProvider.vala"
	self->priv->items_monitor = NULL;
#line 32 "../lib/Items/ApplicationDockItemProvider.vala"
	self->priv->delay_items_monitor_handle = FALSE;
#line 2738 "ApplicationDockItemProvider.c"
}

static void
plank_application_dock_item_provider_finalize (GObject * obj)
{
	PlankApplicationDockItemProvider * self;
	PlankMatcher* _tmp0_;
	PlankMatcher* _tmp1_;
	guint _tmp2_;
	GFileMonitor* _tmp3_;
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_APPLICATION_DOCK_ITEM_PROVIDER, PlankApplicationDockItemProvider);
#line 64 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (self->priv->queued_files);
#line 64 "../lib/Items/ApplicationDockItemProvider.vala"
	self->priv->queued_files = NULL;
#line 66 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp0_ = plank_matcher_get_default ();
#line 66 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp1_ = _tmp0_;
#line 66 "../lib/Items/ApplicationDockItemProvider.vala"
	g_signal_parse_name ("application-opened", PLANK_TYPE_MATCHER, &_tmp2_, NULL, FALSE);
#line 66 "../lib/Items/ApplicationDockItemProvider.vala"
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _plank_application_dock_item_provider_app_opened_plank_matcher_application_opened, self);
#line 66 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (_tmp1_);
#line 68 "../lib/Items/ApplicationDockItemProvider.vala"
	_tmp3_ = self->priv->items_monitor;
#line 68 "../lib/Items/ApplicationDockItemProvider.vala"
	if (_tmp3_ != NULL) {
#line 2769 "ApplicationDockItemProvider.c"
		GFileMonitor* _tmp4_;
		guint _tmp5_;
		GFileMonitor* _tmp6_;
#line 69 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp4_ = self->priv->items_monitor;
#line 69 "../lib/Items/ApplicationDockItemProvider.vala"
		g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 69 "../lib/Items/ApplicationDockItemProvider.vala"
		g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _plank_application_dock_item_provider_handle_items_dir_changed_g_file_monitor_changed, self);
#line 70 "../lib/Items/ApplicationDockItemProvider.vala"
		_tmp6_ = self->priv->items_monitor;
#line 70 "../lib/Items/ApplicationDockItemProvider.vala"
		g_file_monitor_cancel (_tmp6_);
#line 71 "../lib/Items/ApplicationDockItemProvider.vala"
		_g_object_unref0 (self->priv->items_monitor);
#line 71 "../lib/Items/ApplicationDockItemProvider.vala"
		self->priv->items_monitor = NULL;
#line 2787 "ApplicationDockItemProvider.c"
	}
#line 29 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (self->priv->_LaunchersDir);
#line 31 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (self->priv->items_monitor);
#line 33 "../lib/Items/ApplicationDockItemProvider.vala"
	_g_object_unref0 (self->priv->queued_files);
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	G_OBJECT_CLASS (plank_application_dock_item_provider_parent_class)->finalize (obj);
#line 2797 "ApplicationDockItemProvider.c"
}

/**
 * A container and controller class for managing application dock items on a dock.
 */
static GType
plank_application_dock_item_provider_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankApplicationDockItemProviderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_application_dock_item_provider_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankApplicationDockItemProvider), 0, (GInstanceInitFunc) plank_application_dock_item_provider_instance_init, NULL };
	static const GInterfaceInfo plank_unity_client_info = { (GInterfaceInitFunc) plank_application_dock_item_provider_plank_unity_client_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType plank_application_dock_item_provider_type_id;
	plank_application_dock_item_provider_type_id = g_type_register_static (PLANK_TYPE_DOCK_ITEM_PROVIDER, "PlankApplicationDockItemProvider", &g_define_type_info, 0);
	g_type_add_interface_static (plank_application_dock_item_provider_type_id, PLANK_TYPE_UNITY_CLIENT, &plank_unity_client_info);
	PlankApplicationDockItemProvider_private_offset = g_type_add_instance_private (plank_application_dock_item_provider_type_id, sizeof (PlankApplicationDockItemProviderPrivate));
	return plank_application_dock_item_provider_type_id;
}

GType
plank_application_dock_item_provider_get_type (void)
{
	static volatile gsize plank_application_dock_item_provider_type_id__once = 0;
	if (g_once_init_enter (&plank_application_dock_item_provider_type_id__once)) {
		GType plank_application_dock_item_provider_type_id;
		plank_application_dock_item_provider_type_id = plank_application_dock_item_provider_get_type_once ();
		g_once_init_leave (&plank_application_dock_item_provider_type_id__once, plank_application_dock_item_provider_type_id);
	}
	return plank_application_dock_item_provider_type_id__once;
}

static void
_vala_plank_application_dock_item_provider_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec)
{
	PlankApplicationDockItemProvider * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_APPLICATION_DOCK_ITEM_PROVIDER, PlankApplicationDockItemProvider);
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	switch (property_id) {
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
		case PLANK_APPLICATION_DOCK_ITEM_PROVIDER_LAUNCHERS_DIR_PROPERTY:
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
		g_value_set_object (value, plank_application_dock_item_provider_get_LaunchersDir (self));
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
		break;
#line 2843 "ApplicationDockItemProvider.c"
		default:
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
		break;
#line 2849 "ApplicationDockItemProvider.c"
	}
}

static void
_vala_plank_application_dock_item_provider_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec)
{
	PlankApplicationDockItemProvider * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_APPLICATION_DOCK_ITEM_PROVIDER, PlankApplicationDockItemProvider);
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
	switch (property_id) {
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
		case PLANK_APPLICATION_DOCK_ITEM_PROVIDER_LAUNCHERS_DIR_PROPERTY:
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
		plank_application_dock_item_provider_set_LaunchersDir (self, g_value_get_object (value));
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
		break;
#line 2869 "ApplicationDockItemProvider.c"
		default:
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/Items/ApplicationDockItemProvider.vala"
		break;
#line 2875 "ApplicationDockItemProvider.c"
	}
}

