/* FileDockItem.c generated by valac 0.56.18, the Vala compiler
 * generated from FileDockItem.vala, do not modify */

/**/
/*  Copyright (C) 2011 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gi18n-lib.h>
#include "plank-internal.h"

#define PLANK_FILE_DOCK_ITEM_DEFAULT_ICONS "inode-directory;;folder"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_FILE_DOCK_ITEM_0_PROPERTY,
	PLANK_FILE_DOCK_ITEM_OWNED_FILE_PROPERTY,
	PLANK_FILE_DOCK_ITEM_NUM_PROPERTIES
};
static GParamSpec* plank_file_dock_item_properties[PLANK_FILE_DOCK_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
typedef struct _Block11Data Block11Data;
typedef struct _Block12Data Block12Data;
typedef struct _Block13Data Block13Data;

struct _PlankFileDockItemPrivate {
	GFile* _OwnedFile;
	GFileMonitor* dir_monitor;
};

struct _Block11Data {
	int _ref_count_;
	PlankFileDockItem* self;
	GeeHashMap* icons;
	GeeArrayList* keys;
};

struct _Block12Data {
	int _ref_count_;
	PlankFileDockItem* self;
	GeeHashMap* menu_items;
	GeeArrayList* keys;
};

struct _Block13Data {
	int _ref_count_;
	Block12Data * _data12_;
	GFile* file;
};

static gint PlankFileDockItem_private_offset;
static gpointer plank_file_dock_item_parent_class = NULL;

static void plank_file_dock_item_stop_monitor (PlankFileDockItem* self);
static void plank_file_dock_item_real_load_from_launcher (PlankDockItem* base);
static gchar* plank_file_dock_item_get_display_name (GFile* file);
static void plank_file_dock_item_handle_dir_changed (GFile* f,
                                              GFile* other,
                                              GFileMonitorEvent event,
                                              PlankFileDockItem* self);
static void _plank_file_dock_item_handle_dir_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                      GFile* file,
                                                                      GFile* other_file,
                                                                      GFileMonitorEvent event_type,
                                                                      gpointer self);
static gboolean plank_file_dock_item_has_default_icon_match (PlankFileDockItem* self);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void plank_file_dock_item_real_draw_icon_fast (PlankDockItem* base,
                                               PlankSurface* surface);
static void plank_file_dock_item_real_draw_icon (PlankDockItem* base,
                                          PlankSurface* surface);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static GeeHashMap* plank_file_dock_item_get_files (GFile* file);
static gboolean __lambda16_ (Block11Data* _data11_,
                      const gchar* display_name,
                      GFile* file);
static gboolean ___lambda16__gee_forall_map_func (gconstpointer k,
                                           gconstpointer v,
                                           gpointer self);
static PlankAnimationType plank_file_dock_item_real_on_clicked (PlankDockElement* base,
                                                         PlankPopupButton button,
                                                         GdkModifierType mod,
                                                         guint32 event_time);
static GeeArrayList* plank_file_dock_item_real_get_menu_items (PlankDockElement* base);
static GeeArrayList* plank_file_dock_item_get_dir_menu_items (PlankFileDockItem* self);
static GeeArrayList* plank_file_dock_item_get_file_menu_items (PlankFileDockItem* self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static gboolean __lambda17_ (Block12Data* _data12_,
                      const gchar* display_name,
                      GFile* file);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static void ___lambda18_ (Block13Data* _data13_);
static void ____lambda18__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void ___lambda19_ (Block13Data* _data13_);
static void ____lambda19__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static gboolean ___lambda17__gee_forall_map_func (gconstpointer k,
                                           gconstpointer v,
                                           gpointer self);
static void ___lambda20_ (PlankFileDockItem* self);
static void ____lambda20__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda21_ (PlankFileDockItem* self);
static void ___lambda21__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void ___lambda22_ (PlankFileDockItem* self);
static void ____lambda22__gtk_menu_item_activate (GtkMenuItem* _sender,
                                           gpointer self);
static void _plank_file_dock_item_launch_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self);
static void __lambda23_ (PlankFileDockItem* self);
static void ___lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static GObject * plank_file_dock_item_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void plank_file_dock_item_finalize (GObject * obj);
static GType plank_file_dock_item_get_type_once (void);
static void _vala_plank_file_dock_item_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_plank_file_dock_item_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
plank_file_dock_item_get_instance_private (PlankFileDockItem* self)
{
	return G_STRUCT_MEMBER_P (self, PlankFileDockItem_private_offset);
}

/**
 * {@inheritDoc}
 */
PlankFileDockItem*
plank_file_dock_item_construct_with_file (GType object_type,
                                          GFile* file)
{
	PlankFileDockItem * self = NULL;
	PlankDockItemPreferences* prefs = NULL;
	PlankDockItemPreferences* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 39 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 41 "../lib/Items/FileDockItem.vala"
	_tmp0_ = plank_dock_item_preferences_new ();
#line 41 "../lib/Items/FileDockItem.vala"
	prefs = _tmp0_;
#line 42 "../lib/Items/FileDockItem.vala"
	_tmp1_ = g_file_get_uri (file);
#line 42 "../lib/Items/FileDockItem.vala"
	_tmp2_ = _tmp1_;
#line 42 "../lib/Items/FileDockItem.vala"
	plank_dock_item_preferences_set_Launcher (prefs, _tmp2_);
#line 42 "../lib/Items/FileDockItem.vala"
	_g_free0 (_tmp2_);
#line 44 "../lib/Items/FileDockItem.vala"
	self = (PlankFileDockItem*) g_object_new (object_type, "Prefs", prefs, "OwnedFile", file, NULL);
#line 39 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (prefs);
#line 39 "../lib/Items/FileDockItem.vala"
	return self;
#line 216 "FileDockItem.c"
}

PlankFileDockItem*
plank_file_dock_item_new_with_file (GFile* file)
{
#line 39 "../lib/Items/FileDockItem.vala"
	return plank_file_dock_item_construct_with_file (PLANK_TYPE_FILE_DOCK_ITEM, file);
#line 224 "FileDockItem.c"
}

/**
 * {@inheritDoc}
 */
PlankFileDockItem*
plank_file_dock_item_construct_with_dockitem_file (GType object_type,
                                                   GFile* file)
{
	PlankFileDockItem * self = NULL;
	PlankDockItemPreferences* prefs = NULL;
	PlankDockItemPreferences* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
#line 50 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 52 "../lib/Items/FileDockItem.vala"
	_tmp0_ = plank_dock_item_preferences_new_with_file (file);
#line 52 "../lib/Items/FileDockItem.vala"
	prefs = _tmp0_;
#line 54 "../lib/Items/FileDockItem.vala"
	_tmp1_ = plank_dock_item_preferences_get_Launcher (prefs);
#line 54 "../lib/Items/FileDockItem.vala"
	_tmp2_ = _tmp1_;
#line 54 "../lib/Items/FileDockItem.vala"
	_tmp3_ = g_file_new_for_uri (_tmp2_);
#line 54 "../lib/Items/FileDockItem.vala"
	_tmp4_ = _tmp3_;
#line 54 "../lib/Items/FileDockItem.vala"
	self = (PlankFileDockItem*) g_object_new (object_type, "Prefs", prefs, "OwnedFile", _tmp4_, NULL);
#line 54 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (_tmp4_);
#line 50 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (prefs);
#line 50 "../lib/Items/FileDockItem.vala"
	return self;
#line 263 "FileDockItem.c"
}

PlankFileDockItem*
plank_file_dock_item_new_with_dockitem_file (GFile* file)
{
#line 50 "../lib/Items/FileDockItem.vala"
	return plank_file_dock_item_construct_with_dockitem_file (PLANK_TYPE_FILE_DOCK_ITEM, file);
#line 271 "FileDockItem.c"
}

/**
 * {@inheritDoc}
 */
PlankFileDockItem*
plank_file_dock_item_construct_with_dockitem_filename (GType object_type,
                                                       const gchar* filename)
{
	PlankFileDockItem * self = NULL;
	PlankDockItemPreferences* prefs = NULL;
	PlankDockItemPreferences* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
#line 60 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 62 "../lib/Items/FileDockItem.vala"
	_tmp0_ = plank_dock_item_preferences_new_with_filename (filename);
#line 62 "../lib/Items/FileDockItem.vala"
	prefs = _tmp0_;
#line 64 "../lib/Items/FileDockItem.vala"
	_tmp1_ = plank_dock_item_preferences_get_Launcher (prefs);
#line 64 "../lib/Items/FileDockItem.vala"
	_tmp2_ = _tmp1_;
#line 64 "../lib/Items/FileDockItem.vala"
	_tmp3_ = g_file_new_for_uri (_tmp2_);
#line 64 "../lib/Items/FileDockItem.vala"
	_tmp4_ = _tmp3_;
#line 64 "../lib/Items/FileDockItem.vala"
	self = (PlankFileDockItem*) g_object_new (object_type, "Prefs", prefs, "OwnedFile", _tmp4_, NULL);
#line 64 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (_tmp4_);
#line 60 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (prefs);
#line 60 "../lib/Items/FileDockItem.vala"
	return self;
#line 310 "FileDockItem.c"
}

PlankFileDockItem*
plank_file_dock_item_new_with_dockitem_filename (const gchar* filename)
{
#line 60 "../lib/Items/FileDockItem.vala"
	return plank_file_dock_item_construct_with_dockitem_filename (PLANK_TYPE_FILE_DOCK_ITEM, filename);
#line 318 "FileDockItem.c"
}

/**
 * {@inheritDoc}
 */
static void
_plank_file_dock_item_handle_dir_changed_g_file_monitor_changed (GFileMonitor* _sender,
                                                                 GFile* file,
                                                                 GFile* other_file,
                                                                 GFileMonitorEvent event_type,
                                                                 gpointer self)
{
#line 103 "../lib/Items/FileDockItem.vala"
	plank_file_dock_item_handle_dir_changed (file, other_file, event_type, (PlankFileDockItem*) self);
#line 333 "FileDockItem.c"
}

static void
plank_file_dock_item_real_load_from_launcher (PlankDockItem* base)
{
	PlankFileDockItem * self;
	PlankDockItemPreferences* _tmp0_;
	PlankDockItemPreferences* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	PlankDockItemPreferences* _tmp4_;
	PlankDockItemPreferences* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	gchar* _tmp10_ = NULL;
	GFile* _tmp11_;
	gchar* _tmp12_;
	GFile* _tmp14_;
	GFile* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GFile* _tmp21_;
	GError* _inner_error0_ = NULL;
#line 80 "../lib/Items/FileDockItem.vala"
	self = (PlankFileDockItem*) base;
#line 82 "../lib/Items/FileDockItem.vala"
	plank_file_dock_item_stop_monitor (self);
#line 84 "../lib/Items/FileDockItem.vala"
	_tmp0_ = plank_dock_item_get_Prefs ((PlankDockItem*) self);
#line 84 "../lib/Items/FileDockItem.vala"
	_tmp1_ = _tmp0_;
#line 84 "../lib/Items/FileDockItem.vala"
	_tmp2_ = plank_dock_item_preferences_get_Launcher (_tmp1_);
#line 84 "../lib/Items/FileDockItem.vala"
	_tmp3_ = _tmp2_;
#line 84 "../lib/Items/FileDockItem.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 85 "../lib/Items/FileDockItem.vala"
		return;
#line 375 "FileDockItem.c"
	}
#line 87 "../lib/Items/FileDockItem.vala"
	_tmp4_ = plank_dock_item_get_Prefs ((PlankDockItem*) self);
#line 87 "../lib/Items/FileDockItem.vala"
	_tmp5_ = _tmp4_;
#line 87 "../lib/Items/FileDockItem.vala"
	_tmp6_ = plank_dock_item_preferences_get_Launcher (_tmp5_);
#line 87 "../lib/Items/FileDockItem.vala"
	_tmp7_ = _tmp6_;
#line 87 "../lib/Items/FileDockItem.vala"
	_tmp8_ = g_file_new_for_uri (_tmp7_);
#line 87 "../lib/Items/FileDockItem.vala"
	_tmp9_ = _tmp8_;
#line 87 "../lib/Items/FileDockItem.vala"
	plank_file_dock_item_set_OwnedFile (self, _tmp9_);
#line 87 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (_tmp9_);
#line 88 "../lib/Items/FileDockItem.vala"
	_tmp11_ = self->priv->_OwnedFile;
#line 88 "../lib/Items/FileDockItem.vala"
	_tmp12_ = plank_drawing_service_get_icon_from_file (_tmp11_);
#line 88 "../lib/Items/FileDockItem.vala"
	_tmp10_ = _tmp12_;
#line 88 "../lib/Items/FileDockItem.vala"
	if (_tmp10_ == NULL) {
#line 401 "FileDockItem.c"
		gchar* _tmp13_;
#line 88 "../lib/Items/FileDockItem.vala"
		_tmp13_ = g_strdup (PLANK_FILE_DOCK_ITEM_DEFAULT_ICONS);
#line 88 "../lib/Items/FileDockItem.vala"
		_g_free0 (_tmp10_);
#line 88 "../lib/Items/FileDockItem.vala"
		_tmp10_ = _tmp13_;
#line 409 "FileDockItem.c"
	}
#line 88 "../lib/Items/FileDockItem.vala"
	plank_dock_item_set_Icon ((PlankDockItem*) self, _tmp10_);
#line 90 "../lib/Items/FileDockItem.vala"
	_tmp14_ = self->priv->_OwnedFile;
#line 90 "../lib/Items/FileDockItem.vala"
	if (!g_file_is_native (_tmp14_)) {
#line 417 "FileDockItem.c"
		GFile* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 91 "../lib/Items/FileDockItem.vala"
		_tmp15_ = self->priv->_OwnedFile;
#line 91 "../lib/Items/FileDockItem.vala"
		_tmp16_ = g_file_get_uri (_tmp15_);
#line 91 "../lib/Items/FileDockItem.vala"
		_tmp17_ = _tmp16_;
#line 91 "../lib/Items/FileDockItem.vala"
		plank_dock_element_set_Text ((PlankDockElement*) self, _tmp17_);
#line 91 "../lib/Items/FileDockItem.vala"
		_g_free0 (_tmp17_);
#line 92 "../lib/Items/FileDockItem.vala"
		_g_free0 (_tmp10_);
#line 92 "../lib/Items/FileDockItem.vala"
		return;
#line 435 "FileDockItem.c"
	}
#line 95 "../lib/Items/FileDockItem.vala"
	_tmp18_ = self->priv->_OwnedFile;
#line 95 "../lib/Items/FileDockItem.vala"
	_tmp19_ = plank_file_dock_item_get_display_name (_tmp18_);
#line 95 "../lib/Items/FileDockItem.vala"
	_tmp20_ = _tmp19_;
#line 95 "../lib/Items/FileDockItem.vala"
	plank_dock_element_set_Text ((PlankDockElement*) self, _tmp20_);
#line 95 "../lib/Items/FileDockItem.vala"
	_g_free0 (_tmp20_);
#line 98 "../lib/Items/FileDockItem.vala"
	_tmp21_ = self->priv->_OwnedFile;
#line 98 "../lib/Items/FileDockItem.vala"
	if (g_file_query_file_type (_tmp21_, 0, NULL) == G_FILE_TYPE_DIRECTORY) {
#line 99 "../lib/Items/FileDockItem.vala"
		plank_dock_element_set_Button ((PlankDockElement*) self, PLANK_POPUP_BUTTON_RIGHT | PLANK_POPUP_BUTTON_LEFT);
#line 453 "FileDockItem.c"
		{
			GFileMonitor* _tmp22_ = NULL;
			GFile* _tmp23_;
			GFileMonitor* _tmp24_;
			GFileMonitor* _tmp25_;
			GFileMonitor* _tmp26_;
#line 102 "../lib/Items/FileDockItem.vala"
			_tmp23_ = self->priv->_OwnedFile;
#line 102 "../lib/Items/FileDockItem.vala"
			_tmp24_ = g_file_monitor_directory (_tmp23_, 0, NULL, &_inner_error0_);
#line 102 "../lib/Items/FileDockItem.vala"
			_tmp22_ = _tmp24_;
#line 102 "../lib/Items/FileDockItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 468 "FileDockItem.c"
				goto __catch0_g_error;
			}
#line 102 "../lib/Items/FileDockItem.vala"
			_tmp25_ = _tmp22_;
#line 102 "../lib/Items/FileDockItem.vala"
			_tmp22_ = NULL;
#line 102 "../lib/Items/FileDockItem.vala"
			_g_object_unref0 (self->priv->dir_monitor);
#line 102 "../lib/Items/FileDockItem.vala"
			self->priv->dir_monitor = _tmp25_;
#line 103 "../lib/Items/FileDockItem.vala"
			_tmp26_ = self->priv->dir_monitor;
#line 103 "../lib/Items/FileDockItem.vala"
			g_signal_connect_object (_tmp26_, "changed", (GCallback) _plank_file_dock_item_handle_dir_changed_g_file_monitor_changed, self, 0);
#line 101 "../lib/Items/FileDockItem.vala"
			_g_object_unref0 (_tmp22_);
#line 485 "FileDockItem.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			gchar* _tmp27_ = NULL;
			GFile* _tmp28_;
			gchar* _tmp29_;
#line 101 "../lib/Items/FileDockItem.vala"
			g_clear_error (&_inner_error0_);
#line 105 "../lib/Items/FileDockItem.vala"
			_tmp28_ = self->priv->_OwnedFile;
#line 105 "../lib/Items/FileDockItem.vala"
			_tmp29_ = g_file_get_path (_tmp28_);
#line 105 "../lib/Items/FileDockItem.vala"
			_tmp27_ = _tmp29_;
#line 105 "../lib/Items/FileDockItem.vala"
			if (_tmp27_ == NULL) {
#line 503 "FileDockItem.c"
				gchar* _tmp30_;
#line 105 "../lib/Items/FileDockItem.vala"
				_tmp30_ = g_strdup ("");
#line 105 "../lib/Items/FileDockItem.vala"
				_g_free0 (_tmp27_);
#line 105 "../lib/Items/FileDockItem.vala"
				_tmp27_ = _tmp30_;
#line 511 "FileDockItem.c"
			}
#line 105 "../lib/Items/FileDockItem.vala"
			g_critical ("FileDockItem.vala:105: Unable to watch the stack directory '%s'.", _tmp27_);
#line 101 "../lib/Items/FileDockItem.vala"
			_g_free0 (_tmp27_);
#line 517 "FileDockItem.c"
		}
		__finally0:
#line 101 "../lib/Items/FileDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 101 "../lib/Items/FileDockItem.vala"
			_g_free0 (_tmp10_);
#line 101 "../lib/Items/FileDockItem.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 101 "../lib/Items/FileDockItem.vala"
			g_clear_error (&_inner_error0_);
#line 101 "../lib/Items/FileDockItem.vala"
			return;
#line 530 "FileDockItem.c"
		}
	}
#line 80 "../lib/Items/FileDockItem.vala"
	_g_free0 (_tmp10_);
#line 535 "FileDockItem.c"
}

static void
plank_file_dock_item_stop_monitor (PlankFileDockItem* self)
{
	GFileMonitor* _tmp0_;
#line 110 "../lib/Items/FileDockItem.vala"
	g_return_if_fail (self != NULL);
#line 112 "../lib/Items/FileDockItem.vala"
	_tmp0_ = self->priv->dir_monitor;
#line 112 "../lib/Items/FileDockItem.vala"
	if (_tmp0_ != NULL) {
#line 548 "FileDockItem.c"
		GFileMonitor* _tmp1_;
		guint _tmp2_;
		GFileMonitor* _tmp3_;
#line 113 "../lib/Items/FileDockItem.vala"
		_tmp1_ = self->priv->dir_monitor;
#line 113 "../lib/Items/FileDockItem.vala"
		g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp2_, NULL, FALSE);
#line 113 "../lib/Items/FileDockItem.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _plank_file_dock_item_handle_dir_changed_g_file_monitor_changed, self);
#line 114 "../lib/Items/FileDockItem.vala"
		_tmp3_ = self->priv->dir_monitor;
#line 114 "../lib/Items/FileDockItem.vala"
		g_file_monitor_cancel (_tmp3_);
#line 115 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (self->priv->dir_monitor);
#line 115 "../lib/Items/FileDockItem.vala"
		self->priv->dir_monitor = NULL;
#line 566 "FileDockItem.c"
	}
}

static void
plank_file_dock_item_handle_dir_changed (GFile* f,
                                         GFile* other,
                                         GFileMonitorEvent event,
                                         PlankFileDockItem* self)
{
#line 120 "../lib/Items/FileDockItem.vala"
	g_return_if_fail (self != NULL);
#line 120 "../lib/Items/FileDockItem.vala"
	g_return_if_fail (f != NULL);
#line 122 "../lib/Items/FileDockItem.vala"
	plank_dock_item_reset_icon_buffer ((PlankDockItem*) self);
#line 582 "FileDockItem.c"
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 132 "../lib/Items/FileDockItem.vala"
	for (i = 0; i < stack_length; i++) {
#line 132 "../lib/Items/FileDockItem.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 132 "../lib/Items/FileDockItem.vala"
			return TRUE;
#line 597 "FileDockItem.c"
		}
	}
#line 132 "../lib/Items/FileDockItem.vala"
	return FALSE;
#line 602 "FileDockItem.c"
}

static gboolean
plank_file_dock_item_has_default_icon_match (PlankFileDockItem* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar** default_icons = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint default_icons_length1;
	gint _default_icons_size_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gboolean result;
#line 125 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 127 "../lib/Items/FileDockItem.vala"
	_tmp0_ = plank_dock_item_get_Icon ((PlankDockItem*) self);
#line 127 "../lib/Items/FileDockItem.vala"
	_tmp1_ = _tmp0_;
#line 127 "../lib/Items/FileDockItem.vala"
	if (g_strcmp0 (_tmp1_, PLANK_FILE_DOCK_ITEM_DEFAULT_ICONS) == 0) {
#line 128 "../lib/Items/FileDockItem.vala"
		result = TRUE;
#line 128 "../lib/Items/FileDockItem.vala"
		return result;
#line 632 "FileDockItem.c"
	}
#line 130 "../lib/Items/FileDockItem.vala"
	_tmp3_ = _tmp2_ = g_strsplit (PLANK_FILE_DOCK_ITEM_DEFAULT_ICONS, ";;", 0);
#line 130 "../lib/Items/FileDockItem.vala"
	default_icons = _tmp3_;
#line 130 "../lib/Items/FileDockItem.vala"
	default_icons_length1 = _vala_array_length (_tmp2_);
#line 130 "../lib/Items/FileDockItem.vala"
	_default_icons_size_ = default_icons_length1;
#line 131 "../lib/Items/FileDockItem.vala"
	_tmp4_ = plank_dock_item_get_Icon ((PlankDockItem*) self);
#line 131 "../lib/Items/FileDockItem.vala"
	_tmp5_ = _tmp4_;
#line 131 "../lib/Items/FileDockItem.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, ";;", 0);
#line 648 "FileDockItem.c"
	{
		gchar** icon_collection = NULL;
		gint icon_collection_length1 = 0;
		gint _icon_collection_size_ = 0;
		gint icon_it = 0;
#line 131 "../lib/Items/FileDockItem.vala"
		icon_collection = _tmp7_;
#line 131 "../lib/Items/FileDockItem.vala"
		icon_collection_length1 = _vala_array_length (_tmp6_);
#line 131 "../lib/Items/FileDockItem.vala"
		for (icon_it = 0; icon_it < icon_collection_length1; icon_it = icon_it + 1) {
#line 660 "FileDockItem.c"
			const gchar* icon = NULL;
#line 131 "../lib/Items/FileDockItem.vala"
			icon = icon_collection[icon_it];
#line 664 "FileDockItem.c"
			{
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
#line 132 "../lib/Items/FileDockItem.vala"
				_tmp8_ = icon;
#line 132 "../lib/Items/FileDockItem.vala"
				_tmp9_ = default_icons;
#line 132 "../lib/Items/FileDockItem.vala"
				_tmp9__length1 = default_icons_length1;
#line 132 "../lib/Items/FileDockItem.vala"
				if (_vala_string_array_contains (_tmp9_, _tmp9__length1, _tmp8_)) {
#line 133 "../lib/Items/FileDockItem.vala"
					result = TRUE;
#line 133 "../lib/Items/FileDockItem.vala"
					icon_collection = (_vala_array_free (icon_collection, icon_collection_length1, (GDestroyNotify) g_free), NULL);
#line 133 "../lib/Items/FileDockItem.vala"
					default_icons = (_vala_array_free (default_icons, default_icons_length1, (GDestroyNotify) g_free), NULL);
#line 133 "../lib/Items/FileDockItem.vala"
					return result;
#line 685 "FileDockItem.c"
				}
			}
		}
#line 131 "../lib/Items/FileDockItem.vala"
		icon_collection = (_vala_array_free (icon_collection, icon_collection_length1, (GDestroyNotify) g_free), NULL);
#line 691 "FileDockItem.c"
	}
#line 135 "../lib/Items/FileDockItem.vala"
	result = FALSE;
#line 135 "../lib/Items/FileDockItem.vala"
	default_icons = (_vala_array_free (default_icons, default_icons_length1, (GDestroyNotify) g_free), NULL);
#line 135 "../lib/Items/FileDockItem.vala"
	return result;
#line 699 "FileDockItem.c"
}

/**
 * {@inheritDoc}
 */
static void
plank_file_dock_item_real_draw_icon_fast (PlankDockItem* base,
                                          PlankSurface* surface)
{
	PlankFileDockItem * self;
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	gint width = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint height = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint radius = 0;
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	cairo_surface_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble line_width_half = 0.0;
	cairo_pattern_t* rg = NULL;
	cairo_pattern_t* _tmp10_;
#line 141 "../lib/Items/FileDockItem.vala"
	self = (PlankFileDockItem*) base;
#line 141 "../lib/Items/FileDockItem.vala"
	g_return_if_fail (surface != NULL);
#line 143 "../lib/Items/FileDockItem.vala"
	_tmp0_ = plank_surface_get_Context (surface);
#line 143 "../lib/Items/FileDockItem.vala"
	_tmp1_ = _tmp0_;
#line 143 "../lib/Items/FileDockItem.vala"
	cr = _tmp1_;
#line 144 "../lib/Items/FileDockItem.vala"
	_tmp2_ = plank_surface_get_Width (surface);
#line 144 "../lib/Items/FileDockItem.vala"
	_tmp3_ = _tmp2_;
#line 144 "../lib/Items/FileDockItem.vala"
	width = _tmp3_;
#line 145 "../lib/Items/FileDockItem.vala"
	_tmp4_ = plank_surface_get_Height (surface);
#line 145 "../lib/Items/FileDockItem.vala"
	_tmp5_ = _tmp4_;
#line 145 "../lib/Items/FileDockItem.vala"
	height = _tmp5_;
#line 146 "../lib/Items/FileDockItem.vala"
	radius = 3 + ((6 * height) / (128 - 48));
#line 147 "../lib/Items/FileDockItem.vala"
	x_scale = 1.0;
#line 147 "../lib/Items/FileDockItem.vala"
	y_scale = 1.0;
#line 148 "../lib/Items/FileDockItem.vala"
	_tmp6_ = plank_surface_get_Internal (surface);
#line 148 "../lib/Items/FileDockItem.vala"
	_tmp7_ = _tmp6_;
#line 148 "../lib/Items/FileDockItem.vala"
	cairo_surface_get_device_scale (_tmp7_, &_tmp8_, &_tmp9_);
#line 148 "../lib/Items/FileDockItem.vala"
	x_scale = _tmp8_;
#line 148 "../lib/Items/FileDockItem.vala"
	y_scale = _tmp9_;
#line 149 "../lib/Items/FileDockItem.vala"
	line_width_half = 0.5 * ((gint) MAX (x_scale, y_scale));
#line 151 "../lib/Items/FileDockItem.vala"
	cairo_move_to (cr, (gdouble) radius, line_width_half);
#line 152 "../lib/Items/FileDockItem.vala"
	cairo_arc (cr, (width - radius) - line_width_half, radius + line_width_half, (gdouble) radius, -G_PI_2, (gdouble) 0);
#line 153 "../lib/Items/FileDockItem.vala"
	cairo_arc (cr, (width - radius) - line_width_half, (height - radius) - line_width_half, (gdouble) radius, (gdouble) 0, G_PI_2);
#line 154 "../lib/Items/FileDockItem.vala"
	cairo_arc (cr, radius + line_width_half, (height - radius) - line_width_half, (gdouble) radius, G_PI_2, G_PI);
#line 155 "../lib/Items/FileDockItem.vala"
	cairo_arc (cr, radius + line_width_half, radius + line_width_half, (gdouble) radius, G_PI, -G_PI_2);
#line 156 "../lib/Items/FileDockItem.vala"
	cairo_close_path (cr);
#line 158 "../lib/Items/FileDockItem.vala"
	cairo_set_source_rgba (cr, (gdouble) 1, (gdouble) 1, (gdouble) 1, 0.6);
#line 159 "../lib/Items/FileDockItem.vala"
	cairo_set_line_width (cr, 2 * line_width_half);
#line 160 "../lib/Items/FileDockItem.vala"
	cairo_stroke_preserve (cr);
#line 162 "../lib/Items/FileDockItem.vala"
	_tmp10_ = cairo_pattern_create_radial ((gdouble) (width / 2), (gdouble) height, (gdouble) (height / 8), (gdouble) (width / 2), (gdouble) height, (gdouble) height);
#line 162 "../lib/Items/FileDockItem.vala"
	rg = _tmp10_;
#line 163 "../lib/Items/FileDockItem.vala"
	cairo_pattern_add_color_stop_rgba (rg, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 1);
#line 164 "../lib/Items/FileDockItem.vala"
	cairo_pattern_add_color_stop_rgba (rg, (gdouble) 1, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.6);
#line 166 "../lib/Items/FileDockItem.vala"
	cairo_set_source (cr, rg);
#line 167 "../lib/Items/FileDockItem.vala"
	cairo_fill (cr);
#line 141 "../lib/Items/FileDockItem.vala"
	_cairo_pattern_destroy0 (rg);
#line 801 "FileDockItem.c"
}

/**
 * {@inheritDoc}
 */
static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 173 "../lib/Items/FileDockItem.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 173 "../lib/Items/FileDockItem.vala"
	return _data11_;
#line 814 "FileDockItem.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 173 "../lib/Items/FileDockItem.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 824 "FileDockItem.c"
		PlankFileDockItem* self;
#line 173 "../lib/Items/FileDockItem.vala"
		self = _data11_->self;
#line 173 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (_data11_->keys);
#line 173 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (_data11_->icons);
#line 173 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (self);
#line 173 "../lib/Items/FileDockItem.vala"
		g_slice_free (Block11Data, _data11_);
#line 836 "FileDockItem.c"
	}
}

static gboolean
__lambda16_ (Block11Data* _data11_,
             const gchar* display_name,
             GFile* file)
{
	PlankFileDockItem* self;
	gchar* icon = NULL;
	gchar* text = NULL;
	gchar* uri = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* key = NULL;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	GeeHashMap* _tmp14_;
	const gchar* _tmp15_;
	GeeArrayList* _tmp16_;
	gboolean result;
#line 190 "../lib/Items/FileDockItem.vala"
	self = _data11_->self;
#line 190 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (display_name != NULL, FALSE);
#line 190 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 192 "../lib/Items/FileDockItem.vala"
	_tmp0_ = g_file_get_uri (file);
#line 192 "../lib/Items/FileDockItem.vala"
	uri = _tmp0_;
#line 193 "../lib/Items/FileDockItem.vala"
	_tmp1_ = uri;
#line 193 "../lib/Items/FileDockItem.vala"
	if (g_str_has_suffix (_tmp1_, ".desktop")) {
#line 873 "FileDockItem.c"
		const gchar* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
#line 194 "../lib/Items/FileDockItem.vala"
		_tmp2_ = uri;
#line 194 "../lib/Items/FileDockItem.vala"
		plank_application_dock_item_parse_launcher (_tmp2_, &_tmp3_, &_tmp4_, NULL, NULL, NULL);
#line 194 "../lib/Items/FileDockItem.vala"
		_g_free0 (icon);
#line 194 "../lib/Items/FileDockItem.vala"
		icon = _tmp3_;
#line 194 "../lib/Items/FileDockItem.vala"
		_g_free0 (text);
#line 194 "../lib/Items/FileDockItem.vala"
		text = _tmp4_;
#line 889 "FileDockItem.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		gchar* _tmp8_;
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
#line 196 "../lib/Items/FileDockItem.vala"
		_tmp6_ = plank_drawing_service_get_icon_from_file (file);
#line 196 "../lib/Items/FileDockItem.vala"
		_tmp5_ = _tmp6_;
#line 196 "../lib/Items/FileDockItem.vala"
		if (_tmp5_ == NULL) {
#line 902 "FileDockItem.c"
			gchar* _tmp7_;
#line 196 "../lib/Items/FileDockItem.vala"
			_tmp7_ = g_strdup ("");
#line 196 "../lib/Items/FileDockItem.vala"
			_g_free0 (_tmp5_);
#line 196 "../lib/Items/FileDockItem.vala"
			_tmp5_ = _tmp7_;
#line 910 "FileDockItem.c"
		}
#line 196 "../lib/Items/FileDockItem.vala"
		_tmp8_ = _tmp5_;
#line 196 "../lib/Items/FileDockItem.vala"
		_tmp5_ = NULL;
#line 196 "../lib/Items/FileDockItem.vala"
		_g_free0 (icon);
#line 196 "../lib/Items/FileDockItem.vala"
		icon = _tmp8_;
#line 197 "../lib/Items/FileDockItem.vala"
		_tmp9_ = display_name;
#line 197 "../lib/Items/FileDockItem.vala"
		if (_tmp9_ == NULL) {
#line 197 "../lib/Items/FileDockItem.vala"
			_tmp9_ = "";
#line 926 "FileDockItem.c"
		}
#line 197 "../lib/Items/FileDockItem.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 197 "../lib/Items/FileDockItem.vala"
		_g_free0 (text);
#line 197 "../lib/Items/FileDockItem.vala"
		text = _tmp10_;
#line 193 "../lib/Items/FileDockItem.vala"
		_g_free0 (_tmp5_);
#line 936 "FileDockItem.c"
	}
#line 200 "../lib/Items/FileDockItem.vala"
	_tmp11_ = text;
#line 200 "../lib/Items/FileDockItem.vala"
	_tmp12_ = uri;
#line 200 "../lib/Items/FileDockItem.vala"
	_tmp13_ = g_strdup_printf ("%s%s", _tmp11_, _tmp12_);
#line 200 "../lib/Items/FileDockItem.vala"
	key = _tmp13_;
#line 201 "../lib/Items/FileDockItem.vala"
	_tmp14_ = _data11_->icons;
#line 201 "../lib/Items/FileDockItem.vala"
	_tmp15_ = icon;
#line 201 "../lib/Items/FileDockItem.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, key, _tmp15_);
#line 202 "../lib/Items/FileDockItem.vala"
	_tmp16_ = _data11_->keys;
#line 202 "../lib/Items/FileDockItem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, key);
#line 204 "../lib/Items/FileDockItem.vala"
	result = TRUE;
#line 204 "../lib/Items/FileDockItem.vala"
	_g_free0 (key);
#line 204 "../lib/Items/FileDockItem.vala"
	_g_free0 (uri);
#line 204 "../lib/Items/FileDockItem.vala"
	_g_free0 (text);
#line 204 "../lib/Items/FileDockItem.vala"
	_g_free0 (icon);
#line 204 "../lib/Items/FileDockItem.vala"
	return result;
#line 968 "FileDockItem.c"
}

static gboolean
___lambda16__gee_forall_map_func (gconstpointer k,
                                  gconstpointer v,
                                  gpointer self)
{
	gboolean result;
	result = __lambda16_ (self, (const gchar*) k, (GFile*) v);
#line 190 "../lib/Items/FileDockItem.vala"
	return result;
#line 980 "FileDockItem.c"
}

static void
plank_file_dock_item_real_draw_icon (PlankDockItem* base,
                                     PlankSurface* surface)
{
	PlankFileDockItem * self;
	Block11Data* _data11_;
	gboolean _tmp0_ = FALSE;
	cairo_t* cr = NULL;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	gint width = 0;
	gint _tmp3_;
	gint _tmp4_;
	gint height = 0;
	gint _tmp5_;
	gint _tmp6_;
	gint radius = 0;
	GeeHashMap* _tmp7_;
	GeeArrayList* _tmp8_;
	GFile* _tmp9_;
	GeeHashMap* _tmp10_;
	GeeHashMap* _tmp11_;
	GeeMapIterator* _tmp12_;
	GeeMapIterator* _tmp13_;
	gint pos = 0;
	gint icon_width = 0;
	gint icon_height = 0;
	gint offset = 0;
	GeeArrayList* _tmp14_;
#line 173 "../lib/Items/FileDockItem.vala"
	self = (PlankFileDockItem*) base;
#line 173 "../lib/Items/FileDockItem.vala"
	g_return_if_fail (surface != NULL);
#line 173 "../lib/Items/FileDockItem.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 173 "../lib/Items/FileDockItem.vala"
	_data11_->_ref_count_ = 1;
#line 173 "../lib/Items/FileDockItem.vala"
	_data11_->self = g_object_ref (self);
#line 175 "../lib/Items/FileDockItem.vala"
	if (!plank_dock_item_is_valid ((PlankDockItem*) self)) {
#line 175 "../lib/Items/FileDockItem.vala"
		_tmp0_ = TRUE;
#line 1026 "FileDockItem.c"
	} else {
#line 175 "../lib/Items/FileDockItem.vala"
		_tmp0_ = !plank_file_dock_item_has_default_icon_match (self);
#line 1030 "FileDockItem.c"
	}
#line 175 "../lib/Items/FileDockItem.vala"
	if (_tmp0_) {
#line 176 "../lib/Items/FileDockItem.vala"
		PLANK_DOCK_ITEM_CLASS (plank_file_dock_item_parent_class)->draw_icon (G_TYPE_CHECK_INSTANCE_CAST (self, PLANK_TYPE_DOCK_ITEM, PlankDockItem), surface);
#line 177 "../lib/Items/FileDockItem.vala"
		block11_data_unref (_data11_);
#line 177 "../lib/Items/FileDockItem.vala"
		_data11_ = NULL;
#line 177 "../lib/Items/FileDockItem.vala"
		return;
#line 1042 "FileDockItem.c"
	}
#line 180 "../lib/Items/FileDockItem.vala"
	_tmp1_ = plank_surface_get_Context (surface);
#line 180 "../lib/Items/FileDockItem.vala"
	_tmp2_ = _tmp1_;
#line 180 "../lib/Items/FileDockItem.vala"
	cr = _tmp2_;
#line 181 "../lib/Items/FileDockItem.vala"
	_tmp3_ = plank_surface_get_Width (surface);
#line 181 "../lib/Items/FileDockItem.vala"
	_tmp4_ = _tmp3_;
#line 181 "../lib/Items/FileDockItem.vala"
	width = _tmp4_;
#line 182 "../lib/Items/FileDockItem.vala"
	_tmp5_ = plank_surface_get_Height (surface);
#line 182 "../lib/Items/FileDockItem.vala"
	_tmp6_ = _tmp5_;
#line 182 "../lib/Items/FileDockItem.vala"
	height = _tmp6_;
#line 183 "../lib/Items/FileDockItem.vala"
	radius = 3 + ((6 * height) / (128 - 48));
#line 185 "../lib/Items/FileDockItem.vala"
	plank_dock_item_draw_icon_fast ((PlankDockItem*) self, surface);
#line 187 "../lib/Items/FileDockItem.vala"
	_tmp7_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 187 "../lib/Items/FileDockItem.vala"
	_data11_->icons = _tmp7_;
#line 188 "../lib/Items/FileDockItem.vala"
	_tmp8_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 188 "../lib/Items/FileDockItem.vala"
	_data11_->keys = _tmp8_;
#line 190 "../lib/Items/FileDockItem.vala"
	_tmp9_ = self->priv->_OwnedFile;
#line 190 "../lib/Items/FileDockItem.vala"
	_tmp10_ = plank_file_dock_item_get_files (_tmp9_);
#line 190 "../lib/Items/FileDockItem.vala"
	_tmp11_ = _tmp10_;
#line 190 "../lib/Items/FileDockItem.vala"
	_tmp12_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp11_);
#line 190 "../lib/Items/FileDockItem.vala"
	_tmp13_ = _tmp12_;
#line 190 "../lib/Items/FileDockItem.vala"
	gee_map_iterator_foreach (_tmp13_, ___lambda16__gee_forall_map_func, _data11_);
#line 190 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (_tmp13_);
#line 190 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (_tmp11_);
#line 207 "../lib/Items/FileDockItem.vala"
	pos = 0;
#line 208 "../lib/Items/FileDockItem.vala"
	icon_width = (gint) ((width - ((80 * radius) / 33.0)) / 2.0);
#line 209 "../lib/Items/FileDockItem.vala"
	icon_height = (gint) ((height - ((80 * radius) / 33.0)) / 2.0);
#line 210 "../lib/Items/FileDockItem.vala"
	offset = (gint) ((width - (2 * icon_width)) / 3.0);
#line 212 "../lib/Items/FileDockItem.vala"
	_tmp14_ = _data11_->keys;
#line 212 "../lib/Items/FileDockItem.vala"
	gee_list_sort ((GeeList*) _tmp14_, NULL, NULL, NULL);
#line 1102 "FileDockItem.c"
	{
		GeeArrayList* _s_list = NULL;
		GeeArrayList* _tmp15_;
		gint _s_size = 0;
		GeeArrayList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _s_index = 0;
#line 213 "../lib/Items/FileDockItem.vala"
		_tmp15_ = _data11_->keys;
#line 213 "../lib/Items/FileDockItem.vala"
		_s_list = _tmp15_;
#line 213 "../lib/Items/FileDockItem.vala"
		_tmp16_ = _s_list;
#line 213 "../lib/Items/FileDockItem.vala"
		_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
#line 213 "../lib/Items/FileDockItem.vala"
		_tmp18_ = _tmp17_;
#line 213 "../lib/Items/FileDockItem.vala"
		_s_size = _tmp18_;
#line 213 "../lib/Items/FileDockItem.vala"
		_s_index = -1;
#line 213 "../lib/Items/FileDockItem.vala"
		while (TRUE) {
#line 1127 "FileDockItem.c"
			gint _tmp19_;
			gint _tmp20_;
			gchar* s = NULL;
			GeeArrayList* _tmp21_;
			gpointer _tmp22_;
			gint x = 0;
			gint y = 0;
			gint _tmp23_;
			GdkPixbuf* pbuf = NULL;
			GeeHashMap* _tmp24_;
			const gchar* _tmp25_;
			gpointer _tmp26_;
			gchar* _tmp27_;
			GdkPixbuf* _tmp28_;
			GdkPixbuf* _tmp29_;
			cairo_t* _tmp30_;
			GdkPixbuf* _tmp31_;
			GdkPixbuf* _tmp32_;
			gint _tmp33_;
			gint _tmp34_;
			GdkPixbuf* _tmp35_;
			gint _tmp36_;
			gint _tmp37_;
			cairo_t* _tmp38_;
#line 213 "../lib/Items/FileDockItem.vala"
			_s_index = _s_index + 1;
#line 213 "../lib/Items/FileDockItem.vala"
			_tmp19_ = _s_index;
#line 213 "../lib/Items/FileDockItem.vala"
			_tmp20_ = _s_size;
#line 213 "../lib/Items/FileDockItem.vala"
			if (!(_tmp19_ < _tmp20_)) {
#line 213 "../lib/Items/FileDockItem.vala"
				break;
#line 1162 "FileDockItem.c"
			}
#line 213 "../lib/Items/FileDockItem.vala"
			_tmp21_ = _s_list;
#line 213 "../lib/Items/FileDockItem.vala"
			_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) _tmp21_, _s_index);
#line 213 "../lib/Items/FileDockItem.vala"
			s = (gchar*) _tmp22_;
#line 214 "../lib/Items/FileDockItem.vala"
			x = pos % 2;
#line 215 "../lib/Items/FileDockItem.vala"
			y = pos / 2;
#line 217 "../lib/Items/FileDockItem.vala"
			pos = pos + 1;
#line 217 "../lib/Items/FileDockItem.vala"
			_tmp23_ = pos;
#line 217 "../lib/Items/FileDockItem.vala"
			if (_tmp23_ > 4) {
#line 218 "../lib/Items/FileDockItem.vala"
				_g_free0 (s);
#line 218 "../lib/Items/FileDockItem.vala"
				break;
#line 1184 "FileDockItem.c"
			}
#line 220 "../lib/Items/FileDockItem.vala"
			_tmp24_ = _data11_->icons;
#line 220 "../lib/Items/FileDockItem.vala"
			_tmp25_ = s;
#line 220 "../lib/Items/FileDockItem.vala"
			_tmp26_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp24_, _tmp25_);
#line 220 "../lib/Items/FileDockItem.vala"
			_tmp27_ = (gchar*) _tmp26_;
#line 220 "../lib/Items/FileDockItem.vala"
			_tmp28_ = plank_drawing_service_load_icon (_tmp27_, icon_width, icon_height);
#line 220 "../lib/Items/FileDockItem.vala"
			_tmp29_ = _tmp28_;
#line 220 "../lib/Items/FileDockItem.vala"
			_g_free0 (_tmp27_);
#line 220 "../lib/Items/FileDockItem.vala"
			pbuf = _tmp29_;
#line 221 "../lib/Items/FileDockItem.vala"
			_tmp30_ = cr;
#line 221 "../lib/Items/FileDockItem.vala"
			_tmp31_ = pbuf;
#line 221 "../lib/Items/FileDockItem.vala"
			_tmp32_ = pbuf;
#line 221 "../lib/Items/FileDockItem.vala"
			_tmp33_ = gdk_pixbuf_get_width (_tmp32_);
#line 221 "../lib/Items/FileDockItem.vala"
			_tmp34_ = _tmp33_;
#line 221 "../lib/Items/FileDockItem.vala"
			_tmp35_ = pbuf;
#line 221 "../lib/Items/FileDockItem.vala"
			_tmp36_ = gdk_pixbuf_get_height (_tmp35_);
#line 221 "../lib/Items/FileDockItem.vala"
			_tmp37_ = _tmp36_;
#line 221 "../lib/Items/FileDockItem.vala"
			gdk_cairo_set_source_pixbuf (_tmp30_, _tmp31_, (gdouble) (((x * (icon_width + offset)) + offset) + ((icon_width - _tmp34_) / 2)), (gdouble) (((y * (icon_height + offset)) + offset) + ((icon_height - _tmp37_) / 2)));
#line 224 "../lib/Items/FileDockItem.vala"
			_tmp38_ = cr;
#line 224 "../lib/Items/FileDockItem.vala"
			cairo_paint (_tmp38_);
#line 213 "../lib/Items/FileDockItem.vala"
			_g_object_unref0 (pbuf);
#line 213 "../lib/Items/FileDockItem.vala"
			_g_free0 (s);
#line 1228 "FileDockItem.c"
		}
	}
#line 173 "../lib/Items/FileDockItem.vala"
	block11_data_unref (_data11_);
#line 173 "../lib/Items/FileDockItem.vala"
	_data11_ = NULL;
#line 1235 "FileDockItem.c"
}

/**
 * Launches the application associated with this item.
 */
void
plank_file_dock_item_launch (PlankFileDockItem* self)
{
	PlankSystem* _tmp0_;
	GFile* _tmp1_;
#line 231 "../lib/Items/FileDockItem.vala"
	g_return_if_fail (self != NULL);
#line 233 "../lib/Items/FileDockItem.vala"
	_tmp0_ = plank_system_get_default ();
#line 233 "../lib/Items/FileDockItem.vala"
	_tmp1_ = self->priv->_OwnedFile;
#line 233 "../lib/Items/FileDockItem.vala"
	plank_system_open (_tmp0_, _tmp1_);
#line 234 "../lib/Items/FileDockItem.vala"
	plank_dock_element_set_ClickedAnimation ((PlankDockElement*) self, PLANK_ANIMATION_TYPE_BOUNCE);
#line 235 "../lib/Items/FileDockItem.vala"
	plank_dock_element_set_LastClicked ((PlankDockElement*) self, g_get_monotonic_time ());
#line 1258 "FileDockItem.c"
}

/**
 * {@inheritDoc}
 */
static PlankAnimationType
plank_file_dock_item_real_on_clicked (PlankDockElement* base,
                                      PlankPopupButton button,
                                      GdkModifierType mod,
                                      guint32 event_time)
{
	PlankFileDockItem * self;
	PlankAnimationType result;
#line 241 "../lib/Items/FileDockItem.vala"
	self = (PlankFileDockItem*) base;
#line 243 "../lib/Items/FileDockItem.vala"
	if (button == PLANK_POPUP_BUTTON_MIDDLE) {
#line 244 "../lib/Items/FileDockItem.vala"
		plank_file_dock_item_launch (self);
#line 245 "../lib/Items/FileDockItem.vala"
		result = PLANK_ANIMATION_TYPE_BOUNCE;
#line 245 "../lib/Items/FileDockItem.vala"
		return result;
#line 1282 "FileDockItem.c"
	}
#line 249 "../lib/Items/FileDockItem.vala"
	if (button == PLANK_POPUP_BUTTON_LEFT) {
#line 250 "../lib/Items/FileDockItem.vala"
		plank_file_dock_item_launch (self);
#line 251 "../lib/Items/FileDockItem.vala"
		result = PLANK_ANIMATION_TYPE_BOUNCE;
#line 251 "../lib/Items/FileDockItem.vala"
		return result;
#line 1292 "FileDockItem.c"
	}
#line 254 "../lib/Items/FileDockItem.vala"
	result = PLANK_ANIMATION_TYPE_NONE;
#line 254 "../lib/Items/FileDockItem.vala"
	return result;
#line 1298 "FileDockItem.c"
}

/**
 * {@inheritDoc}
 */
static GeeArrayList*
plank_file_dock_item_real_get_menu_items (PlankDockElement* base)
{
	PlankFileDockItem * self;
	GFile* _tmp0_;
	GeeArrayList* _tmp2_;
	GeeArrayList* result;
#line 260 "../lib/Items/FileDockItem.vala"
	self = (PlankFileDockItem*) base;
#line 262 "../lib/Items/FileDockItem.vala"
	_tmp0_ = self->priv->_OwnedFile;
#line 262 "../lib/Items/FileDockItem.vala"
	if (g_file_query_file_type (_tmp0_, 0, NULL) == G_FILE_TYPE_DIRECTORY) {
#line 1317 "FileDockItem.c"
		GeeArrayList* _tmp1_;
#line 263 "../lib/Items/FileDockItem.vala"
		_tmp1_ = plank_file_dock_item_get_dir_menu_items (self);
#line 263 "../lib/Items/FileDockItem.vala"
		result = _tmp1_;
#line 263 "../lib/Items/FileDockItem.vala"
		return result;
#line 1325 "FileDockItem.c"
	}
#line 265 "../lib/Items/FileDockItem.vala"
	_tmp2_ = plank_file_dock_item_get_file_menu_items (self);
#line 265 "../lib/Items/FileDockItem.vala"
	result = _tmp2_;
#line 265 "../lib/Items/FileDockItem.vala"
	return result;
#line 1333 "FileDockItem.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 268 "../lib/Items/FileDockItem.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 268 "../lib/Items/FileDockItem.vala"
	return _data12_;
#line 1343 "FileDockItem.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 268 "../lib/Items/FileDockItem.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 1353 "FileDockItem.c"
		PlankFileDockItem* self;
#line 268 "../lib/Items/FileDockItem.vala"
		self = _data12_->self;
#line 268 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (_data12_->keys);
#line 268 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (_data12_->menu_items);
#line 268 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (self);
#line 268 "../lib/Items/FileDockItem.vala"
		g_slice_free (Block12Data, _data12_);
#line 1365 "FileDockItem.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 275 "../lib/Items/FileDockItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 1374 "FileDockItem.c"
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 275 "../lib/Items/FileDockItem.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 275 "../lib/Items/FileDockItem.vala"
	return _data13_;
#line 1384 "FileDockItem.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 275 "../lib/Items/FileDockItem.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 1394 "FileDockItem.c"
		PlankFileDockItem* self;
#line 275 "../lib/Items/FileDockItem.vala"
		self = _data13_->_data12_->self;
#line 275 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (_data13_->file);
#line 275 "../lib/Items/FileDockItem.vala"
		block12_data_unref (_data13_->_data12_);
#line 275 "../lib/Items/FileDockItem.vala"
		_data13_->_data12_ = NULL;
#line 275 "../lib/Items/FileDockItem.vala"
		g_slice_free (Block13Data, _data13_);
#line 1406 "FileDockItem.c"
	}
}

static void
___lambda18_ (Block13Data* _data13_)
{
	Block12Data* _data12_;
	PlankFileDockItem* self;
	PlankSystem* _tmp0_;
#line 282 "../lib/Items/FileDockItem.vala"
	_data12_ = _data13_->_data12_;
#line 282 "../lib/Items/FileDockItem.vala"
	self = _data12_->self;
#line 283 "../lib/Items/FileDockItem.vala"
	_tmp0_ = plank_system_get_default ();
#line 283 "../lib/Items/FileDockItem.vala"
	plank_system_launch (_tmp0_, _data13_->file);
#line 284 "../lib/Items/FileDockItem.vala"
	plank_dock_element_set_ClickedAnimation ((PlankDockElement*) self, PLANK_ANIMATION_TYPE_BOUNCE);
#line 285 "../lib/Items/FileDockItem.vala"
	plank_dock_element_set_LastClicked ((PlankDockElement*) self, g_get_monotonic_time ());
#line 1428 "FileDockItem.c"
}

static void
____lambda18__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 282 "../lib/Items/FileDockItem.vala"
	___lambda18_ (self);
#line 1437 "FileDockItem.c"
}

static void
___lambda19_ (Block13Data* _data13_)
{
	Block12Data* _data12_;
	PlankFileDockItem* self;
	PlankSystem* _tmp0_;
#line 291 "../lib/Items/FileDockItem.vala"
	_data12_ = _data13_->_data12_;
#line 291 "../lib/Items/FileDockItem.vala"
	self = _data12_->self;
#line 292 "../lib/Items/FileDockItem.vala"
	_tmp0_ = plank_system_get_default ();
#line 292 "../lib/Items/FileDockItem.vala"
	plank_system_open (_tmp0_, _data13_->file);
#line 293 "../lib/Items/FileDockItem.vala"
	plank_dock_element_set_ClickedAnimation ((PlankDockElement*) self, PLANK_ANIMATION_TYPE_BOUNCE);
#line 294 "../lib/Items/FileDockItem.vala"
	plank_dock_element_set_LastClicked ((PlankDockElement*) self, g_get_monotonic_time ());
#line 1458 "FileDockItem.c"
}

static void
____lambda19__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 291 "../lib/Items/FileDockItem.vala"
	___lambda19_ (self);
#line 1467 "FileDockItem.c"
}

static gboolean
__lambda17_ (Block12Data* _data12_,
             const gchar* display_name,
             GFile* file)
{
	PlankFileDockItem* self;
	Block13Data* _data13_;
	GFile* _tmp0_;
	GtkMenuItem* item = NULL;
	gchar* icon = NULL;
	gchar* text = NULL;
	gchar* uri = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* key = NULL;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	GeeHashMap* _tmp23_;
	GtkMenuItem* _tmp24_;
	GeeArrayList* _tmp25_;
	gboolean result;
#line 275 "../lib/Items/FileDockItem.vala"
	self = _data12_->self;
#line 275 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (display_name != NULL, FALSE);
#line 275 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 275 "../lib/Items/FileDockItem.vala"
	_data13_ = g_slice_new0 (Block13Data);
#line 275 "../lib/Items/FileDockItem.vala"
	_data13_->_ref_count_ = 1;
#line 275 "../lib/Items/FileDockItem.vala"
	_data13_->_data12_ = block12_data_ref (_data12_);
#line 275 "../lib/Items/FileDockItem.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 275 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (_data13_->file);
#line 275 "../lib/Items/FileDockItem.vala"
	_data13_->file = _tmp0_;
#line 278 "../lib/Items/FileDockItem.vala"
	_tmp1_ = g_file_get_uri (_data13_->file);
#line 278 "../lib/Items/FileDockItem.vala"
	uri = _tmp1_;
#line 279 "../lib/Items/FileDockItem.vala"
	_tmp2_ = uri;
#line 279 "../lib/Items/FileDockItem.vala"
	if (g_str_has_suffix (_tmp2_, ".desktop")) {
#line 1518 "FileDockItem.c"
		const gchar* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		GtkMenuItem* _tmp8_;
		GtkMenuItem* _tmp9_;
#line 280 "../lib/Items/FileDockItem.vala"
		_tmp3_ = uri;
#line 280 "../lib/Items/FileDockItem.vala"
		plank_application_dock_item_parse_launcher (_tmp3_, &_tmp4_, &_tmp5_, NULL, NULL, NULL);
#line 280 "../lib/Items/FileDockItem.vala"
		_g_free0 (icon);
#line 280 "../lib/Items/FileDockItem.vala"
		icon = _tmp4_;
#line 280 "../lib/Items/FileDockItem.vala"
		_g_free0 (text);
#line 280 "../lib/Items/FileDockItem.vala"
		text = _tmp5_;
#line 281 "../lib/Items/FileDockItem.vala"
		_tmp6_ = text;
#line 281 "../lib/Items/FileDockItem.vala"
		_tmp7_ = icon;
#line 281 "../lib/Items/FileDockItem.vala"
		_tmp8_ = plank_dock_element_create_menu_item (_tmp6_, _tmp7_, TRUE);
#line 281 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (item);
#line 281 "../lib/Items/FileDockItem.vala"
		item = _tmp8_;
#line 282 "../lib/Items/FileDockItem.vala"
		_tmp9_ = item;
#line 282 "../lib/Items/FileDockItem.vala"
		g_signal_connect_data (_tmp9_, "activate", (GCallback) ____lambda18__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 1552 "FileDockItem.c"
	} else {
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_;
		gchar* _tmp13_;
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		GtkMenuItem* _tmp18_;
		GtkMenuItem* _tmp19_;
#line 288 "../lib/Items/FileDockItem.vala"
		_tmp11_ = plank_drawing_service_get_icon_from_file (_data13_->file);
#line 288 "../lib/Items/FileDockItem.vala"
		_tmp10_ = _tmp11_;
#line 288 "../lib/Items/FileDockItem.vala"
		if (_tmp10_ == NULL) {
#line 1569 "FileDockItem.c"
			gchar* _tmp12_;
#line 288 "../lib/Items/FileDockItem.vala"
			_tmp12_ = g_strdup ("");
#line 288 "../lib/Items/FileDockItem.vala"
			_g_free0 (_tmp10_);
#line 288 "../lib/Items/FileDockItem.vala"
			_tmp10_ = _tmp12_;
#line 1577 "FileDockItem.c"
		}
#line 288 "../lib/Items/FileDockItem.vala"
		_tmp13_ = _tmp10_;
#line 288 "../lib/Items/FileDockItem.vala"
		_tmp10_ = NULL;
#line 288 "../lib/Items/FileDockItem.vala"
		_g_free0 (icon);
#line 288 "../lib/Items/FileDockItem.vala"
		icon = _tmp13_;
#line 289 "../lib/Items/FileDockItem.vala"
		_tmp14_ = display_name;
#line 289 "../lib/Items/FileDockItem.vala"
		if (_tmp14_ == NULL) {
#line 289 "../lib/Items/FileDockItem.vala"
			_tmp14_ = "";
#line 1593 "FileDockItem.c"
		}
#line 289 "../lib/Items/FileDockItem.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 289 "../lib/Items/FileDockItem.vala"
		_g_free0 (text);
#line 289 "../lib/Items/FileDockItem.vala"
		text = _tmp15_;
#line 290 "../lib/Items/FileDockItem.vala"
		_tmp16_ = text;
#line 290 "../lib/Items/FileDockItem.vala"
		_tmp17_ = icon;
#line 290 "../lib/Items/FileDockItem.vala"
		_tmp18_ = plank_dock_element_create_literal_menu_item (_tmp16_, _tmp17_, TRUE);
#line 290 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (item);
#line 290 "../lib/Items/FileDockItem.vala"
		item = _tmp18_;
#line 291 "../lib/Items/FileDockItem.vala"
		_tmp19_ = item;
#line 291 "../lib/Items/FileDockItem.vala"
		g_signal_connect_data (_tmp19_, "activate", (GCallback) ____lambda19__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 279 "../lib/Items/FileDockItem.vala"
		_g_free0 (_tmp10_);
#line 1617 "FileDockItem.c"
	}
#line 298 "../lib/Items/FileDockItem.vala"
	_tmp20_ = text;
#line 298 "../lib/Items/FileDockItem.vala"
	_tmp21_ = uri;
#line 298 "../lib/Items/FileDockItem.vala"
	_tmp22_ = g_strdup_printf ("%s%s", _tmp20_, _tmp21_);
#line 298 "../lib/Items/FileDockItem.vala"
	key = _tmp22_;
#line 299 "../lib/Items/FileDockItem.vala"
	_tmp23_ = _data12_->menu_items;
#line 299 "../lib/Items/FileDockItem.vala"
	_tmp24_ = item;
#line 299 "../lib/Items/FileDockItem.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, key, _tmp24_);
#line 300 "../lib/Items/FileDockItem.vala"
	_tmp25_ = _data12_->keys;
#line 300 "../lib/Items/FileDockItem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, key);
#line 302 "../lib/Items/FileDockItem.vala"
	result = TRUE;
#line 302 "../lib/Items/FileDockItem.vala"
	_g_free0 (key);
#line 302 "../lib/Items/FileDockItem.vala"
	_g_free0 (uri);
#line 302 "../lib/Items/FileDockItem.vala"
	_g_free0 (text);
#line 302 "../lib/Items/FileDockItem.vala"
	_g_free0 (icon);
#line 302 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (item);
#line 302 "../lib/Items/FileDockItem.vala"
	block13_data_unref (_data13_);
#line 302 "../lib/Items/FileDockItem.vala"
	_data13_ = NULL;
#line 302 "../lib/Items/FileDockItem.vala"
	return result;
#line 1655 "FileDockItem.c"
}

static gboolean
___lambda17__gee_forall_map_func (gconstpointer k,
                                  gconstpointer v,
                                  gpointer self)
{
	gboolean result;
	result = __lambda17_ (self, (const gchar*) k, (GFile*) v);
#line 275 "../lib/Items/FileDockItem.vala"
	return result;
#line 1667 "FileDockItem.c"
}

static void
___lambda20_ (PlankFileDockItem* self)
{
#line 317 "../lib/Items/FileDockItem.vala"
	plank_dock_item_delete ((PlankDockItem*) self);
#line 1675 "FileDockItem.c"
}

static void
____lambda20__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 317 "../lib/Items/FileDockItem.vala"
	___lambda20_ ((PlankFileDockItem*) self);
#line 1684 "FileDockItem.c"
}

static void
__lambda21_ (PlankFileDockItem* self)
{
#line 323 "../lib/Items/FileDockItem.vala"
	plank_file_dock_item_launch (self);
#line 1692 "FileDockItem.c"
}

static void
___lambda21__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 322 "../lib/Items/FileDockItem.vala"
	__lambda21_ ((PlankFileDockItem*) self);
#line 1701 "FileDockItem.c"
}

static GeeArrayList*
plank_file_dock_item_get_dir_menu_items (PlankFileDockItem* self)
{
	Block12Data* _data12_;
	GeeArrayList* items = NULL;
	GeeArrayList* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeArrayList* _tmp2_;
	GFile* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeMapIterator* _tmp6_;
	GeeMapIterator* _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	PlankDefaultApplicationDockItemProvider* default_provider = NULL;
	PlankDockContainer* _tmp28_;
	PlankDockContainer* _tmp29_;
	gboolean _tmp30_ = FALSE;
	PlankDefaultApplicationDockItemProvider* _tmp31_;
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp42_;
	GeeArrayList* _tmp43_;
	GeeArrayList* result;
#line 268 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 268 "../lib/Items/FileDockItem.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 268 "../lib/Items/FileDockItem.vala"
	_data12_->_ref_count_ = 1;
#line 268 "../lib/Items/FileDockItem.vala"
	_data12_->self = g_object_ref (self);
#line 270 "../lib/Items/FileDockItem.vala"
	_tmp0_ = gee_array_list_new (gtk_menu_item_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 270 "../lib/Items/FileDockItem.vala"
	items = _tmp0_;
#line 272 "../lib/Items/FileDockItem.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, gtk_menu_item_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 272 "../lib/Items/FileDockItem.vala"
	_data12_->menu_items = _tmp1_;
#line 273 "../lib/Items/FileDockItem.vala"
	_tmp2_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 273 "../lib/Items/FileDockItem.vala"
	_data12_->keys = _tmp2_;
#line 275 "../lib/Items/FileDockItem.vala"
	_tmp3_ = self->priv->_OwnedFile;
#line 275 "../lib/Items/FileDockItem.vala"
	_tmp4_ = plank_file_dock_item_get_files (_tmp3_);
#line 275 "../lib/Items/FileDockItem.vala"
	_tmp5_ = _tmp4_;
#line 275 "../lib/Items/FileDockItem.vala"
	_tmp6_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp5_);
#line 275 "../lib/Items/FileDockItem.vala"
	_tmp7_ = _tmp6_;
#line 275 "../lib/Items/FileDockItem.vala"
	gee_map_iterator_foreach (_tmp7_, ___lambda17__gee_forall_map_func, _data12_);
#line 275 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (_tmp7_);
#line 275 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (_tmp5_);
#line 305 "../lib/Items/FileDockItem.vala"
	_tmp8_ = _data12_->keys;
#line 305 "../lib/Items/FileDockItem.vala"
	gee_list_sort ((GeeList*) _tmp8_, NULL, NULL, NULL);
#line 1770 "FileDockItem.c"
	{
		GeeArrayList* _s_list = NULL;
		GeeArrayList* _tmp9_;
		gint _s_size = 0;
		GeeArrayList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _s_index = 0;
#line 306 "../lib/Items/FileDockItem.vala"
		_tmp9_ = _data12_->keys;
#line 306 "../lib/Items/FileDockItem.vala"
		_s_list = _tmp9_;
#line 306 "../lib/Items/FileDockItem.vala"
		_tmp10_ = _s_list;
#line 306 "../lib/Items/FileDockItem.vala"
		_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 306 "../lib/Items/FileDockItem.vala"
		_tmp12_ = _tmp11_;
#line 306 "../lib/Items/FileDockItem.vala"
		_s_size = _tmp12_;
#line 306 "../lib/Items/FileDockItem.vala"
		_s_index = -1;
#line 306 "../lib/Items/FileDockItem.vala"
		while (TRUE) {
#line 1795 "FileDockItem.c"
			gint _tmp13_;
			gint _tmp14_;
			gchar* s = NULL;
			GeeArrayList* _tmp15_;
			gpointer _tmp16_;
			GeeArrayList* _tmp17_;
			GeeHashMap* _tmp18_;
			const gchar* _tmp19_;
			gpointer _tmp20_;
			GtkMenuItem* _tmp21_;
#line 306 "../lib/Items/FileDockItem.vala"
			_s_index = _s_index + 1;
#line 306 "../lib/Items/FileDockItem.vala"
			_tmp13_ = _s_index;
#line 306 "../lib/Items/FileDockItem.vala"
			_tmp14_ = _s_size;
#line 306 "../lib/Items/FileDockItem.vala"
			if (!(_tmp13_ < _tmp14_)) {
#line 306 "../lib/Items/FileDockItem.vala"
				break;
#line 1816 "FileDockItem.c"
			}
#line 306 "../lib/Items/FileDockItem.vala"
			_tmp15_ = _s_list;
#line 306 "../lib/Items/FileDockItem.vala"
			_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _s_index);
#line 306 "../lib/Items/FileDockItem.vala"
			s = (gchar*) _tmp16_;
#line 307 "../lib/Items/FileDockItem.vala"
			_tmp17_ = items;
#line 307 "../lib/Items/FileDockItem.vala"
			_tmp18_ = _data12_->menu_items;
#line 307 "../lib/Items/FileDockItem.vala"
			_tmp19_ = s;
#line 307 "../lib/Items/FileDockItem.vala"
			_tmp20_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, _tmp19_);
#line 307 "../lib/Items/FileDockItem.vala"
			_tmp21_ = (GtkMenuItem*) _tmp20_;
#line 307 "../lib/Items/FileDockItem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp21_);
#line 307 "../lib/Items/FileDockItem.vala"
			_g_object_unref0 (_tmp21_);
#line 306 "../lib/Items/FileDockItem.vala"
			_g_free0 (s);
#line 1840 "FileDockItem.c"
		}
	}
#line 309 "../lib/Items/FileDockItem.vala"
	_tmp22_ = _data12_->keys;
#line 309 "../lib/Items/FileDockItem.vala"
	_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 309 "../lib/Items/FileDockItem.vala"
	_tmp24_ = _tmp23_;
#line 309 "../lib/Items/FileDockItem.vala"
	if (_tmp24_ > 0) {
#line 1851 "FileDockItem.c"
		GeeArrayList* _tmp25_;
		GtkSeparatorMenuItem* _tmp26_;
		GtkSeparatorMenuItem* _tmp27_;
#line 310 "../lib/Items/FileDockItem.vala"
		_tmp25_ = items;
#line 310 "../lib/Items/FileDockItem.vala"
		_tmp26_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 310 "../lib/Items/FileDockItem.vala"
		g_object_ref_sink (_tmp26_);
#line 310 "../lib/Items/FileDockItem.vala"
		_tmp27_ = _tmp26_;
#line 310 "../lib/Items/FileDockItem.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, (GtkMenuItem*) _tmp27_);
#line 310 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (_tmp27_);
#line 1867 "FileDockItem.c"
	}
#line 312 "../lib/Items/FileDockItem.vala"
	_tmp28_ = plank_dock_element_get_Container ((PlankDockElement*) self);
#line 312 "../lib/Items/FileDockItem.vala"
	_tmp29_ = _tmp28_;
#line 312 "../lib/Items/FileDockItem.vala"
	default_provider = PLANK_IS_DEFAULT_APPLICATION_DOCK_ITEM_PROVIDER (_tmp29_) ? ((PlankDefaultApplicationDockItemProvider*) _tmp29_) : NULL;
#line 313 "../lib/Items/FileDockItem.vala"
	_tmp31_ = default_provider;
#line 313 "../lib/Items/FileDockItem.vala"
	if (_tmp31_ != NULL) {
#line 1879 "FileDockItem.c"
		PlankDefaultApplicationDockItemProvider* _tmp32_;
		PlankDockPreferences* _tmp33_;
		PlankDockPreferences* _tmp34_;
		gboolean _tmp35_;
		gboolean _tmp36_;
#line 314 "../lib/Items/FileDockItem.vala"
		_tmp32_ = default_provider;
#line 314 "../lib/Items/FileDockItem.vala"
		_tmp33_ = plank_default_application_dock_item_provider_get_Prefs (_tmp32_);
#line 314 "../lib/Items/FileDockItem.vala"
		_tmp34_ = _tmp33_;
#line 314 "../lib/Items/FileDockItem.vala"
		_tmp35_ = plank_dock_preferences_get_LockItems (_tmp34_);
#line 314 "../lib/Items/FileDockItem.vala"
		_tmp36_ = _tmp35_;
#line 314 "../lib/Items/FileDockItem.vala"
		_tmp30_ = !_tmp36_;
#line 1897 "FileDockItem.c"
	} else {
#line 313 "../lib/Items/FileDockItem.vala"
		_tmp30_ = FALSE;
#line 1901 "FileDockItem.c"
	}
#line 313 "../lib/Items/FileDockItem.vala"
	if (_tmp30_) {
#line 1905 "FileDockItem.c"
		GtkCheckMenuItem* delete_item = NULL;
		GtkCheckMenuItem* _tmp37_;
		GtkCheckMenuItem* _tmp38_;
		GtkCheckMenuItem* _tmp39_;
		GeeArrayList* _tmp40_;
		GtkCheckMenuItem* _tmp41_;
#line 315 "../lib/Items/FileDockItem.vala"
		_tmp37_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_mnemonic (_ ("_Keep in Dock"));
#line 315 "../lib/Items/FileDockItem.vala"
		g_object_ref_sink (_tmp37_);
#line 315 "../lib/Items/FileDockItem.vala"
		delete_item = _tmp37_;
#line 316 "../lib/Items/FileDockItem.vala"
		_tmp38_ = delete_item;
#line 316 "../lib/Items/FileDockItem.vala"
		gtk_check_menu_item_set_active (_tmp38_, TRUE);
#line 317 "../lib/Items/FileDockItem.vala"
		_tmp39_ = delete_item;
#line 317 "../lib/Items/FileDockItem.vala"
		g_signal_connect_object ((GtkMenuItem*) _tmp39_, "activate", (GCallback) ____lambda20__gtk_menu_item_activate, self, 0);
#line 318 "../lib/Items/FileDockItem.vala"
		_tmp40_ = items;
#line 318 "../lib/Items/FileDockItem.vala"
		_tmp41_ = delete_item;
#line 318 "../lib/Items/FileDockItem.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp40_, (GtkMenuItem*) _tmp41_);
#line 313 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (delete_item);
#line 1934 "FileDockItem.c"
	}
#line 321 "../lib/Items/FileDockItem.vala"
	_tmp42_ = plank_dock_element_create_menu_item (_ ("_Open in File Browser"), "gtk-open", FALSE);
#line 321 "../lib/Items/FileDockItem.vala"
	item = _tmp42_;
#line 322 "../lib/Items/FileDockItem.vala"
	g_signal_connect_object (item, "activate", (GCallback) ___lambda21__gtk_menu_item_activate, self, 0);
#line 325 "../lib/Items/FileDockItem.vala"
	_tmp43_ = items;
#line 325 "../lib/Items/FileDockItem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, item);
#line 327 "../lib/Items/FileDockItem.vala"
	result = items;
#line 327 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (item);
#line 327 "../lib/Items/FileDockItem.vala"
	block12_data_unref (_data12_);
#line 327 "../lib/Items/FileDockItem.vala"
	_data12_ = NULL;
#line 327 "../lib/Items/FileDockItem.vala"
	return result;
#line 1956 "FileDockItem.c"
}

static void
___lambda22_ (PlankFileDockItem* self)
{
#line 339 "../lib/Items/FileDockItem.vala"
	plank_dock_item_delete ((PlankDockItem*) self);
#line 1964 "FileDockItem.c"
}

static void
____lambda22__gtk_menu_item_activate (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 339 "../lib/Items/FileDockItem.vala"
	___lambda22_ ((PlankFileDockItem*) self);
#line 1973 "FileDockItem.c"
}

static void
_plank_file_dock_item_launch_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                     gpointer self)
{
#line 344 "../lib/Items/FileDockItem.vala"
	plank_file_dock_item_launch ((PlankFileDockItem*) self);
#line 1982 "FileDockItem.c"
}

static void
__lambda23_ (PlankFileDockItem* self)
{
	PlankSystem* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 349 "../lib/Items/FileDockItem.vala"
	_tmp0_ = plank_system_get_default ();
#line 349 "../lib/Items/FileDockItem.vala"
	_tmp1_ = self->priv->_OwnedFile;
#line 349 "../lib/Items/FileDockItem.vala"
	_tmp2_ = g_file_get_parent (_tmp1_);
#line 349 "../lib/Items/FileDockItem.vala"
	_tmp3_ = _tmp2_;
#line 349 "../lib/Items/FileDockItem.vala"
	plank_system_open (_tmp0_, _tmp3_);
#line 349 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (_tmp3_);
#line 350 "../lib/Items/FileDockItem.vala"
	plank_dock_element_set_ClickedAnimation ((PlankDockElement*) self, PLANK_ANIMATION_TYPE_BOUNCE);
#line 351 "../lib/Items/FileDockItem.vala"
	plank_dock_element_set_LastClicked ((PlankDockElement*) self, g_get_monotonic_time ());
#line 2008 "FileDockItem.c"
}

static void
___lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 348 "../lib/Items/FileDockItem.vala"
	__lambda23_ ((PlankFileDockItem*) self);
#line 2017 "FileDockItem.c"
}

static GeeArrayList*
plank_file_dock_item_get_file_menu_items (PlankFileDockItem* self)
{
	GeeArrayList* items = NULL;
	GeeArrayList* _tmp0_;
	PlankDefaultApplicationDockItemProvider* default_provider = NULL;
	PlankDockContainer* _tmp1_;
	PlankDockContainer* _tmp2_;
	gboolean _tmp3_ = FALSE;
	PlankDefaultApplicationDockItemProvider* _tmp4_;
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	GeeArrayList* _tmp17_;
	GtkMenuItem* _tmp18_;
	GtkMenuItem* _tmp19_;
	GtkMenuItem* _tmp20_;
	GeeArrayList* _tmp21_;
	GtkMenuItem* _tmp22_;
	GeeArrayList* result;
#line 330 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 332 "../lib/Items/FileDockItem.vala"
	_tmp0_ = gee_array_list_new (gtk_menu_item_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 332 "../lib/Items/FileDockItem.vala"
	items = _tmp0_;
#line 334 "../lib/Items/FileDockItem.vala"
	_tmp1_ = plank_dock_element_get_Container ((PlankDockElement*) self);
#line 334 "../lib/Items/FileDockItem.vala"
	_tmp2_ = _tmp1_;
#line 334 "../lib/Items/FileDockItem.vala"
	default_provider = PLANK_IS_DEFAULT_APPLICATION_DOCK_ITEM_PROVIDER (_tmp2_) ? ((PlankDefaultApplicationDockItemProvider*) _tmp2_) : NULL;
#line 335 "../lib/Items/FileDockItem.vala"
	_tmp4_ = default_provider;
#line 335 "../lib/Items/FileDockItem.vala"
	if (_tmp4_ != NULL) {
#line 2056 "FileDockItem.c"
		PlankDefaultApplicationDockItemProvider* _tmp5_;
		PlankDockPreferences* _tmp6_;
		PlankDockPreferences* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 336 "../lib/Items/FileDockItem.vala"
		_tmp5_ = default_provider;
#line 336 "../lib/Items/FileDockItem.vala"
		_tmp6_ = plank_default_application_dock_item_provider_get_Prefs (_tmp5_);
#line 336 "../lib/Items/FileDockItem.vala"
		_tmp7_ = _tmp6_;
#line 336 "../lib/Items/FileDockItem.vala"
		_tmp8_ = plank_dock_preferences_get_LockItems (_tmp7_);
#line 336 "../lib/Items/FileDockItem.vala"
		_tmp9_ = _tmp8_;
#line 336 "../lib/Items/FileDockItem.vala"
		_tmp3_ = !_tmp9_;
#line 2074 "FileDockItem.c"
	} else {
#line 335 "../lib/Items/FileDockItem.vala"
		_tmp3_ = FALSE;
#line 2078 "FileDockItem.c"
	}
#line 335 "../lib/Items/FileDockItem.vala"
	if (_tmp3_) {
#line 2082 "FileDockItem.c"
		GtkCheckMenuItem* delete_item = NULL;
		GtkCheckMenuItem* _tmp10_;
		GtkCheckMenuItem* _tmp11_;
		GtkCheckMenuItem* _tmp12_;
		GeeArrayList* _tmp13_;
		GtkCheckMenuItem* _tmp14_;
#line 337 "../lib/Items/FileDockItem.vala"
		_tmp10_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_mnemonic (_ ("_Keep in Dock"));
#line 337 "../lib/Items/FileDockItem.vala"
		g_object_ref_sink (_tmp10_);
#line 337 "../lib/Items/FileDockItem.vala"
		delete_item = _tmp10_;
#line 338 "../lib/Items/FileDockItem.vala"
		_tmp11_ = delete_item;
#line 338 "../lib/Items/FileDockItem.vala"
		gtk_check_menu_item_set_active (_tmp11_, TRUE);
#line 339 "../lib/Items/FileDockItem.vala"
		_tmp12_ = delete_item;
#line 339 "../lib/Items/FileDockItem.vala"
		g_signal_connect_object ((GtkMenuItem*) _tmp12_, "activate", (GCallback) ____lambda22__gtk_menu_item_activate, self, 0);
#line 340 "../lib/Items/FileDockItem.vala"
		_tmp13_ = items;
#line 340 "../lib/Items/FileDockItem.vala"
		_tmp14_ = delete_item;
#line 340 "../lib/Items/FileDockItem.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, (GtkMenuItem*) _tmp14_);
#line 335 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (delete_item);
#line 2111 "FileDockItem.c"
	}
#line 343 "../lib/Items/FileDockItem.vala"
	_tmp15_ = plank_dock_element_create_menu_item (_ ("_Open"), "gtk-open", FALSE);
#line 343 "../lib/Items/FileDockItem.vala"
	item = _tmp15_;
#line 344 "../lib/Items/FileDockItem.vala"
	_tmp16_ = item;
#line 344 "../lib/Items/FileDockItem.vala"
	g_signal_connect_object (_tmp16_, "activate", (GCallback) _plank_file_dock_item_launch_gtk_menu_item_activate, self, 0);
#line 345 "../lib/Items/FileDockItem.vala"
	_tmp17_ = items;
#line 345 "../lib/Items/FileDockItem.vala"
	_tmp18_ = item;
#line 345 "../lib/Items/FileDockItem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
#line 347 "../lib/Items/FileDockItem.vala"
	_tmp19_ = plank_dock_element_create_menu_item (_ ("Open Containing _Folder"), "folder", FALSE);
#line 347 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (item);
#line 347 "../lib/Items/FileDockItem.vala"
	item = _tmp19_;
#line 348 "../lib/Items/FileDockItem.vala"
	_tmp20_ = item;
#line 348 "../lib/Items/FileDockItem.vala"
	g_signal_connect_object (_tmp20_, "activate", (GCallback) ___lambda23__gtk_menu_item_activate, self, 0);
#line 353 "../lib/Items/FileDockItem.vala"
	_tmp21_ = items;
#line 353 "../lib/Items/FileDockItem.vala"
	_tmp22_ = item;
#line 353 "../lib/Items/FileDockItem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
#line 355 "../lib/Items/FileDockItem.vala"
	result = items;
#line 355 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (item);
#line 355 "../lib/Items/FileDockItem.vala"
	return result;
#line 2149 "FileDockItem.c"
}

static GeeHashMap*
plank_file_dock_item_get_files (GFile* file)
{
	GeeHashMap* files = NULL;
	GeeHashMap* _tmp0_;
	guint count = 0U;
	GError* _inner_error0_ = NULL;
	GeeHashMap* result;
#line 358 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 360 "../lib/Items/FileDockItem.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 360 "../lib/Items/FileDockItem.vala"
	files = _tmp0_;
#line 361 "../lib/Items/FileDockItem.vala"
	count = 0U;
#line 2168 "FileDockItem.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp1_;
		GFileInfo* info = NULL;
#line 364 "../lib/Items/FileDockItem.vala"
		_tmp1_ = g_file_enumerate_children (file, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME "," G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN "," G_FILE_ATTRIBUTE_ACCESS_CAN_READ, 0, NULL, &_inner_error0_);
#line 364 "../lib/Items/FileDockItem.vala"
		enumerator = _tmp1_;
#line 364 "../lib/Items/FileDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2179 "FileDockItem.c"
			goto __catch0_g_error;
		}
#line 371 "../lib/Items/FileDockItem.vala"
		while (TRUE) {
#line 2184 "FileDockItem.c"
			GFileInfo* _tmp2_ = NULL;
			GFileEnumerator* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			guint _tmp8_;
			const gchar* name = NULL;
			GFileInfo* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_ = NULL;
			GFileInfo* _tmp14_;
			const gchar* _tmp15_;
			GeeHashMap* _tmp17_;
			const gchar* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
#line 371 "../lib/Items/FileDockItem.vala"
			_tmp3_ = enumerator;
#line 371 "../lib/Items/FileDockItem.vala"
			_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error0_);
#line 371 "../lib/Items/FileDockItem.vala"
			_tmp2_ = _tmp4_;
#line 371 "../lib/Items/FileDockItem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 371 "../lib/Items/FileDockItem.vala"
				_g_object_unref0 (info);
#line 371 "../lib/Items/FileDockItem.vala"
				_g_object_unref0 (enumerator);
#line 2214 "FileDockItem.c"
				goto __catch0_g_error;
			}
#line 371 "../lib/Items/FileDockItem.vala"
			_tmp5_ = _tmp2_;
#line 371 "../lib/Items/FileDockItem.vala"
			_tmp2_ = NULL;
#line 371 "../lib/Items/FileDockItem.vala"
			_g_object_unref0 (info);
#line 371 "../lib/Items/FileDockItem.vala"
			info = _tmp5_;
#line 371 "../lib/Items/FileDockItem.vala"
			_tmp6_ = info;
#line 371 "../lib/Items/FileDockItem.vala"
			if (!(_tmp6_ != NULL)) {
#line 371 "../lib/Items/FileDockItem.vala"
				_g_object_unref0 (_tmp2_);
#line 371 "../lib/Items/FileDockItem.vala"
				break;
#line 2233 "FileDockItem.c"
			}
#line 372 "../lib/Items/FileDockItem.vala"
			_tmp7_ = info;
#line 372 "../lib/Items/FileDockItem.vala"
			if (g_file_info_get_is_hidden (_tmp7_)) {
#line 373 "../lib/Items/FileDockItem.vala"
				_g_object_unref0 (_tmp2_);
#line 373 "../lib/Items/FileDockItem.vala"
				continue;
#line 2243 "FileDockItem.c"
			}
#line 375 "../lib/Items/FileDockItem.vala"
			_tmp8_ = count;
#line 375 "../lib/Items/FileDockItem.vala"
			count = _tmp8_ + 1;
#line 375 "../lib/Items/FileDockItem.vala"
			if (_tmp8_ >= PLANK_FOLDER_MAX_FILE_COUNT) {
#line 2251 "FileDockItem.c"
				gchar* _tmp9_;
				gchar* _tmp10_;
#line 376 "../lib/Items/FileDockItem.vala"
				_tmp9_ = g_file_get_path (file);
#line 376 "../lib/Items/FileDockItem.vala"
				_tmp10_ = _tmp9_;
#line 376 "../lib/Items/FileDockItem.vala"
				g_critical ("FileDockItem.vala:376: There are way too many files (%u+) in '%s'.", PLANK_FOLDER_MAX_FILE_COUNT, _tmp10_);
#line 376 "../lib/Items/FileDockItem.vala"
				_g_free0 (_tmp10_);
#line 377 "../lib/Items/FileDockItem.vala"
				_g_object_unref0 (_tmp2_);
#line 377 "../lib/Items/FileDockItem.vala"
				break;
#line 2266 "FileDockItem.c"
			}
#line 380 "../lib/Items/FileDockItem.vala"
			_tmp11_ = info;
#line 380 "../lib/Items/FileDockItem.vala"
			_tmp12_ = g_file_info_get_name (_tmp11_);
#line 380 "../lib/Items/FileDockItem.vala"
			name = _tmp12_;
#line 381 "../lib/Items/FileDockItem.vala"
			_tmp14_ = info;
#line 381 "../lib/Items/FileDockItem.vala"
			_tmp15_ = g_file_info_get_display_name (_tmp14_);
#line 381 "../lib/Items/FileDockItem.vala"
			_tmp13_ = _tmp15_;
#line 381 "../lib/Items/FileDockItem.vala"
			if (_tmp13_ == NULL) {
#line 2282 "FileDockItem.c"
				const gchar* _tmp16_;
#line 381 "../lib/Items/FileDockItem.vala"
				_tmp16_ = name;
#line 381 "../lib/Items/FileDockItem.vala"
				_tmp13_ = _tmp16_;
#line 2288 "FileDockItem.c"
			}
#line 381 "../lib/Items/FileDockItem.vala"
			_tmp17_ = files;
#line 381 "../lib/Items/FileDockItem.vala"
			_tmp18_ = name;
#line 381 "../lib/Items/FileDockItem.vala"
			_tmp19_ = g_file_get_child (file, _tmp18_);
#line 381 "../lib/Items/FileDockItem.vala"
			_tmp20_ = _tmp19_;
#line 381 "../lib/Items/FileDockItem.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, _tmp13_, _tmp20_);
#line 381 "../lib/Items/FileDockItem.vala"
			_g_object_unref0 (_tmp20_);
#line 371 "../lib/Items/FileDockItem.vala"
			_g_object_unref0 (_tmp2_);
#line 2304 "FileDockItem.c"
		}
#line 363 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (info);
#line 363 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (enumerator);
#line 2310 "FileDockItem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 363 "../lib/Items/FileDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 2317 "FileDockItem.c"
	}
	__finally0:
#line 363 "../lib/Items/FileDockItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 363 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (files);
#line 363 "../lib/Items/FileDockItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 363 "../lib/Items/FileDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 363 "../lib/Items/FileDockItem.vala"
		return NULL;
#line 2330 "FileDockItem.c"
	}
#line 385 "../lib/Items/FileDockItem.vala"
	result = files;
#line 385 "../lib/Items/FileDockItem.vala"
	return result;
#line 2336 "FileDockItem.c"
}

static gchar*
plank_file_dock_item_get_display_name (GFile* file)
{
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 388 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 2349 "FileDockItem.c"
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp0_;
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_;
		gchar* _tmp4_;
#line 391 "../lib/Items/FileDockItem.vala"
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME, 0, NULL, &_inner_error0_);
#line 391 "../lib/Items/FileDockItem.vala"
		info = _tmp0_;
#line 391 "../lib/Items/FileDockItem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2362 "FileDockItem.c"
			goto __catch0_g_error;
		}
#line 392 "../lib/Items/FileDockItem.vala"
		_tmp2_ = g_file_info_get_display_name (info);
#line 392 "../lib/Items/FileDockItem.vala"
		_tmp1_ = _tmp2_;
#line 392 "../lib/Items/FileDockItem.vala"
		if (_tmp1_ == NULL) {
#line 2371 "FileDockItem.c"
			const gchar* _tmp3_;
#line 392 "../lib/Items/FileDockItem.vala"
			_tmp3_ = g_file_info_get_name (info);
#line 392 "../lib/Items/FileDockItem.vala"
			_tmp1_ = _tmp3_;
#line 2377 "FileDockItem.c"
		}
#line 392 "../lib/Items/FileDockItem.vala"
		_tmp4_ = g_strdup (_tmp1_);
#line 392 "../lib/Items/FileDockItem.vala"
		result = _tmp4_;
#line 392 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (info);
#line 392 "../lib/Items/FileDockItem.vala"
		return result;
#line 2387 "FileDockItem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 390 "../lib/Items/FileDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 2394 "FileDockItem.c"
	}
	__finally0:
#line 390 "../lib/Items/FileDockItem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 390 "../lib/Items/FileDockItem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 390 "../lib/Items/FileDockItem.vala"
		g_clear_error (&_inner_error0_);
#line 390 "../lib/Items/FileDockItem.vala"
		return NULL;
#line 2405 "FileDockItem.c"
	}
#line 395 "../lib/Items/FileDockItem.vala"
	_tmp6_ = g_file_get_path (file);
#line 395 "../lib/Items/FileDockItem.vala"
	_tmp5_ = _tmp6_;
#line 395 "../lib/Items/FileDockItem.vala"
	if (_tmp5_ == NULL) {
#line 2413 "FileDockItem.c"
		gchar* _tmp7_;
#line 395 "../lib/Items/FileDockItem.vala"
		_tmp7_ = g_strdup ("");
#line 395 "../lib/Items/FileDockItem.vala"
		_g_free0 (_tmp5_);
#line 395 "../lib/Items/FileDockItem.vala"
		_tmp5_ = _tmp7_;
#line 2421 "FileDockItem.c"
	}
#line 395 "../lib/Items/FileDockItem.vala"
	g_debug ("FileDockItem.vala:395: Could not get display-name for '%s'", _tmp5_);
#line 397 "../lib/Items/FileDockItem.vala"
	_tmp8_ = g_strdup ("Unknown");
#line 397 "../lib/Items/FileDockItem.vala"
	result = _tmp8_;
#line 397 "../lib/Items/FileDockItem.vala"
	_g_free0 (_tmp5_);
#line 397 "../lib/Items/FileDockItem.vala"
	return result;
#line 2433 "FileDockItem.c"
}

PlankFileDockItem*
plank_file_dock_item_construct (GType object_type)
{
	PlankFileDockItem * self = NULL;
#line 28 "../lib/Items/FileDockItem.vala"
	self = (PlankFileDockItem*) plank_dock_item_construct (object_type);
#line 28 "../lib/Items/FileDockItem.vala"
	return self;
#line 2444 "FileDockItem.c"
}

PlankFileDockItem*
plank_file_dock_item_new (void)
{
#line 28 "../lib/Items/FileDockItem.vala"
	return plank_file_dock_item_construct (PLANK_TYPE_FILE_DOCK_ITEM);
#line 2452 "FileDockItem.c"
}

GFile*
plank_file_dock_item_get_OwnedFile (PlankFileDockItem* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 32 "../lib/Items/FileDockItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../lib/Items/FileDockItem.vala"
	_tmp0_ = self->priv->_OwnedFile;
#line 32 "../lib/Items/FileDockItem.vala"
	result = _tmp0_;
#line 32 "../lib/Items/FileDockItem.vala"
	return result;
#line 2468 "FileDockItem.c"
}

void
plank_file_dock_item_set_OwnedFile (PlankFileDockItem* self,
                                    GFile* value)
{
	GFile* old_value;
#line 32 "../lib/Items/FileDockItem.vala"
	g_return_if_fail (self != NULL);
#line 32 "../lib/Items/FileDockItem.vala"
	old_value = plank_file_dock_item_get_OwnedFile (self);
#line 32 "../lib/Items/FileDockItem.vala"
	if (old_value != value) {
#line 2482 "FileDockItem.c"
		GFile* _tmp0_;
#line 32 "../lib/Items/FileDockItem.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 32 "../lib/Items/FileDockItem.vala"
		_g_object_unref0 (self->priv->_OwnedFile);
#line 32 "../lib/Items/FileDockItem.vala"
		self->priv->_OwnedFile = _tmp0_;
#line 32 "../lib/Items/FileDockItem.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_file_dock_item_properties[PLANK_FILE_DOCK_ITEM_OWNED_FILE_PROPERTY]);
#line 2492 "FileDockItem.c"
	}
}

static GObject *
plank_file_dock_item_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankFileDockItem * self;
#line 67 "../lib/Items/FileDockItem.vala"
	parent_class = G_OBJECT_CLASS (plank_file_dock_item_parent_class);
#line 67 "../lib/Items/FileDockItem.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 67 "../lib/Items/FileDockItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_FILE_DOCK_ITEM, PlankFileDockItem);
#line 69 "../lib/Items/FileDockItem.vala"
	plank_dock_item_load_from_launcher ((PlankDockItem*) self);
#line 67 "../lib/Items/FileDockItem.vala"
	return obj;
#line 2514 "FileDockItem.c"
}

static void
plank_file_dock_item_class_init (PlankFileDockItemClass * klass,
                                 gpointer klass_data)
{
#line 28 "../lib/Items/FileDockItem.vala"
	plank_file_dock_item_parent_class = g_type_class_peek_parent (klass);
#line 28 "../lib/Items/FileDockItem.vala"
	g_type_class_adjust_private_offset (klass, &PlankFileDockItem_private_offset);
#line 28 "../lib/Items/FileDockItem.vala"
	((PlankDockItemClass *) klass)->load_from_launcher = (void (*) (PlankDockItem*)) plank_file_dock_item_real_load_from_launcher;
#line 28 "../lib/Items/FileDockItem.vala"
	((PlankDockItemClass *) klass)->draw_icon_fast = (void (*) (PlankDockItem*, PlankSurface*)) plank_file_dock_item_real_draw_icon_fast;
#line 28 "../lib/Items/FileDockItem.vala"
	((PlankDockItemClass *) klass)->draw_icon = (void (*) (PlankDockItem*, PlankSurface*)) plank_file_dock_item_real_draw_icon;
#line 28 "../lib/Items/FileDockItem.vala"
	((PlankDockElementClass *) klass)->on_clicked = (PlankAnimationType (*) (PlankDockElement*, PlankPopupButton, GdkModifierType, guint32)) plank_file_dock_item_real_on_clicked;
#line 28 "../lib/Items/FileDockItem.vala"
	((PlankDockElementClass *) klass)->get_menu_items = (GeeArrayList* (*) (PlankDockElement*)) plank_file_dock_item_real_get_menu_items;
#line 28 "../lib/Items/FileDockItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_file_dock_item_get_property;
#line 28 "../lib/Items/FileDockItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_file_dock_item_set_property;
#line 28 "../lib/Items/FileDockItem.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_file_dock_item_constructor;
#line 28 "../lib/Items/FileDockItem.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_file_dock_item_finalize;
#line 28 "../lib/Items/FileDockItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_FILE_DOCK_ITEM_OWNED_FILE_PROPERTY, plank_file_dock_item_properties[PLANK_FILE_DOCK_ITEM_OWNED_FILE_PROPERTY] = g_param_spec_object ("OwnedFile", "OwnedFile", "OwnedFile", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 2545 "FileDockItem.c"
}

static void
plank_file_dock_item_instance_init (PlankFileDockItem * self,
                                    gpointer klass)
{
#line 28 "../lib/Items/FileDockItem.vala"
	self->priv = plank_file_dock_item_get_instance_private (self);
#line 2554 "FileDockItem.c"
}

static void
plank_file_dock_item_finalize (GObject * obj)
{
	PlankFileDockItem * self;
#line 28 "../lib/Items/FileDockItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_FILE_DOCK_ITEM, PlankFileDockItem);
#line 74 "../lib/Items/FileDockItem.vala"
	plank_file_dock_item_stop_monitor (self);
#line 32 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (self->priv->_OwnedFile);
#line 34 "../lib/Items/FileDockItem.vala"
	_g_object_unref0 (self->priv->dir_monitor);
#line 28 "../lib/Items/FileDockItem.vala"
	G_OBJECT_CLASS (plank_file_dock_item_parent_class)->finalize (obj);
#line 2571 "FileDockItem.c"
}

/**
 * A dock item for files or folders on the dock.
 *
 * Folders act like stacks and display the contents of the folder in the
 * popup menu. Files just open the associated file.
 */
static GType
plank_file_dock_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankFileDockItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_file_dock_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankFileDockItem), 0, (GInstanceInitFunc) plank_file_dock_item_instance_init, NULL };
	GType plank_file_dock_item_type_id;
	plank_file_dock_item_type_id = g_type_register_static (PLANK_TYPE_DOCK_ITEM, "PlankFileDockItem", &g_define_type_info, 0);
	PlankFileDockItem_private_offset = g_type_add_instance_private (plank_file_dock_item_type_id, sizeof (PlankFileDockItemPrivate));
	return plank_file_dock_item_type_id;
}

GType
plank_file_dock_item_get_type (void)
{
	static volatile gsize plank_file_dock_item_type_id__once = 0;
	if (g_once_init_enter (&plank_file_dock_item_type_id__once)) {
		GType plank_file_dock_item_type_id;
		plank_file_dock_item_type_id = plank_file_dock_item_get_type_once ();
		g_once_init_leave (&plank_file_dock_item_type_id__once, plank_file_dock_item_type_id);
	}
	return plank_file_dock_item_type_id__once;
}

static void
_vala_plank_file_dock_item_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	PlankFileDockItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_FILE_DOCK_ITEM, PlankFileDockItem);
#line 28 "../lib/Items/FileDockItem.vala"
	switch (property_id) {
#line 28 "../lib/Items/FileDockItem.vala"
		case PLANK_FILE_DOCK_ITEM_OWNED_FILE_PROPERTY:
#line 28 "../lib/Items/FileDockItem.vala"
		g_value_set_object (value, plank_file_dock_item_get_OwnedFile (self));
#line 28 "../lib/Items/FileDockItem.vala"
		break;
#line 2618 "FileDockItem.c"
		default:
#line 28 "../lib/Items/FileDockItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../lib/Items/FileDockItem.vala"
		break;
#line 2624 "FileDockItem.c"
	}
}

static void
_vala_plank_file_dock_item_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	PlankFileDockItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_FILE_DOCK_ITEM, PlankFileDockItem);
#line 28 "../lib/Items/FileDockItem.vala"
	switch (property_id) {
#line 28 "../lib/Items/FileDockItem.vala"
		case PLANK_FILE_DOCK_ITEM_OWNED_FILE_PROPERTY:
#line 28 "../lib/Items/FileDockItem.vala"
		plank_file_dock_item_set_OwnedFile (self, g_value_get_object (value));
#line 28 "../lib/Items/FileDockItem.vala"
		break;
#line 2644 "FileDockItem.c"
		default:
#line 28 "../lib/Items/FileDockItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../lib/Items/FileDockItem.vala"
		break;
#line 2650 "FileDockItem.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 52 "../lib/Docklets/DockletManager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2661 "FileDockItem.c"
		gssize i;
#line 52 "../lib/Docklets/DockletManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 52 "../lib/Docklets/DockletManager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 52 "../lib/Docklets/DockletManager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2669 "FileDockItem.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 52 "../lib/Docklets/DockletManager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 52 "../lib/Docklets/DockletManager.vala"
	g_free (array);
#line 2684 "FileDockItem.c"
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
#line 52 "../lib/Docklets/DockletManager.vala"
	if (array) {
#line 52 "../lib/Docklets/DockletManager.vala"
		while (((gpointer*) array)[length]) {
#line 52 "../lib/Docklets/DockletManager.vala"
			length++;
#line 2698 "FileDockItem.c"
		}
	}
#line 52 "../lib/Docklets/DockletManager.vala"
	return length;
#line 2703 "FileDockItem.c"
}

