/* PreferencesWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from PreferencesWindow.vala, do not modify */

/**/
/*  Copyright (C) 2014 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include "plank-internal.h"
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_PREFERENCES_WINDOW_0_PROPERTY,
	PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY,
	PLANK_PREFERENCES_WINDOW_NUM_PROPERTIES
};
static GParamSpec* plank_preferences_window_properties[PLANK_PREFERENCES_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _PlankPreferencesWindowPrivate {
	PlankDockController* _controller;
	PlankDockPreferences* prefs;
	GtkComboBoxText* cb_theme;
	GtkComboBoxText* cb_hidemode;
	GtkComboBoxText* cb_display_plug;
	GtkComboBoxText* cb_position;
	GtkComboBoxText* cb_alignment;
	GtkComboBoxText* cb_items_alignment;
	GtkSpinButton* sp_hide_delay;
	GtkSpinButton* sp_unhide_delay;
	GtkScale* s_offset;
	GtkAdjustment* adj_hide_delay;
	GtkAdjustment* adj_unhide_delay;
	GtkAdjustment* adj_iconsize;
	GtkAdjustment* adj_offset;
	GtkSwitch* sw_hide;
	GtkSwitch* sw_primary_display;
	GtkSwitch* sw_workspace_only;
	GtkSwitch* sw_show_unpinned;
	GtkSwitch* sw_lock_items;
	GtkSwitch* sw_pressure_reveal;
	GtkIconView* view_docklets;
};

static gint PlankPreferencesWindow_private_offset;
static gpointer plank_preferences_window_parent_class = NULL;

static void plank_preferences_window_controller_changed (PlankPreferencesWindow* self);
static void plank_preferences_window_disconnect_signals (PlankPreferencesWindow* self);
static void plank_preferences_window_init_dock_tab (PlankPreferencesWindow* self);
static void plank_preferences_window_connect_signals (PlankPreferencesWindow* self);
static gboolean plank_preferences_window_real_key_press_event (GtkWidget* base,
                                                        GdkEventKey* event);
static void plank_preferences_window_prefs_changed (PlankPreferencesWindow* self,
                                             GObject* o,
                                             GParamSpec* prop);
static void plank_preferences_window_theme_changed (PlankPreferencesWindow* self,
                                             GtkComboBox* widget);
static void plank_preferences_window_hidemode_changed (PlankPreferencesWindow* self,
                                                GtkComboBox* widget);
static void plank_preferences_window_position_changed (PlankPreferencesWindow* self,
                                                GtkComboBox* widget);
static void plank_preferences_window_alignment_changed (PlankPreferencesWindow* self,
                                                 GtkComboBox* widget);
static void plank_preferences_window_items_alignment_changed (PlankPreferencesWindow* self,
                                                       GtkComboBox* widget);
static void plank_preferences_window_hide_toggled (PlankPreferencesWindow* self,
                                            GObject* widget,
                                            GParamSpec* param);
static void plank_preferences_window_primary_display_toggled (PlankPreferencesWindow* self,
                                                       GObject* widget,
                                                       GParamSpec* param);
static void plank_preferences_window_workspace_only_toggled (PlankPreferencesWindow* self,
                                                      GObject* widget,
                                                      GParamSpec* param);
static void plank_preferences_window_show_unpinned_toggled (PlankPreferencesWindow* self,
                                                     GObject* widget,
                                                     GParamSpec* param);
static void plank_preferences_window_lock_items_toggled (PlankPreferencesWindow* self,
                                                  GObject* widget,
                                                  GParamSpec* param);
static void plank_preferences_window_pressure_reveal_toggled (PlankPreferencesWindow* self,
                                                       GObject* widget,
                                                       GParamSpec* param);
static void plank_preferences_window_iconsize_changed (PlankPreferencesWindow* self,
                                                GtkAdjustment* adj);
static void plank_preferences_window_offset_changed (PlankPreferencesWindow* self,
                                              GtkAdjustment* adj);
static void plank_preferences_window_hide_delay_changed (PlankPreferencesWindow* self,
                                                  GtkAdjustment* adj);
static void plank_preferences_window_unhide_delay_changed (PlankPreferencesWindow* self,
                                                    GtkAdjustment* adj);
static void plank_preferences_window_monitor_changed (PlankPreferencesWindow* self,
                                               GtkComboBox* widget);
static void _plank_preferences_window_prefs_changed_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void _plank_preferences_window_theme_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                    gpointer self);
static void _plank_preferences_window_hidemode_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                       gpointer self);
static void _plank_preferences_window_position_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                       gpointer self);
static void _plank_preferences_window_hide_delay_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                                gpointer self);
static void _plank_preferences_window_unhide_delay_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                                  gpointer self);
static void _plank_preferences_window_monitor_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                      gpointer self);
static void _plank_preferences_window_iconsize_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                              gpointer self);
static void _plank_preferences_window_offset_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                            gpointer self);
static void _plank_preferences_window_hide_toggled_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void _plank_preferences_window_primary_display_toggled_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
static void _plank_preferences_window_workspace_only_toggled_g_object_notify (GObject* _sender,
                                                                       GParamSpec* pspec,
                                                                       gpointer self);
static void _plank_preferences_window_show_unpinned_toggled_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self);
static void _plank_preferences_window_lock_items_toggled_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void _plank_preferences_window_pressure_reveal_toggled_g_object_notify (GObject* _sender,
                                                                        GParamSpec* pspec,
                                                                        gpointer self);
static void _plank_preferences_window_alignment_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                        gpointer self);
static void _plank_preferences_window_items_alignment_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                              gpointer self);
static void plank_preferences_window_init_docklets_tab (PlankPreferencesWindow* self);
static void plank_preferences_window_view_drag_begin (GtkWidget* widget,
                                               GdkDragContext* context,
                                               PlankPreferencesWindow* self);
static void _plank_preferences_window_view_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                      GdkDragContext* context,
                                                                      gpointer self);
static void plank_preferences_window_view_item_activated (GtkIconView* view,
                                                   GtkTreePath* path,
                                                   PlankPreferencesWindow* self);
static void _plank_preferences_window_view_item_activated_gtk_icon_view_item_activated (GtkIconView* _sender,
                                                                                 GtkTreePath* path,
                                                                                 gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static GObject * plank_preferences_window_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _plank_preferences_window_controller_changed_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void plank_preferences_window_finalize (GObject * obj);
static GType plank_preferences_window_get_type_once (void);
static void _vala_plank_preferences_window_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_plank_preferences_window_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
plank_preferences_window_get_instance_private (PlankPreferencesWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PlankPreferencesWindow_private_offset);
}

PlankPreferencesWindow*
plank_preferences_window_construct (GType object_type,
                                    PlankDockController* controller)
{
	PlankPreferencesWindow * self = NULL;
#line 77 "../lib/Widgets/PreferencesWindow.vala"
	g_return_val_if_fail (controller != NULL, NULL);
#line 79 "../lib/Widgets/PreferencesWindow.vala"
	self = (PlankPreferencesWindow*) g_object_new (object_type, "controller", controller, NULL);
#line 77 "../lib/Widgets/PreferencesWindow.vala"
	return self;
#line 232 "PreferencesWindow.c"
}

PlankPreferencesWindow*
plank_preferences_window_new (PlankDockController* controller)
{
#line 77 "../lib/Widgets/PreferencesWindow.vala"
	return plank_preferences_window_construct (PLANK_TYPE_PREFERENCES_WINDOW, controller);
#line 240 "PreferencesWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 99 "../lib/Widgets/PreferencesWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 248 "PreferencesWindow.c"
}

static void
plank_preferences_window_controller_changed (PlankPreferencesWindow* self)
{
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	PlankDockPreferences* _tmp3_;
#line 95 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 97 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_disconnect_signals (self);
#line 99 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 99 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 99 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 99 "../lib/Widgets/PreferencesWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 99 "../lib/Widgets/PreferencesWindow.vala"
	_g_object_unref0 (self->priv->prefs);
#line 99 "../lib/Widgets/PreferencesWindow.vala"
	self->priv->prefs = _tmp3_;
#line 101 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_init_dock_tab (self);
#line 102 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_connect_signals (self);
#line 278 "PreferencesWindow.c"
}

static gboolean
plank_preferences_window_real_key_press_event (GtkWidget* base,
                                               GdkEventKey* event)
{
	PlankPreferencesWindow * self;
	gboolean result;
#line 105 "../lib/Widgets/PreferencesWindow.vala"
	self = (PlankPreferencesWindow*) base;
#line 105 "../lib/Widgets/PreferencesWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 107 "../lib/Widgets/PreferencesWindow.vala"
	if (event->keyval == GDK_KEY_Escape) {
#line 108 "../lib/Widgets/PreferencesWindow.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 295 "PreferencesWindow.c"
	}
#line 110 "../lib/Widgets/PreferencesWindow.vala"
	result = GTK_WIDGET_CLASS (plank_preferences_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), event);
#line 110 "../lib/Widgets/PreferencesWindow.vala"
	return result;
#line 301 "PreferencesWindow.c"
}

static void
plank_preferences_window_prefs_changed (PlankPreferencesWindow* self,
                                        GObject* o,
                                        GParamSpec* prop)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label0 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label1 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label2 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label3 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label4 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label5 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label6 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label7 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label8 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label9 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label10 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label11 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label12 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label13 = 0;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	static GQuark _tmp2_label14 = 0;
#line 113 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 113 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (o != NULL);
#line 113 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (prop != NULL);
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = prop->name;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = _tmp0_;
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 115 "../lib/Widgets/PreferencesWindow.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("Alignment")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 358 "PreferencesWindow.c"
			default:
			{
				GtkComboBoxText* _tmp4_;
				PlankDockPreferences* _tmp5_;
				GtkAlign _tmp6_;
				GtkAlign _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 117 "../lib/Widgets/PreferencesWindow.vala"
				_tmp4_ = self->priv->cb_alignment;
#line 117 "../lib/Widgets/PreferencesWindow.vala"
				_tmp5_ = self->priv->prefs;
#line 117 "../lib/Widgets/PreferencesWindow.vala"
				_tmp6_ = plank_dock_preferences_get_Alignment (_tmp5_);
#line 117 "../lib/Widgets/PreferencesWindow.vala"
				_tmp7_ = _tmp6_;
#line 117 "../lib/Widgets/PreferencesWindow.vala"
				_tmp8_ = g_strdup_printf ("%i", (gint) _tmp7_);
#line 117 "../lib/Widgets/PreferencesWindow.vala"
				_tmp9_ = _tmp8_;
#line 117 "../lib/Widgets/PreferencesWindow.vala"
				gtk_combo_box_set_active_id ((GtkComboBox*) _tmp4_, _tmp9_);
#line 117 "../lib/Widgets/PreferencesWindow.vala"
				_g_free0 (_tmp9_);
#line 118 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 385 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("CurrentWorkspaceOnly")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 391 "PreferencesWindow.c"
			default:
			{
				GtkSwitch* _tmp10_;
				PlankDockPreferences* _tmp11_;
				gboolean _tmp12_;
				gboolean _tmp13_;
#line 120 "../lib/Widgets/PreferencesWindow.vala"
				_tmp10_ = self->priv->sw_workspace_only;
#line 120 "../lib/Widgets/PreferencesWindow.vala"
				_tmp11_ = self->priv->prefs;
#line 120 "../lib/Widgets/PreferencesWindow.vala"
				_tmp12_ = plank_dock_preferences_get_CurrentWorkspaceOnly (_tmp11_);
#line 120 "../lib/Widgets/PreferencesWindow.vala"
				_tmp13_ = _tmp12_;
#line 120 "../lib/Widgets/PreferencesWindow.vala"
				gtk_switch_set_active (_tmp10_, _tmp13_);
#line 121 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 410 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("IconSize")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 416 "PreferencesWindow.c"
			default:
			{
				GtkAdjustment* _tmp14_;
				PlankDockPreferences* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
#line 123 "../lib/Widgets/PreferencesWindow.vala"
				_tmp14_ = self->priv->adj_iconsize;
#line 123 "../lib/Widgets/PreferencesWindow.vala"
				_tmp15_ = self->priv->prefs;
#line 123 "../lib/Widgets/PreferencesWindow.vala"
				_tmp16_ = plank_dock_preferences_get_IconSize (_tmp15_);
#line 123 "../lib/Widgets/PreferencesWindow.vala"
				_tmp17_ = _tmp16_;
#line 123 "../lib/Widgets/PreferencesWindow.vala"
				gtk_adjustment_set_value (_tmp14_, (gdouble) _tmp17_);
#line 124 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 435 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("ItemsAlignment")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 441 "PreferencesWindow.c"
			default:
			{
				GtkComboBoxText* _tmp18_;
				PlankDockPreferences* _tmp19_;
				GtkAlign _tmp20_;
				GtkAlign _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
#line 126 "../lib/Widgets/PreferencesWindow.vala"
				_tmp18_ = self->priv->cb_items_alignment;
#line 126 "../lib/Widgets/PreferencesWindow.vala"
				_tmp19_ = self->priv->prefs;
#line 126 "../lib/Widgets/PreferencesWindow.vala"
				_tmp20_ = plank_dock_preferences_get_ItemsAlignment (_tmp19_);
#line 126 "../lib/Widgets/PreferencesWindow.vala"
				_tmp21_ = _tmp20_;
#line 126 "../lib/Widgets/PreferencesWindow.vala"
				_tmp22_ = g_strdup_printf ("%i", (gint) _tmp21_);
#line 126 "../lib/Widgets/PreferencesWindow.vala"
				_tmp23_ = _tmp22_;
#line 126 "../lib/Widgets/PreferencesWindow.vala"
				gtk_combo_box_set_active_id ((GtkComboBox*) _tmp18_, _tmp23_);
#line 126 "../lib/Widgets/PreferencesWindow.vala"
				_g_free0 (_tmp23_);
#line 127 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 468 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("HideMode")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 474 "PreferencesWindow.c"
			default:
			{
				gboolean hide_none = FALSE;
				PlankDockPreferences* _tmp24_;
				PlankHideType _tmp25_;
				PlankHideType _tmp26_;
				GtkSwitch* _tmp27_;
#line 129 "../lib/Widgets/PreferencesWindow.vala"
				_tmp24_ = self->priv->prefs;
#line 129 "../lib/Widgets/PreferencesWindow.vala"
				_tmp25_ = plank_dock_preferences_get_HideMode (_tmp24_);
#line 129 "../lib/Widgets/PreferencesWindow.vala"
				_tmp26_ = _tmp25_;
#line 129 "../lib/Widgets/PreferencesWindow.vala"
				hide_none = _tmp26_ != PLANK_HIDE_TYPE_NONE;
#line 130 "../lib/Widgets/PreferencesWindow.vala"
				_tmp27_ = self->priv->sw_hide;
#line 130 "../lib/Widgets/PreferencesWindow.vala"
				gtk_switch_set_active (_tmp27_, hide_none);
#line 131 "../lib/Widgets/PreferencesWindow.vala"
				if (!hide_none) {
#line 496 "PreferencesWindow.c"
					GtkComboBoxText* _tmp28_;
					PlankDockPreferences* _tmp29_;
					PlankHideType _tmp30_;
					PlankHideType _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
#line 132 "../lib/Widgets/PreferencesWindow.vala"
					_tmp28_ = self->priv->cb_hidemode;
#line 132 "../lib/Widgets/PreferencesWindow.vala"
					_tmp29_ = self->priv->prefs;
#line 132 "../lib/Widgets/PreferencesWindow.vala"
					_tmp30_ = plank_dock_preferences_get_HideMode (_tmp29_);
#line 132 "../lib/Widgets/PreferencesWindow.vala"
					_tmp31_ = _tmp30_;
#line 132 "../lib/Widgets/PreferencesWindow.vala"
					_tmp32_ = g_strdup_printf ("%i", (gint) _tmp31_);
#line 132 "../lib/Widgets/PreferencesWindow.vala"
					_tmp33_ = _tmp32_;
#line 132 "../lib/Widgets/PreferencesWindow.vala"
					gtk_combo_box_set_active_id ((GtkComboBox*) _tmp28_, _tmp33_);
#line 132 "../lib/Widgets/PreferencesWindow.vala"
					_g_free0 (_tmp33_);
#line 519 "PreferencesWindow.c"
				}
#line 133 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 523 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("LockItems")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 529 "PreferencesWindow.c"
			default:
			{
				GtkSwitch* _tmp34_;
				PlankDockPreferences* _tmp35_;
				gboolean _tmp36_;
				gboolean _tmp37_;
#line 135 "../lib/Widgets/PreferencesWindow.vala"
				_tmp34_ = self->priv->sw_lock_items;
#line 135 "../lib/Widgets/PreferencesWindow.vala"
				_tmp35_ = self->priv->prefs;
#line 135 "../lib/Widgets/PreferencesWindow.vala"
				_tmp36_ = plank_dock_preferences_get_LockItems (_tmp35_);
#line 135 "../lib/Widgets/PreferencesWindow.vala"
				_tmp37_ = _tmp36_;
#line 135 "../lib/Widgets/PreferencesWindow.vala"
				gtk_switch_set_active (_tmp34_, _tmp37_);
#line 136 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 548 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("Monitor")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 554 "PreferencesWindow.c"
			default:
			{
				gint pos = 0;
				GdkScreen* _tmp38_;
				gint _tmp39_ = 0;
				gchar** _tmp40_;
#line 138 "../lib/Widgets/PreferencesWindow.vala"
				pos = 0;
#line 139 "../lib/Widgets/PreferencesWindow.vala"
				_tmp38_ = gtk_window_get_screen ((GtkWindow*) self);
#line 139 "../lib/Widgets/PreferencesWindow.vala"
				_tmp40_ = plank_position_manager_get_monitor_plug_names (_tmp38_, &_tmp39_);
#line 567 "PreferencesWindow.c"
				{
					gchar** plug_name_collection = NULL;
					gint plug_name_collection_length1 = 0;
					gint _plug_name_collection_size_ = 0;
					gint plug_name_it = 0;
#line 139 "../lib/Widgets/PreferencesWindow.vala"
					plug_name_collection = _tmp40_;
#line 139 "../lib/Widgets/PreferencesWindow.vala"
					plug_name_collection_length1 = _tmp39_;
#line 139 "../lib/Widgets/PreferencesWindow.vala"
					for (plug_name_it = 0; plug_name_it < plug_name_collection_length1; plug_name_it = plug_name_it + 1) {
#line 579 "PreferencesWindow.c"
						const gchar* plug_name = NULL;
#line 139 "../lib/Widgets/PreferencesWindow.vala"
						plug_name = plug_name_collection[plug_name_it];
#line 583 "PreferencesWindow.c"
						{
							const gchar* _tmp41_;
							PlankDockPreferences* _tmp42_;
							const gchar* _tmp43_;
							const gchar* _tmp44_;
							gint _tmp46_;
#line 140 "../lib/Widgets/PreferencesWindow.vala"
							_tmp41_ = plug_name;
#line 140 "../lib/Widgets/PreferencesWindow.vala"
							_tmp42_ = self->priv->prefs;
#line 140 "../lib/Widgets/PreferencesWindow.vala"
							_tmp43_ = plank_dock_preferences_get_Monitor (_tmp42_);
#line 140 "../lib/Widgets/PreferencesWindow.vala"
							_tmp44_ = _tmp43_;
#line 140 "../lib/Widgets/PreferencesWindow.vala"
							if (g_strcmp0 (_tmp41_, _tmp44_) == 0) {
#line 600 "PreferencesWindow.c"
								GtkComboBoxText* _tmp45_;
#line 141 "../lib/Widgets/PreferencesWindow.vala"
								_tmp45_ = self->priv->cb_display_plug;
#line 141 "../lib/Widgets/PreferencesWindow.vala"
								gtk_combo_box_set_active ((GtkComboBox*) _tmp45_, pos);
#line 606 "PreferencesWindow.c"
							}
#line 142 "../lib/Widgets/PreferencesWindow.vala"
							_tmp46_ = pos;
#line 142 "../lib/Widgets/PreferencesWindow.vala"
							pos = _tmp46_ + 1;
#line 612 "PreferencesWindow.c"
						}
					}
#line 139 "../lib/Widgets/PreferencesWindow.vala"
					plug_name_collection = (_vala_array_free (plug_name_collection, plug_name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 617 "PreferencesWindow.c"
				}
#line 144 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 621 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("Offset")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 627 "PreferencesWindow.c"
			default:
			{
				GtkAdjustment* _tmp47_;
				PlankDockPreferences* _tmp48_;
				gint _tmp49_;
				gint _tmp50_;
#line 146 "../lib/Widgets/PreferencesWindow.vala"
				_tmp47_ = self->priv->adj_offset;
#line 146 "../lib/Widgets/PreferencesWindow.vala"
				_tmp48_ = self->priv->prefs;
#line 146 "../lib/Widgets/PreferencesWindow.vala"
				_tmp49_ = plank_dock_preferences_get_Offset (_tmp48_);
#line 146 "../lib/Widgets/PreferencesWindow.vala"
				_tmp50_ = _tmp49_;
#line 146 "../lib/Widgets/PreferencesWindow.vala"
				gtk_adjustment_set_value (_tmp47_, (gdouble) _tmp50_);
#line 147 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 646 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("PinnedOnly")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 652 "PreferencesWindow.c"
			default:
			{
				GtkSwitch* _tmp51_;
				PlankDockPreferences* _tmp52_;
				gboolean _tmp53_;
				gboolean _tmp54_;
#line 149 "../lib/Widgets/PreferencesWindow.vala"
				_tmp51_ = self->priv->sw_show_unpinned;
#line 149 "../lib/Widgets/PreferencesWindow.vala"
				_tmp52_ = self->priv->prefs;
#line 149 "../lib/Widgets/PreferencesWindow.vala"
				_tmp53_ = plank_dock_preferences_get_PinnedOnly (_tmp52_);
#line 149 "../lib/Widgets/PreferencesWindow.vala"
				_tmp54_ = _tmp53_;
#line 149 "../lib/Widgets/PreferencesWindow.vala"
				gtk_switch_set_active (_tmp51_, !_tmp54_);
#line 150 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 671 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("Position")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 677 "PreferencesWindow.c"
			default:
			{
				GtkComboBoxText* _tmp55_;
				PlankDockPreferences* _tmp56_;
				GtkPositionType _tmp57_;
				GtkPositionType _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
#line 152 "../lib/Widgets/PreferencesWindow.vala"
				_tmp55_ = self->priv->cb_position;
#line 152 "../lib/Widgets/PreferencesWindow.vala"
				_tmp56_ = self->priv->prefs;
#line 152 "../lib/Widgets/PreferencesWindow.vala"
				_tmp57_ = plank_dock_preferences_get_Position (_tmp56_);
#line 152 "../lib/Widgets/PreferencesWindow.vala"
				_tmp58_ = _tmp57_;
#line 152 "../lib/Widgets/PreferencesWindow.vala"
				_tmp59_ = g_strdup_printf ("%i", (gint) _tmp58_);
#line 152 "../lib/Widgets/PreferencesWindow.vala"
				_tmp60_ = _tmp59_;
#line 152 "../lib/Widgets/PreferencesWindow.vala"
				gtk_combo_box_set_active_id ((GtkComboBox*) _tmp55_, _tmp60_);
#line 152 "../lib/Widgets/PreferencesWindow.vala"
				_g_free0 (_tmp60_);
#line 153 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 704 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("PressureReveal")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 710 "PreferencesWindow.c"
			default:
			{
				GtkSwitch* _tmp61_;
				PlankDockPreferences* _tmp62_;
				gboolean _tmp63_;
				gboolean _tmp64_;
#line 155 "../lib/Widgets/PreferencesWindow.vala"
				_tmp61_ = self->priv->sw_pressure_reveal;
#line 155 "../lib/Widgets/PreferencesWindow.vala"
				_tmp62_ = self->priv->prefs;
#line 155 "../lib/Widgets/PreferencesWindow.vala"
				_tmp63_ = plank_dock_preferences_get_PressureReveal (_tmp62_);
#line 155 "../lib/Widgets/PreferencesWindow.vala"
				_tmp64_ = _tmp63_;
#line 155 "../lib/Widgets/PreferencesWindow.vala"
				gtk_switch_set_active (_tmp61_, _tmp64_);
#line 156 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 729 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("Theme")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 735 "PreferencesWindow.c"
			default:
			{
				gint pos = 0;
				gint _tmp65_ = 0;
				gchar** _tmp66_;
#line 158 "../lib/Widgets/PreferencesWindow.vala"
				pos = 0;
#line 159 "../lib/Widgets/PreferencesWindow.vala"
				_tmp66_ = plank_theme_get_theme_list (&_tmp65_);
#line 745 "PreferencesWindow.c"
				{
					gchar** theme_collection = NULL;
					gint theme_collection_length1 = 0;
					gint _theme_collection_size_ = 0;
					gint theme_it = 0;
#line 159 "../lib/Widgets/PreferencesWindow.vala"
					theme_collection = _tmp66_;
#line 159 "../lib/Widgets/PreferencesWindow.vala"
					theme_collection_length1 = _tmp65_;
#line 159 "../lib/Widgets/PreferencesWindow.vala"
					for (theme_it = 0; theme_it < theme_collection_length1; theme_it = theme_it + 1) {
#line 757 "PreferencesWindow.c"
						const gchar* theme = NULL;
#line 159 "../lib/Widgets/PreferencesWindow.vala"
						theme = theme_collection[theme_it];
#line 761 "PreferencesWindow.c"
						{
							const gchar* _tmp67_;
							PlankDockPreferences* _tmp68_;
							const gchar* _tmp69_;
							const gchar* _tmp70_;
							gint _tmp72_;
#line 160 "../lib/Widgets/PreferencesWindow.vala"
							_tmp67_ = theme;
#line 160 "../lib/Widgets/PreferencesWindow.vala"
							_tmp68_ = self->priv->prefs;
#line 160 "../lib/Widgets/PreferencesWindow.vala"
							_tmp69_ = plank_dock_preferences_get_Theme (_tmp68_);
#line 160 "../lib/Widgets/PreferencesWindow.vala"
							_tmp70_ = _tmp69_;
#line 160 "../lib/Widgets/PreferencesWindow.vala"
							if (g_strcmp0 (_tmp67_, _tmp70_) == 0) {
#line 778 "PreferencesWindow.c"
								GtkComboBoxText* _tmp71_;
#line 161 "../lib/Widgets/PreferencesWindow.vala"
								_tmp71_ = self->priv->cb_theme;
#line 161 "../lib/Widgets/PreferencesWindow.vala"
								gtk_combo_box_set_active ((GtkComboBox*) _tmp71_, pos);
#line 784 "PreferencesWindow.c"
							}
#line 162 "../lib/Widgets/PreferencesWindow.vala"
							_tmp72_ = pos;
#line 162 "../lib/Widgets/PreferencesWindow.vala"
							pos = _tmp72_ + 1;
#line 790 "PreferencesWindow.c"
						}
					}
#line 159 "../lib/Widgets/PreferencesWindow.vala"
					theme_collection = (_vala_array_free (theme_collection, theme_collection_length1, (GDestroyNotify) g_free), NULL);
#line 795 "PreferencesWindow.c"
				}
#line 164 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 799 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("HideDelay")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 805 "PreferencesWindow.c"
			default:
			{
				GtkAdjustment* _tmp73_;
				PlankDockPreferences* _tmp74_;
				guint _tmp75_;
				guint _tmp76_;
#line 166 "../lib/Widgets/PreferencesWindow.vala"
				_tmp73_ = self->priv->adj_hide_delay;
#line 166 "../lib/Widgets/PreferencesWindow.vala"
				_tmp74_ = self->priv->prefs;
#line 166 "../lib/Widgets/PreferencesWindow.vala"
				_tmp75_ = plank_dock_preferences_get_HideDelay (_tmp74_);
#line 166 "../lib/Widgets/PreferencesWindow.vala"
				_tmp76_ = _tmp75_;
#line 166 "../lib/Widgets/PreferencesWindow.vala"
				gtk_adjustment_set_value (_tmp73_, (gdouble) _tmp76_);
#line 167 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 824 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("UnhideDelay")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 830 "PreferencesWindow.c"
			default:
			{
				GtkAdjustment* _tmp77_;
				PlankDockPreferences* _tmp78_;
				guint _tmp79_;
				guint _tmp80_;
#line 169 "../lib/Widgets/PreferencesWindow.vala"
				_tmp77_ = self->priv->adj_unhide_delay;
#line 169 "../lib/Widgets/PreferencesWindow.vala"
				_tmp78_ = self->priv->prefs;
#line 169 "../lib/Widgets/PreferencesWindow.vala"
				_tmp79_ = plank_dock_preferences_get_UnhideDelay (_tmp78_);
#line 169 "../lib/Widgets/PreferencesWindow.vala"
				_tmp80_ = _tmp79_;
#line 169 "../lib/Widgets/PreferencesWindow.vala"
				gtk_adjustment_set_value (_tmp77_, (gdouble) _tmp80_);
#line 170 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 849 "PreferencesWindow.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label14) ? _tmp2_label14 : (_tmp2_label14 = g_quark_from_static_string ("DockItems")))) {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 855 "PreferencesWindow.c"
			default:
			{
#line 173 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 860 "PreferencesWindow.c"
			}
		}
	} else {
#line 115 "../lib/Widgets/PreferencesWindow.vala"
		switch (0) {
#line 866 "PreferencesWindow.c"
			default:
			{
				const gchar* _tmp81_;
#line 175 "../lib/Widgets/PreferencesWindow.vala"
				_tmp81_ = prop->name;
#line 175 "../lib/Widgets/PreferencesWindow.vala"
				g_warning ("PreferencesWindow.vala:175: %s not supported", _tmp81_);
#line 176 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 876 "PreferencesWindow.c"
			}
		}
	}
}

static void
plank_preferences_window_theme_changed (PlankPreferencesWindow* self,
                                        GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 181 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 181 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 183 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 183 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_text_get_active_text (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_combo_box_text_get_type (), GtkComboBoxText));
#line 183 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 183 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_Theme (_tmp0_, _tmp2_);
#line 183 "../lib/Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp2_);
#line 903 "PreferencesWindow.c"
}

static void
plank_preferences_window_hidemode_changed (PlankPreferencesWindow* self,
                                           GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	const gchar* _tmp1_;
#line 186 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 186 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 188 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 188 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_get_active_id (widget);
#line 188 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_HideMode (_tmp0_, (PlankHideType) atoi (_tmp1_));
#line 922 "PreferencesWindow.c"
}

static void
plank_preferences_window_position_changed (PlankPreferencesWindow* self,
                                           GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	const gchar* _tmp1_;
#line 191 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 191 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 193 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 193 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_get_active_id (widget);
#line 193 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_Position (_tmp0_, (GtkPositionType) atoi (_tmp1_));
#line 941 "PreferencesWindow.c"
}

static void
plank_preferences_window_alignment_changed (PlankPreferencesWindow* self,
                                            GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	const gchar* _tmp1_;
	GtkComboBoxText* _tmp2_;
	PlankDockPreferences* _tmp3_;
	GtkAlign _tmp4_;
	GtkAlign _tmp5_;
	GtkScale* _tmp6_;
	PlankDockPreferences* _tmp7_;
	GtkAlign _tmp8_;
	GtkAlign _tmp9_;
#line 196 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 196 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 198 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 198 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_get_active_id (widget);
#line 198 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_Alignment (_tmp0_, (GtkAlign) atoi (_tmp1_));
#line 199 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = self->priv->cb_items_alignment;
#line 199 "../lib/Widgets/PreferencesWindow.vala"
	_tmp3_ = self->priv->prefs;
#line 199 "../lib/Widgets/PreferencesWindow.vala"
	_tmp4_ = plank_dock_preferences_get_Alignment (_tmp3_);
#line 199 "../lib/Widgets/PreferencesWindow.vala"
	_tmp5_ = _tmp4_;
#line 199 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, _tmp5_ == GTK_ALIGN_FILL);
#line 200 "../lib/Widgets/PreferencesWindow.vala"
	_tmp6_ = self->priv->s_offset;
#line 200 "../lib/Widgets/PreferencesWindow.vala"
	_tmp7_ = self->priv->prefs;
#line 200 "../lib/Widgets/PreferencesWindow.vala"
	_tmp8_ = plank_dock_preferences_get_Alignment (_tmp7_);
#line 200 "../lib/Widgets/PreferencesWindow.vala"
	_tmp9_ = _tmp8_;
#line 200 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, _tmp9_ == GTK_ALIGN_CENTER);
#line 988 "PreferencesWindow.c"
}

static void
plank_preferences_window_items_alignment_changed (PlankPreferencesWindow* self,
                                                  GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	const gchar* _tmp1_;
#line 203 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 203 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 205 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 205 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_get_active_id (widget);
#line 205 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_ItemsAlignment (_tmp0_, (GtkAlign) atoi (_tmp1_));
#line 1007 "PreferencesWindow.c"
}

static void
plank_preferences_window_hide_toggled (PlankPreferencesWindow* self,
                                       GObject* widget,
                                       GParamSpec* param)
{
#line 208 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 208 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 208 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 210 "../lib/Widgets/PreferencesWindow.vala"
	if (gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch))) {
#line 1023 "PreferencesWindow.c"
		PlankDockPreferences* _tmp0_;
		GtkComboBoxText* _tmp1_;
		GtkSpinButton* _tmp2_;
		GtkSpinButton* _tmp3_;
		GtkSwitch* _tmp4_;
#line 211 "../lib/Widgets/PreferencesWindow.vala"
		_tmp0_ = self->priv->prefs;
#line 211 "../lib/Widgets/PreferencesWindow.vala"
		plank_dock_preferences_set_HideMode (_tmp0_, PLANK_HIDE_TYPE_INTELLIGENT);
#line 212 "../lib/Widgets/PreferencesWindow.vala"
		_tmp1_ = self->priv->cb_hidemode;
#line 212 "../lib/Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, TRUE);
#line 213 "../lib/Widgets/PreferencesWindow.vala"
		_tmp2_ = self->priv->sp_hide_delay;
#line 213 "../lib/Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, TRUE);
#line 214 "../lib/Widgets/PreferencesWindow.vala"
		_tmp3_ = self->priv->sp_unhide_delay;
#line 214 "../lib/Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, TRUE);
#line 215 "../lib/Widgets/PreferencesWindow.vala"
		_tmp4_ = self->priv->sw_pressure_reveal;
#line 215 "../lib/Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
#line 1049 "PreferencesWindow.c"
	} else {
		PlankDockPreferences* _tmp5_;
		GtkComboBoxText* _tmp6_;
		GtkSpinButton* _tmp7_;
		GtkSpinButton* _tmp8_;
		GtkSwitch* _tmp9_;
#line 217 "../lib/Widgets/PreferencesWindow.vala"
		_tmp5_ = self->priv->prefs;
#line 217 "../lib/Widgets/PreferencesWindow.vala"
		plank_dock_preferences_set_HideMode (_tmp5_, PLANK_HIDE_TYPE_NONE);
#line 218 "../lib/Widgets/PreferencesWindow.vala"
		_tmp6_ = self->priv->cb_hidemode;
#line 218 "../lib/Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, FALSE);
#line 219 "../lib/Widgets/PreferencesWindow.vala"
		_tmp7_ = self->priv->sp_hide_delay;
#line 219 "../lib/Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
#line 220 "../lib/Widgets/PreferencesWindow.vala"
		_tmp8_ = self->priv->sp_unhide_delay;
#line 220 "../lib/Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, FALSE);
#line 221 "../lib/Widgets/PreferencesWindow.vala"
		_tmp9_ = self->priv->sw_pressure_reveal;
#line 221 "../lib/Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, FALSE);
#line 1076 "PreferencesWindow.c"
	}
}

static void
plank_preferences_window_primary_display_toggled (PlankPreferencesWindow* self,
                                                  GObject* widget,
                                                  GParamSpec* param)
{
#line 225 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 225 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 225 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 227 "../lib/Widgets/PreferencesWindow.vala"
	if (gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch))) {
#line 1093 "PreferencesWindow.c"
		PlankDockPreferences* _tmp0_;
		GtkComboBoxText* _tmp1_;
#line 228 "../lib/Widgets/PreferencesWindow.vala"
		_tmp0_ = self->priv->prefs;
#line 228 "../lib/Widgets/PreferencesWindow.vala"
		plank_dock_preferences_set_Monitor (_tmp0_, "");
#line 229 "../lib/Widgets/PreferencesWindow.vala"
		_tmp1_ = self->priv->cb_display_plug;
#line 229 "../lib/Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 1104 "PreferencesWindow.c"
	} else {
		PlankDockPreferences* _tmp2_;
		GtkComboBoxText* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GtkComboBoxText* _tmp6_;
#line 231 "../lib/Widgets/PreferencesWindow.vala"
		_tmp2_ = self->priv->prefs;
#line 231 "../lib/Widgets/PreferencesWindow.vala"
		_tmp3_ = self->priv->cb_display_plug;
#line 231 "../lib/Widgets/PreferencesWindow.vala"
		_tmp4_ = gtk_combo_box_text_get_active_text (_tmp3_);
#line 231 "../lib/Widgets/PreferencesWindow.vala"
		_tmp5_ = _tmp4_;
#line 231 "../lib/Widgets/PreferencesWindow.vala"
		plank_dock_preferences_set_Monitor (_tmp2_, _tmp5_);
#line 231 "../lib/Widgets/PreferencesWindow.vala"
		_g_free0 (_tmp5_);
#line 232 "../lib/Widgets/PreferencesWindow.vala"
		_tmp6_ = self->priv->cb_display_plug;
#line 232 "../lib/Widgets/PreferencesWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, TRUE);
#line 1127 "PreferencesWindow.c"
	}
}

static void
plank_preferences_window_workspace_only_toggled (PlankPreferencesWindow* self,
                                                 GObject* widget,
                                                 GParamSpec* param)
{
	PlankDockPreferences* _tmp0_;
#line 236 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 236 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 236 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 238 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 238 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_CurrentWorkspaceOnly (_tmp0_, gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch)));
#line 1147 "PreferencesWindow.c"
}

static void
plank_preferences_window_show_unpinned_toggled (PlankPreferencesWindow* self,
                                                GObject* widget,
                                                GParamSpec* param)
{
	PlankDockPreferences* _tmp0_;
#line 241 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 241 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 241 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 243 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 243 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_PinnedOnly (_tmp0_, !gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch)));
#line 1166 "PreferencesWindow.c"
}

static void
plank_preferences_window_lock_items_toggled (PlankPreferencesWindow* self,
                                             GObject* widget,
                                             GParamSpec* param)
{
	PlankDockPreferences* _tmp0_;
#line 246 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 246 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 246 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 248 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 248 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_LockItems (_tmp0_, gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch)));
#line 1185 "PreferencesWindow.c"
}

static void
plank_preferences_window_pressure_reveal_toggled (PlankPreferencesWindow* self,
                                                  GObject* widget,
                                                  GParamSpec* param)
{
	PlankDockPreferences* _tmp0_;
#line 251 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 251 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 251 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (param != NULL);
#line 253 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 253 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_PressureReveal (_tmp0_, gtk_switch_get_active (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_switch_get_type (), GtkSwitch)));
#line 1204 "PreferencesWindow.c"
}

static void
plank_preferences_window_iconsize_changed (PlankPreferencesWindow* self,
                                           GtkAdjustment* adj)
{
	PlankDockPreferences* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 256 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 256 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (adj != NULL);
#line 258 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 258 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_adjustment_get_value (adj);
#line 258 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 258 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_IconSize (_tmp0_, (gint) _tmp2_);
#line 1226 "PreferencesWindow.c"
}

static void
plank_preferences_window_offset_changed (PlankPreferencesWindow* self,
                                         GtkAdjustment* adj)
{
	PlankDockPreferences* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 261 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 261 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (adj != NULL);
#line 263 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 263 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_adjustment_get_value (adj);
#line 263 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 263 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_Offset (_tmp0_, (gint) _tmp2_);
#line 1248 "PreferencesWindow.c"
}

static void
plank_preferences_window_hide_delay_changed (PlankPreferencesWindow* self,
                                             GtkAdjustment* adj)
{
	PlankDockPreferences* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 266 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 266 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (adj != NULL);
#line 268 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 268 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_adjustment_get_value (adj);
#line 268 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 268 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_HideDelay (_tmp0_, (guint) ((gint) _tmp2_));
#line 1270 "PreferencesWindow.c"
}

static void
plank_preferences_window_unhide_delay_changed (PlankPreferencesWindow* self,
                                               GtkAdjustment* adj)
{
	PlankDockPreferences* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 271 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 271 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (adj != NULL);
#line 273 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 273 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_adjustment_get_value (adj);
#line 273 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 273 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_UnhideDelay (_tmp0_, (guint) ((gint) _tmp2_));
#line 1292 "PreferencesWindow.c"
}

static void
plank_preferences_window_monitor_changed (PlankPreferencesWindow* self,
                                          GtkComboBox* widget)
{
	PlankDockPreferences* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 276 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 276 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 278 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 278 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_combo_box_text_get_active_text (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_combo_box_text_get_type (), GtkComboBoxText));
#line 278 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 278 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_preferences_set_Monitor (_tmp0_, _tmp2_);
#line 278 "../lib/Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp2_);
#line 1316 "PreferencesWindow.c"
}

static void
_plank_preferences_window_prefs_changed_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
#line 283 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_prefs_changed ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1326 "PreferencesWindow.c"
}

static void
_plank_preferences_window_theme_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                               gpointer self)
{
#line 285 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_theme_changed ((PlankPreferencesWindow*) self, _sender);
#line 1335 "PreferencesWindow.c"
}

static void
_plank_preferences_window_hidemode_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                  gpointer self)
{
#line 286 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_hidemode_changed ((PlankPreferencesWindow*) self, _sender);
#line 1344 "PreferencesWindow.c"
}

static void
_plank_preferences_window_position_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                  gpointer self)
{
#line 287 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_position_changed ((PlankPreferencesWindow*) self, _sender);
#line 1353 "PreferencesWindow.c"
}

static void
_plank_preferences_window_hide_delay_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                           gpointer self)
{
#line 288 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_hide_delay_changed ((PlankPreferencesWindow*) self, _sender);
#line 1362 "PreferencesWindow.c"
}

static void
_plank_preferences_window_unhide_delay_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                             gpointer self)
{
#line 289 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_unhide_delay_changed ((PlankPreferencesWindow*) self, _sender);
#line 1371 "PreferencesWindow.c"
}

static void
_plank_preferences_window_monitor_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self)
{
#line 290 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_monitor_changed ((PlankPreferencesWindow*) self, _sender);
#line 1380 "PreferencesWindow.c"
}

static void
_plank_preferences_window_iconsize_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                         gpointer self)
{
#line 291 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_iconsize_changed ((PlankPreferencesWindow*) self, _sender);
#line 1389 "PreferencesWindow.c"
}

static void
_plank_preferences_window_offset_changed_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                                       gpointer self)
{
#line 292 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_offset_changed ((PlankPreferencesWindow*) self, _sender);
#line 1398 "PreferencesWindow.c"
}

static void
_plank_preferences_window_hide_toggled_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 293 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_hide_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1408 "PreferencesWindow.c"
}

static void
_plank_preferences_window_primary_display_toggled_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
#line 294 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_primary_display_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1418 "PreferencesWindow.c"
}

static void
_plank_preferences_window_workspace_only_toggled_g_object_notify (GObject* _sender,
                                                                  GParamSpec* pspec,
                                                                  gpointer self)
{
#line 295 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_workspace_only_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1428 "PreferencesWindow.c"
}

static void
_plank_preferences_window_show_unpinned_toggled_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self)
{
#line 296 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_show_unpinned_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1438 "PreferencesWindow.c"
}

static void
_plank_preferences_window_lock_items_toggled_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 297 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_lock_items_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1448 "PreferencesWindow.c"
}

static void
_plank_preferences_window_pressure_reveal_toggled_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self)
{
#line 298 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_pressure_reveal_toggled ((PlankPreferencesWindow*) self, _sender, pspec);
#line 1458 "PreferencesWindow.c"
}

static void
_plank_preferences_window_alignment_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self)
{
#line 299 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_alignment_changed ((PlankPreferencesWindow*) self, _sender);
#line 1467 "PreferencesWindow.c"
}

static void
_plank_preferences_window_items_alignment_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                         gpointer self)
{
#line 300 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_items_alignment_changed ((PlankPreferencesWindow*) self, _sender);
#line 1476 "PreferencesWindow.c"
}

static void
plank_preferences_window_connect_signals (PlankPreferencesWindow* self)
{
	PlankDockPreferences* _tmp0_;
	GtkComboBoxText* _tmp1_;
	GtkComboBoxText* _tmp2_;
	GtkComboBoxText* _tmp3_;
	GtkAdjustment* _tmp4_;
	GtkAdjustment* _tmp5_;
	GtkComboBoxText* _tmp6_;
	GtkAdjustment* _tmp7_;
	GtkAdjustment* _tmp8_;
	GtkSwitch* _tmp9_;
	GtkSwitch* _tmp10_;
	GtkSwitch* _tmp11_;
	GtkSwitch* _tmp12_;
	GtkSwitch* _tmp13_;
	GtkSwitch* _tmp14_;
	GtkComboBoxText* _tmp15_;
	GtkComboBoxText* _tmp16_;
#line 281 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 283 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 283 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp0_, "notify", (GCallback) _plank_preferences_window_prefs_changed_g_object_notify, self, 0);
#line 285 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = self->priv->cb_theme;
#line 285 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp1_, "changed", (GCallback) _plank_preferences_window_theme_changed_gtk_combo_box_changed, self, 0);
#line 286 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = self->priv->cb_hidemode;
#line 286 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp2_, "changed", (GCallback) _plank_preferences_window_hidemode_changed_gtk_combo_box_changed, self, 0);
#line 287 "../lib/Widgets/PreferencesWindow.vala"
	_tmp3_ = self->priv->cb_position;
#line 287 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp3_, "changed", (GCallback) _plank_preferences_window_position_changed_gtk_combo_box_changed, self, 0);
#line 288 "../lib/Widgets/PreferencesWindow.vala"
	_tmp4_ = self->priv->adj_hide_delay;
#line 288 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object (_tmp4_, "value-changed", (GCallback) _plank_preferences_window_hide_delay_changed_gtk_adjustment_value_changed, self, 0);
#line 289 "../lib/Widgets/PreferencesWindow.vala"
	_tmp5_ = self->priv->adj_unhide_delay;
#line 289 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object (_tmp5_, "value-changed", (GCallback) _plank_preferences_window_unhide_delay_changed_gtk_adjustment_value_changed, self, 0);
#line 290 "../lib/Widgets/PreferencesWindow.vala"
	_tmp6_ = self->priv->cb_display_plug;
#line 290 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp6_, "changed", (GCallback) _plank_preferences_window_monitor_changed_gtk_combo_box_changed, self, 0);
#line 291 "../lib/Widgets/PreferencesWindow.vala"
	_tmp7_ = self->priv->adj_iconsize;
#line 291 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object (_tmp7_, "value-changed", (GCallback) _plank_preferences_window_iconsize_changed_gtk_adjustment_value_changed, self, 0);
#line 292 "../lib/Widgets/PreferencesWindow.vala"
	_tmp8_ = self->priv->adj_offset;
#line 292 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object (_tmp8_, "value-changed", (GCallback) _plank_preferences_window_offset_changed_gtk_adjustment_value_changed, self, 0);
#line 293 "../lib/Widgets/PreferencesWindow.vala"
	_tmp9_ = self->priv->sw_hide;
#line 293 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::active", (GCallback) _plank_preferences_window_hide_toggled_g_object_notify, self, 0);
#line 294 "../lib/Widgets/PreferencesWindow.vala"
	_tmp10_ = self->priv->sw_primary_display;
#line 294 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp10_, "notify::active", (GCallback) _plank_preferences_window_primary_display_toggled_g_object_notify, self, 0);
#line 295 "../lib/Widgets/PreferencesWindow.vala"
	_tmp11_ = self->priv->sw_workspace_only;
#line 295 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp11_, "notify::active", (GCallback) _plank_preferences_window_workspace_only_toggled_g_object_notify, self, 0);
#line 296 "../lib/Widgets/PreferencesWindow.vala"
	_tmp12_ = self->priv->sw_show_unpinned;
#line 296 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp12_, "notify::active", (GCallback) _plank_preferences_window_show_unpinned_toggled_g_object_notify, self, 0);
#line 297 "../lib/Widgets/PreferencesWindow.vala"
	_tmp13_ = self->priv->sw_lock_items;
#line 297 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::active", (GCallback) _plank_preferences_window_lock_items_toggled_g_object_notify, self, 0);
#line 298 "../lib/Widgets/PreferencesWindow.vala"
	_tmp14_ = self->priv->sw_pressure_reveal;
#line 298 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) _tmp14_, "notify::active", (GCallback) _plank_preferences_window_pressure_reveal_toggled_g_object_notify, self, 0);
#line 299 "../lib/Widgets/PreferencesWindow.vala"
	_tmp15_ = self->priv->cb_alignment;
#line 299 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp15_, "changed", (GCallback) _plank_preferences_window_alignment_changed_gtk_combo_box_changed, self, 0);
#line 300 "../lib/Widgets/PreferencesWindow.vala"
	_tmp16_ = self->priv->cb_items_alignment;
#line 300 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp16_, "changed", (GCallback) _plank_preferences_window_items_alignment_changed_gtk_combo_box_changed, self, 0);
#line 1569 "PreferencesWindow.c"
}

static void
plank_preferences_window_disconnect_signals (PlankPreferencesWindow* self)
{
	PlankDockPreferences* _tmp0_;
	guint _tmp1_;
	GtkComboBoxText* _tmp2_;
	guint _tmp3_;
	GtkComboBoxText* _tmp4_;
	guint _tmp5_;
	GtkComboBoxText* _tmp6_;
	guint _tmp7_;
	GtkAdjustment* _tmp8_;
	guint _tmp9_;
	GtkAdjustment* _tmp10_;
	guint _tmp11_;
	GtkComboBoxText* _tmp12_;
	guint _tmp13_;
	GtkAdjustment* _tmp14_;
	guint _tmp15_;
	GtkAdjustment* _tmp16_;
	guint _tmp17_;
	GtkSwitch* _tmp18_;
	guint _tmp19_;
	GQuark _tmp20_;
	GtkSwitch* _tmp21_;
	guint _tmp22_;
	GQuark _tmp23_;
	GtkSwitch* _tmp24_;
	guint _tmp25_;
	GQuark _tmp26_;
	GtkSwitch* _tmp27_;
	guint _tmp28_;
	GQuark _tmp29_;
	GtkSwitch* _tmp30_;
	guint _tmp31_;
	GQuark _tmp32_;
	GtkSwitch* _tmp33_;
	guint _tmp34_;
	GQuark _tmp35_;
	GtkComboBoxText* _tmp36_;
	guint _tmp37_;
	GtkComboBoxText* _tmp38_;
	guint _tmp39_;
#line 303 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 305 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->prefs;
#line 305 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp1_, NULL, FALSE);
#line 305 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _plank_preferences_window_prefs_changed_g_object_notify, self);
#line 307 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = self->priv->cb_theme;
#line 307 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp3_, NULL, FALSE);
#line 307 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _plank_preferences_window_theme_changed_gtk_combo_box_changed, self);
#line 308 "../lib/Widgets/PreferencesWindow.vala"
	_tmp4_ = self->priv->cb_hidemode;
#line 308 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp5_, NULL, FALSE);
#line 308 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _plank_preferences_window_hidemode_changed_gtk_combo_box_changed, self);
#line 309 "../lib/Widgets/PreferencesWindow.vala"
	_tmp6_ = self->priv->cb_position;
#line 309 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp7_, NULL, FALSE);
#line 309 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _plank_preferences_window_position_changed_gtk_combo_box_changed, self);
#line 310 "../lib/Widgets/PreferencesWindow.vala"
	_tmp8_ = self->priv->adj_hide_delay;
#line 310 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp9_, NULL, FALSE);
#line 310 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _plank_preferences_window_hide_delay_changed_gtk_adjustment_value_changed, self);
#line 311 "../lib/Widgets/PreferencesWindow.vala"
	_tmp10_ = self->priv->adj_unhide_delay;
#line 311 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp11_, NULL, FALSE);
#line 311 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _plank_preferences_window_unhide_delay_changed_gtk_adjustment_value_changed, self);
#line 312 "../lib/Widgets/PreferencesWindow.vala"
	_tmp12_ = self->priv->cb_display_plug;
#line 312 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp13_, NULL, FALSE);
#line 312 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _plank_preferences_window_monitor_changed_gtk_combo_box_changed, self);
#line 313 "../lib/Widgets/PreferencesWindow.vala"
	_tmp14_ = self->priv->adj_iconsize;
#line 313 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp15_, NULL, FALSE);
#line 313 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _plank_preferences_window_iconsize_changed_gtk_adjustment_value_changed, self);
#line 314 "../lib/Widgets/PreferencesWindow.vala"
	_tmp16_ = self->priv->adj_offset;
#line 314 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp17_, NULL, FALSE);
#line 314 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _plank_preferences_window_offset_changed_gtk_adjustment_value_changed, self);
#line 315 "../lib/Widgets/PreferencesWindow.vala"
	_tmp18_ = self->priv->sw_hide;
#line 315 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp19_, &_tmp20_, TRUE);
#line 315 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, _tmp20_, NULL, (GCallback) _plank_preferences_window_hide_toggled_g_object_notify, self);
#line 316 "../lib/Widgets/PreferencesWindow.vala"
	_tmp21_ = self->priv->sw_primary_display;
#line 316 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp22_, &_tmp23_, TRUE);
#line 316 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp21_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp22_, _tmp23_, NULL, (GCallback) _plank_preferences_window_primary_display_toggled_g_object_notify, self);
#line 317 "../lib/Widgets/PreferencesWindow.vala"
	_tmp24_ = self->priv->sw_workspace_only;
#line 317 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp25_, &_tmp26_, TRUE);
#line 317 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, _tmp26_, NULL, (GCallback) _plank_preferences_window_workspace_only_toggled_g_object_notify, self);
#line 318 "../lib/Widgets/PreferencesWindow.vala"
	_tmp27_ = self->priv->sw_show_unpinned;
#line 318 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp28_, &_tmp29_, TRUE);
#line 318 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp27_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp28_, _tmp29_, NULL, (GCallback) _plank_preferences_window_show_unpinned_toggled_g_object_notify, self);
#line 319 "../lib/Widgets/PreferencesWindow.vala"
	_tmp30_ = self->priv->sw_lock_items;
#line 319 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp31_, &_tmp32_, TRUE);
#line 319 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp30_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp31_, _tmp32_, NULL, (GCallback) _plank_preferences_window_lock_items_toggled_g_object_notify, self);
#line 320 "../lib/Widgets/PreferencesWindow.vala"
	_tmp33_ = self->priv->sw_pressure_reveal;
#line 320 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp34_, &_tmp35_, TRUE);
#line 320 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp33_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp34_, _tmp35_, NULL, (GCallback) _plank_preferences_window_pressure_reveal_toggled_g_object_notify, self);
#line 321 "../lib/Widgets/PreferencesWindow.vala"
	_tmp36_ = self->priv->cb_alignment;
#line 321 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp37_, NULL, FALSE);
#line 321 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp36_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp37_, 0, NULL, (GCallback) _plank_preferences_window_alignment_changed_gtk_combo_box_changed, self);
#line 322 "../lib/Widgets/PreferencesWindow.vala"
	_tmp38_ = self->priv->cb_items_alignment;
#line 322 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp39_, NULL, FALSE);
#line 322 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_handlers_disconnect_matched ((GtkComboBox*) _tmp38_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp39_, 0, NULL, (GCallback) _plank_preferences_window_items_alignment_changed_gtk_combo_box_changed, self);
#line 1719 "PreferencesWindow.c"
}

static void
plank_preferences_window_init_dock_tab (PlankPreferencesWindow* self)
{
	gint pos = 0;
	GtkComboBoxText* _tmp0_;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	GtkComboBoxText* _tmp13_;
	PlankDockPreferences* _tmp14_;
	PlankHideType _tmp15_;
	PlankHideType _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GtkComboBoxText* _tmp19_;
	PlankDockPreferences* _tmp20_;
	PlankHideType _tmp21_;
	PlankHideType _tmp22_;
	GtkComboBoxText* _tmp23_;
	PlankDockPreferences* _tmp24_;
	GtkPositionType _tmp25_;
	GtkPositionType _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GtkAdjustment* _tmp29_;
	PlankDockPreferences* _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	GtkAdjustment* _tmp33_;
	PlankDockPreferences* _tmp34_;
	guint _tmp35_;
	guint _tmp36_;
	GtkComboBoxText* _tmp37_;
	GdkScreen* _tmp38_;
	gint _tmp39_ = 0;
	gchar** _tmp40_;
	PlankDockPreferences* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	GtkComboBoxText* _tmp55_;
	PlankDockPreferences* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	GtkSpinButton* _tmp59_;
	PlankDockPreferences* _tmp60_;
	PlankHideType _tmp61_;
	PlankHideType _tmp62_;
	GtkSpinButton* _tmp63_;
	PlankDockPreferences* _tmp64_;
	PlankHideType _tmp65_;
	PlankHideType _tmp66_;
	GtkAdjustment* _tmp67_;
	PlankDockPreferences* _tmp68_;
	gint _tmp69_;
	gint _tmp70_;
	GtkAdjustment* _tmp71_;
	PlankDockPreferences* _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
	GtkScale* _tmp75_;
	PlankDockPreferences* _tmp76_;
	GtkAlign _tmp77_;
	GtkAlign _tmp78_;
	GtkSwitch* _tmp79_;
	PlankDockPreferences* _tmp80_;
	PlankHideType _tmp81_;
	PlankHideType _tmp82_;
	GtkSwitch* _tmp83_;
	PlankDockPreferences* _tmp84_;
	const gchar* _tmp85_;
	const gchar* _tmp86_;
	GtkSwitch* _tmp87_;
	PlankDockPreferences* _tmp88_;
	gboolean _tmp89_;
	gboolean _tmp90_;
	GtkSwitch* _tmp91_;
	PlankDockPreferences* _tmp92_;
	gboolean _tmp93_;
	gboolean _tmp94_;
	GtkSwitch* _tmp95_;
	PlankDockPreferences* _tmp96_;
	gboolean _tmp97_;
	gboolean _tmp98_;
	GtkSwitch* _tmp99_;
	PlankDockPreferences* _tmp100_;
	gboolean _tmp101_;
	gboolean _tmp102_;
	GtkComboBoxText* _tmp103_;
	PlankDockPreferences* _tmp104_;
	GtkAlign _tmp105_;
	GtkAlign _tmp106_;
	gchar* _tmp107_;
	gchar* _tmp108_;
	GtkComboBoxText* _tmp109_;
	PlankDockPreferences* _tmp110_;
	GtkAlign _tmp111_;
	GtkAlign _tmp112_;
	gchar* _tmp113_;
	gchar* _tmp114_;
	GtkComboBoxText* _tmp115_;
	PlankDockPreferences* _tmp116_;
	GtkAlign _tmp117_;
	GtkAlign _tmp118_;
#line 325 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 327 "../lib/Widgets/PreferencesWindow.vala"
	pos = 0;
#line 328 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->cb_theme;
#line 328 "../lib/Widgets/PreferencesWindow.vala"
	gtk_combo_box_text_remove_all (_tmp0_);
#line 329 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = plank_theme_get_theme_list (&_tmp1_);
#line 1834 "PreferencesWindow.c"
	{
		gchar** theme_collection = NULL;
		gint theme_collection_length1 = 0;
		gint _theme_collection_size_ = 0;
		gint theme_it = 0;
#line 329 "../lib/Widgets/PreferencesWindow.vala"
		theme_collection = _tmp2_;
#line 329 "../lib/Widgets/PreferencesWindow.vala"
		theme_collection_length1 = _tmp1_;
#line 329 "../lib/Widgets/PreferencesWindow.vala"
		for (theme_it = 0; theme_it < theme_collection_length1; theme_it = theme_it + 1) {
#line 1846 "PreferencesWindow.c"
			const gchar* theme = NULL;
#line 329 "../lib/Widgets/PreferencesWindow.vala"
			theme = theme_collection[theme_it];
#line 1850 "PreferencesWindow.c"
			{
				GtkComboBoxText* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				PlankDockPreferences* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gint _tmp12_;
#line 330 "../lib/Widgets/PreferencesWindow.vala"
				_tmp3_ = self->priv->cb_theme;
#line 330 "../lib/Widgets/PreferencesWindow.vala"
				_tmp4_ = g_strdup_printf ("%i", pos);
#line 330 "../lib/Widgets/PreferencesWindow.vala"
				_tmp5_ = _tmp4_;
#line 330 "../lib/Widgets/PreferencesWindow.vala"
				_tmp6_ = theme;
#line 330 "../lib/Widgets/PreferencesWindow.vala"
				gtk_combo_box_text_append (_tmp3_, _tmp5_, _tmp6_);
#line 330 "../lib/Widgets/PreferencesWindow.vala"
				_g_free0 (_tmp5_);
#line 331 "../lib/Widgets/PreferencesWindow.vala"
				_tmp7_ = theme;
#line 331 "../lib/Widgets/PreferencesWindow.vala"
				_tmp8_ = self->priv->prefs;
#line 331 "../lib/Widgets/PreferencesWindow.vala"
				_tmp9_ = plank_dock_preferences_get_Theme (_tmp8_);
#line 331 "../lib/Widgets/PreferencesWindow.vala"
				_tmp10_ = _tmp9_;
#line 331 "../lib/Widgets/PreferencesWindow.vala"
				if (g_strcmp0 (_tmp7_, _tmp10_) == 0) {
#line 1883 "PreferencesWindow.c"
					GtkComboBoxText* _tmp11_;
#line 332 "../lib/Widgets/PreferencesWindow.vala"
					_tmp11_ = self->priv->cb_theme;
#line 332 "../lib/Widgets/PreferencesWindow.vala"
					gtk_combo_box_set_active ((GtkComboBox*) _tmp11_, pos);
#line 1889 "PreferencesWindow.c"
				}
#line 333 "../lib/Widgets/PreferencesWindow.vala"
				_tmp12_ = pos;
#line 333 "../lib/Widgets/PreferencesWindow.vala"
				pos = _tmp12_ + 1;
#line 1895 "PreferencesWindow.c"
			}
		}
#line 329 "../lib/Widgets/PreferencesWindow.vala"
		theme_collection = (_vala_array_free (theme_collection, theme_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1900 "PreferencesWindow.c"
	}
#line 336 "../lib/Widgets/PreferencesWindow.vala"
	_tmp13_ = self->priv->cb_hidemode;
#line 336 "../lib/Widgets/PreferencesWindow.vala"
	_tmp14_ = self->priv->prefs;
#line 336 "../lib/Widgets/PreferencesWindow.vala"
	_tmp15_ = plank_dock_preferences_get_HideMode (_tmp14_);
#line 336 "../lib/Widgets/PreferencesWindow.vala"
	_tmp16_ = _tmp15_;
#line 336 "../lib/Widgets/PreferencesWindow.vala"
	_tmp17_ = g_strdup_printf ("%i", (gint) _tmp16_);
#line 336 "../lib/Widgets/PreferencesWindow.vala"
	_tmp18_ = _tmp17_;
#line 336 "../lib/Widgets/PreferencesWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp13_, _tmp18_);
#line 336 "../lib/Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp18_);
#line 337 "../lib/Widgets/PreferencesWindow.vala"
	_tmp19_ = self->priv->cb_hidemode;
#line 337 "../lib/Widgets/PreferencesWindow.vala"
	_tmp20_ = self->priv->prefs;
#line 337 "../lib/Widgets/PreferencesWindow.vala"
	_tmp21_ = plank_dock_preferences_get_HideMode (_tmp20_);
#line 337 "../lib/Widgets/PreferencesWindow.vala"
	_tmp22_ = _tmp21_;
#line 337 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, _tmp22_ != PLANK_HIDE_TYPE_NONE);
#line 338 "../lib/Widgets/PreferencesWindow.vala"
	_tmp23_ = self->priv->cb_position;
#line 338 "../lib/Widgets/PreferencesWindow.vala"
	_tmp24_ = self->priv->prefs;
#line 338 "../lib/Widgets/PreferencesWindow.vala"
	_tmp25_ = plank_dock_preferences_get_Position (_tmp24_);
#line 338 "../lib/Widgets/PreferencesWindow.vala"
	_tmp26_ = _tmp25_;
#line 338 "../lib/Widgets/PreferencesWindow.vala"
	_tmp27_ = g_strdup_printf ("%i", (gint) _tmp26_);
#line 338 "../lib/Widgets/PreferencesWindow.vala"
	_tmp28_ = _tmp27_;
#line 338 "../lib/Widgets/PreferencesWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp23_, _tmp28_);
#line 338 "../lib/Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp28_);
#line 339 "../lib/Widgets/PreferencesWindow.vala"
	_tmp29_ = self->priv->adj_hide_delay;
#line 339 "../lib/Widgets/PreferencesWindow.vala"
	_tmp30_ = self->priv->prefs;
#line 339 "../lib/Widgets/PreferencesWindow.vala"
	_tmp31_ = plank_dock_preferences_get_HideDelay (_tmp30_);
#line 339 "../lib/Widgets/PreferencesWindow.vala"
	_tmp32_ = _tmp31_;
#line 339 "../lib/Widgets/PreferencesWindow.vala"
	gtk_adjustment_set_value (_tmp29_, (gdouble) _tmp32_);
#line 340 "../lib/Widgets/PreferencesWindow.vala"
	_tmp33_ = self->priv->adj_unhide_delay;
#line 340 "../lib/Widgets/PreferencesWindow.vala"
	_tmp34_ = self->priv->prefs;
#line 340 "../lib/Widgets/PreferencesWindow.vala"
	_tmp35_ = plank_dock_preferences_get_UnhideDelay (_tmp34_);
#line 340 "../lib/Widgets/PreferencesWindow.vala"
	_tmp36_ = _tmp35_;
#line 340 "../lib/Widgets/PreferencesWindow.vala"
	gtk_adjustment_set_value (_tmp33_, (gdouble) _tmp36_);
#line 342 "../lib/Widgets/PreferencesWindow.vala"
	pos = 0;
#line 343 "../lib/Widgets/PreferencesWindow.vala"
	_tmp37_ = self->priv->cb_display_plug;
#line 343 "../lib/Widgets/PreferencesWindow.vala"
	gtk_combo_box_text_remove_all (_tmp37_);
#line 344 "../lib/Widgets/PreferencesWindow.vala"
	_tmp38_ = gtk_window_get_screen ((GtkWindow*) self);
#line 344 "../lib/Widgets/PreferencesWindow.vala"
	_tmp40_ = plank_position_manager_get_monitor_plug_names (_tmp38_, &_tmp39_);
#line 1974 "PreferencesWindow.c"
	{
		gchar** plug_name_collection = NULL;
		gint plug_name_collection_length1 = 0;
		gint _plug_name_collection_size_ = 0;
		gint plug_name_it = 0;
#line 344 "../lib/Widgets/PreferencesWindow.vala"
		plug_name_collection = _tmp40_;
#line 344 "../lib/Widgets/PreferencesWindow.vala"
		plug_name_collection_length1 = _tmp39_;
#line 344 "../lib/Widgets/PreferencesWindow.vala"
		for (plug_name_it = 0; plug_name_it < plug_name_collection_length1; plug_name_it = plug_name_it + 1) {
#line 1986 "PreferencesWindow.c"
			const gchar* plug_name = NULL;
#line 344 "../lib/Widgets/PreferencesWindow.vala"
			plug_name = plug_name_collection[plug_name_it];
#line 1990 "PreferencesWindow.c"
			{
				GtkComboBoxText* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				const gchar* _tmp44_;
				const gchar* _tmp45_;
				PlankDockPreferences* _tmp46_;
				const gchar* _tmp47_;
				const gchar* _tmp48_;
				gint _tmp50_;
#line 345 "../lib/Widgets/PreferencesWindow.vala"
				_tmp41_ = self->priv->cb_display_plug;
#line 345 "../lib/Widgets/PreferencesWindow.vala"
				_tmp42_ = g_strdup_printf ("%i", pos);
#line 345 "../lib/Widgets/PreferencesWindow.vala"
				_tmp43_ = _tmp42_;
#line 345 "../lib/Widgets/PreferencesWindow.vala"
				_tmp44_ = plug_name;
#line 345 "../lib/Widgets/PreferencesWindow.vala"
				gtk_combo_box_text_append (_tmp41_, _tmp43_, _tmp44_);
#line 345 "../lib/Widgets/PreferencesWindow.vala"
				_g_free0 (_tmp43_);
#line 346 "../lib/Widgets/PreferencesWindow.vala"
				_tmp45_ = plug_name;
#line 346 "../lib/Widgets/PreferencesWindow.vala"
				_tmp46_ = self->priv->prefs;
#line 346 "../lib/Widgets/PreferencesWindow.vala"
				_tmp47_ = plank_dock_preferences_get_Monitor (_tmp46_);
#line 346 "../lib/Widgets/PreferencesWindow.vala"
				_tmp48_ = _tmp47_;
#line 346 "../lib/Widgets/PreferencesWindow.vala"
				if (g_strcmp0 (_tmp45_, _tmp48_) == 0) {
#line 2023 "PreferencesWindow.c"
					GtkComboBoxText* _tmp49_;
#line 347 "../lib/Widgets/PreferencesWindow.vala"
					_tmp49_ = self->priv->cb_display_plug;
#line 347 "../lib/Widgets/PreferencesWindow.vala"
					gtk_combo_box_set_active ((GtkComboBox*) _tmp49_, pos);
#line 2029 "PreferencesWindow.c"
				}
#line 348 "../lib/Widgets/PreferencesWindow.vala"
				_tmp50_ = pos;
#line 348 "../lib/Widgets/PreferencesWindow.vala"
				pos = _tmp50_ + 1;
#line 2035 "PreferencesWindow.c"
			}
		}
#line 344 "../lib/Widgets/PreferencesWindow.vala"
		plug_name_collection = (_vala_array_free (plug_name_collection, plug_name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2040 "PreferencesWindow.c"
	}
#line 350 "../lib/Widgets/PreferencesWindow.vala"
	_tmp51_ = self->priv->prefs;
#line 350 "../lib/Widgets/PreferencesWindow.vala"
	_tmp52_ = plank_dock_preferences_get_Monitor (_tmp51_);
#line 350 "../lib/Widgets/PreferencesWindow.vala"
	_tmp53_ = _tmp52_;
#line 350 "../lib/Widgets/PreferencesWindow.vala"
	if (g_strcmp0 (_tmp53_, "") == 0) {
#line 2050 "PreferencesWindow.c"
		GtkComboBoxText* _tmp54_;
#line 351 "../lib/Widgets/PreferencesWindow.vala"
		_tmp54_ = self->priv->cb_display_plug;
#line 351 "../lib/Widgets/PreferencesWindow.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp54_, 0);
#line 2056 "PreferencesWindow.c"
	}
#line 352 "../lib/Widgets/PreferencesWindow.vala"
	_tmp55_ = self->priv->cb_display_plug;
#line 352 "../lib/Widgets/PreferencesWindow.vala"
	_tmp56_ = self->priv->prefs;
#line 352 "../lib/Widgets/PreferencesWindow.vala"
	_tmp57_ = plank_dock_preferences_get_Monitor (_tmp56_);
#line 352 "../lib/Widgets/PreferencesWindow.vala"
	_tmp58_ = _tmp57_;
#line 352 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp55_, g_strcmp0 (_tmp58_, "") != 0);
#line 354 "../lib/Widgets/PreferencesWindow.vala"
	_tmp59_ = self->priv->sp_hide_delay;
#line 354 "../lib/Widgets/PreferencesWindow.vala"
	_tmp60_ = self->priv->prefs;
#line 354 "../lib/Widgets/PreferencesWindow.vala"
	_tmp61_ = plank_dock_preferences_get_HideMode (_tmp60_);
#line 354 "../lib/Widgets/PreferencesWindow.vala"
	_tmp62_ = _tmp61_;
#line 354 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp59_, _tmp62_ != PLANK_HIDE_TYPE_NONE);
#line 355 "../lib/Widgets/PreferencesWindow.vala"
	_tmp63_ = self->priv->sp_unhide_delay;
#line 355 "../lib/Widgets/PreferencesWindow.vala"
	_tmp64_ = self->priv->prefs;
#line 355 "../lib/Widgets/PreferencesWindow.vala"
	_tmp65_ = plank_dock_preferences_get_HideMode (_tmp64_);
#line 355 "../lib/Widgets/PreferencesWindow.vala"
	_tmp66_ = _tmp65_;
#line 355 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp63_, _tmp66_ != PLANK_HIDE_TYPE_NONE);
#line 357 "../lib/Widgets/PreferencesWindow.vala"
	_tmp67_ = self->priv->adj_iconsize;
#line 357 "../lib/Widgets/PreferencesWindow.vala"
	_tmp68_ = self->priv->prefs;
#line 357 "../lib/Widgets/PreferencesWindow.vala"
	_tmp69_ = plank_dock_preferences_get_IconSize (_tmp68_);
#line 357 "../lib/Widgets/PreferencesWindow.vala"
	_tmp70_ = _tmp69_;
#line 357 "../lib/Widgets/PreferencesWindow.vala"
	gtk_adjustment_set_value (_tmp67_, (gdouble) _tmp70_);
#line 358 "../lib/Widgets/PreferencesWindow.vala"
	_tmp71_ = self->priv->adj_offset;
#line 358 "../lib/Widgets/PreferencesWindow.vala"
	_tmp72_ = self->priv->prefs;
#line 358 "../lib/Widgets/PreferencesWindow.vala"
	_tmp73_ = plank_dock_preferences_get_Offset (_tmp72_);
#line 358 "../lib/Widgets/PreferencesWindow.vala"
	_tmp74_ = _tmp73_;
#line 358 "../lib/Widgets/PreferencesWindow.vala"
	gtk_adjustment_set_value (_tmp71_, (gdouble) _tmp74_);
#line 359 "../lib/Widgets/PreferencesWindow.vala"
	_tmp75_ = self->priv->s_offset;
#line 359 "../lib/Widgets/PreferencesWindow.vala"
	_tmp76_ = self->priv->prefs;
#line 359 "../lib/Widgets/PreferencesWindow.vala"
	_tmp77_ = plank_dock_preferences_get_Alignment (_tmp76_);
#line 359 "../lib/Widgets/PreferencesWindow.vala"
	_tmp78_ = _tmp77_;
#line 359 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp75_, _tmp78_ == GTK_ALIGN_CENTER);
#line 360 "../lib/Widgets/PreferencesWindow.vala"
	_tmp79_ = self->priv->sw_hide;
#line 360 "../lib/Widgets/PreferencesWindow.vala"
	_tmp80_ = self->priv->prefs;
#line 360 "../lib/Widgets/PreferencesWindow.vala"
	_tmp81_ = plank_dock_preferences_get_HideMode (_tmp80_);
#line 360 "../lib/Widgets/PreferencesWindow.vala"
	_tmp82_ = _tmp81_;
#line 360 "../lib/Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp79_, _tmp82_ != PLANK_HIDE_TYPE_NONE);
#line 361 "../lib/Widgets/PreferencesWindow.vala"
	_tmp83_ = self->priv->sw_primary_display;
#line 361 "../lib/Widgets/PreferencesWindow.vala"
	_tmp84_ = self->priv->prefs;
#line 361 "../lib/Widgets/PreferencesWindow.vala"
	_tmp85_ = plank_dock_preferences_get_Monitor (_tmp84_);
#line 361 "../lib/Widgets/PreferencesWindow.vala"
	_tmp86_ = _tmp85_;
#line 361 "../lib/Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp83_, g_strcmp0 (_tmp86_, "") == 0);
#line 362 "../lib/Widgets/PreferencesWindow.vala"
	_tmp87_ = self->priv->sw_workspace_only;
#line 362 "../lib/Widgets/PreferencesWindow.vala"
	_tmp88_ = self->priv->prefs;
#line 362 "../lib/Widgets/PreferencesWindow.vala"
	_tmp89_ = plank_dock_preferences_get_CurrentWorkspaceOnly (_tmp88_);
#line 362 "../lib/Widgets/PreferencesWindow.vala"
	_tmp90_ = _tmp89_;
#line 362 "../lib/Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp87_, _tmp90_);
#line 363 "../lib/Widgets/PreferencesWindow.vala"
	_tmp91_ = self->priv->sw_show_unpinned;
#line 363 "../lib/Widgets/PreferencesWindow.vala"
	_tmp92_ = self->priv->prefs;
#line 363 "../lib/Widgets/PreferencesWindow.vala"
	_tmp93_ = plank_dock_preferences_get_PinnedOnly (_tmp92_);
#line 363 "../lib/Widgets/PreferencesWindow.vala"
	_tmp94_ = _tmp93_;
#line 363 "../lib/Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp91_, !_tmp94_);
#line 364 "../lib/Widgets/PreferencesWindow.vala"
	_tmp95_ = self->priv->sw_lock_items;
#line 364 "../lib/Widgets/PreferencesWindow.vala"
	_tmp96_ = self->priv->prefs;
#line 364 "../lib/Widgets/PreferencesWindow.vala"
	_tmp97_ = plank_dock_preferences_get_LockItems (_tmp96_);
#line 364 "../lib/Widgets/PreferencesWindow.vala"
	_tmp98_ = _tmp97_;
#line 364 "../lib/Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp95_, _tmp98_);
#line 365 "../lib/Widgets/PreferencesWindow.vala"
	_tmp99_ = self->priv->sw_pressure_reveal;
#line 365 "../lib/Widgets/PreferencesWindow.vala"
	_tmp100_ = self->priv->prefs;
#line 365 "../lib/Widgets/PreferencesWindow.vala"
	_tmp101_ = plank_dock_preferences_get_PressureReveal (_tmp100_);
#line 365 "../lib/Widgets/PreferencesWindow.vala"
	_tmp102_ = _tmp101_;
#line 365 "../lib/Widgets/PreferencesWindow.vala"
	gtk_switch_set_active (_tmp99_, _tmp102_);
#line 366 "../lib/Widgets/PreferencesWindow.vala"
	_tmp103_ = self->priv->cb_alignment;
#line 366 "../lib/Widgets/PreferencesWindow.vala"
	_tmp104_ = self->priv->prefs;
#line 366 "../lib/Widgets/PreferencesWindow.vala"
	_tmp105_ = plank_dock_preferences_get_Alignment (_tmp104_);
#line 366 "../lib/Widgets/PreferencesWindow.vala"
	_tmp106_ = _tmp105_;
#line 366 "../lib/Widgets/PreferencesWindow.vala"
	_tmp107_ = g_strdup_printf ("%i", (gint) _tmp106_);
#line 366 "../lib/Widgets/PreferencesWindow.vala"
	_tmp108_ = _tmp107_;
#line 366 "../lib/Widgets/PreferencesWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp103_, _tmp108_);
#line 366 "../lib/Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp108_);
#line 367 "../lib/Widgets/PreferencesWindow.vala"
	_tmp109_ = self->priv->cb_items_alignment;
#line 367 "../lib/Widgets/PreferencesWindow.vala"
	_tmp110_ = self->priv->prefs;
#line 367 "../lib/Widgets/PreferencesWindow.vala"
	_tmp111_ = plank_dock_preferences_get_ItemsAlignment (_tmp110_);
#line 367 "../lib/Widgets/PreferencesWindow.vala"
	_tmp112_ = _tmp111_;
#line 367 "../lib/Widgets/PreferencesWindow.vala"
	_tmp113_ = g_strdup_printf ("%i", (gint) _tmp112_);
#line 367 "../lib/Widgets/PreferencesWindow.vala"
	_tmp114_ = _tmp113_;
#line 367 "../lib/Widgets/PreferencesWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp109_, _tmp114_);
#line 367 "../lib/Widgets/PreferencesWindow.vala"
	_g_free0 (_tmp114_);
#line 368 "../lib/Widgets/PreferencesWindow.vala"
	_tmp115_ = self->priv->cb_items_alignment;
#line 368 "../lib/Widgets/PreferencesWindow.vala"
	_tmp116_ = self->priv->prefs;
#line 368 "../lib/Widgets/PreferencesWindow.vala"
	_tmp117_ = plank_dock_preferences_get_Alignment (_tmp116_);
#line 368 "../lib/Widgets/PreferencesWindow.vala"
	_tmp118_ = _tmp117_;
#line 368 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp115_, _tmp118_ == GTK_ALIGN_FILL);
#line 2220 "PreferencesWindow.c"
}

static void
_plank_preferences_window_view_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                 GdkDragContext* context,
                                                                 gpointer self)
{
#line 381 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_view_drag_begin (_sender, context, (PlankPreferencesWindow*) self);
#line 2230 "PreferencesWindow.c"
}

static void
_plank_preferences_window_view_item_activated_gtk_icon_view_item_activated (GtkIconView* _sender,
                                                                            GtkTreePath* path,
                                                                            gpointer self)
{
#line 382 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_view_item_activated (_sender, path, (PlankPreferencesWindow*) self);
#line 2240 "PreferencesWindow.c"
}

static void
plank_preferences_window_init_docklets_tab (PlankPreferencesWindow* self)
{
	PlankDockletViewModel* model_docklets = NULL;
	PlankDockletViewModel* _tmp0_;
	GtkTreeModelSort* sorted_docklets = NULL;
	PlankDockletViewModel* _tmp1_;
	GtkTreeModelSort* _tmp2_;
	GtkTargetEntry te = {0};
	GtkTargetEntry _tmp3_ = {0};
	GtkIconView* _tmp4_;
	GtkTargetEntry _tmp5_;
	GtkTargetEntry* _tmp6_;
	GtkTargetEntry* _tmp7_;
	gint _tmp7__length1;
	GtkIconView* _tmp8_;
	GtkIconView* _tmp9_;
	GtkIconView* _tmp10_;
	GtkIconView* _tmp11_;
	GtkIconView* _tmp12_;
	GtkTreeModelSort* _tmp34_;
	GtkIconView* _tmp35_;
	GtkTreeModelSort* _tmp36_;
#line 371 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 373 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = plank_docklet_view_model_new ();
#line 373 "../lib/Widgets/PreferencesWindow.vala"
	model_docklets = _tmp0_;
#line 374 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = model_docklets;
#line 374 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = (GtkTreeModelSort*) gtk_tree_model_sort_new_with_model ((GtkTreeModel*) _tmp1_);
#line 374 "../lib/Widgets/PreferencesWindow.vala"
	sorted_docklets = _tmp2_;
#line 376 "../lib/Widgets/PreferencesWindow.vala"
	_tmp3_.target = "text/plank-uri-list";
#line 376 "../lib/Widgets/PreferencesWindow.vala"
	_tmp3_.flags = (guint) GTK_TARGET_SAME_APP;
#line 376 "../lib/Widgets/PreferencesWindow.vala"
	_tmp3_.info = (guint) 0;
#line 376 "../lib/Widgets/PreferencesWindow.vala"
	te = _tmp3_;
#line 377 "../lib/Widgets/PreferencesWindow.vala"
	_tmp4_ = self->priv->view_docklets;
#line 377 "../lib/Widgets/PreferencesWindow.vala"
	_tmp5_ = te;
#line 377 "../lib/Widgets/PreferencesWindow.vala"
	_tmp6_ = g_new0 (GtkTargetEntry, 1);
#line 377 "../lib/Widgets/PreferencesWindow.vala"
	_tmp6_[0] = _tmp5_;
#line 377 "../lib/Widgets/PreferencesWindow.vala"
	_tmp7_ = _tmp6_;
#line 377 "../lib/Widgets/PreferencesWindow.vala"
	_tmp7__length1 = 1;
#line 377 "../lib/Widgets/PreferencesWindow.vala"
	gtk_icon_view_enable_model_drag_source (_tmp4_, GDK_BUTTON1_MASK, _tmp7_, (gint) 1, GDK_ACTION_PRIVATE);
#line 377 "../lib/Widgets/PreferencesWindow.vala"
	_tmp7_ = (g_free (_tmp7_), NULL);
#line 378 "../lib/Widgets/PreferencesWindow.vala"
	_tmp8_ = self->priv->view_docklets;
#line 378 "../lib/Widgets/PreferencesWindow.vala"
	gtk_icon_view_set_text_column (_tmp8_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_NAME);
#line 379 "../lib/Widgets/PreferencesWindow.vala"
	_tmp9_ = self->priv->view_docklets;
#line 379 "../lib/Widgets/PreferencesWindow.vala"
	gtk_icon_view_set_tooltip_column (_tmp9_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_DESCRIPTION);
#line 380 "../lib/Widgets/PreferencesWindow.vala"
	_tmp10_ = self->priv->view_docklets;
#line 380 "../lib/Widgets/PreferencesWindow.vala"
	gtk_icon_view_set_pixbuf_column (_tmp10_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_PIXBUF);
#line 381 "../lib/Widgets/PreferencesWindow.vala"
	_tmp11_ = self->priv->view_docklets;
#line 381 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GtkWidget*) _tmp11_, "drag-begin", (GCallback) _plank_preferences_window_view_drag_begin_gtk_widget_drag_begin, self, G_CONNECT_AFTER);
#line 382 "../lib/Widgets/PreferencesWindow.vala"
	_tmp12_ = self->priv->view_docklets;
#line 382 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object (_tmp12_, "item-activated", (GCallback) _plank_preferences_window_view_item_activated_gtk_icon_view_item_activated, self, 0);
#line 2322 "PreferencesWindow.c"
	{
		GeeIterator* _docklet_it = NULL;
		PlankDockletManager* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeIterator* _tmp16_;
		GeeIterator* _tmp17_;
#line 384 "../lib/Widgets/PreferencesWindow.vala"
		_tmp13_ = plank_docklet_manager_get_default ();
#line 384 "../lib/Widgets/PreferencesWindow.vala"
		_tmp14_ = plank_docklet_manager_list_docklets (_tmp13_);
#line 384 "../lib/Widgets/PreferencesWindow.vala"
		_tmp15_ = _tmp14_;
#line 384 "../lib/Widgets/PreferencesWindow.vala"
		_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 384 "../lib/Widgets/PreferencesWindow.vala"
		_tmp17_ = _tmp16_;
#line 384 "../lib/Widgets/PreferencesWindow.vala"
		_g_object_unref0 (_tmp15_);
#line 384 "../lib/Widgets/PreferencesWindow.vala"
		_docklet_it = _tmp17_;
#line 384 "../lib/Widgets/PreferencesWindow.vala"
		while (TRUE) {
#line 2346 "PreferencesWindow.c"
			GeeIterator* _tmp18_;
			PlankDocklet* docklet = NULL;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			GdkPixbuf* pixbuf = NULL;
			PlankDocklet* _tmp21_;
			const gchar* _tmp22_;
			GdkPixbuf* _tmp23_;
			PlankDockletViewModel* _tmp24_;
			PlankDocklet* _tmp25_;
			const gchar* _tmp26_;
			PlankDocklet* _tmp27_;
			const gchar* _tmp28_;
			PlankDocklet* _tmp29_;
			const gchar* _tmp30_;
			PlankDocklet* _tmp31_;
			const gchar* _tmp32_;
			GdkPixbuf* _tmp33_;
#line 384 "../lib/Widgets/PreferencesWindow.vala"
			_tmp18_ = _docklet_it;
#line 384 "../lib/Widgets/PreferencesWindow.vala"
			if (!gee_iterator_next (_tmp18_)) {
#line 384 "../lib/Widgets/PreferencesWindow.vala"
				break;
#line 2371 "PreferencesWindow.c"
			}
#line 384 "../lib/Widgets/PreferencesWindow.vala"
			_tmp19_ = _docklet_it;
#line 384 "../lib/Widgets/PreferencesWindow.vala"
			_tmp20_ = gee_iterator_get (_tmp19_);
#line 384 "../lib/Widgets/PreferencesWindow.vala"
			docklet = (PlankDocklet*) _tmp20_;
#line 385 "../lib/Widgets/PreferencesWindow.vala"
			_tmp21_ = docklet;
#line 385 "../lib/Widgets/PreferencesWindow.vala"
			_tmp22_ = plank_docklet_get_icon (_tmp21_);
#line 385 "../lib/Widgets/PreferencesWindow.vala"
			_tmp23_ = plank_drawing_service_load_icon (_tmp22_, 48, 48);
#line 385 "../lib/Widgets/PreferencesWindow.vala"
			pixbuf = _tmp23_;
#line 386 "../lib/Widgets/PreferencesWindow.vala"
			_tmp24_ = model_docklets;
#line 386 "../lib/Widgets/PreferencesWindow.vala"
			_tmp25_ = docklet;
#line 386 "../lib/Widgets/PreferencesWindow.vala"
			_tmp26_ = plank_docklet_get_id (_tmp25_);
#line 386 "../lib/Widgets/PreferencesWindow.vala"
			_tmp27_ = docklet;
#line 386 "../lib/Widgets/PreferencesWindow.vala"
			_tmp28_ = plank_docklet_get_name (_tmp27_);
#line 386 "../lib/Widgets/PreferencesWindow.vala"
			_tmp29_ = docklet;
#line 386 "../lib/Widgets/PreferencesWindow.vala"
			_tmp30_ = plank_docklet_get_description (_tmp29_);
#line 386 "../lib/Widgets/PreferencesWindow.vala"
			_tmp31_ = docklet;
#line 386 "../lib/Widgets/PreferencesWindow.vala"
			_tmp32_ = plank_docklet_get_icon (_tmp31_);
#line 386 "../lib/Widgets/PreferencesWindow.vala"
			_tmp33_ = pixbuf;
#line 386 "../lib/Widgets/PreferencesWindow.vala"
			plank_docklet_view_model_add (_tmp24_, _tmp26_, _tmp28_, _tmp30_, _tmp32_, _tmp33_);
#line 384 "../lib/Widgets/PreferencesWindow.vala"
			_g_object_unref0 (pixbuf);
#line 384 "../lib/Widgets/PreferencesWindow.vala"
			_g_object_unref0 (docklet);
#line 2413 "PreferencesWindow.c"
		}
#line 384 "../lib/Widgets/PreferencesWindow.vala"
		_g_object_unref0 (_docklet_it);
#line 2417 "PreferencesWindow.c"
	}
#line 389 "../lib/Widgets/PreferencesWindow.vala"
	_tmp34_ = sorted_docklets;
#line 389 "../lib/Widgets/PreferencesWindow.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp34_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_NAME, GTK_SORT_ASCENDING);
#line 390 "../lib/Widgets/PreferencesWindow.vala"
	_tmp35_ = self->priv->view_docklets;
#line 390 "../lib/Widgets/PreferencesWindow.vala"
	_tmp36_ = sorted_docklets;
#line 390 "../lib/Widgets/PreferencesWindow.vala"
	gtk_icon_view_set_model (_tmp35_, (GtkTreeModel*) _tmp36_);
#line 371 "../lib/Widgets/PreferencesWindow.vala"
	_g_object_unref0 (sorted_docklets);
#line 371 "../lib/Widgets/PreferencesWindow.vala"
	_g_object_unref0 (model_docklets);
#line 2433 "PreferencesWindow.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 400 "../lib/Widgets/PreferencesWindow.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 2441 "PreferencesWindow.c"
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
#line 400 "../lib/Widgets/PreferencesWindow.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
#line 2449 "PreferencesWindow.c"
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
#line 400 "../lib/Widgets/PreferencesWindow.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
#line 2457 "PreferencesWindow.c"
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 405 "../lib/Widgets/PreferencesWindow.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 2465 "PreferencesWindow.c"
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 405 "../lib/Widgets/PreferencesWindow.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 2473 "PreferencesWindow.c"
}

static void
plank_preferences_window_view_drag_begin (GtkWidget* widget,
                                          GdkDragContext* context,
                                          PlankPreferencesWindow* self)
{
	GtkIconView* view = NULL;
	GList* selection = NULL;
	GtkIconView* _tmp0_;
	GList* _tmp1_;
	GList* path_list = NULL;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	GtkTreeModel* model = NULL;
	GtkIconView* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeIter iter = {0};
	GValue val = {0};
	GtkTreePath* path = NULL;
	GList* _tmp7_;
	gconstpointer _tmp8_;
	GtkTreePath* _tmp9_;
	GtkTreeModel* _tmp10_;
	GtkTreePath* _tmp11_;
	GtkTreeIter _tmp12_ = {0};
	GtkTreeModel* _tmp13_;
	GtkTreeIter _tmp14_;
	GValue _tmp15_ = {0};
	gchar* icon_name = NULL;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gint icon_size = 0;
	PlankDockPreferences* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint window_scale_factor = 0;
	GdkWindow* _tmp21_;
	cairo_surface_t* surface = NULL;
	const gchar* _tmp22_;
	cairo_surface_t* _tmp23_;
	cairo_surface_t* _tmp24_;
	cairo_surface_t* _tmp25_;
#line 394 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 394 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (widget != NULL);
#line 394 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (context != NULL);
#line 396 "../lib/Widgets/PreferencesWindow.vala"
	view = G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_icon_view_get_type (), GtkIconView);
#line 397 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = view;
#line 397 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = gtk_icon_view_get_selected_items (_tmp0_);
#line 397 "../lib/Widgets/PreferencesWindow.vala"
	selection = _tmp1_;
#line 398 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = selection;
#line 398 "../lib/Widgets/PreferencesWindow.vala"
	_tmp3_ = g_list_first (_tmp2_);
#line 398 "../lib/Widgets/PreferencesWindow.vala"
	path_list = _tmp3_;
#line 399 "../lib/Widgets/PreferencesWindow.vala"
	_tmp4_ = path_list;
#line 399 "../lib/Widgets/PreferencesWindow.vala"
	if (_tmp4_ == NULL) {
#line 400 "../lib/Widgets/PreferencesWindow.vala"
		(selection == NULL) ? NULL : (selection = (_g_list_free___vala_GtkTreePath_free0_ (selection), NULL));
#line 400 "../lib/Widgets/PreferencesWindow.vala"
		return;
#line 2546 "PreferencesWindow.c"
	}
#line 402 "../lib/Widgets/PreferencesWindow.vala"
	_tmp5_ = view;
#line 402 "../lib/Widgets/PreferencesWindow.vala"
	_tmp6_ = gtk_icon_view_get_model (_tmp5_);
#line 402 "../lib/Widgets/PreferencesWindow.vala"
	model = _tmp6_;
#line 405 "../lib/Widgets/PreferencesWindow.vala"
	_tmp7_ = path_list;
#line 405 "../lib/Widgets/PreferencesWindow.vala"
	_tmp8_ = _tmp7_->data;
#line 405 "../lib/Widgets/PreferencesWindow.vala"
	_tmp9_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) _tmp8_);
#line 405 "../lib/Widgets/PreferencesWindow.vala"
	path = _tmp9_;
#line 406 "../lib/Widgets/PreferencesWindow.vala"
	_tmp10_ = model;
#line 406 "../lib/Widgets/PreferencesWindow.vala"
	_tmp11_ = path;
#line 406 "../lib/Widgets/PreferencesWindow.vala"
	gtk_tree_model_get_iter (_tmp10_, &_tmp12_, _tmp11_);
#line 406 "../lib/Widgets/PreferencesWindow.vala"
	iter = _tmp12_;
#line 407 "../lib/Widgets/PreferencesWindow.vala"
	_tmp13_ = model;
#line 407 "../lib/Widgets/PreferencesWindow.vala"
	_tmp14_ = iter;
#line 407 "../lib/Widgets/PreferencesWindow.vala"
	gtk_tree_model_get_value (_tmp13_, &_tmp14_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_ICON, &_tmp15_);
#line 407 "../lib/Widgets/PreferencesWindow.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 407 "../lib/Widgets/PreferencesWindow.vala"
	val = _tmp15_;
#line 409 "../lib/Widgets/PreferencesWindow.vala"
	_tmp16_ = g_value_get_string (&val);
#line 409 "../lib/Widgets/PreferencesWindow.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 409 "../lib/Widgets/PreferencesWindow.vala"
	icon_name = _tmp17_;
#line 410 "../lib/Widgets/PreferencesWindow.vala"
	_tmp18_ = self->priv->prefs;
#line 410 "../lib/Widgets/PreferencesWindow.vala"
	_tmp19_ = plank_dock_preferences_get_IconSize (_tmp18_);
#line 410 "../lib/Widgets/PreferencesWindow.vala"
	_tmp20_ = _tmp19_;
#line 410 "../lib/Widgets/PreferencesWindow.vala"
	icon_size = _tmp20_;
#line 411 "../lib/Widgets/PreferencesWindow.vala"
	_tmp21_ = gtk_widget_get_window ((GtkWidget*) self);
#line 411 "../lib/Widgets/PreferencesWindow.vala"
	window_scale_factor = gdk_window_get_scale_factor (_tmp21_);
#line 412 "../lib/Widgets/PreferencesWindow.vala"
	icon_size *= window_scale_factor;
#line 413 "../lib/Widgets/PreferencesWindow.vala"
	_tmp22_ = icon_name;
#line 413 "../lib/Widgets/PreferencesWindow.vala"
	_tmp23_ = plank_drawing_service_load_icon_for_scale (_tmp22_, icon_size, icon_size, window_scale_factor);
#line 413 "../lib/Widgets/PreferencesWindow.vala"
	surface = _tmp23_;
#line 414 "../lib/Widgets/PreferencesWindow.vala"
	_tmp24_ = surface;
#line 414 "../lib/Widgets/PreferencesWindow.vala"
	cairo_surface_set_device_offset (_tmp24_, (-icon_size) / 2.0, (-icon_size) / 2.0);
#line 415 "../lib/Widgets/PreferencesWindow.vala"
	_tmp25_ = surface;
#line 415 "../lib/Widgets/PreferencesWindow.vala"
	gtk_drag_set_icon_surface (context, _tmp25_);
#line 394 "../lib/Widgets/PreferencesWindow.vala"
	_cairo_surface_destroy0 (surface);
#line 394 "../lib/Widgets/PreferencesWindow.vala"
	_g_free0 (icon_name);
#line 394 "../lib/Widgets/PreferencesWindow.vala"
	__vala_GtkTreePath_free0 (path);
#line 394 "../lib/Widgets/PreferencesWindow.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 394 "../lib/Widgets/PreferencesWindow.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free___vala_GtkTreePath_free0_ (selection), NULL));
#line 2624 "PreferencesWindow.c"
}

static void
plank_preferences_window_view_item_activated (GtkIconView* view,
                                              GtkTreePath* path,
                                              PlankPreferencesWindow* self)
{
	PlankApplicationDockItemProvider* provider = NULL;
	PlankDockController* _tmp0_;
	PlankDockItemProvider* _tmp1_;
	PlankDockItemProvider* _tmp2_;
	PlankApplicationDockItemProvider* _tmp3_;
	GtkTreeModel* model = NULL;
	GtkTreeModel* _tmp4_;
	GtkTreeIter iter = {0};
	GValue val = {0};
	GtkTreeModel* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	GtkTreeModel* _tmp7_;
	GtkTreeIter _tmp8_;
	GValue _tmp9_ = {0};
	gchar* uri = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	PlankApplicationDockItemProvider* _tmp13_;
	const gchar* _tmp14_;
#line 419 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 419 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (view != NULL);
#line 419 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (path != NULL);
#line 421 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 421 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = plank_dock_controller_get_default_provider (_tmp0_);
#line 421 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = _tmp1_;
#line 421 "../lib/Widgets/PreferencesWindow.vala"
	provider = PLANK_IS_APPLICATION_DOCK_ITEM_PROVIDER (_tmp2_) ? ((PlankApplicationDockItemProvider*) _tmp2_) : NULL;
#line 422 "../lib/Widgets/PreferencesWindow.vala"
	_tmp3_ = provider;
#line 422 "../lib/Widgets/PreferencesWindow.vala"
	if (_tmp3_ == NULL) {
#line 423 "../lib/Widgets/PreferencesWindow.vala"
		return;
#line 2672 "PreferencesWindow.c"
	}
#line 425 "../lib/Widgets/PreferencesWindow.vala"
	_tmp4_ = gtk_icon_view_get_model (view);
#line 425 "../lib/Widgets/PreferencesWindow.vala"
	model = _tmp4_;
#line 428 "../lib/Widgets/PreferencesWindow.vala"
	_tmp5_ = model;
#line 428 "../lib/Widgets/PreferencesWindow.vala"
	gtk_tree_model_get_iter (_tmp5_, &_tmp6_, path);
#line 428 "../lib/Widgets/PreferencesWindow.vala"
	iter = _tmp6_;
#line 429 "../lib/Widgets/PreferencesWindow.vala"
	_tmp7_ = model;
#line 429 "../lib/Widgets/PreferencesWindow.vala"
	_tmp8_ = iter;
#line 429 "../lib/Widgets/PreferencesWindow.vala"
	gtk_tree_model_get_value (_tmp7_, &_tmp8_, (gint) PLANK_DOCKLET_VIEW_MODEL_COLUMN_ID, &_tmp9_);
#line 429 "../lib/Widgets/PreferencesWindow.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 429 "../lib/Widgets/PreferencesWindow.vala"
	val = _tmp9_;
#line 431 "../lib/Widgets/PreferencesWindow.vala"
	_tmp10_ = g_value_get_string (&val);
#line 431 "../lib/Widgets/PreferencesWindow.vala"
	_tmp11_ = g_strdup_printf ("%s%s", PLANK_DOCKLET_URI_PREFIX, _tmp10_);
#line 431 "../lib/Widgets/PreferencesWindow.vala"
	uri = _tmp11_;
#line 432 "../lib/Widgets/PreferencesWindow.vala"
	_tmp12_ = uri;
#line 432 "../lib/Widgets/PreferencesWindow.vala"
	g_debug ("PreferencesWindow.vala:432: Try to add docklet for '%s'", _tmp12_);
#line 433 "../lib/Widgets/PreferencesWindow.vala"
	_tmp13_ = provider;
#line 433 "../lib/Widgets/PreferencesWindow.vala"
	_tmp14_ = uri;
#line 433 "../lib/Widgets/PreferencesWindow.vala"
	plank_dock_item_provider_add_item_with_uri ((PlankDockItemProvider*) _tmp13_, _tmp14_, NULL);
#line 419 "../lib/Widgets/PreferencesWindow.vala"
	_g_free0 (uri);
#line 419 "../lib/Widgets/PreferencesWindow.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 2714 "PreferencesWindow.c"
}

PlankDockController*
plank_preferences_window_get_controller (PlankPreferencesWindow* self)
{
	PlankDockController* result;
	PlankDockController* _tmp0_;
#line 28 "../lib/Widgets/PreferencesWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = self->priv->_controller;
#line 28 "../lib/Widgets/PreferencesWindow.vala"
	result = _tmp0_;
#line 28 "../lib/Widgets/PreferencesWindow.vala"
	return result;
#line 2730 "PreferencesWindow.c"
}

void
plank_preferences_window_set_controller (PlankPreferencesWindow* self,
                                         PlankDockController* value)
{
	PlankDockController* old_value;
#line 28 "../lib/Widgets/PreferencesWindow.vala"
	g_return_if_fail (self != NULL);
#line 28 "../lib/Widgets/PreferencesWindow.vala"
	old_value = plank_preferences_window_get_controller (self);
#line 28 "../lib/Widgets/PreferencesWindow.vala"
	if (old_value != value) {
#line 2744 "PreferencesWindow.c"
		PlankDockController* _tmp0_;
#line 28 "../lib/Widgets/PreferencesWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "../lib/Widgets/PreferencesWindow.vala"
		_g_object_unref0 (self->priv->_controller);
#line 28 "../lib/Widgets/PreferencesWindow.vala"
		self->priv->_controller = _tmp0_;
#line 28 "../lib/Widgets/PreferencesWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_preferences_window_properties[PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY]);
#line 2754 "PreferencesWindow.c"
	}
}

static void
_plank_preferences_window_controller_changed_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 92 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_controller_changed ((PlankPreferencesWindow*) self);
#line 2765 "PreferencesWindow.c"
}

static GObject *
plank_preferences_window_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankPreferencesWindow * self;
	gchar* title = NULL;
	gchar* _tmp0_;
	PlankDockController* _tmp1_;
	PlankDockPreferences* _tmp2_;
	PlankDockPreferences* _tmp3_;
	PlankDockPreferences* _tmp4_;
#line 82 "../lib/Widgets/PreferencesWindow.vala"
	parent_class = G_OBJECT_CLASS (plank_preferences_window_parent_class);
#line 82 "../lib/Widgets/PreferencesWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 82 "../lib/Widgets/PreferencesWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_PREFERENCES_WINDOW, PlankPreferencesWindow);
#line 84 "../lib/Widgets/PreferencesWindow.vala"
	_tmp0_ = g_strdup (_ ("Preferences"));
#line 84 "../lib/Widgets/PreferencesWindow.vala"
	title = _tmp0_;
#line 86 "../lib/Widgets/PreferencesWindow.vala"
	_tmp1_ = self->priv->_controller;
#line 86 "../lib/Widgets/PreferencesWindow.vala"
	_tmp2_ = plank_dock_controller_get_prefs (_tmp1_);
#line 86 "../lib/Widgets/PreferencesWindow.vala"
	_tmp3_ = _tmp2_;
#line 86 "../lib/Widgets/PreferencesWindow.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 86 "../lib/Widgets/PreferencesWindow.vala"
	_g_object_unref0 (self->priv->prefs);
#line 86 "../lib/Widgets/PreferencesWindow.vala"
	self->priv->prefs = _tmp4_;
#line 88 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_init_dock_tab (self);
#line 89 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_init_docklets_tab (self);
#line 90 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_connect_signals (self);
#line 92 "../lib/Widgets/PreferencesWindow.vala"
	g_signal_connect_object ((GObject*) self, "notify::controller", (GCallback) _plank_preferences_window_controller_changed_g_object_notify, self, 0);
#line 82 "../lib/Widgets/PreferencesWindow.vala"
	_g_free0 (title);
#line 82 "../lib/Widgets/PreferencesWindow.vala"
	return obj;
#line 2816 "PreferencesWindow.c"
}

static void
plank_preferences_window_class_init (PlankPreferencesWindowClass * klass,
                                     gpointer klass_data)
{
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	plank_preferences_window_parent_class = g_type_class_peek_parent (klass);
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	g_type_class_adjust_private_offset (klass, &PlankPreferencesWindow_private_offset);
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) plank_preferences_window_real_key_press_event;
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_preferences_window_get_property;
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_preferences_window_set_property;
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_preferences_window_constructor;
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_preferences_window_finalize;
#line 2837 "PreferencesWindow.c"
	/**
	 * The controller for this dock.
	 */
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY, plank_preferences_window_properties[PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", PLANK_TYPE_DOCK_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/net/launchpad/plank/ui/preferences.ui");
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_theme", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_theme));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_hidemode", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_hidemode));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_display_plug", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_display_plug));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_position", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_position));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_alignment", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_alignment));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cb_items_alignment", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, cb_items_alignment));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sp_hide_delay", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sp_hide_delay));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sp_unhide_delay", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sp_unhide_delay));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "s_offset", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, s_offset));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "adj_hide_delay", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, adj_hide_delay));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "adj_unhide_delay", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, adj_unhide_delay));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "adj_iconsize", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, adj_iconsize));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "adj_offset", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, adj_offset));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_hide", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_hide));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_primary_display", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_primary_display));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_workspace_only", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_workspace_only));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_show_unpinned", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_show_unpinned));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_lock_items", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_lock_items));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sw_pressure_reveal", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, sw_pressure_reveal));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "view_docklets", FALSE, PlankPreferencesWindow_private_offset + G_STRUCT_OFFSET (PlankPreferencesWindowPrivate, view_docklets));
#line 2885 "PreferencesWindow.c"
}

static void
plank_preferences_window_instance_init (PlankPreferencesWindow * self,
                                        gpointer klass)
{
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	self->priv = plank_preferences_window_get_instance_private (self);
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2896 "PreferencesWindow.c"
}

static void
plank_preferences_window_finalize (GObject * obj)
{
	PlankPreferencesWindow * self;
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_PREFERENCES_WINDOW, PlankPreferencesWindow);
#line 28 "../lib/Widgets/PreferencesWindow.vala"
	_g_object_unref0 (self->priv->_controller);
#line 30 "../lib/Widgets/PreferencesWindow.vala"
	_g_object_unref0 (self->priv->prefs);
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	G_OBJECT_CLASS (plank_preferences_window_parent_class)->finalize (obj);
#line 2911 "PreferencesWindow.c"
}

static GType
plank_preferences_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankPreferencesWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_preferences_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankPreferencesWindow), 0, (GInstanceInitFunc) plank_preferences_window_instance_init, NULL };
	GType plank_preferences_window_type_id;
	plank_preferences_window_type_id = g_type_register_static (gtk_window_get_type (), "PlankPreferencesWindow", &g_define_type_info, 0);
	PlankPreferencesWindow_private_offset = g_type_add_instance_private (plank_preferences_window_type_id, sizeof (PlankPreferencesWindowPrivate));
	return plank_preferences_window_type_id;
}

GType
plank_preferences_window_get_type (void)
{
	static volatile gsize plank_preferences_window_type_id__once = 0;
	if (g_once_init_enter (&plank_preferences_window_type_id__once)) {
		GType plank_preferences_window_type_id;
		plank_preferences_window_type_id = plank_preferences_window_get_type_once ();
		g_once_init_leave (&plank_preferences_window_type_id__once, plank_preferences_window_type_id);
	}
	return plank_preferences_window_type_id__once;
}

static void
_vala_plank_preferences_window_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	PlankPreferencesWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_PREFERENCES_WINDOW, PlankPreferencesWindow);
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/PreferencesWindow.vala"
		case PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY:
#line 23 "../lib/Widgets/PreferencesWindow.vala"
		g_value_set_object (value, plank_preferences_window_get_controller (self));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
		break;
#line 2952 "PreferencesWindow.c"
		default:
#line 23 "../lib/Widgets/PreferencesWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/PreferencesWindow.vala"
		break;
#line 2958 "PreferencesWindow.c"
	}
}

static void
_vala_plank_preferences_window_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	PlankPreferencesWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_PREFERENCES_WINDOW, PlankPreferencesWindow);
#line 23 "../lib/Widgets/PreferencesWindow.vala"
	switch (property_id) {
#line 23 "../lib/Widgets/PreferencesWindow.vala"
		case PLANK_PREFERENCES_WINDOW_CONTROLLER_PROPERTY:
#line 23 "../lib/Widgets/PreferencesWindow.vala"
		plank_preferences_window_set_controller (self, g_value_get_object (value));
#line 23 "../lib/Widgets/PreferencesWindow.vala"
		break;
#line 2978 "PreferencesWindow.c"
		default:
#line 23 "../lib/Widgets/PreferencesWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../lib/Widgets/PreferencesWindow.vala"
		break;
#line 2984 "PreferencesWindow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 114 "../lib/Services/EnvironmentSettings.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2995 "PreferencesWindow.c"
		gssize i;
#line 114 "../lib/Services/EnvironmentSettings.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 114 "../lib/Services/EnvironmentSettings.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 114 "../lib/Services/EnvironmentSettings.vala"
				destroy_func (((gpointer*) array)[i]);
#line 3003 "PreferencesWindow.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 114 "../lib/Services/EnvironmentSettings.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 114 "../lib/Services/EnvironmentSettings.vala"
	g_free (array);
#line 3018 "PreferencesWindow.c"
}

